using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.Ecommerce;
using CMS.GlobalHelper;
using CMS.CMSHelper;

/// <summary>
/// Summary description for Functions
/// </summary>
public static class EcommerceFunctions
{
    /// <summary>
    /// Return formated price
    /// </summary>
    /// <param name="SKUPrice"></param>
    /// <returns></returns>
    public static string GetFormatedPrice(object SKUPrice)
    {
        string formatedPrice = "";
        double price = ValidationHelper.GetDouble(SKUPrice, 0);
        if ((price > 0) && (CMSContext.CurrentSite != null))
        {
            int currencyId = CMSContext.CurrentSite.SiteDefaultCurrencyID;
            int mCurrentCurrency = currencyId;
            if ((CMSContext.CurrentShoppingCart != null) && (CMSContext.CurrentShoppingCart.CurrencyInfoObj!= null))
            {
                mCurrentCurrency = CMSContext.CurrentShoppingCart.CurrencyInfoObj.CurrencyID;
            }

            double rate = CurrencyInfoProvider.GetLastValidExchangeRate(mCurrentCurrency);
            if (rate <= 0)
            {
                rate = 1.0;
            }

            CurrencyInfo currency = CurrencyInfoProvider.GetCurrencyInfo(mCurrentCurrency);
            price = CurrencyInfoProvider.RoundTo(price / rate, currency);
            formatedPrice = CurrencyInfoProvider.GetFormatedPrice(price, currency);
        }
        return formatedPrice;
    }


    /// <summary>
    /// Return link to "add to shoppingcart"
    /// </summary>
    /// <param name="productId"></param>
    /// <returns></returns>
    public static string GetAddToShoppingCartLink(object productId)
    {
        if (productId != DBNull.Value)
        {
            return "<img src=\"~/App_Themes/Default/Images/CMSDesk/Tools/Ecommerce/Orders/addorder.gif\" alt=\"Add to cart\" /><a href=\"~/ShoppingCart.aspx?productId=" + Convert.ToString(productId) + "&quantity=1\">" + ResHelper.GetString("EcommerceFunctions.AddToShoppingCart") + "</a>";
        }
        else
        {
            return "";
        }
    }


    /// <summary>
    /// Returns the public SKU status display name
    /// </summary>
    /// <param name="statusId">Status ID</param>
    public static string GetPublicStatusName(object statusId)
    {
        int sid = ValidationHelper.GetInteger(statusId, 0);
        if (sid > 0)
        {
            PublicStatusInfo si = PublicStatusInfoProvider.GetPublicStatusInfo(sid);
            if (si != null)
            {
                return si.PublicStatusDisplayName;
            }
        }
        return "";
    }

}
