using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SiteProvider;
using CMS.CMSHelper;
using CMS.TreeEngine;
using CMS.SettingsProvider;

public partial class CMSDesk_Content_SelectImageDialog_Header : CMSModalPage
{
    protected int selectedNodeId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // Get selected node ID
        selectedNodeId = ValidationHelper.GetInteger(Request.Params["selectedNodeId"], 0);

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);

        if (!IsPostBack)
        {
            string select = ValidationHelper.GetString(Request.QueryString["select"], "image");

            /*if (select.ToLower() == "image")
            {*/
            titleElem.TitleText = ResHelper.GetString("SelectImageDialog.Title");
            titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/SelectImageDialog/selectfile.gif";
            /*}
             else
             {
                 titleElem.TitleText = ResHelper.GetString("SelectFlashDialog.Title");
                 titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/SelectImageDialog/selectflash.gif";
             }*/

            lblSite.Text = ResHelper.GetString("SelectImageDialog.Site");
            btnUpload.Text = ResHelper.GetString("SelectImageDialog.Upload");
            string imagesUrl = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/SelectImageDialog/";
            imgUpload.ImageUrl = imagesUrl + "upload.gif";
        
            // Fill in the site list
            if (drpSites.Items.Count == 0)
            {

                // If actual user is global administrator, get all sites
                if (CMSContext.CurrentUser.IsGlobalAdministrator)
                {
                    DataSet ds = SiteInfoProvider.GetAllSites();
                    if (!DataHelper.DataSourceIsEmpty(ds))
                    {
                        drpSites.DataSource = ds.Tables[0];
                        drpSites.DataBind();
                    }
                }
                // Else get only user's sites.
                else
                {
                    DataTable ds = UserInfoProvider.GetUserSites(CMSContext.CurrentUser.UserID);

                    if (!DataHelper.DataSourceIsEmpty(ds))
                    {
                        drpSites.DataSource = ds;
                        drpSites.DataBind();
                    }
                }

                try
                {
                    drpSites.SelectedValue = CMSContext.CurrentSite.SiteID.ToString();
                }
                catch
                {
                }
            }
            drpSites.Attributes.Add("onchange", "RefreshSite(this);");
        }

        // Set tree URL
        string treeUrl = "tree.aspx" + Request.Url.Query;
        if (treeUrl.IndexOf("?") >= 0)
        {
            treeUrl += "&siteid=";
        }
        else
        {
            treeUrl += "?siteid=";
        }
        this.ltlScript.Text += ScriptHelper.GetScript("var treeUrl = '" + treeUrl + "'; var selectElem = document.getElementById('" + this.drpSites.ClientID + "'); RefreshSite();");
    }


    protected void btnUpload_Click(object sender, EventArgs e)
    {
        // Selected node info
        CMS.TreeEngine.TreeNode node = null;
        int nodeClassId = 0;

        // CMS.File class info
        DataClassInfo dci = null;

        // Indicates wheather cms.file child class is allowed
        bool isAllowed = false;

        if (selectedNodeId > 0)
        {
            // Get selected node info
            TreeProvider tree = new TreeProvider();
            node = tree.SelectSingleNode(selectedNodeId, TreeProvider.ALL_CULTURES);

            // Get cms.file class id
            dci = DataClassInfoProvider.GetDataClass("cms.file");

            if ((node != null) && (dci != null))
            {
                // Get selected node class ID
                nodeClassId = ValidationHelper.GetInteger(node.GetValue("NodeClassID"), 0);

                // Check wheather cms.file child class is allowed
                isAllowed = DataClassInfoProvider.IsChildClassAllowed(nodeClassId, dci.ClassID);
            }
        }

        if (isAllowed)
        {
            // Open 'Upload' dialog window            
            ltlScript.Text = ScriptHelper.GetScript("modalDialog('" + ResolveUrl("~/CMSDesk/Content/EditFrameset.aspx?action=new&nodeid=" + selectedNodeId + "&classid=" + dci.ClassID + "&dialog=1") + "', 'UploadFile', 600, 280)");
        }
        else
        {
            // Show error message
            ltlScript.Text = ScriptHelper.GetAlertScript(ResHelper.GetString("SelectImageDialog_CMSFileNotAllowed"));
        }
    }
}
