using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SiteProvider;
using CMS.CMSHelper;
using CMS.TreeEngine;
using CMS.SettingsProvider;

public partial class CMSDesk_Content_SelectImageDialog_HeaderRight : CMSModalPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);

        btnUpload.Text = ResHelper.GetString("SelectImageDialog.Upload");        
    }


    protected void btnUpload_Click(object sender, EventArgs e)
    {
        
        // Get selected node ID
        int nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);

        // Selected node info
        CMS.TreeEngine.TreeNode node = null;
        int nodeClassId = 0;

        // CMS.File class info
        DataClassInfo dci = null;      
  
        // Indicates wheather cms.file child class is allowed
        bool isAllowed = false;

        if (nodeId > 0)
        {
            // Get selected node info
            TreeProvider tree = new TreeProvider();
            node = tree.SelectSingleNode(nodeId, TreeProvider.ALL_CULTURES);

            // Get cms.file class id
            dci = DataClassInfoProvider.GetDataClass("cms.file");

            if ((node != null) && (dci != null))
            {
                // Get selected node class ID
                nodeClassId = ValidationHelper.GetInteger(node.GetValue("NodeClassID"),0);

                // Check wheather cms.file child class is allowed
                isAllowed = DataClassInfoProvider.IsChildClassAllowed(nodeClassId, dci.ClassID);
            }
        }

        if (isAllowed)
        {
            // Open 'Upload' dialog window            
            ltlScript.Text = ScriptHelper.GetScript("modalDialog('" + ResolveUrl("~/CMSDesk/Content/EditFrameset.aspx?action=new&nodeid=" + nodeId + "&classid=" + dci.ClassID + "&dialog=1") + "', 'UploadFile', 600, 280)");            
        }
        else
        {
            // Show error message
            ltlScript.Text = ScriptHelper.GetAlertScript(ResHelper.GetString("SelectImageDialog_CMSFileNotAllowed"));
        }
    }

}
