using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.FileManager;
using CMS.SiteProvider;
using CMS.SettingsProvider;

public partial class CMSDesk_Content_SelectLinkDialog_footer : CMSModalPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        CurrentSiteInfo currentSite = CMSContext.CurrentSite;

        int nodeId = 0;
        int siteId = 0;
        TreeProvider tree = null;

        lblDocName.Text = ResHelper.GetString("SelectLinkDialog.DocumentName");
        btnOK.Text = ResHelper.GetString("General.OK");
        btnCancel.Text = ResHelper.GetString("General.Cancel");
        btnCancel.OnClientClick = "top.window.close();";

        // get nodeid        
        nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);
        siteId = ValidationHelper.GetInteger(Request.QueryString["siteid"], 0);
                        
        if (nodeId > 0)
        {
            if ((CMSContext.CurrentUser != null) && (currentSite != null))
            {
                tree = new TreeProvider();            
                CMS.TreeEngine.TreeNode node = tree.SelectSingleNode(nodeId, TreeProvider.ALL_CULTURES);
                if (node != null)
                {
                    // display document name
                    lblDocNameValue.Text = node.DocumentName;

                    // get domain name
                    SiteInfo si = SiteInfoProvider.GetSiteInfo(siteId);
                    string siteDomain = "";
                    if (si != null)
                    {
                        if (si.DomainName.ToLower() != currentSite.DomainName.ToLower())
                        {
                            siteDomain = si.DomainName;
                        }                                            
                    }

                    // set on OK click
                    string documentUrl = null;
                    if (SettingsKeyProvider.GetBoolValue(currentSite.SiteName + ".CMSUsePermanentURLs"))
                    {
                        documentUrl = AttachmentManager.GetPermanentDocUrl(node.NodeGUID, node.NodeAlias, currentSite.SiteName);
                    }
                    else
                    {
                        documentUrl = CMSContext.GetUrl(node.NodeAliasPath, node.DocumentUrlPath);
                    }
                    
                    btnOK.OnClientClick = "SetUrl('" + siteDomain + ResolveUrl(documentUrl) + "');";
                }
            }
        }
    }
}
