using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.TreeEngine;
using CMS.WorkflowEngine;
using CMS.FileManager;

public partial class CMSDesk_MyDesk_recyclebin : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/MyDesk/RecycleBin/RecycleBin.gif";
        this.titleElem.TitleText = ResHelper.GetString("MyDesk.RecycleBinTitle");
        ugRecycleBin.GridView.GridLines = GridLines.Horizontal;
        ugRecycleBin.ImageDirectoryPath = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/MyDesk/RecycleBin/";

        object[,] parameters = new object[2, 3];
        parameters[0, 0] = "@UserID";
        parameters[0, 1] = CMSContext.CurrentUser.UserID;
        parameters[1, 0] = "@SiteID";
        parameters[1, 1] = CMSContext.CurrentSite.SiteID;

        ugRecycleBin.QueryParameters = parameters;

        ugRecycleBin.OnAction += new OnActionEventHandler(ugRecycleBin_OnAction);
        ugRecycleBin.HideControlForZeroRows = true;

        btnEmptyRecBin.Text = ResHelper.GetString("RecycleBin.EmptyRecycleBin");
        btnEmptyRecBin.Attributes.Add("onclick", "if(confirm('" + ResHelper.GetString("recyclebin.confirmemptyrecbin") + "')==false){return false;}" + ClientScript.GetPostBackEventReference(this.btnEmptyRecBin, null));


        string error = ValidationHelper.GetString(Request.QueryString["displayerror"], "");
        if (error != "")
        {
            this.lblError.Text = ResHelper.GetString("recyclebin.errorsomenotdestroyed");
        }

    }

    protected void btnEmptyRecBin_Click(System.Object sender, System.EventArgs e)
    {
        bool allDeleted = true;
        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
        VersionManager verMan = new VersionManager(tree);
        CMS.TreeEngine.TreeNode deletedNode = null;
        bool userHasGlobalDestroyPerm = CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Content", "Destroy");

        object[,] parameters = new object[2, 3];
        parameters[0, 0] = "@UserID";
        parameters[0, 1] = CMSContext.CurrentUser.UserID;
        parameters[1, 0] = "@SiteID";
        parameters[1, 1] = CMSContext.CurrentSite.SiteID;

        DataSet ds = tree.Connection.ExecuteQuery("cms.versionhistory.selectmyrecyclebin", parameters, null);
        // check permissions and destroy                            
        foreach (DataRow dr in ds.Tables[0].Rows)
        {
            deletedNode = verMan.GetVersion(Convert.ToInt32(dr["VersionHistoryId"]));
            string aliasPath = Convert.ToString(deletedNode.GetValue("NodeAliasPath"));
            int aclId = Convert.ToInt32(deletedNode.GetValue("NodeACLID"));
            string className = deletedNode.NodeClassName;

            // check permissions
            if (!((userHasGlobalDestroyPerm || CMSContext.CurrentUser.IsAuthorizedPerClassName(className, "Destroy") ||
                (TreeSecurityProvider.IsAuthorizedPerACL(aclId, NodePermissionsEnum.Destroy, CMSContext.CurrentUser) == AuthorizationResultEnum.Allowed))))
            {
                allDeleted = false;
            }
            else
            {
                // destroy
                verMan.DestroyDocumentHistory(Convert.ToInt32(dr["DocumentID"]));
            }
        }
        if (allDeleted == false)
        {
            Response.Redirect(Page.Request.Url.ToString() + "?displayerror=true");
        }
        else
        {
            Response.Redirect(Page.Request.Url.ToString());
        }
    }


    /// <summary>
    /// Handles the UniGrid's OnAction event.
    /// </summary>
    /// <param name="actionName">Name of item (button) that throws event.</param>
    /// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
    protected void ugRecycleBin_OnAction(string actionName, object actionArgument)
    {
        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
        VersionManager verMan = new VersionManager(tree);
        if (actionName == "restore")
        {
            int versionHistoryId = Convert.ToInt32(actionArgument);
            try
            {
                verMan.RestoreDocument(versionHistoryId);
            }
            catch (Exception ex)
            {
                this.lblError.Text = ex.Message;
            }
        }
        else if (actionName == "destroy")
        {
            int documentId = Convert.ToInt32(actionArgument);
            verMan.DestroyDocumentHistory(documentId);
        }
    }

}
