using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.SiteProvider;
using CMS.GlobalHelper;
using CMS.DataEngine;
using CMS.Ecommerce;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Ecommerce_Products_Product_Edit_Tax_Control : System.Web.UI.UserControl
{
    protected int productID = 0;

    /// <summary>
    /// Product ID
    /// </summary>
    public int ProductID
    {
        get
        {
            return productID;
        }
        set
        {
            productID = value;
        }
    }


    /// <summary>
    /// Form enabled
    /// </summary>
    public bool Enabled
    {
        get
        {
            return gridClasses.Enabled;
        }
        set
        {
            gridClasses.Enabled = value;
        }
    }


    protected void Page_Load(object sender, EventArgs e)
    {
        if (productID > 0)
        {
            lblSiteTitle.Text = ResHelper.GetString("Product_Edit_Tax.TaxTitle");
            gridClasses.Columns[0].HeaderText = ResHelper.GetString("Product_Edit_Tax.Select");
            gridClasses.Columns[1].HeaderText = ResHelper.GetString("Product_Edit_Tax.TaxName");

            if (!IsPostBack)
            {
                DataSet ds = TaxClassInfoProvider.GetTaxClasses(null, "TaxClassDisplayName");
                gridClasses.DataSource = ds;
                
                gridClasses.Columns[2].Visible = true;
                gridClasses.DataBind();
                gridClasses.Columns[2].Visible = false;
            }
        }

    }


    /// <summary>
    /// Databound, sets values to checkboxes
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void gvSites_DataBound(object sender, EventArgs e)
    {
        DataSet ds = TaxClassInfoProvider.GetSKUTaxClasses(productID);

        for (int i = 0; i < gridClasses.Rows.Count; i++)
        {
            CheckBox chBox = (CheckBox)gridClasses.Rows[i].FindControl("chkSelect");
            DataRow[] foundRows;
            string expression = "TaxClassID=" + gridClasses.Rows[i].Cells[2].Text;

            foundRows = ds.Tables[0].Select(expression);

            if (foundRows.Length != 0)
            {
                chBox.Checked = true;
            }
            else
            {
                chBox.Checked = false;
            }
        }
    }

    
    /// <summary>
    /// Updates tax classes for SKU
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public void Save()
    {
        // check 'EcommerceModify' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Ecommerce", "EcommerceModify"))
        {
            CMSDeskPage.RedirectToAccessDenied("CMS.Ecommerce", "EcommerceModify");
        }

        DataSet ds = TaxClassInfoProvider.GetTaxClasses();
        for (int i = 0; i < ds.Tables[0].Rows.Count; i++)
        {
            int taxClassId = Convert.ToInt32(gridClasses.Rows[i].Cells[2].Text);

            bool isChecked = ((CheckBox)gridClasses.Rows[i].FindControl("chkSelect")).Checked;

            // if checked
            if (isChecked)
            {
                TaxClassInfoProvider.AddTaxClassToSKU(taxClassId, productID);
            }
            // if not checked
            else
            {
                TaxClassInfoProvider.RemoveTaxClassFromSKU(taxClassId, productID);
            }
        }

        lblInfo.Visible = true;
        lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
    }
}
