using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.LicenseProvider;

public partial class CMSDesk_Tools_Forums_Forums_Forum_View : CMSDeskPage
{
    protected int forumId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (DataHelper.GetNotEmpty(UrlHelper.GetCurrentDomain(), "") != "")
        {
            LicenseHelper.CheckFeatureAndRedirect(UrlHelper.GetCurrentDomain(), FeatureEnum.Forums);
        }

        // check 'Read' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.forums", "Read"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.forums", "Read");
        }

        forumId = ValidationHelper.GetInteger(Request.QueryString["forumid"], 0);
        ForumFlatView1.ForumID = forumId;
        ForumFlatView1.CheckPermissions = false;
        ForumFlatView1.mForumProperties.EnablePicture = true;
        ForumFlatView1.mForumProperties.EnableSignature = true;
        ForumFlatView1.mForumProperties.MaxPictureHeight = 60;
        ForumFlatView1.mForumProperties.MaxPictureWidth = 50;
    }
}
