using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Forums;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Forums_Groups_Group_View : CMSDeskPage
{
    protected int groupId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // check 'Read' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.forums", "Read"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.forums", "Read");
        }

        groupId = ValidationHelper.GetInteger(Request.QueryString["groupid"], 0);
        ForumGroupInfo group = ForumGroupInfoProvider.GetForumGroupInfo(groupId);
        if (group != null)
        {
            Forum1.GroupName = Server.HtmlEncode(group.GroupName);
            Forum1.CheckPermissions = false;
            Forum1.DisplayOnlyOpen = false;
            Forum1.mForumProperties.EnablePicture = true;
            Forum1.mForumProperties.EnableSignature = true;
            Forum1.mForumProperties.MaxPictureHeight = 60;
            Forum1.mForumProperties.MaxPictureWidth = 50;
        }
    }
}
