using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Forums;
using CMS.SiteProvider;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Forums_Posts_ForumPost_View : CMSDeskPage
{
    protected int postId = 0;
    protected int forumId = 0;
    protected ForumPostInfo post = null;



    protected void Page_Load(object sender, EventArgs e)
    {
        // check 'Read' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.forums", "Read"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.forums", "Read");
        }

        ForumNewPost1.OnCancelClick += new EventHandler(ForumNewPost1_OnCancelClick);
        if (ValidationHelper.GetInteger(Request.QueryString["reply"], 0) != 0)
        {
            forumId = ValidationHelper.GetInteger(Request.QueryString["forumId"], 0);
            postId = ValidationHelper.GetInteger(Request.QueryString["postid"], 0);

            NewThreadTitle.TitleText = ResHelper.GetString("ForumPost_View.PostTitleText");
            NewThreadTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Forums/Posts/newthread.gif";

            pnlBody.Visible = false;

            PanelNewThread.Visible = true;
            //ForumNewPost1.Visible = true;
            ForumNewPost1.ReplyToPostID = postId;
            ForumNewPost1.ForumID = forumId;
            ForumNewPost1.OnInsertPost += new EventHandler(ForumNewPost1_OnInsertPost);
            ForumNewPost1.mForumProperties.EnablePicture = true;
            ForumNewPost1.mForumProperties.EnableSignature = true;
        }
        else
        {
            //New thread
            forumId = ValidationHelper.GetInteger(Request.QueryString["forumId"], 0);
            if (forumId != 0)
            {
                NewThreadTitle.TitleText = ResHelper.GetString("ForumPost_View.NewThreadHeaderCaption");
                NewThreadTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Forums/Posts/newthread.gif";

                pnlBody.Visible = false;

                PanelNewThread.Visible = true;
                //ForumNewPost1.Visible = true;
                ForumNewPost1.ForumID = forumId;
                ForumNewPost1.EnableCancel = false;
                ForumNewPost1.OnInsertPost += new EventHandler(ForumNewPost1_OnInsertPost);
                ForumNewPost1.mForumProperties.EnablePicture = true;
                ForumNewPost1.mForumProperties.EnableSignature = true;
            }
            else
            {
               


                // Selected post
                PostTitle.TitleText = ResHelper.GetString("ForumPost_View.PostTitleText");
                PostTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Forums/Posts/post.gif";

                postId = ValidationHelper.GetInteger(Request.QueryString["postid"], 0);
                post = ForumPostInfoProvider.GetForumPostInfo(postId);
                if (post == null)
                {
                    pnlMenu.Visible = false;
                    return;
                }

                ForumPost1.AllowReply = false;
                ForumPost1.EnableSubscription = false;

                ForumPost1.mForumProperties.EnablePicture = true;
                ForumPost1.mForumProperties.EnableSignature = true;

                bool canApprove = false;
                ForumInfo fi = ForumInfoProvider.GetForumInfo(post.PostForumID);
                if (fi != null)
                {
                    this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "ForumScripts",
                        ScriptHelper.GetScript(" function ReplyToPost(postId)\n" +
                "{    if (postId != 0){\n" +
                "location.href='ForumPost_View.aspx?postid=' + postId + '&reply=1&forumId=" + fi.ForumID + "' }}\n"));
                    
                    if (fi.ForumModerated)
                    {
                        canApprove = true;
                    }
                }

                //Create menu using inserted skmMenu control
                InitializeMenu(canApprove);

               
                    this.ltlScript.Text += ScriptHelper.GetScript(
                        "function DeletePost(postId) { if (confirm('" + ResHelper.GetString("ForumPost_View.DeleteConfirmation") + "')) { " + this.Page.ClientScript.GetPostBackEventReference(this.btnDelete, null) + "; } } \n" +
                        "function ApprovePost(postId) { " + this.Page.ClientScript.GetPostBackEventReference(this.btnApprove, null) + "; } \n"
                    );
                



                ForumPost1.PostID = postId;
            }
        }
    }


    void ForumNewPost1_OnCancelClick(object sender, EventArgs e)
    {
        HttpContext.Current.Response.Redirect("ForumPost_View.aspx?postid=" + postId);
    }

    /// <summary>
    /// On insert
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    void ForumNewPost1_OnInsertPost(object sender, EventArgs e)
    {
        ltlScript.Text += ScriptHelper.GetScript("parent.frames['posts_tree'].location.href = 'ForumPost_Tree.aspx?postid=" + ForumNewPost1.PostID.ToString() + "&forumid=" + forumId.ToString() + "';");
        ltlScript.Text += ScriptHelper.GetScript("parent.frames['posts_edit'].location.href = 'ForumPost_View.aspx?postid=" + ForumNewPost1.PostID.ToString() + "';");
        ForumNewPost1.AllowRedirect = false;
    }

    protected void InitializeMenu(bool showApprove)
    {
        string imagesUrl = ResolveUrl("~/App_Themes/" + this.Page.Theme + "/Images/CMSDesk/Tools/Forums/Posts/");
        CMS.skmMenuControl.MenuItem newItem = null;

        // Create the edit menu
        menuElem.Items.Clear();

        //initialize edit button in menu
        newItem = new CMS.skmMenuControl.MenuItem();
        newItem.ToolTip = ResHelper.GetString("ForumPost_View.EditToolTip");
        newItem.JavascriptCommand = "EditPost(" + postId.ToString() + ");";
        newItem.ImageAltText = newItem.ToolTip;
        newItem.Text = ResHelper.GetString("ForumPost_View.IconEdit");
        newItem.Image = imagesUrl + "edit.gif";
        newItem.MouseOverImage = newItem.Image;
        newItem.MouseOverCssClass = "MenuItemEditSmall";
        newItem.CssClass = "MenuItemEditSmall";
        menuElem.Items.Add(newItem);

        //initialize delete button in menu
        newItem = new CMS.skmMenuControl.MenuItem();
        newItem.ToolTip = ResHelper.GetString("ForumPost_View.DeleteToolTip");
        newItem.JavascriptCommand = "DeletePost(" + postId.ToString() + ");";
        newItem.ImageAltText = newItem.ToolTip;
        newItem.Text = ResHelper.GetString("ForumPost_View.IconDelete");
        newItem.Image = imagesUrl + "delete.gif";
        newItem.MouseOverImage = newItem.Image;
        newItem.MouseOverCssClass = "MenuItemEditSmall";
        newItem.CssClass = "MenuItemEditSmall";
        menuElem.Items.Add(newItem);

        //initialize reply button in menu
        newItem = new CMS.skmMenuControl.MenuItem();
        newItem.ToolTip = ResHelper.GetString("ForumPost_View.ReplyToolTip");
        newItem.JavascriptCommand = "ReplyToPost(" + postId.ToString() + ");";
        newItem.ImageAltText = newItem.ToolTip;
        newItem.Text = ResHelper.GetString("ForumPost_View.IconReply");
        newItem.Image = imagesUrl + "reply.gif";
        newItem.MouseOverImage = newItem.Image;
        newItem.MouseOverCssClass = "MenuItemEdit";
        newItem.CssClass = "MenuItemEdit";
        menuElem.Items.Add(newItem);

        if (showApprove)
        {
            newItem = new CMS.skmMenuControl.MenuItem();
            if (post.PostApprovedByUserID == 0)
            {
                //if post is not approved, show 'Approve' button
                newItem.ToolTip = ResHelper.GetString("ForumPost_View.ApproveToolTip");
                newItem.Text = ResHelper.GetString("ForumPost_View.IconApprove");
                newItem.Image = imagesUrl + "approve.gif";
            }
            else
            {
                //if post is not approved, show 'Reject' button
                newItem.ToolTip = ResHelper.GetString("ForumPost_View.RejectToolTip");
                newItem.Text = ResHelper.GetString("ForumPost_View.IconReject");
                newItem.Image = imagesUrl + "reject.gif";
            }
            newItem.JavascriptCommand = "ApprovePost(" + postId.ToString() + ");";
            newItem.ImageAltText = newItem.ToolTip;
            newItem.MouseOverImage = newItem.Image;
            newItem.MouseOverCssClass = "MenuItemEdit";
            newItem.CssClass = "MenuItemEdit";
            menuElem.Items.Add(newItem);
        }

        this.menuElem.Layout = CMS.skmMenuControl.MenuLayout.Horizontal;
    }

    /// <summary>
    /// This function is executed by callback iniciated by 'Delete' button in menu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnDelete_Click(object sender, EventArgs e)
    {
        // check 'Read' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.forums", "Modify"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.forums", "Modify");
        }

        ForumPostInfoProvider.DeleteForumPostInfo(postId);

        if (post.PostParentID == 0)
        {
            //reload post edit frames with actual data
            ltlScript.Text += ScriptHelper.GetScript("parent.frames['posts_tree'].location.href = 'ForumPost_Tree.aspx?forumid=" + post.PostForumID + "';");
            ltlScript.Text += ScriptHelper.GetScript("parent.frames['posts_edit'].location.href = 'ForumPost_View.aspx?forumid=" + post.PostForumID + "';");
        }
        else
        {
            //reload post edit frames with actual data
            ltlScript.Text += ScriptHelper.GetScript("parent.frames['posts_tree'].location.href = 'ForumPost_Tree.aspx?postid=" + post.PostParentID.ToString() + "&forumid=" + post.PostForumID + "';");
            ltlScript.Text += ScriptHelper.GetScript("parent.frames['posts_edit'].location.href = 'ForumPost_View.aspx?postid=" + post.PostParentID.ToString() + "';");
        }
    }

    /// <summary>
    /// This function is executed by callback iniciated by 'Approve' button in menu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnApprove_Click(object sender, EventArgs e)
    {
        // check 'Read' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.forums", "Modify"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.forums", "Modify");
        }

        //if post is approved
        if (post.PostApprovedByUserID > 0)
        {
            //reject post
            post.PostApprovedByUserID = 0;
            ForumPostInfoProvider.SetForumPostInfo(post);
            ltlScript.Text += ScriptHelper.GetScript("parent.frames['posts_tree'].location.href = 'ForumPost_Tree.aspx?postid=" + post.PostId.ToString() + "&forumid=" + post.PostForumID + "';");
            ltlScript.Text += ScriptHelper.GetScript("parent.frames['posts_edit'].location.href = 'ForumPost_View.aspx?postid=" + postId.ToString() + "';");
        }
        else
        {
            //approve post
            if (CMSContext.CurrentUser != null)
            {
                post.PostApprovedByUserID = CMSContext.CurrentUser.UserID;
                ForumPostInfoProvider.SetForumPostInfo(post);
                ltlScript.Text += ScriptHelper.GetScript("parent.frames['posts_tree'].location.href = 'ForumPost_Tree.aspx?postid=" + post.PostId.ToString() + "&forumid=" + post.PostForumID + "';");
                ltlScript.Text += ScriptHelper.GetScript("parent.frames['posts_edit'].location.href = 'ForumPost_View.aspx?postid=" + postId.ToString() + "';");
            }
        }
    }
}
