using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.Newsletter;
using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.Controls;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Newsletters_Newsletters_Newsletter_ContentEditorHeader : System.Web.UI.UserControl
{
    private int mIssueID = 0;
    
    /// <summary>
    /// Issue ID
    /// </summary>
    public int IssueID
    {
        get
        {
            return mIssueID;
        }
        set
        {
            mIssueID = value;
        }
    }


    protected void Page_Load(object sender, EventArgs e)
    {
        this.btnInsertField.Attributes.Add("onMouseOver", "RememberFocusedRegion()");
        this.btnInsertField.Attributes.Add("onClick", "InsertHTML('{%' + document.getElementById('" + this.lstInsertField.ClientID + "').value +  '%}'); return false;");

        btnInsertField.Text = ResHelper.GetString("NewsletterTemplate_Edit.Insert");
        lblInsertField.Text = ResHelper.GetString("NewsletterTemplate_Edit.TemplateInsertFieldLabel");
        lblSubject.Text = ResHelper.GetString("NewsletterTemplate_Edit.Subject");
        rfvSubject.ErrorMessage = ResHelper.GetString("NewsletterContentEditor.SubjectRequired");
        txtSubject.Focus();

        Issue issue = null;
        if (IssueID > 0)
        {
            issue = IssueProvider.GetIssue(IssueID);
        }


        if (!IsPostBack)
        {
            FillFieldsList();
            if (issue != null)
            {
                txtSubject.Text = issue.IssueSubject;
            }
        }

        //if item in list is selected, it gets focus => we must remember id of last focused editable region
        lstInsertField.Attributes.Add("onMouseOver", "RememberFocusedRegion()");
    }


    /// <summary>
    /// Fills list of available fields
    /// </summary>
    protected void FillFieldsList()
    {
        ListItem newItem = new ListItem(ResHelper.GetString("NewsletterTemplate.MacroEmail"), IssueHelper.MacroEmail);
        lstInsertField.Items.Add(newItem);
        newItem = new ListItem(ResHelper.GetString("NewsletterTemplate.MacroFirstName"), IssueHelper.MacroFirstName);
        lstInsertField.Items.Add(newItem);
        newItem = new ListItem(ResHelper.GetString("NewsletterTemplate.MacroLastName"), IssueHelper.MacroLastName);
        lstInsertField.Items.Add(newItem);
        newItem = new ListItem(ResHelper.GetString("NewsletterTemplate.MacroUnsubscribeLink"), IssueHelper.MacroUnsubscribeLink);
        lstInsertField.Items.Add(newItem);
    }


    /// <summary>
    /// Saves the content to the specified issue
    /// </summary>
    /// <param name="issue">Issue data</param>
    public string SaveContent(Issue issue)
    {
        string result = new Validator().NotEmpty(txtSubject.Text, ResHelper.GetString("NewsletterContentEditor.SubjectRequired")).Result;
        if (result == "")
        {
            issue.IssueSubject = txtSubject.Text;
        }
        return result;
    }

}
