using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;

using CMS.GlobalHelper;
using CMS.DataEngine;
using CMS.SiteProvider;
using CMS.Newsletter;
using CMS.CMSHelper;
using CMS.FormEngine;

public partial class CMSDesk_Tools_Newsletters_Subscribers_Subscriber_General : CMSDeskPage
{
    protected int subscriberId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {

        formCustomFields.OnAfterValidate += new DataForm.OnAfterValidateEventHandler(formCustomFields_OnAfterValidate);
        formCustomFields.OnAfterSave += new DataForm.OnAfterSaveEventHandler(formCustomFields_OnAfterSave);

        // get subscriber id from querystring
        if ((Request.QueryString["subscriberid"] != null) && (Request.QueryString["subscriberid"] != ""))
        {
            subscriberId = Convert.ToInt32(Request.QueryString["subscriberid"]);
            // fill editing form
            if (!IsPostBack)
            {
                Subscriber subscriberObj = SubscriberProvider.GetSubscriber(subscriberId);
                if (subscriberObj == null)
                {
                    Response.Redirect("Subscriber_New.aspx");
                }
                formCustomFields.ItemID = subscriberObj.SubscriberID;

                // show that the subscriber was created or updated successfully
                if (Request.QueryString["saved"] == "1")
                {
                    lblInfo.Visible = true;
                    lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
                }
            }
        }
    }


    protected override void Render(HtmlTextWriter writer)
    {
        formCustomFields.BasicForm.SubmitButton.Width= 100;
        base.Render(writer);
        
    }

    void formCustomFields_OnAfterSave()
    {
        lblInfo.Visible = true;
        lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
    }

    void formCustomFields_OnAfterValidate()
    {
        Control ctrl = formCustomFields.BasicForm.FindControl("SubscriberEmail");
        if ((ctrl != null) && (ctrl is TextBox))
        {
            string mail = ((TextBox)ctrl).Text;
            
            Subscriber subscriberObj = SubscriberProvider.GetSubscriber(subscriberId);

            if (subscriberObj != null)
            {

                if ((subscriberObj.SubscriberEmail.ToLower() != mail.ToLower().Trim())&&(SubscriberProvider.emailExists(mail.Trim())))
                {
                    lblError.Visible = true;
                    lblError.Text = ResHelper.GetString("Subscriber_Edit.EmailAlreadyExists");
                    formCustomFields.BasicForm.StopProcessing = true;
                }
            }
            else
            {
                formCustomFields.BasicForm.StopProcessing = true;
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("Subscriber_Edit.SubscriberDoesNotExists");
            }
        }
    }
 
}