<%@ Control Language="C#" AutoEventWireup="true" CodeFile="MyAddresses.ascx.cs" Inherits="CMSEcommerce_MyAddresses" %>
<%@ Register Src="~/CMSFormControls/CountrySelector.ascx" TagName="CountrySelector"
    TagPrefix="uc1" %>
<div>
    <asp:Label ID="lblError" runat="server" Visible="false" EnableViewState="false" Style="color: Red" />
    <%--Address list--%>
    <asp:PlaceHolder runat="server" ID="plhList">
        <div style="margin-bottom: 15px">
            <asp:LinkButton ID="btnNew" runat="server" OnClick="btnNew_OnClick" /></div>
        <asp:GridView ID="gridAddresses" runat="server" AutoGenerateColumns="false" CellPadding="3"
            GridLines="Horizontal" DataKeyNames="AddressID" OnRowCommand="gridAddresses_RowCommand"
            OnRowDataBound="gridAddresses_RowDataBound" Width="100%">
            <HeaderStyle HorizontalAlign="Left" CssClass="UniGridHead" />
            <Columns>
                <asp:TemplateField>
                    <ItemStyle Wrap="false" />
                    <ItemTemplate>
                        <asp:LinkButton runat="server" ID="btnEdit" CommandArgument='<%# Eval("AddressID") %>'
                            CommandName="Change" />&nbsp;
                        <asp:LinkButton runat="server" ID="btnDelete" CommandArgument='<%# Eval("AddressID") %>'
                            CommandName="Del" />
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:BoundField DataField="AddressName">
                    <ItemStyle Wrap="false" Width="100%" />
                </asp:BoundField>
            </Columns>
        </asp:GridView>
    </asp:PlaceHolder>
    <%--Address edit--%>
    <asp:PlaceHolder runat="server" ID="plhEdit" Visible="false">
    <asp:Panel ID="pnlAddressEdit" runat="server" DefaultButton="btnOK">
        <div style="margin-bottom: 15px">
            <asp:LinkButton ID="btnList" runat="server" OnClick="btnList_OnClick" />&nbsp;
            <asp:Label ID="lblAddress" runat="server" />
        </div>
        <asp:Label runat="server" ID="lblInfo" EnableViewState="false" Visible="false" />
        <table style="vertical-align: top">
            <tr>
                <td>
                    <asp:Label runat="server" ID="lblPersonalName" EnableViewState="false" />
                </td>
                <td>
                    <asp:TextBox ID="txtPersonalName" runat="server" MaxLength="200" CssClass="TextBoxField" />
                </td>
                <td>
                    <asp:RequiredFieldValidator ID="rqvPersonalName" runat="server" ControlToValidate="txtPersonalName"
                        ValidationGroup="Address" />
                </td>
            </tr>
            <tr>
                <td class="FieldLabel" valign="top">
                    <asp:Label runat="server" ID="lblAddressLine1" EnableViewState="false" /></td>
                <td>
                    <table border="0" cellpadding="0" cellspacing="0">
                        <tr>
                            <td>
                                <asp:TextBox ID="txtAddressLine1" runat="server" MaxLength="100" CssClass="TextBoxField" />
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <asp:TextBox ID="txtAddressLine2" runat="server" MaxLength="100" CssClass="TextBoxField" />
                            </td>
                        </tr>
                    </table>
                </td>
                <td valign="top">
                    <asp:RequiredFieldValidator ID="rqvLine" runat="server" ControlToValidate="txtAddressLine1"
                        ValidationGroup="Address" /></td>
            </tr>
            <tr>
                <td class="FieldLabel">
                    <asp:Label runat="server" ID="lblAddressCity" EnableViewState="false" /></td>
                <td>
                    <asp:TextBox ID="txtAddressCity" runat="server" MaxLength="100" CssClass="TextBoxField" /></td>
                <td>
                    <asp:RequiredFieldValidator ID="rqvCity" runat="server" ControlToValidate="txtAddressCity"
                        ValidationGroup="Address" /></td>
            </tr>
            <tr>
                <td class="FieldLabel">
                    <asp:Label runat="server" ID="lblAddressZip" EnableViewState="false" /></td>
                <td>
                    <asp:TextBox ID="txtAddressZip" runat="server" MaxLength="20" CssClass="TextBoxField" /></td>
                <td>
                    <asp:RequiredFieldValidator ID="rqvZipCode" runat="server" ValidationGroup="Address"
                        ControlToValidate="txtAddressZip" Display="Dynamic" />
                </td>
            </tr>
            <tr>
                <td class="FieldLabel">
                    <asp:Label runat="server" ID="lblAddressCountry" EnableViewState="false" />
                </td>
                <td>
                    <uc1:CountrySelector ID="ucCountrySelector" runat="server" UseCodeNameForSelection="false" />
                </td>
                <td>
                    &nbsp;</td>
            </tr>
            <tr>
                <td class="FieldLabel">
                    <asp:Label runat="server" ID="lblAddressDeliveryPhone" EnableViewState="false" /></td>
                <td>
                    <asp:TextBox ID="txtAddressDeliveryPhone" runat="server" MaxLength="100" CssClass="TextBoxField" /></td>
                <td>
                    &nbsp;</td>
            </tr>
            <tr>
                <td>
                </td>
                <td>
                    <br />
                    <asp:Button runat="server" ID="btnOK" OnClick="btnOK_OnClick" EnableViewState="false"
                        ValidationGroup="Address" CssClass="ContentButton" /></td>
                <td>
                    &nbsp;</td>
            </tr>
        </table>
    </asp:Panel>
    </asp:PlaceHolder>
</div>
