using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.DataEngine;
using CMS.SiteProvider;
using CMS.Ecommerce;
using CMS.CMSHelper;
using CMS.TreeEngine;

public partial class CMSFormControls_NewProduct : CMS.FormEngine.FormEngineUserControl
{
    private string mProductName = "";     
    private double mProductWeight = 0;
    private double mProductHeight = 0;
    private double mProductWidth = 0;
    private double mProductDepth = 0;
    private string mProductImagePath = "";
    private string mProductDescription = "";
    private double mProductPrice = 0; 
    
    private int mProductId = 0;
    private int mNodeId = 0;
    private bool mShowOkButton = true;


    #region "Public properties"

    /// <summary>
    /// True if the OK button is enabled
    /// </summary>
    public bool ButtonEnabled
    {
        get { return btnOK.Enabled; }
        set 
        {
            btnOK.Enabled = value;
        }
    }


    /// <summary>
    /// Product name
    /// </summary>
    public string ProductName
    {
        get { return mProductName; }
        set { mProductName = value; }
    }


    /// <summary>
    /// Product price
    /// </summary>
    public double ProductPrice
    {
        get { return mProductPrice; }
        set { mProductPrice = value; }
    }

    /// <summary>
    /// Product weight
    /// </summary>
    public double ProductWeight
    {
        get { return mProductWeight; }
        set { mProductWeight = value; }
    }

    /// <summary>
    /// Product height
    /// </summary>
    public double ProductHeight
    {
        get { return mProductHeight; }
        set { mProductHeight = value; }
    }

    /// <summary>
    /// Product width
    /// </summary>
    public double ProductWidth
    {
        get { return mProductWidth; }
        set { mProductWidth = value; }
    }

    /// <summary>
    /// Product depth
    /// </summary>
    public double ProductDepth
    {
        get { return mProductDepth; }
        set { mProductDepth = value; }
    }

    /// <summary>
    /// Product image path
    /// </summary>
    public string ProductImagePath
    {
        get { return mProductImagePath; }
        set { mProductImagePath = value; }
    }

    /// <summary>
    /// Product description
    /// </summary>
    public string ProductDescription
    {
        get { return mProductDescription; }
        set { mProductDescription = value; }
    }

    /// <summary>
    /// ProductID
    /// </summary>
    public int ProductID
    {
        get { return mProductId; }
        set { mProductId = value; }
    }

    /// <summary>
    /// NodeID
    /// </summary>
    public int NodeID
    {
        get { return mNodeId; }
        set { mNodeId = value; }
    }

    /// <summary>
    /// Show OK button.
    /// </summary>
    public bool ShowOkButton
    {
        get { return mShowOkButton; }
        set { mShowOkButton = value; }
    }


    /// <summary>
    /// Indicates whether form is enabled or not.
    /// </summary>
    public bool FormEnabled
    {
        get 
        {
            return ValidationHelper.GetBoolean(ViewState["FormEnabled"], true);  
        }
        set
        {
            this.txtSKUAvailableInDays.Enabled = value;
            fckTemplateBody.Enabled = value;
            //this.txtSKUDescription.Enabled = value;
            this.txtSKUName.Enabled = value;
            this.txtSKUNumber.Enabled = value;
            this.txtSKUPrice.Enabled = value;
            this.chkSKUEnabled.Enabled = value;
            this.drpSKUDepartmentID.Enabled = value;
            this.drpSKUInternalStatusID.Enabled = value;
            this.drpSKUManufacturerID.Enabled = value;
            this.drpSKUPublicStatusID.Enabled = value;
            this.drpSKUSupplierID.Enabled = value;            
            this.imgSelect.Enabled = false;
            this.txtSKUWeight.Enabled = value;
            this.txtSKUHeight.Enabled = value;
            this.txtSKUWidth.Enabled = value;
            this.txtSKUDepth.Enabled = value;
            
            ViewState["FormEnabled"] = value;
        }
    }

    #endregion


    protected void Page_Load(object sender, EventArgs e)
    {


        fckTemplateBody.BasePath = "~/CMSAdminControls/FCKeditor/";
        fckTemplateBody.AutoDetectLanguage = false;
        fckTemplateBody.DefaultLanguage = System.Threading.Thread.CurrentThread.CurrentCulture.TwoLetterISOLanguageName;
        fckTemplateBody.EditorAreaCSS = "";
        fckTemplateBody.ToolbarSet = "Basic";

        // control initializations				
        lblSKUInternalStatusID.Text = ResHelper.GetString("com_SKU_edit_general.SKUInternalStatusIDLabel");
        lblSKUDepartmentID.Text = ResHelper.GetString("com_SKU_edit_general.SKUDepartmentIDLabel");
        lblSKUManufacturerID.Text = ResHelper.GetString("com_SKU_edit_general.SKUManufacturerIDLabel");
        lblSKUDescription.Text = ResHelper.GetString("com_SKU_edit_general.SKUDescriptionLabel");
        lblSKUName.Text = ResHelper.GetString("com_SKU_edit_general.SKUNameLabel");
        lblSKUNumber.Text = ResHelper.GetString("com_SKU_edit_general.SKUNumberLabel");
        lblSKUEnabled.Text = ResHelper.GetString("com_SKU_edit_general.SKUEnabledLabel");
        lblSKUAvailableInDays.Text = ResHelper.GetString("com_SKU_edit_general.SKUAvailableInDaysLabel");
        lblSKUPublicStatusID.Text = ResHelper.GetString("com_SKU_edit_general.SKUPublicStatusIDLabel");
        lblSKUSupplierID.Text = ResHelper.GetString("com_SKU_edit_general.SKUSupplierIDLabel");
        lblSKUPrice.Text = ResHelper.GetString("com_SKU_edit_general.SKUPriceLabel");
        lblSKUImagePath.Text = ResHelper.GetString("NewProduct.lblSKUImagePath");
        lblSKUWeight.Text = ResHelper.GetString("NewProduct.lblSKUWeight");
        lblSKUHeight.Text = ResHelper.GetString("NewProduct.lblSKUHeight");
        lblSKUWidth.Text = ResHelper.GetString("NewProduct.lblSKUWidth");
        lblSKUDepth.Text = ResHelper.GetString("NewProduct.lblSKUDepth");

        rfvSKUName.ErrorMessage = ResHelper.GetString("com_SKU_edit_general.NameError");
        rfvSKUPrice.ErrorMessage = ResHelper.GetString("com_SKU_edit_general.PriceError");
        //rfvSKUNumber.ErrorMessage = ResHelper.GetString("com_SKU_edit_general.NumberError");


        if (!mShowOkButton)
        {
            btnOK.Visible = false;
        }

        btnOK.Text = ResHelper.GetString("General.OK");
        
        if (!IsPostBack)
        {
            if (CMSContext.CurrentUser != null)
            {
                if (CMSContext.CurrentUser.IsGlobalAdministrator)
                {
                    drpSKUDepartmentID.DataSource = DepartmentInfoProvider.GetDepartments();
                }
                else
                {
                    drpSKUDepartmentID.DataSource = DepartmentInfoProvider.GetUserDepartments(CMSContext.CurrentUser.UserID);
                }
                drpSKUDepartmentID.DataBind();
            }

            drpSKUManufacturerID.DataSource = ManufacturerInfoProvider.GetAllManufacturers(StatusEnum.Enabled);
            drpSKUManufacturerID.DataBind();
            drpSKUManufacturerID.Items.Insert(0, new ListItem("", "0"));

            drpSKUSupplierID.DataSource = SupplierInfoProvider.GetAllSuppliers(StatusEnum.Enabled);
            drpSKUSupplierID.DataBind();
            drpSKUSupplierID.Items.Insert(0, new ListItem("", "0"));

            drpSKUPublicStatusID.DataSource = PublicStatusInfoProvider.GetStatuses(StatusEnum.Enabled);
            drpSKUPublicStatusID.DataBind();
            drpSKUPublicStatusID.Items.Insert(0, new ListItem("", "0"));

            drpSKUInternalStatusID.DataSource = InternalStatusInfoProvider.GetStatuses(StatusEnum.Enabled);
            drpSKUInternalStatusID.DataBind();
            drpSKUInternalStatusID.Items.Insert(0, new ListItem("", "0"));

             
            if (mProductId > 0)
            {
                SKUInfo su = SKUInfoProvider.GetSKUInfo(mProductId);
                if (su != null)
                {
                    LoadData(su);

                    if (ValidationHelper.GetString(Request.QueryString["saved"], "") == "1")
                    {
                        lblInfo.Visible = true;
                        lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
                    }
                }
            }
        }

        
    }

    /// <summary>
    /// Load data of editing ecommerceEcommerce.
    /// </summary>
    /// <param name="skuiObj">EcommerceEcommerce object.</param>
    protected void LoadData(SKUInfo skuiObj)
    {
        //// load values
        txtSKUNumber.Text = skuiObj.SKUNumber;
        txtSKUName.Text = skuiObj.SKUName;
        fckTemplateBody.ResolvedValue = skuiObj.SKUDescription;
        //txtSKUDescription.Text = skuiObj.SKUDescription;
        txtSKUPrice.Text = Convert.ToString(skuiObj.SKUPrice);
        chkSKUEnabled.Checked = skuiObj.SKUEnabled;
        txtSKUAvailableInDays.Text = Convert.ToString(skuiObj.SKUAvailableInDays);        
        imgSelect.Value = skuiObj.SKUImagePath;
        txtSKUWeight.Text = (skuiObj.SKUWeight > 0) ? skuiObj.SKUWeight.ToString() : "";
        txtSKUWidth.Text = (skuiObj.SKUWidth > 0) ? skuiObj.SKUWidth.ToString() : "";
        txtSKUHeight.Text = (skuiObj.SKUHeight > 0) ? skuiObj.SKUHeight.ToString() : "";
        txtSKUDepth.Text = (skuiObj.SKUDepth > 0) ? skuiObj.SKUDepth.ToString() : "";

        if (skuiObj.SKUDepartmentID != 0)
        {
            ListItem li = drpSKUDepartmentID.Items.FindByValue(skuiObj.SKUDepartmentID.ToString());
            if (li != null)
            {
                li.Selected = true;
            }
        }
        if (skuiObj.SKUInternalStatusID != 0)
        {
            ListItem li = drpSKUInternalStatusID.Items.FindByValue(skuiObj.SKUInternalStatusID.ToString());
            if (li != null)
            {
                li.Selected = true;
            }
        }
        if (skuiObj.SKUManufacturerID != 0)
        {
            ListItem li = drpSKUManufacturerID.Items.FindByValue(skuiObj.SKUManufacturerID.ToString());
            if (li != null)
            {
                li.Selected = true;
            }
        }
        if (skuiObj.SKUPublicStatusID != 0)
        {
            ListItem li = drpSKUPublicStatusID.Items.FindByValue(skuiObj.SKUPublicStatusID.ToString());
            if (li != null)
            {
                li.Selected = true;
            }
        }
        if (skuiObj.SKUSupplierID != 0)
        {
            ListItem li = drpSKUSupplierID.Items.FindByValue(skuiObj.SKUSupplierID.ToString());
            if (li != null)
            {
                li.Selected = true;
            }
        }
    }

    /// <summary>
    /// Action when button is clicked
    /// </summary>
    public int OnBtnOkClick()
    {
        btnOK.CausesValidation = FormEnabled;

        string errorMessage = new Validator().NotEmpty(txtSKUName.Text, rfvSKUName.ErrorMessage).NotEmpty(txtSKUPrice.Text, rfvSKUPrice.ErrorMessage).Result;
        string temp = "";

        if (errorMessage == "")
        {

            // Get SKUInfo
            SKUInfo skuiObj = SKUInfoProvider.GetSKUInfo(mProductId);

            if (skuiObj == null)
            {
                // create new item -> insert
                skuiObj = new SKUInfo();

            }
            
            if (txtSKUAvailableInDays.Text == "" || ValidationHelper.IsInteger(txtSKUAvailableInDays.Text))
            {
                if (txtSKUAvailableInDays.Text != "")
                {
                    skuiObj.SKUAvailableInDays = ValidationHelper.GetInteger(txtSKUAvailableInDays.Text.Trim(),0);
                }
            }
            else
            {
                lblError.Text = ResHelper.GetString("com_SKU_edit_general.DaysErrorFormat");
                lblError.Visible = true;
                return 0;
            }


            if (drpSKUDepartmentID.SelectedIndex == -1)
            {
                lblError.Text = ResHelper.GetString("com_SKU_edit_general.EmptyDepartment");
                lblError.Visible = true;
                return 0;
            }
            
            temp = txtSKUPrice.Text.Trim();
            skuiObj.SKUPrice = ValidationHelper.GetDouble(temp, 0);
            if ((skuiObj.SKUPrice == 0) || (!ValidationHelper.IsPositiveNumber(temp)))            
            {
                lblError.Text = ResHelper.GetString("com_SKU_edit_general.PriceErrorFormat");
                lblError.Visible = true;
                return 0;
            }

            temp = txtSKUWeight.Text.Trim();
            skuiObj.SKUWeight = ValidationHelper.GetDouble(temp, 0);
            if (temp != "")
            {
                if ((skuiObj.SKUWeight == 0) || (!ValidationHelper.IsPositiveNumber(temp)))
                {
                    lblError.Text = ResHelper.GetString("NewProduct.WeightWrongFormat");
                    lblError.Visible = true;
                    return 0;
                }
            }


            temp = txtSKUHeight.Text.Trim();            
            skuiObj.SKUHeight = ValidationHelper.GetDouble(temp, 0);
            if (temp != "")
            {
                if ((skuiObj.SKUHeight == 0) || (!ValidationHelper.IsPositiveNumber(temp)))
                {
                    lblError.Text = ResHelper.GetString("NewProduct.HeightWrongFormat");
                    lblError.Visible = true;
                    return 0;
                }
            }


            temp = txtSKUWidth.Text.Trim();
            skuiObj.SKUWidth = ValidationHelper.GetDouble(temp, 0);
            if (temp != "")
            {
                if ((skuiObj.SKUWidth == 0) || (!ValidationHelper.IsPositiveNumber(temp)))
                {
                    lblError.Text = ResHelper.GetString("NewProduct.WidthWrongFormat");
                    lblError.Visible = true;
                    return 0;
                }
            }


            temp = txtSKUDepth.Text.Trim();
            skuiObj.SKUDepth = ValidationHelper.GetDouble(temp, 0);
            if (temp != "")
            {
                if ((skuiObj.SKUDepth == 0) || (!ValidationHelper.IsPositiveNumber(temp)))
                {
                    lblError.Text = ResHelper.GetString("NewProduct.DepthWrongFormat");
                    lblError.Visible = true;
                    return 0;
                }
            }

            skuiObj.SKUName = txtSKUName.Text.Trim();
            skuiObj.SKUNumber = txtSKUNumber.Text.Trim();
            skuiObj.SKUDescription = fckTemplateBody.ResolvedValue; //txtSKUDescription.Text.Trim();
            skuiObj.SKUEnabled = chkSKUEnabled.Checked;
            skuiObj.SKUInternalStatusID = ValidationHelper.GetInteger(drpSKUInternalStatusID.SelectedValue, 0);
            skuiObj.SKUDepartmentID = ValidationHelper.GetInteger(drpSKUDepartmentID.SelectedValue, 0);
            skuiObj.SKUManufacturerID = ValidationHelper.GetInteger(drpSKUManufacturerID.SelectedValue, 0);
            skuiObj.SKUPublicStatusID = ValidationHelper.GetInteger(drpSKUPublicStatusID.SelectedValue, 0);
            skuiObj.SKUSupplierID = ValidationHelper.GetInteger(drpSKUSupplierID.SelectedValue, 0);
            skuiObj.SKUImagePath = imgSelect.Value;

            SKUInfoProvider.SetSKUInfo(skuiObj);

            if ((mNodeId > 0) && (mProductId == 0))
            {
                TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
                CMS.TreeEngine.TreeNode node = tree.SelectSingleNode(mNodeId, TreeProvider.ALL_CULTURES);
                node.NodeSKUID = skuiObj.SKUID;
                node.Update();
                // Ensure new SKU values
                SKUInfoProvider.SetSKUInfo(skuiObj);
            }

            return ValidationHelper.GetInteger(skuiObj.SKUID, 0);
        }
        else
        {
            lblError.Visible = true;
            lblError.Text = errorMessage;
        }

        return 0;
        
    }


    public event EventHandler OnOkClickHandler;

    protected void btnOK_Click(object sender, EventArgs e)
    {
        // Update data only if the form is enabled
        if (FormEnabled)
        {
            this.ProductID = OnBtnOkClick();
        }

        if (this.ProductID > 0)
        {
            if (OnOkClickHandler != null)
            {
                OnOkClickHandler(this, null);
            }
        }
    }


    /// <summary>
    /// Sets values to the form fields.
    /// </summary>
    public void SetValues()
    {
        txtSKUName.Text = mProductName;
        txtSKUHeight.Text = (mProductHeight > 0) ? mProductHeight.ToString() : "";
        txtSKUWeight.Text = (mProductWeight > 0) ? mProductWeight.ToString() : "";
        txtSKUWidth.Text = (mProductWidth > 0) ? mProductWidth.ToString() : "";
        txtSKUDepth.Text = (mProductDepth > 0) ? mProductDepth.ToString() : "";
        txtSKUPrice.Text = (mProductPrice > 0) ? mProductPrice.ToString() : "";
        fckTemplateBody.ResolvedValue = mProductDescription;
        //txtSKUDescription.Text = mProductDescription;
        imgSelect.Value = mProductImagePath;
    }
}
