using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.SiteProvider;
using CMS.DataEngine;
using CMS.SettingsProvider;

public partial class CMSFormControls_RoleSelector : CMS.FormEngine.FormEngineUserControl, System.Web.UI.ICallbackEventHandler
{
    private string mCallbackArg;

    #region CallBackHandling

    public void RaiseCallbackEvent(string eventArgument)
    {
        mCallbackArg = eventArgument;
    }


    private string Validate(string[] values)
    {
        return "";
    }


    public string GetCallbackResult()
    {
        return Validate(mCallbackArg.Split(';'));
    }

    #endregion

    protected void Page_Load(object sender, EventArgs e)
    {
        // Initialize callback for role names validation
        string argument = "document.getElementById('" + txtRoles.ClientID + "').value";
        string clientCallback = "CheckRoleNames";
        string CallbackRef = Page.ClientScript.GetCallbackEventReference(this, argument, clientCallback, "'" + lblStatus.ClientID + "'");
        txtRoles.Attributes["onchange"] = String.Format("javascript:{0}", CallbackRef);
                
        // Initialize select button
        btnSelect.Text = ResHelper.GetString("FormControls_RoleSelection.btnSelect");
        btnSelect.OnClientClick = "ShowDialog('" + txtRoles.ClientID + "','" + lblStatus.ClientID + "'); return false;";

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "SelectRoles", ScriptHelper.GetScript("function  ShowDialog(txtClientID, lblClientID){modalDialog('" + ResolveUrl("~/CMSWebParts/Designers/RoleCheckboxSelection.aspx") + "?lblElem=' + lblClientID + '&txtElem=' + txtClientID + '&names=' + document.getElementById(txtClientID).value,'RoleNameSelection', 400, 440); return false;}" +
                                                                                                                    "function SetRolesToTextBox(roleNames,txtClientID,lblClientID){if((txtClientID != '')&&(lblClientID!= '')) { document.getElementById(txtClientID).value = roleNames; document.getElementById(lblClientID).innerHTML='';} return false;}" +                                                                                                                    
                                                                                                                    "function CheckRoleNames(result, context){document.getElementById(context).innerHTML = result; return false; }"));        
    }

    ///<summary>Gets or sets field value.</summary>
    public override object Value
    {
        get
        {
            return this.txtRoles.Text;
        }
        set
        {
            this.txtRoles.Text = (string)value;
        }
    }


    /// <summary>
    /// Return TRUE if 'RoleSelection' control value is valid.
    /// </summary>
    /// <returns></returns>
    public override bool IsValid()
    {
        string validationResult = Validate(txtRoles.Text.Split(';'));
        if (validationResult == "")
        {
            return true;
        }
        else
        {
            this.ValidationError = validationResult;
            return false;
        }
    }
}
