using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.SiteProvider;
using CMS.DataEngine;
using CMS.SettingsProvider;

public partial class CMSFormControls_selectclassnames : CMS.FormEngine.FormEngineUserControl, System.Web.UI.ICallbackEventHandler
{
    private string _callbackArg;

    #region CallBackHandling

    public void RaiseCallbackEvent(string eventArgument)
    {
        _callbackArg = eventArgument;
    }


    private string Validate(string[] values)
    {
        foreach (string className in values)
        {
            if (className != string.Empty)
            {
                DataClassInfo di = DataClassInfoProvider.GetDataClass(className);
                if ((di == null) && (values.Length>0))
                {
                    return ResHelper.GetString("FormControls_SelectClassNames.NotExist").Replace("%%code%%", className);
                }
            }
        }
        return string.Empty;
    }


    public string GetCallbackResult()
    {
        return Validate(_callbackArg.Split(';'));
    }

    #endregion

    protected void Page_Load(object sender, EventArgs e)
    {
        string argument = "document.getElementById('" + txtName.ClientID + "').value";
        string clientCallback = "CheckClassNames";
        string CallbackRef = Page.ClientScript.GetCallbackEventReference(this, argument, clientCallback, "'" + lblStatus.ClientID + "'");
        txtName.Attributes["onchange"] = String.Format("javascript:{0}", CallbackRef);
                
        btnSelect.Text = ResHelper.GetString("FormControls_SelectClassNames.btnSelect");
        btnSelect.OnClientClick = "SelectClassNamesDialog('" + txtName.ClientID + "','" + lblStatus.ClientID +"'); return false;";

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "SelectClassNames", ScriptHelper.GetScript("function  SelectClassNamesDialog(txtClientID, lblClientID){modalDialog('" + ResolveUrl("~/CMSWebParts/Designers/ClassNameSelection.aspx") + "?lblElem=' + lblClientID + '&txtElem=' + txtClientID + '&name=' + document.getElementById(txtClientID).value,'ClassNameSelection', 400, 440); return false;}" +
                                                                                                                    "function SelectClassNames(classNames,txtClientID,lblClientID){if((txtClientID != '')&&(lblClientID!= '')) { document.getElementById(txtClientID).value = classNames; document.getElementById(lblClientID).innerHTML='';} return false;}" +
                                                                                                                    "function CheckClassNames(result, context){document.getElementById(context).innerHTML = result; return false; }"));

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);  
    }

    ///<summary>Gets or sets field value.</summary>
    public override object Value
    {
        get
        {
            return this.txtName.Text;
        }
        set
        {
            this.txtName.Text = (string)value;
        }
    }


    /// <summary>
    /// Return true if user control is valid.
    /// </summary>
    /// <returns></returns>
    public override bool IsValid()
    {
        string ValidationResult = Validate(txtName.Text.Split(';'));
        if (ValidationResult == string.Empty)
        {
            return true;
        }
        else
        {
            this.ValidationError = ValidationResult;
            return false;
        }
    }
}
