using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.SiteProvider;
using CMS.DataEngine;
using CMS.SettingsProvider;

public partial class CMSFormControls_selecttransformation : CMS.FormEngine.FormEngineUserControl, System.Web.UI.ICallbackEventHandler
{
    private string _callbackArg;

    #region CallBackHandling

    public void RaiseCallbackEvent(string eventArgument)
    {
        _callbackArg = eventArgument;
    }


    private string Validate(string value, bool allowPreselect)
    {
        // transformation exists
        TransformationInfo ti = TransformationInfoProvider.GetTransformation(value);
        if (ti == null)
        {
            if (allowPreselect)
            {
                // transformation does not exist
                DataClassInfo di = DataClassInfoProvider.GetDataClass(value);
                if ((di == null) && (value != string.Empty))
                {
                    return ResHelper.GetString("FormControls_SelectTransformation.NotExist").Replace("%%code%%", value);
                }
                else
                {
                    return String.Empty;
                }
            }
            else
            {
                return ResHelper.GetString("FormControls_SelectTransformation.TransofrmationNotExist").Replace("%%code%%", value);
            }
        }

        return string.Empty;
    }


    public string GetCallbackResult()
    {
        return Validate(_callbackArg, true);
    }

    #endregion

    protected void Page_Load(object sender, EventArgs e)
    {
        bool isClassNames = true;
        string classNames = "";
        string javaScript = "";

        string argument = "document.getElementById('" + txtName.ClientID + "').value";
        string clientCallback = "CheckTransformation";
        string CallbackRef = Page.ClientScript.GetCallbackEventReference(this, argument, clientCallback, "'" + lblStatus.ClientID + "'");
        txtName.Attributes["onchange"] = String.Format("javascript:{0}", CallbackRef);

        try
        {
            classNames = this.DataDR["ClassNames"].ToString();
        }
        catch
        {
            isClassNames = false;
        }

        btnSelect.Text = ResHelper.GetString("FormControls_SelectTransformation.btnSelect");
        btnSelect.OnClientClick = "SelectTransformationDialog('" + txtName.ClientID + "','" + lblStatus.ClientID + "'); return false;";
        btnEdit.Text = ResHelper.GetString("formcontrols_selecttransformation.btnedit");
        btnEdit.OnClientClick = "EditTransformationDialog('" + txtName.ClientID + "','" + lblStatus.ClientID + "'); return false;";
        if (isClassNames && classNames != string.Empty)
        {
            string[] splitClassNames = classNames.Split(';');
            javaScript = "function  SelectTransformationDialog(txtClientID,lblClientID){modalDialog('" + ResolveUrl("~/CMSWebParts/Designers/TransformationSelection.aspx") + "?lblElem=' + lblClientID + '&txtElem=' + txtClientID + '&name=' + document.getElementById(txtClientID).value + '&classname=" + splitClassNames[0] + "','TransformationSelection', 400, 500); return false;}";
            //this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "SelectTransformationDialog", ScriptHelper.GetScript("function  SelectTransformationDialog(txtClientID){modalDialog('" + ResolveUrl("~/CMSWebParts/Designers/TransformationSelection.aspx") + "?txtElem=' + txtClientID + '&name=' + document.getElementById(txtClientID).value + '&classname=" + splitClassNames[0] + "','TransformationSelection', 500, 460); return false;}"));
        }
        else
        {
            javaScript = "function  SelectTransformationDialog(txtClientID,lblClientID){modalDialog('" + ResolveUrl("~/CMSWebParts/Designers/TransformationSelection.aspx") + "?lblElem=' + lblClientID + '&txtElem=' + txtClientID + '&name=' + document.getElementById(txtClientID).value,'TransformationSelection', 400, 500); return false;}";
            //this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "SelectTransformationDialog", ScriptHelper.GetScript("function  SelectTransformationDialog(txtClientID){modalDialog('" + ResolveUrl("~/CMSWebParts/Designers/TransformationSelection.aspx") + "?txtElem=' + txtClientID + '&name=' + document.getElementById(txtClientID).value,'TransformationSelection', 500, 460); return false;}"));
        }
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "SelectTransformation", ScriptHelper.GetScript(javaScript + "function SelectTransformation(transformationName,txtClientID,lblClientID){if((lblClientID != '') && (txtClientID != '')) { document.getElementById(txtClientID).value = transformationName;document.getElementById(lblClientID).innerHTML='';} return false;}" +
                                                                                                                                     "function CheckTransformation(result, context){document.getElementById(context).innerHTML = result; return false; }"));
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "EditTransformation", ScriptHelper.GetScript("function  EditTransformationDialog(txtClientID){modalDialog('" + ResolveUrl("~/CMSSiteManager/Development/DocumentTypes/DocumentType_Edit_Transformation_Edit.aspx") + "?name=' + document.getElementById(txtClientID).value + '&editonlycode=true','TransformationEdit', 1024, 768); return false;}"));

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);
    }

    ///<summary>Gets or sets field value.</summary>
    public override object Value
    {
        get
        {
            return this.txtName.Text;
        }
        set
        {
            this.txtName.Text = (string)value;
        }
    }


    /// <summary>
    /// Return true if user control is valid.
    /// </summary>
    /// <returns></returns>
    public override bool IsValid()
    {
        string ValidationResult = Validate(txtName.Text, false);
        if (ValidationResult == string.Empty)
        {
            return true;
        }
        else
        {
            this.ValidationError = ValidationResult;
            return false;
        }
    }
}
