CREATE TABLE [CMS_Attachment] (
		[AttachmentID]                int NOT NULL IDENTITY(1, 1),
		[AttachmentName]              nvarchar(255) NOT NULL,
		[AttachmentExtension]         nvarchar(50) NOT NULL,
		[AttachmentSize]              int NOT NULL,
		[AttachmentMimeType]          nvarchar(100) NOT NULL,
		[AttachmentBinary]            image NULL,
		[AttachmentImageWidth]        int NULL,
		[AttachmentImageHeight]       int NULL,
		[AttachmentDocumentID]        int NOT NULL,
		[AttachmentGUID]              uniqueidentifier NOT NULL,
		[AttachmentLastHistoryID]     int NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [CMS_Attachment]
	ADD
	CONSTRAINT [PK__CMS_Attachment__08B54D69]
	PRIMARY KEY
	([AttachmentID])
	ON [PRIMARY]
IF OBJECT_ID(N'[CMS_Attachment]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Document]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Attac__Attac__09A971A2]') IS NULL
BEGIN
		ALTER TABLE [CMS_Attachment]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Attac__Attac__09A971A2]
			FOREIGN KEY ([AttachmentDocumentID]) REFERENCES [CMS_Document] ([DocumentID])
			NOT FOR REPLICATION
END
CREATE INDEX [IX_CMS_Attachment]
	ON [CMS_Attachment] ([AttachmentName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Attachment_1]
	ON [CMS_Attachment] ([AttachmentDocumentID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Attachment_2]
	ON [CMS_Attachment] ([AttachmentLastHistoryID])
	ON [PRIMARY]
