CREATE TABLE [CMS_Document] (
		[DocumentID]                                int NOT NULL IDENTITY(1, 1),
		[DocumentName]                              nvarchar(100) NOT NULL,
		[DocumentNamePath]                          nvarchar(1500) NULL,
		[DocumentModifiedWhen]                      datetime NULL,
		[DocumentModifiedByUserID]                  int NULL,
		[DocumentForeignKeyValue]                   int NULL,
		[DocumentCreatedByUserID]                   int NULL,
		[DocumentCreatedWhen]                       datetime NULL,
		[DocumentCheckedOutByUserID]                int NULL,
		[DocumentCheckedOutWhen]                    datetime NULL,
		[DocumentCheckedOutVersionHistoryID]        int NULL,
		[DocumentPublishedVersionHistoryID]         int NULL,
		[DocumentWorkflowStepID]                    int NULL,
		[DocumentPublishFrom]                       datetime NULL,
		[DocumentPublishTo]                         datetime NULL,
		[DocumentUrlPath]                           nvarchar(450) NULL,
		[DocumentCulture]                           nvarchar(10) NOT NULL,
		[DocumentNodeID]                            int NOT NULL,
		[DocumentPageTitle]                         ntext NULL,
		[DocumentPageKeyWords]                      ntext NULL,
		[DocumentPageDescription]                   ntext NULL,
		[DocumentShowInSiteMap]                     bit NOT NULL,
		[DocumentMenuItemHideInNavigation]          bit NULL,
		[DocumentMenuCaption]                       nvarchar(200) NULL,
		[DocumentMenuStyle]                         nvarchar(50) NULL,
		[DocumentMenuItemImage]                     nvarchar(200) NULL,
		[DocumentMenuItemLeftImage]                 nvarchar(200) NULL,
		[DocumentMenuItemRightImage]                nvarchar(200) NULL,
		[DocumentPageTemplateID]                    int NULL,
		[DocumentMenuJavascript]                    nvarchar(100) NULL,
		[DocumentMenuRedirectUrl]                   nvarchar(250) NULL,
		[DocumentUseNamePathForUrlPath]             bit NULL,
		[DocumentStylesheetID]                      int NULL,
		[DocumentContent]                           ntext NULL,
		[DocumentMenuClass]                         nvarchar(50) NULL,
		[DocumentMenuStyleOver]                     nvarchar(50) NULL,
		[DocumentMenuClassOver]                     nvarchar(50) NULL,
		[DocumentMenuItemImageOver]                 nvarchar(200) NULL,
		[DocumentMenuItemLeftImageOver]             nvarchar(200) NULL,
		[DocumentMenuItemRightImageOver]            nvarchar(200) NULL,
		[DocumentMenuStyleHighlighted]              nvarchar(50) NULL,
		[DocumentMenuClassHighlighted]              nvarchar(50) NULL,
		[DocumentMenuItemImageHighlighted]          nvarchar(200) NULL,
		[DocumentMenuItemLeftImageHighlighted]      nvarchar(200) NULL,
		[DocumentMenuItemRightImageHighlighted]     nvarchar(200) NULL,
		[DocumentMenuItemInactive]                  bit NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [CMS_Document]
	ADD
	CONSTRAINT [PK__CMS_Document__37A5467C]
	PRIMARY KEY
	([DocumentID])
	ON [PRIMARY]
IF OBJECT_ID(N'[CMS_Document]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_PageTemplate]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Docum__Docum__398D8EEE]') IS NULL
BEGIN
		ALTER TABLE [CMS_Document]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Docum__Docum__398D8EEE]
			FOREIGN KEY ([DocumentPageTemplateID]) REFERENCES [CMS_PageTemplate] ([PageTemplateID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_Document]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Tree]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Docum__Docum__3A81B327]') IS NULL
BEGIN
		ALTER TABLE [CMS_Document]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Docum__Docum__3A81B327]
			FOREIGN KEY ([DocumentNodeID]) REFERENCES [CMS_Tree] ([NodeID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_Document]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_User]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Docum__Docum__3B75D760]') IS NULL
BEGIN
		ALTER TABLE [CMS_Document]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Docum__Docum__3B75D760]
			FOREIGN KEY ([DocumentCreatedByUserID]) REFERENCES [CMS_User] ([UserID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_Document]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_User]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Docum__Docum__3C69FB99]') IS NULL
BEGIN
		ALTER TABLE [CMS_Document]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Docum__Docum__3C69FB99]
			FOREIGN KEY ([DocumentCheckedOutByUserID]) REFERENCES [CMS_User] ([UserID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_Document]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_User]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Docum__Docum__3D5E1FD2]') IS NULL
BEGIN
		ALTER TABLE [CMS_Document]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Docum__Docum__3D5E1FD2]
			FOREIGN KEY ([DocumentModifiedByUserID]) REFERENCES [CMS_User] ([UserID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_Document]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_WorkflowStep]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Docum__Docum__3E52440B]') IS NULL
BEGIN
		ALTER TABLE [CMS_Document]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Docum__Docum__3E52440B]
			FOREIGN KEY ([DocumentWorkflowStepID]) REFERENCES [CMS_WorkflowStep] ([StepID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_Document]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_VersionHistory]') IS NOT NULL
	AND OBJECT_ID(N'[FK_CMS_Document_CMS_VersionHistory]') IS NULL
BEGIN
		ALTER TABLE [CMS_Document]
			WITH NOCHECK
			ADD CONSTRAINT [FK_CMS_Document_CMS_VersionHistory]
			FOREIGN KEY ([DocumentCheckedOutVersionHistoryID]) REFERENCES [CMS_VersionHistory] ([VersionHistoryID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_Document]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_VersionHistory]') IS NOT NULL
	AND OBJECT_ID(N'[FK_CMS_Document_CMS_VersionHistory1]') IS NULL
BEGIN
		ALTER TABLE [CMS_Document]
			WITH NOCHECK
			ADD CONSTRAINT [FK_CMS_Document_CMS_VersionHistory1]
			FOREIGN KEY ([DocumentPublishedVersionHistoryID]) REFERENCES [CMS_VersionHistory] ([VersionHistoryID])
			NOT FOR REPLICATION
END
CREATE INDEX [IX_CMS_Document]
	ON [CMS_Document] ([DocumentName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_1]
	ON [CMS_Document] ([DocumentForeignKeyValue])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_10]
	ON [CMS_Document] ([DocumentUrlPath])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_12]
	ON [CMS_Document] ([DocumentCulture])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_13]
	ON [CMS_Document] ([DocumentNodeID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_14]
	ON [CMS_Document] ([DocumentShowInSiteMap])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_15]
	ON [CMS_Document] ([DocumentMenuItemHideInNavigation])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_16]
	ON [CMS_Document] ([DocumentStylesheetID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_2]
	ON [CMS_Document] ([DocumentCheckedOutByUserID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_3]
	ON [CMS_Document] ([DocumentCheckedOutVersionHistoryID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_4]
	ON [CMS_Document] ([DocumentPublishedVersionHistoryID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_5]
	ON [CMS_Document] ([DocumentWorkflowStepID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_6]
	ON [CMS_Document] ([DocumentModifiedByUserID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_7]
	ON [CMS_Document] ([DocumentPublishFrom])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_8]
	ON [CMS_Document] ([DocumentPublishTo])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Document_9]
	ON [CMS_Document] ([DocumentCreatedByUserID])
	ON [PRIMARY]
