CREATE TABLE [CMS_Form] (
		[FormID]                   int NOT NULL IDENTITY(1, 1),
		[FormDisplayName]          nvarchar(100) NOT NULL,
		[FormName]                 nvarchar(100) NOT NULL,
		[FormSendToEmail]          nvarchar(400) NULL,
		[FormSendFromEmail]        nvarchar(400) NULL,
		[FormEmailSubject]         nvarchar(250) NULL,
		[FormClassID]              int NOT NULL,
		[FormItems]                int NOT NULL,
		[FormReportFields]         ntext NULL,
		[FormRedirectToUrl]        nvarchar(400) NULL,
		[FormDisplayText]          ntext NULL,
		[FormClearAfterSave]       bit NOT NULL,
		[FormSubmitButtonText]     nvarchar(400) NULL,
		[FormSiteID]               int NOT NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [CMS_Form]
	ADD
	CONSTRAINT [PK__CMS_Form__25518C17]
	PRIMARY KEY
	([FormID])
	ON [PRIMARY]
ALTER TABLE [CMS_Form]
	ADD
	CONSTRAINT [DF__CMS_Form__FormCl__2645B050]
	DEFAULT ((0)) FOR [FormClearAfterSave]
ALTER TABLE [CMS_Form]
	ADD
	CONSTRAINT [DF__CMS_Form__FormIt__2739D489]
	DEFAULT ((0)) FOR [FormItems]
IF OBJECT_ID(N'[CMS_Form]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Class]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Form__FormCl__282DF8C2]') IS NULL
BEGIN
		ALTER TABLE [CMS_Form]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Form__FormCl__282DF8C2]
			FOREIGN KEY ([FormClassID]) REFERENCES [CMS_Class] ([ClassID])
			NOT FOR REPLICATION
END
CREATE INDEX [IX_CMS_Form]
	ON [CMS_Form] ([FormDisplayName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Form_1]
	ON [CMS_Form] ([FormName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Form_2]
	ON [CMS_Form] ([FormClassID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Form_3]
	ON [CMS_Form] ([FormSiteID])
	ON [PRIMARY]
