CREATE TABLE [CMS_SettingsKey] (
		[KeyID]              int NOT NULL IDENTITY(1, 1),
		[KeyName]            nvarchar(100) NOT NULL,
		[KeyDisplayName]     nvarchar(200) NOT NULL,
		[KeyDescription]     ntext NULL,
		[KeyValue]           ntext NULL,
		[KeyType]            nvarchar(50) NOT NULL,
		[KeyCategoryID]      int NOT NULL,
		[SiteID]             int NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [CMS_SettingsKey]
	ADD
	CONSTRAINT [PK__CMS_SettingsKey__5BE2A6F2]
	PRIMARY KEY
	([KeyID])
	ON [PRIMARY]
IF OBJECT_ID(N'[CMS_SettingsKey]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_SettingsCategory]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Setti__KeyCa__5CD6CB2B]') IS NULL
BEGIN
		ALTER TABLE [CMS_SettingsKey]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Setti__KeyCa__5CD6CB2B]
			FOREIGN KEY ([KeyCategoryID]) REFERENCES [CMS_SettingsCategory] ([CategoryID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_SettingsKey]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Site]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Setti__SiteI__5DCAEF64]') IS NULL
BEGIN
		ALTER TABLE [CMS_SettingsKey]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Setti__SiteI__5DCAEF64]
			FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID])
			NOT FOR REPLICATION
END
CREATE INDEX [IX_CMS_SettingsKey]
	ON [CMS_SettingsKey] ([KeyDisplayName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_SettingsKey_1]
	ON [CMS_SettingsKey] ([KeyName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_SettingsKey_2]
	ON [CMS_SettingsKey] ([KeyCategoryID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_SettingsKey_3]
	ON [CMS_SettingsKey] ([SiteID])
	ON [PRIMARY]
