CREATE TABLE [CMS_WorkflowStep] (
		[StepID]              int NOT NULL IDENTITY(1, 1),
		[StepDisplayName]     nvarchar(450) NOT NULL,
		[StepName]            nvarchar(450) NOT NULL,
		[StepOrder]           int NOT NULL,
		[StepWorkflowID]      int NOT NULL
)
ON [PRIMARY]
ALTER TABLE [CMS_WorkflowStep]
	ADD
	CONSTRAINT [PK__CMS_WorkflowStep__276EDEB3]
	PRIMARY KEY
	([StepID])
	ON [PRIMARY]
IF OBJECT_ID(N'[CMS_WorkflowStep]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Workflow]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Workf__StepW__286302EC]') IS NULL
BEGIN
		ALTER TABLE [CMS_WorkflowStep]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Workf__StepW__286302EC]
			FOREIGN KEY ([StepWorkflowID]) REFERENCES [CMS_Workflow] ([WorkflowID])
			NOT FOR REPLICATION
END
CREATE INDEX [IX_CMS_WorkflowStep]
	ON [CMS_WorkflowStep] ([StepDisplayName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_WorkflowStep_1]
	ON [CMS_WorkflowStep] ([StepName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_WorkflowStep_2]
	ON [CMS_WorkflowStep] ([StepOrder])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_WorkflowStep_3]
	ON [CMS_WorkflowStep] ([StepWorkflowID])
	ON [PRIMARY]
