CREATE TABLE [COM_Customer] (
		[CustomerID]                            int NOT NULL IDENTITY(1, 1),
		[CustomerFirstName]                     nvarchar(200) NOT NULL,
		[CustomerLastName]                      nvarchar(200) NOT NULL,
		[CustomerEmail]                         nvarchar(200) NULL,
		[CustomerPhone]                         nvarchar(50) NULL,
		[CustomerFax]                           nvarchar(50) NULL,
		[CustomerCompany]                       nvarchar(200) NULL,
		[CustomerUserID]                        int NULL,
		[CustomerPreferredCurrencyID]           int NULL,
		[CustomerPreferredShippingOptionID]     int NULL,
		[CustomerCountryID]                     int NULL,
		[CustomerEnabled]                       bit NOT NULL,
		[CustomerPrefferedPaymentOptionID]      int NULL,
		[CustomerStateID]                       int NULL,
		[CustomerGUID]                          uniqueidentifier NOT NULL,
		[CustomerTaxRegistrationID]             nvarchar(50) NULL,
		[CustomerOrganizationID]                nvarchar(50) NULL
)
ON [PRIMARY]
ALTER TABLE [COM_Customer]
	ADD
	CONSTRAINT [PK_COM_Customer]
	PRIMARY KEY
	([CustomerID])
	ON [PRIMARY]
IF OBJECT_ID(N'[COM_Customer]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Country]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Customer_CMS_Country]') IS NULL
BEGIN
		ALTER TABLE [COM_Customer]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Customer_CMS_Country]
			FOREIGN KEY ([CustomerCountryID]) REFERENCES [CMS_Country] ([CountryID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Customer]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_State]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Customer_CMS_State]') IS NULL
BEGIN
		ALTER TABLE [COM_Customer]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Customer_CMS_State]
			FOREIGN KEY ([CustomerStateID]) REFERENCES [CMS_State] ([StateID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Customer]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_User]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Customer_CMS_User]') IS NULL
BEGIN
		ALTER TABLE [COM_Customer]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Customer_CMS_User]
			FOREIGN KEY ([CustomerUserID]) REFERENCES [CMS_User] ([UserID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Customer]') IS NOT NULL
	AND OBJECT_ID(N'[COM_Currency]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Customer_COM_Currency]') IS NULL
BEGIN
		ALTER TABLE [COM_Customer]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Customer_COM_Currency]
			FOREIGN KEY ([CustomerPreferredCurrencyID]) REFERENCES [COM_Currency] ([CurrencyID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Customer]') IS NOT NULL
	AND OBJECT_ID(N'[COM_PaymentOption]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Customer_COM_PaymentOption]') IS NULL
BEGIN
		ALTER TABLE [COM_Customer]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Customer_COM_PaymentOption]
			FOREIGN KEY ([CustomerPrefferedPaymentOptionID]) REFERENCES [COM_PaymentOption] ([PaymentOptionID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Customer]') IS NOT NULL
	AND OBJECT_ID(N'[COM_ShippingOption]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Customer_COM_ShippingOption]') IS NULL
BEGIN
		ALTER TABLE [COM_Customer]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Customer_COM_ShippingOption]
			FOREIGN KEY ([CustomerPreferredShippingOptionID]) REFERENCES [COM_ShippingOption] ([ShippingOptionID])
			NOT FOR REPLICATION
END
CREATE INDEX [IX_COM_Customer]
	ON [COM_Customer] ([CustomerFirstName])
	ON [PRIMARY]
CREATE INDEX [IX_COM_Customer_1]
	ON [COM_Customer] ([CustomerLastName])
	ON [PRIMARY]
CREATE INDEX [IX_COM_Customer_2]
	ON [COM_Customer] ([CustomerUserID])
	ON [PRIMARY]
CREATE INDEX [IX_COM_Customer_3]
	ON [COM_Customer] ([CustomerID])
	ON [PRIMARY]
