CREATE TABLE [COM_Order] (
		[OrderID]                    int NOT NULL IDENTITY(1, 1),
		[OrderBillingAddressID]      int NOT NULL,
		[OrderShippingAddressID]     int NOT NULL,
		[OrderShippingOptionID]      int NOT NULL,
		[OrderTotalShipping]         float NULL,
		[OrderTotalPrice]            float NOT NULL,
		[OrderTotalTax]              float NOT NULL,
		[OrderDate]                  datetime NOT NULL,
		[OrderStatusID]              int NOT NULL,
		[OrderCurrencyID]            int NULL,
		[OrderCustomerID]            int NOT NULL,
		[OrderCreatedByUserID]       int NULL,
		[OrderNote]                  ntext NULL,
		[OrderSiteID]                int NOT NULL,
		[OrderPaymentOptionID]       int NOT NULL,
		[OrderInvoice]               ntext NULL,
		[OrderInvoiceNumber]         nvarchar(200) NULL,
		[OrderDiscountCouponID]      int NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [COM_Order]
	ADD
	CONSTRAINT [PK_COM_Order]
	PRIMARY KEY
	([OrderID])
	ON [PRIMARY]
IF OBJECT_ID(N'[COM_Order]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Site]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Order_CMS_Site]') IS NULL
BEGIN
		ALTER TABLE [COM_Order]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Order_CMS_Site]
			FOREIGN KEY ([OrderSiteID]) REFERENCES [CMS_Site] ([SiteID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Order]') IS NOT NULL
	AND OBJECT_ID(N'[COM_Currency]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Order_COM_Currency]') IS NULL
BEGIN
		ALTER TABLE [COM_Order]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Order_COM_Currency]
			FOREIGN KEY ([OrderCurrencyID]) REFERENCES [COM_Currency] ([CurrencyID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Order]') IS NOT NULL
	AND OBJECT_ID(N'[COM_Customer]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Order_COM_Customer]') IS NULL
BEGIN
		ALTER TABLE [COM_Order]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Order_COM_Customer]
			FOREIGN KEY ([OrderCustomerID]) REFERENCES [COM_Customer] ([CustomerID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Order]') IS NOT NULL
	AND OBJECT_ID(N'[COM_Address]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Order_COM_CustomerAdress]') IS NULL
BEGIN
		ALTER TABLE [COM_Order]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Order_COM_CustomerAdress]
			FOREIGN KEY ([OrderBillingAddressID]) REFERENCES [COM_Address] ([AddressID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Order]') IS NOT NULL
	AND OBJECT_ID(N'[COM_Address]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Order_COM_CustomerAdress1]') IS NULL
BEGIN
		ALTER TABLE [COM_Order]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Order_COM_CustomerAdress1]
			FOREIGN KEY ([OrderShippingAddressID]) REFERENCES [COM_Address] ([AddressID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Order]') IS NOT NULL
	AND OBJECT_ID(N'[COM_DiscountCoupon]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Order_COM_DiscountCoupon]') IS NULL
BEGIN
		ALTER TABLE [COM_Order]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Order_COM_DiscountCoupon]
			FOREIGN KEY ([OrderDiscountCouponID]) REFERENCES [COM_DiscountCoupon] ([DiscountCouponID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Order]') IS NOT NULL
	AND OBJECT_ID(N'[COM_PaymentOption]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Order_COM_PaymentOption]') IS NULL
BEGIN
		ALTER TABLE [COM_Order]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Order_COM_PaymentOption]
			FOREIGN KEY ([OrderPaymentOptionID]) REFERENCES [COM_PaymentOption] ([PaymentOptionID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Order]') IS NOT NULL
	AND OBJECT_ID(N'[COM_ShippingOption]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Order_COM_ShippingOption]') IS NULL
BEGIN
		ALTER TABLE [COM_Order]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Order_COM_ShippingOption]
			FOREIGN KEY ([OrderShippingOptionID]) REFERENCES [COM_ShippingOption] ([ShippingOptionID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_Order]') IS NOT NULL
	AND OBJECT_ID(N'[COM_OrderStatus]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_Order_COM_Status]') IS NULL
BEGIN
		ALTER TABLE [COM_Order]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_Order_COM_Status]
			FOREIGN KEY ([OrderStatusID]) REFERENCES [COM_OrderStatus] ([StatusID])
			NOT FOR REPLICATION
END
