CREATE TABLE [COM_OrderStatusUser] (
		[OrderID]               int NOT NULL,
		[FromStatusID]          int NULL,
		[ToStatusID]            int NOT NULL,
		[ChangedByUserID]       int NULL,
		[Date]                  datetime NOT NULL,
		[Note]                  ntext NULL,
		[OrderStatusUserID]     int NOT NULL IDENTITY(1, 1)
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [COM_OrderStatusUser]
	ADD
	CONSTRAINT [PK_COM_OrderStatusUser]
	PRIMARY KEY
	([OrderStatusUserID])
	ON [PRIMARY]
IF OBJECT_ID(N'[COM_OrderStatusUser]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_User]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_OrderStatusUser_CMS_User]') IS NULL
BEGIN
		ALTER TABLE [COM_OrderStatusUser]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_OrderStatusUser_CMS_User]
			FOREIGN KEY ([ChangedByUserID]) REFERENCES [CMS_User] ([UserID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_OrderStatusUser]') IS NOT NULL
	AND OBJECT_ID(N'[COM_Order]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_OrderStatusUser_COM_Order]') IS NULL
BEGIN
		ALTER TABLE [COM_OrderStatusUser]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_OrderStatusUser_COM_Order]
			FOREIGN KEY ([OrderID]) REFERENCES [COM_Order] ([OrderID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_OrderStatusUser]') IS NOT NULL
	AND OBJECT_ID(N'[COM_OrderStatus]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_OrderStatusUser_COM_Status]') IS NULL
BEGIN
		ALTER TABLE [COM_OrderStatusUser]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_OrderStatusUser_COM_Status]
			FOREIGN KEY ([FromStatusID]) REFERENCES [COM_OrderStatus] ([StatusID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_OrderStatusUser]') IS NOT NULL
	AND OBJECT_ID(N'[COM_OrderStatus]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_OrderStatusUser_COM_Status1]') IS NULL
BEGIN
		ALTER TABLE [COM_OrderStatusUser]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_OrderStatusUser_COM_Status1]
			FOREIGN KEY ([ToStatusID]) REFERENCES [COM_OrderStatus] ([StatusID])
			NOT FOR REPLICATION
END
CREATE INDEX [IX_COM_OrderStatusUser]
	ON [COM_OrderStatusUser] ([Date])
	ON [PRIMARY]
