CREATE TABLE [COM_ShoppingCart] (
		[ShoppingCartID]                    int NOT NULL IDENTITY(1, 1),
		[ShoppingCartGUID]                  uniqueidentifier NOT NULL,
		[ShoppingCartUserID]                int NULL,
		[ShoppingCartSiteID]                int NOT NULL,
		[ShoppingCartLastUpdate]            datetime NOT NULL,
		[ShoppingCartCurrencyID]            int NULL,
		[ShoppingCartPaymentOptionID]       int NULL,
		[ShoppingCartShippingOptionID]      int NULL,
		[ShoppingCartDiscountCouponID]      int NULL,
		[ShoppingCartBillingAddressID]      int NULL,
		[ShoppingCartShippingAddressID]     int NULL,
		[ShoppingCartCustomerID]            int NULL,
		[ShoppingCartNote]                  ntext NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [COM_ShoppingCart]
	ADD
	CONSTRAINT [PK_COM_ShoppingCart]
	PRIMARY KEY
	([ShoppingCartID])
	ON [PRIMARY]
IF OBJECT_ID(N'[COM_ShoppingCart]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Site]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_ShoppingCart_CMS_Site]') IS NULL
BEGIN
		ALTER TABLE [COM_ShoppingCart]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_ShoppingCart_CMS_Site]
			FOREIGN KEY ([ShoppingCartSiteID]) REFERENCES [CMS_Site] ([SiteID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_ShoppingCart]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_User]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_ShoppingCart_CMS_User]') IS NULL
BEGIN
		ALTER TABLE [COM_ShoppingCart]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_ShoppingCart_CMS_User]
			FOREIGN KEY ([ShoppingCartUserID]) REFERENCES [CMS_User] ([UserID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_ShoppingCart]') IS NOT NULL
	AND OBJECT_ID(N'[COM_Currency]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_ShoppingCart_COM_Currency]') IS NULL
BEGIN
		ALTER TABLE [COM_ShoppingCart]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_ShoppingCart_COM_Currency]
			FOREIGN KEY ([ShoppingCartCurrencyID]) REFERENCES [COM_Currency] ([CurrencyID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_ShoppingCart]') IS NOT NULL
	AND OBJECT_ID(N'[COM_DiscountCoupon]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_ShoppingCart_COM_DiscountCoupon]') IS NULL
BEGIN
		ALTER TABLE [COM_ShoppingCart]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_ShoppingCart_COM_DiscountCoupon]
			FOREIGN KEY ([ShoppingCartDiscountCouponID]) REFERENCES [COM_DiscountCoupon] ([DiscountCouponID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_ShoppingCart]') IS NOT NULL
	AND OBJECT_ID(N'[COM_PaymentOption]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_ShoppingCart_COM_PaymentOption]') IS NULL
BEGIN
		ALTER TABLE [COM_ShoppingCart]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_ShoppingCart_COM_PaymentOption]
			FOREIGN KEY ([ShoppingCartPaymentOptionID]) REFERENCES [COM_PaymentOption] ([PaymentOptionID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[COM_ShoppingCart]') IS NOT NULL
	AND OBJECT_ID(N'[COM_ShippingOption]') IS NOT NULL
	AND OBJECT_ID(N'[FK_COM_ShoppingCart_COM_ShippingOption]') IS NULL
BEGIN
		ALTER TABLE [COM_ShoppingCart]
			WITH NOCHECK
			ADD CONSTRAINT [FK_COM_ShoppingCart_COM_ShippingOption]
			FOREIGN KEY ([ShoppingCartShippingOptionID]) REFERENCES [COM_ShippingOption] ([ShippingOptionID])
			NOT FOR REPLICATION
END
CREATE INDEX [IX_COM_ShoppingCart]
	ON [COM_ShoppingCart] ([ShoppingCartGUID])
	ON [PRIMARY]
