CREATE TABLE [Newsletter_Newsletter] (
		[NewsletterID]                           int NOT NULL IDENTITY(1, 1),
		[NewsletterDisplayName]                  nvarchar(250) NOT NULL,
		[NewsletterName]                         nvarchar(250) NOT NULL,
		[NewsletterType]                         nvarchar(5) NOT NULL,
		[NewsletterSubscriptionTemplateID]       int NOT NULL,
		[NewsletterUnsubscriptionTemplateID]     int NOT NULL,
		[NewsletterSenderName]                   nvarchar(200) NOT NULL,
		[NewsletterSenderEmail]                  nvarchar(200) NOT NULL,
		[NewsletterDynamicSubject]               nvarchar(500) NULL,
		[NewsletterDynamicURL]                   nvarchar(500) NULL,
		[NewsletterDynamicScheduledTaskID]       int NULL,
		[NewsletterTemplateID]                   int NULL,
		[NewsletterSiteID]                       int NOT NULL,
		[NewsletterGUID]                         uniqueidentifier NOT NULL,
		[NewsletterUnsubscribeUrl]               nvarchar(1000) NULL
)
ON [PRIMARY]
ALTER TABLE [Newsletter_Newsletter]
	ADD
	CONSTRAINT [PK__Newsletter_Newsl__41EDCAC5]
	PRIMARY KEY
	([NewsletterID])
	ON [PRIMARY]
IF OBJECT_ID(N'[Newsletter_Newsletter]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Site]') IS NOT NULL
	AND OBJECT_ID(N'[FK__Newslette__Newsl__42E1EEFE]') IS NULL
BEGIN
		ALTER TABLE [Newsletter_Newsletter]
			WITH NOCHECK
			ADD CONSTRAINT [FK__Newslette__Newsl__42E1EEFE]
			FOREIGN KEY ([NewsletterSiteID]) REFERENCES [CMS_Site] ([SiteID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[Newsletter_Newsletter]') IS NOT NULL
	AND OBJECT_ID(N'[Newsletter_EmailTemplate]') IS NOT NULL
	AND OBJECT_ID(N'[FK__Newslette__Newsl__43D61337]') IS NULL
BEGIN
		ALTER TABLE [Newsletter_Newsletter]
			WITH NOCHECK
			ADD CONSTRAINT [FK__Newslette__Newsl__43D61337]
			FOREIGN KEY ([NewsletterSubscriptionTemplateID]) REFERENCES [Newsletter_EmailTemplate] ([TemplateID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[Newsletter_Newsletter]') IS NOT NULL
	AND OBJECT_ID(N'[Newsletter_EmailTemplate]') IS NOT NULL
	AND OBJECT_ID(N'[FK__Newslette__Newsl__44CA3770]') IS NULL
BEGIN
		ALTER TABLE [Newsletter_Newsletter]
			WITH NOCHECK
			ADD CONSTRAINT [FK__Newslette__Newsl__44CA3770]
			FOREIGN KEY ([NewsletterUnsubscriptionTemplateID]) REFERENCES [Newsletter_EmailTemplate] ([TemplateID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[Newsletter_Newsletter]') IS NOT NULL
	AND OBJECT_ID(N'[Newsletter_EmailTemplate]') IS NOT NULL
	AND OBJECT_ID(N'[FK__Newslette__Newsl__45BE5BA9]') IS NULL
BEGIN
		ALTER TABLE [Newsletter_Newsletter]
			WITH NOCHECK
			ADD CONSTRAINT [FK__Newslette__Newsl__45BE5BA9]
			FOREIGN KEY ([NewsletterTemplateID]) REFERENCES [Newsletter_EmailTemplate] ([TemplateID])
			NOT FOR REPLICATION
END
CREATE INDEX [IX_Newsletter_Newsletter]
	ON [Newsletter_Newsletter] ([NewsletterName])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_Newsletter_1]
	ON [Newsletter_Newsletter] ([NewsletterDisplayName])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_Newsletter_2]
	ON [Newsletter_Newsletter] ([NewsletterType])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_Newsletter_3]
	ON [Newsletter_Newsletter] ([NewsletterSubscriptionTemplateID])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_Newsletter_4]
	ON [Newsletter_Newsletter] ([NewsletterUnsubscriptionTemplateID])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_Newsletter_5]
	ON [Newsletter_Newsletter] ([NewsletterDynamicScheduledTaskID])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_Newsletter_6]
	ON [Newsletter_Newsletter] ([NewsletterTemplateID])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_Newsletter_7]
	ON [Newsletter_Newsletter] ([NewsletterSiteID])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_Newsletter_8]
	ON [Newsletter_Newsletter] ([NewsletterGUID])
	ON [PRIMARY]
