CREATE TABLE [Newsletter_NewsletterIssue] (
		[IssueID]               int NOT NULL IDENTITY(1, 1),
		[IssueSubject]          nvarchar(500) NOT NULL,
		[IssueText]             ntext NOT NULL,
		[IssueUnsubscribed]     int NOT NULL,
		[IssueNewsletterID]     int NOT NULL,
		[IssueTemplateID]       int NULL,
		[IssueSentEmails]       int NOT NULL,
		[IssueMailoutTime]      datetime NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [Newsletter_NewsletterIssue]
	ADD
	CONSTRAINT [PK__Newsletter_Newsl__47A6A41B]
	PRIMARY KEY
	([IssueID])
	ON [PRIMARY]
IF OBJECT_ID(N'[Newsletter_NewsletterIssue]') IS NOT NULL
	AND OBJECT_ID(N'[Newsletter_EmailTemplate]') IS NOT NULL
	AND OBJECT_ID(N'[FK__Newslette__Issue__489AC854]') IS NULL
BEGIN
		ALTER TABLE [Newsletter_NewsletterIssue]
			WITH NOCHECK
			ADD CONSTRAINT [FK__Newslette__Issue__489AC854]
			FOREIGN KEY ([IssueTemplateID]) REFERENCES [Newsletter_EmailTemplate] ([TemplateID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[Newsletter_NewsletterIssue]') IS NOT NULL
	AND OBJECT_ID(N'[Newsletter_Newsletter]') IS NOT NULL
	AND OBJECT_ID(N'[FK__Newslette__Issue__498EEC8D]') IS NULL
BEGIN
		ALTER TABLE [Newsletter_NewsletterIssue]
			WITH NOCHECK
			ADD CONSTRAINT [FK__Newslette__Issue__498EEC8D]
			FOREIGN KEY ([IssueNewsletterID]) REFERENCES [Newsletter_Newsletter] ([NewsletterID])
			NOT FOR REPLICATION
END
CREATE INDEX [IX_Newsletter_NewsletterIssue]
	ON [Newsletter_NewsletterIssue] ([IssueUnsubscribed])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_NewsletterIssue_1]
	ON [Newsletter_NewsletterIssue] ([IssueNewsletterID])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_NewsletterIssue_2]
	ON [Newsletter_NewsletterIssue] ([IssueTemplateID])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_NewsletterIssue_3]
	ON [Newsletter_NewsletterIssue] ([IssueSentEmails])
	ON [PRIMARY]
CREATE INDEX [IX_Newsletter_NewsletterIssue_4]
	ON [Newsletter_NewsletterIssue] ([IssueMailoutTime])
	ON [PRIMARY]
