CREATE TABLE [Staging_SyncLog] (
		[SyncLogID]           int NOT NULL IDENTITY(1, 1),
		[SyncLogTaskID]       int NOT NULL,
		[SyncLogServerID]     int NOT NULL,
		[SyncLogTime]         datetime NOT NULL,
		[SyncLogError]        ntext NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [Staging_SyncLog]
	ADD
	CONSTRAINT [PK_Staging_SyncLog]
	PRIMARY KEY
	([SyncLogID])
	ON [PRIMARY]
IF OBJECT_ID(N'[Staging_SyncLog]') IS NOT NULL
	AND OBJECT_ID(N'[Staging_Server]') IS NOT NULL
	AND OBJECT_ID(N'[FK_Staging_SyncLog_Staging_Server]') IS NULL
BEGIN
		ALTER TABLE [Staging_SyncLog]
			WITH NOCHECK
			ADD CONSTRAINT [FK_Staging_SyncLog_Staging_Server]
			FOREIGN KEY ([SyncLogServerID]) REFERENCES [Staging_Server] ([ServerID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[Staging_SyncLog]') IS NOT NULL
	AND OBJECT_ID(N'[Staging_Task]') IS NOT NULL
	AND OBJECT_ID(N'[FK_Staging_SyncLog_Staging_Task]') IS NULL
BEGIN
		ALTER TABLE [Staging_SyncLog]
			WITH NOCHECK
			ADD CONSTRAINT [FK_Staging_SyncLog_Staging_Task]
			FOREIGN KEY ([SyncLogTaskID]) REFERENCES [Staging_Task] ([TaskID])
			NOT FOR REPLICATION
END
