using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;

public partial class login : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        Label lblVersion = (Label)Login1.FindControl("lblVersion");
        if (lblVersion != null)
        {
            lblVersion.Text = ResHelper.GetString("Footer.Version") + "&nbsp;" + CMSContext.SYSTEM_VERSION + "&nbsp;" + ResHelper.GetString("Footer.Build") + "&nbsp;" + typeof(TreeProvider).Assembly.GetName().Version.Major + "." + typeof(TreeProvider).Assembly.GetName().Version.Minor + "." + typeof(TreeProvider).Assembly.GetName().Version.Build;
        }
        
        Login1.LoggingIn += new LoginCancelEventHandler(Login1_LoggingIn);
        Login1.LoggedIn += new EventHandler(Login1_LoggedIn);
        Login1.LoginError += new EventHandler(Login1_LoginError);
        
        if (!IsPostBack)
        {
            Login1.UserName = ValidationHelper.GetString(Request.QueryString["username"], "");            
        }

        //if ( !IsPostBack )
        //{
        //    Login1.UserName = CookieHelper.GetValue("RememberMeName");
        //}
    }

    void Login1_LoginError(object sender, EventArgs e)
    {
       Login1.FailureText = ResHelper.GetString("Login_FailureText");
    }


    void Login1_LoggedIn(object sender, EventArgs e)
    {
        if (Response.Cookies.Count > 0)
        {
            foreach (string s in Response.Cookies.AllKeys)
            {
                if (s == FormsAuthentication.FormsCookieName)
                {
                    if (Login1.RememberMeSet == true)
                    {
                        // Change the value to increase the cookies expiration by
                        Response.Cookies[s].Expires = DateTime.Now.AddYears(1);
                        //CookieHelper.SetValue("RememberMeName", Login1.UserName, DateTime.Now.AddYears(1));
                    }
                }
            }
        }
    }


    void Login1_LoggingIn(object sender, LoginCancelEventArgs e)
    {
        if (((CheckBox)Login1.FindControl("chkRememberMe")).Checked)
        {
            Login1.RememberMeSet = true;
        }
        else
        {
            Login1.RememberMeSet = false;
        }
    }
   
}
