using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Threading;

using CMS.GlobalHelper;
using CMS.CMSHelper;


public partial class CMSSiteManager_Administration_System_System : AdministrationPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        lblAspAccount.Text = ResHelper.GetString("Administration-System.Account");
        lblValueAspAccount.Text = System.Security.Principal.WindowsIdentity.GetCurrent().Name;

        lblAlocatedMemory.Text = ResHelper.GetString("Administration-System.Memory");

        btnClear.Text = ResHelper.GetString("Administration-System.btnClear");
        btnRestart.Text = ResHelper.GetString("Administration-System.btnRestart");

        lblValueAlocatedMemory.Text = GetAllocatedMemory();

        ltlScript.Text = ScriptHelper.GetScript(" function Load() {}");
    
        if ((!Page.IsPostBack) && Request.QueryString["IsRestarted"] != null && Request.QueryString["IsRestarted"] != "" && Request.QueryString["IsRestarted"] == "1")
        {
            lblInfo.Text = ResHelper.GetString("Administration-System.RestartSuccess");
        }
        
        lblRunTime.Text = ResHelper.GetString("Administration.System.RunTime");                

        // Remove miliseconds from the end of the time string
        string timeSpan = (DateTime.Now - Global.ApplicationStart).ToString();            
        timeSpan = timeSpan.Remove(timeSpan.LastIndexOf('.'));

        // Display application run time
        lblRunTimeValue.Text = timeSpan;

        
    }


    /// <summary>
    /// Return all alocated memory
    /// </summary>
    /// <returns></returns>
    private string GetAllocatedMemory()
    {
        return GC.GetTotalMemory(true).ToString();
    }

    /// <summary>
    /// Clear unused memory
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnClear_Click(object sender, EventArgs e)
    {
        // Check modify permission
        if ((CMSContext.CurrentSite != null) && (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Administration", "Modify")))
        {
            RedirectToCMSDeskAccessDenied("CMS.Administration", "Modify");
        }

        GC.Collect();
        lblValueAlocatedMemory.Text = GetAllocatedMemory();
        lblInfo.Text = ResHelper.GetString("Administration-System.ClearSuccess");
    }

    /// <summary>
    /// Restart application
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnRestart_Click(object sender, EventArgs e)
    {        
        // Check modify permission
        if ((CMSContext.CurrentSite != null) && (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Administration", "Modify")))
        {
            RedirectToCMSDeskAccessDenied("CMS.Administration", "Modify");
        }

        HttpRuntime.UnloadAppDomain();

        string url = UrlHelper.AddParameterToUrl(Request.RawUrl, "IsRestarted", "1");
        Response.Redirect(url);
    }

}
