using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;

public partial class SiteManager_Administration_leftmenu : AdministrationPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.TreeViewAdministration.LineImagesFolder = "~/App_Themes/" + this.Page.Theme + "/Images/Tree";
        if (CultureHelper.IsUICultureRTL())
        {
            this.TreeViewAdministration.LineImagesFolder += "/RTL";
        }
        this.TreeViewAdministration.ImageSet = TreeViewImageSet.Custom;
        
        this.TreeViewAdministration.Nodes.Clear();

        string imagesUrl = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Administration/";

        TreeNode rootNode = new TreeNode();
        rootNode.Text = ResHelper.GetString("Administration-LeftMenu.Administration");
        rootNode.Expanded = true;
        rootNode.NavigateUrl = "#";
        TreeViewAdministration.Nodes.Add(rootNode);

        TreeNode newNode = new TreeNode();
        newNode.Text = "<span class=\"ContentTreeItem\" onclick=\"ShowDesktopContent('Users/User_List.aspx?siteid=" + Request.QueryString["siteid"] + "', this);\"><span class=\"Name\">" + ResHelper.GetString("Administration-LeftMenu.Users") + "</span></span>";
        newNode.NavigateUrl = "#";
        newNode.ImageUrl = imagesUrl + "users.gif";
        rootNode.ChildNodes.Add(newNode);


        newNode = new TreeNode();
        newNode.Text = "<span class=\"ContentTreeItem\" onclick=\"ShowDesktopContent('Roles/Role_List.aspx?siteid=" + Request.QueryString["siteid"] + "', this);\"><span class=\"Name\">" + ResHelper.GetString("Administration-LeftMenu.Roles") + "</span></span>";
        newNode.NavigateUrl = "#";
        newNode.ImageUrl = imagesUrl + "roles.gif";
        rootNode.ChildNodes.Add(newNode);

        newNode = new TreeNode();
        newNode.Text = "<span class=\"ContentTreeItem\" onclick=\"ShowDesktopContent('Permissions/default.aspx?siteid=" + Request.QueryString["siteid"] + "', this);\"><span class=\"Name\">" + ResHelper.GetString("Administration-LeftMenu.Permissions") + "</span></span>";
        newNode.NavigateUrl = "#";
        newNode.ImageUrl = imagesUrl + "permissions.gif";
        rootNode.ChildNodes.Add(newNode);

        //newNode = new TreeNode();
        //newNode.Text = "<span class=\"ContentTreeItem\" onclick=\"ShowDesktopContent('RecycleBin/default.aspx?siteid=" + Request.QueryString["siteid"] + "', this);\"><span class=\"Name\">" + ResHelper.GetString("Administration-LeftMenu.RecycleBin") + "</span></span>";
        //newNode.NavigateUrl = "#";
        //newNode.ImageUrl = imagesUrl + "recyclebin.gif";
        //rootNode.ChildNodes.Add(newNode);

        newNode = new TreeNode();
        newNode.Text = "<span class=\"ContentTreeItem\" onclick=\"ShowDesktopContent('ScheduledTasks/Task_List.aspx?siteid=" + Request.QueryString["siteid"] + "', this);\"><span class=\"Name\">" + ResHelper.GetString("Administration-LeftMenu.ScheduledTasks") + "</span></span>";
        newNode.NavigateUrl = "#";
        newNode.ImageUrl = imagesUrl + "tasks.gif";
        rootNode.ChildNodes.Add(newNode);

        newNode = new TreeNode();
        newNode.Text = "<span class=\"ContentTreeItem\" onclick=\"ShowDesktopContent(" + "'EventLog/EventLog.aspx?siteid=" + Request.QueryString["siteid"] + "', this);\"><span class=\"Name\">" + ResHelper.GetString("Administration-LeftMenu.EventLog") + "</span></span>";
        newNode.NavigateUrl = "#";
        newNode.ImageUrl = imagesUrl + "eventlog.gif";
        rootNode.ChildNodes.Add(newNode);

        if ((Request.QueryString["siteid"] == null) || (Request.QueryString["siteid"] == ""))
        {
            newNode = new TreeNode();
            newNode.Text = "<span class=\"ContentTreeItem\" onclick=\"ShowDesktopContent(" + "'System/System_Frameset.aspx?siteid=" + Request.QueryString["siteid"] + "', this);\"><span class=\"Name\">" + ResHelper.GetString("Administration-LeftMenu.System") + "</span></span>";
            newNode.NavigateUrl = "#";
            newNode.ImageUrl = imagesUrl + "system.gif";
            rootNode.ChildNodes.Add(newNode);

            newNode = new TreeNode();
            newNode.Text = "<span class=\"ContentTreeItem\" onclick=\"ShowDesktopContent(" + "'WebFarm/WebFarm_Frameset.aspx?siteid=" + Request.QueryString["siteid"] + "', this);\"><span class=\"Name\">" + ResHelper.GetString("Administration-LeftMenu.WebFarm") + "</span></span>";
            newNode.NavigateUrl = "#";
            newNode.ImageUrl = imagesUrl + "webfarm.gif";
            rootNode.ChildNodes.Add(newNode);
        }

    }
}
