using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SettingsProvider;

public partial class SiteManager_Development_DocumentTypes_DocumentType_Edit_Transformation_List : SiteManagerPage
{
    private int documentTypeId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!SettingsKeyProvider.UsingVirtualPathProvider)
        {
            this.lblInfo.Text = ResHelper.GetString("Transformations.VirtualPathProviderNotRunning");
            this.pnlInfo.Visible = true;
            this.plcTransformations.Visible = false;
            return;
        }

        if (Request.QueryString["documenttypeid"] != null)
        {
            documentTypeId = Convert.ToInt32(Request.QueryString["documenttypeid"]);
        }

        // sets page title
        imgNewTransformation.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/DocumentTypes/addtransformation.gif";
        lnkNewTransformation.NavigateUrl = "DocumentType_Edit_Transformation_Edit.aspx?documenttypeid=" + documentTypeId.ToString();
        lnkNewTransformation.Text = ResHelper.GetString("DocumentType_Edit_Transformation_List.btnNew");

        uniGrid.OnAction += new OnActionEventHandler(uniGrid_OnAction);
        uniGrid.WhereCondition = "CMS_Class.ClassID=" + documentTypeId;
        uniGrid.GridView.GridLines = GridLines.Horizontal;
    }

    /// <summary>
    /// Handles the UniGrid's OnAction event.
    /// </summary>
    /// <param name="actionName">Name of item (button) that throws event.</param>
    /// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
    protected void uniGrid_OnAction(string actionName, object actionArgument)
    {
        if (actionName == "edit")
        {
            Response.Redirect("DocumentType_Edit_Transformation_Edit.aspx?transformationid=" + actionArgument.ToString());
        }
        else if (actionName == "delete")
        {
            // gets full transformation name
            string transformationName = TransformationInfoProvider.GetTransformationFullName(Convert.ToInt32(actionArgument));
            // deletes transformation of the specific name
            TransformationInfoProvider.DeleteTransformation(transformationName);
        }
    }
}
