using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.DataEngine;
using CMS.SiteProvider;
using CMS.CMSHelper;

public partial class CMSSiteManager_Development_InlineControls_InlineControl_New : SiteManagerPage
{

    protected void Page_Load(object sender, EventArgs e)
    {        

        // control initializations				
        lblControlDescription.Text = ResHelper.GetString("InlineControl_Edit.ControlDescriptionLabel");
        lblControlDisplayName.Text = ResHelper.GetString("InlineControl_Edit.ControlDisplayNameLabel");
        lblControlParameterName.Text = ResHelper.GetString("InlineControl_Edit.ControlParameterNameLabel");
        lblControlName.Text = ResHelper.GetString("InlineControl_Edit.ControlNameLabel");

        rfvDisplayName.ErrorMessage = ResHelper.GetString("InlineControl_Edit.ErrorDisplayName");
        rfvName.ErrorMessage = ResHelper.GetString("InlineControl_Edit.ErrorName");
        
        // check 'Assign with current web site' check box
        if ((CMSContext.CurrentSite != null) && (!IsPostBack))
        {
            chkAssign.Text = ResHelper.GetString("General.AssignWithWebSite") + " " + CMSContext.CurrentSite.DisplayName;
            chkAssign.Checked = true;
            chkAssign.Visible = true;
        }

        btnOK.Text = ResHelper.GetString("General.OK");

        // initializes page title control		
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = ResHelper.GetString("InlineControl_Edit.ItemListLink");
        pageTitleTabs[0, 1] = "~/CMSSiteManager/Development/InlineControls/InlineControl_List.aspx";
        pageTitleTabs[0, 2] = "";
        pageTitleTabs[1, 0] = ResHelper.GetString("InlineControl_Edit.NewItemCaption");
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;
        PageTitle.TitleText = ResHelper.GetString("InlineControl_Edit.NewControl");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/InlineControls/newinlinecontrol.gif";
    }


    /// <summary>
    /// Sets data to database.
    /// </summary>
    protected void btnOK_Click(object sender, EventArgs e)
    {
        string errorMessage = new Validator().NotEmpty(txtControlDisplayName.Text.Trim(), rfvDisplayName.ErrorMessage).NotEmpty(txtControlName.Text.Trim(), rfvName.ErrorMessage).Result;

        if (errorMessage == "")
        {
            InlineControlInfo inlineControlObj = new InlineControlInfo();

            inlineControlObj.ControlDescription = txtControlDescription.Text.Trim();
            inlineControlObj.ControlDisplayName = txtControlDisplayName.Text.Trim();
            inlineControlObj.ControlParameterName = txtControlParameterName.Text.Trim();
            inlineControlObj.ControlName = txtControlName.Text.Trim();

            try
            {
                // Create new inline control
                InlineControlInfoProvider.SetInlineControlInfo(inlineControlObj);
                if ((chkAssign.Visible) && (chkAssign.Checked) && (CMSContext.CurrentSite != null))
                {
                    // Add new control to the actual site
                    InlineControlInfoProvider.AddInlineControlToSite(inlineControlObj.ControlID, CMSContext.CurrentSite.SiteID);
                }
                Response.Redirect("InlineControl_Frameset.aspx?inlinecontrolid=" + Convert.ToString(inlineControlObj.ControlID) + "&saved=1");
            }
            catch(Exception ex)
            {
                lblError.Text = ex.Message.Replace("%%name%%", txtControlName.Text);
                lblError.Visible = true;
            }

            
        }
        else
        {
            lblError.Visible = true;
            lblError.Text = errorMessage;
        }
    }
}
