using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SiteProvider;
using CMS.SettingsProvider;

public partial class SiteManager_Development_PageLayouts_PageLayout_List : SiteManagerPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!SettingsKeyProvider.UsingVirtualPathProvider)
        {
            this.lblInfo.Text = ResHelper.GetString("Layouts.VirtualPathProviderNotRunning");
            this.pnlInfo.Visible = true;
            this.plcLayouts.Visible = false;
            return;
        }

        PageTitleLayout.TitleText = ResHelper.GetString("Administration-PageLayout_List.Title");
        PageTitleLayout.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/PageLayouts/layouts.gif";
        ImageNewModule.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/PageLayouts/addlayout.gif";
        HyperlinkNewModule.Text = ResHelper.GetString("Administration-PageLayout_List.NewLayout");

        UniGridModules.GridView.GridLines = GridLines.Horizontal;
        UniGridModules.OnAction += new OnActionEventHandler(UniGridModules_OnAction);
    }

    /// <summary>
    /// Handles the UniGrid's OnAction event.
    /// </summary>
    /// <param name="actionName">Name of item (button) that threw event.</param>
    /// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
    protected void UniGridModules_OnAction(string actionName, object actionArgument)
    {
        if (actionName == "edit")
        {
            Response.Redirect("PageLayout_Edit.aspx?layoutID=" + actionArgument.ToString());
        }
        else if (actionName == "delete")
        {
            LayoutInfoProvider.DeleteLayoutInfo(Convert.ToInt32(actionArgument));
        }       
    }
}
