using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SiteProvider;
using CMS.PortalEngine;

public partial class SiteManager_Development_PageTemplates_PageTemplate_Header : SiteManagerPage
{
    protected int pageTemplateId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        if ((Request.QueryString["templateid"] != null) && (Request.QueryString["templateid"] != ""))
        {
            pageTemplateId = Convert.ToInt32(Request.QueryString["templateid"]);
        }

        if (pageTemplateId != 0)
        {
            // Initialize page title
            string templates = ResHelper.GetString("Administration-PageTemplate_Header.Templates");
            string title = ResHelper.GetString("Administration-PageTemplate_Header.TemplateProperties");
            PageTemplateInfo pti = PageTemplateInfoProvider.GetPageTemplateInfo(pageTemplateId);
            string currentPageTemplate = pti.DisplayName;
            string[,] pageTitleTabs = null;

            if (ValidationHelper.GetInteger(Request.QueryString["nobreadcrumbs"], 0) < 1)
            {
                pageTitleTabs = new string[2, 3];
                pageTitleTabs[0, 0] = templates;
                pageTitleTabs[0, 1] = "~/CMSSiteManager/Development/PageTemplates/PageTemplate_Frameset.aspx";
                pageTitleTabs[0, 2] = "devmain";
                pageTitleTabs[1, 0] = currentPageTemplate;
                pageTitleTabs[1, 1] = "";
                pageTitleTabs[1, 2] = "";
            }
            else
            {
                pageTitleTabs = new string[2, 3];
                pageTitleTabs[0, 0] = templates;
                pageTitleTabs[0, 1] = "";
                pageTitleTabs[0, 2] = "";
                pageTitleTabs[1, 0] = currentPageTemplate;
                pageTitleTabs[1, 1] = "";
                pageTitleTabs[1, 2] = "";
            }
            ptPageTemplate.Breadcrumbs = pageTitleTabs;
            ptPageTemplate.TitleText = title;
            if (pti.IsReusable)
            {
                ptPageTemplate.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/PageTemplates/pagetemplate.gif";
            }
            else
            {
                ptPageTemplate.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/PageTemplates/adhoc.gif";
            }

            // Initialize menu
            string generalString = ResHelper.GetString("Administration-PageTemplate_Header.General");
            string sitesString = ResHelper.GetString("Administration-PageTemplate_Header.Sites");
            string webPartsString = ResHelper.GetString("Administration-PageTemplate_Header.WebParts");
            string layoutsString = ResHelper.GetString("Administration-PageTemplate_Header.Layouts");
            string headerString = ResHelper.GetString("Administration-PageTemplate_Header.Header");

            BasicTabControlMenu.Tabs = new string[5, 4];
            BasicTabControlMenu.Tabs[0, 0] = generalString;
            BasicTabControlMenu.Tabs[0, 2] = "PageTemplate_General.aspx?templateid=" + pageTemplateId;
            BasicTabControlMenu.Tabs[1, 0] = sitesString;
            BasicTabControlMenu.Tabs[1, 2] = "PageTemplate_Sites.aspx?templateid=" + pageTemplateId;
            
            if ((pti != null) && (pti.IsPortal))
            {
                BasicTabControlMenu.Tabs[2, 0] = layoutsString;
                BasicTabControlMenu.Tabs[2, 2] = "PageTemplate_Layouts.aspx?templateid=" + pageTemplateId;
                BasicTabControlMenu.Tabs[3, 0] = webPartsString;
                BasicTabControlMenu.Tabs[3, 2] = "PageTemplate_WebParts.aspx?templateid=" + pageTemplateId;
            }

            BasicTabControlMenu.Tabs[4, 0] = headerString;
            BasicTabControlMenu.Tabs[4, 2] = "PageTemplate_HeaderTab.aspx?templateid=" + pageTemplateId;


            BasicTabControlMenu.UrlTarget = "pt_edit_content";

        }
    }
}
