using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.GlobalHelper;
using CMS.SiteProvider;
using CMS.ResourceManager;

public partial class CMSSiteManager_Development_UICultures_UICulture_String_New : SiteManagerPage
{
    int uiCultureID = 0;
    string[,] pageTitleTabs = new string[2, 3];

    protected void Page_Load(object sender, EventArgs e)
    {
        if ((Request.QueryString["UIcultureID"] != null) && (Request.QueryString["UIcultureID"] != ""))
        {
            uiCultureID = Convert.ToInt32(Request.QueryString["UIcultureID"]);
        }

        // initializes page title
        pageTitleTabs[0, 0] = ResHelper.GetString("UICultures_Strings.Strings");
        pageTitleTabs[0, 1] = "~/CMSSiteManager/Development/UICultures/UICulture_Strings_List.aspx?UIcultureID=" + uiCultureID;
        pageTitleTabs[0, 2] = "";
        pageTitleTabs[1, 0] = ResHelper.GetString("UICultures_Strings.NewString");
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;

        lblCustomString.Text = ResHelper.GetString("Administration-UICulture_String_New.CustomString");
        lblEnglishText.Text = ResHelper.GetString("Administration-UICulture_String_New.EnglishText");
        lblKey.Text = ResHelper.GetString("Administration-UICulture_String_New.Key");
        lblText.Text = ResHelper.GetString("Administration-UICulture_String_New.Text");
        btnOK.Text = ResHelper.GetString("Administration-UICulture_String_New.OK");
        rfvKey.ErrorMessage = ResHelper.GetString("Administration-UICulture_String_New.EmptyKey");
        if (!IsPostBack)
        {
            chkCustomString.Checked = true;
        }

        UICultureInfo uic = new UICultureInfo();
        uic = UICultureInfoProvider.GetUICultureInfo(uiCultureID);
        if (uic.UICultureCode == "en-us")   // !!!
        {
            txtEnglishText.Visible = false;
            lblEnglishText.Visible = false;
        }
        else
        {
            txtEnglishText.Visible = true;
            lblEnglishText.Visible = true;
        }
    }
    protected void btnOK_Click(object sender, EventArgs e)
    {
        try
        {
            string result = new Validator().NotEmpty(txtKey.Text, rfvKey.ErrorMessage).Result;

            if (result == string.Empty)
            {

                UICultureInfo uic = new UICultureInfo();
                uic = UICultureInfoProvider.GetUICultureInfo(uiCultureID);
                ResourceStringInfo ri = new ResourceStringInfo();
                ri.StringKey = txtKey.Text.Trim();
                ri.StringIsCustom = chkCustomString.Checked;
                ri.UICultureCode = uic.UICultureCode;
                ri.TranslationText = txtText.Text;
                SqlResourceManager.SetResourceStringInfo(ri);

                // if english text is set, store it
                if (txtEnglishText.Text != string.Empty)
                {
                    ri.UICultureCode = "en-us";     // !!!
                    ri.TranslationText = txtEnglishText.Text;
                    SqlResourceManager.SetResourceStringInfo(ri);

                }
                lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
                lblInfo.Visible = true;
                pageTitleTabs[1, 0] = ri.StringKey;
                Response.Redirect("UICulture_Strings_Edit.aspx?uicultureID=" + uiCultureID + "&stringid=" + ri.StringId + "&saved=1");
            }
        }
        catch
        {
            lblError.Text = ResHelper.GetString("Administration-UICulture_String_New.StringAlreardyExists").Replace("%%key%%", txtKey.Text.Trim());
            lblError.Visible = true;
        }
    }
}
