using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.GlobalHelper;
using CMS.SiteProvider;
using CMS.ResourceManager;

public partial class CMSSiteManager_Development_UICultures_UICulture_Strings_Edit : SiteManagerPage
{
    int stringID = 0;
    int uiCultureID = 0;
    ResourceStringInfo ri = new ResourceStringInfo();
    string[,] pageTitleTabs = new string[2, 3];

    protected void Page_Load(object sender, EventArgs e)
    {
        if ((Request.QueryString["stringID"] != null) && (Request.QueryString["stringID"] != ""))
        {
            stringID = Convert.ToInt32(Request.QueryString["stringID"]);
        }

        if ((Request.QueryString["uicultureID"] != null) && (Request.QueryString["uicultureID"] != ""))
        {
            uiCultureID = Convert.ToInt32(Request.QueryString["uicultureID"]);
        }

        if ((Request.QueryString["saved"] != null) && (Request.QueryString["saved"] != ""))
        {
            lblInfo.Visible = true;
            lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
        }

        imgNew.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/UICultures/Strings/addstring.gif";
        lnkNew.Text = ResHelper.GetString("Development-UICulture_Strings_List.NewString");
        lnkNew.NavigateUrl = "UICulture_String_New.aspx?UIcultureID=" + uiCultureID;
        
        ri = SqlResourceManager.GetResourceStringInfo(stringID, uiCultureID);

        // initializes page title
        pageTitleTabs[0, 0] = ResHelper.GetString("UICultures_Strings.Strings");
        pageTitleTabs[0, 1] = "~/CMSSiteManager/Development/UICultures/UICulture_Strings_List.aspx?UIcultureID=" + uiCultureID;
        pageTitleTabs[0, 2] = "";
        pageTitleTabs[1, 0] = ri.StringKey;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;

        lblCustomString.Text = ResHelper.GetString("Administration-UICulture_String_New.CustomString");
        lblEnglishText.Text = ResHelper.GetString("Administration-UICulture_String_New.EnglishText");
        lblKey.Text = ResHelper.GetString("Administration-UICulture_String_New.Key");
        lblText.Text = ResHelper.GetString("Administration-UICulture_String_New.Text");
        btnOK.Text = ResHelper.GetString("Administration-UICulture_String_New.OK");
        rfvKey.ErrorMessage = ResHelper.GetString("Administration-UICulture_String_New.EmptyKey");

        if (!IsPostBack)
        {
            
            UICultureInfo uic = new UICultureInfo();
            uic = UICultureInfoProvider.GetUICultureInfo(uiCultureID);
            if (uic.UICultureCode == "en-us")   // !!!
            {
                txtEnglishText.Visible = false;
                lblEnglishText.Visible = false;
                txtKey.Visible = true;
                lblKeyEng.Visible = false;
                txtKey.Text = ri.StringKey;
                txtText.Text = SqlResourceManager.GetStringStrictly(ri.StringKey, "en-us");
            }
            else
            {
                txtEnglishText.Visible = true;
                lblEnglishText.Visible = true;
                txtKey.Visible = false;
                rfvKey.Enabled = false;
                lblKeyEng.Visible = true;
                lblKeyEng.Text = ri.StringKey;
                
                txtEnglishText.Text = ValidationHelper.GetString(SqlResourceManager.GetStringStrictly(ri.StringKey, "en-us"),"");
                txtText.Text = ValidationHelper.GetString(SqlResourceManager.GetStringStrictly(ri.StringKey, uic.UICultureCode),"");
            }

            chkCustomString.Checked = ri.StringIsCustom;
        }
    }

    protected void btnOK_Click(object sender, EventArgs e)
    {
        string result = "";
        UICultureInfo uic = new UICultureInfo();
        uic = UICultureInfoProvider.GetUICultureInfo(uiCultureID);
        if (uic.UICultureCode == "en-us")   // !!!
        {
            result = new Validator().NotEmpty(txtKey.Text, rfvKey.ErrorMessage).Result;
        }

        if (result == string.Empty)
        {
            try
            {
                ResourceStringInfo rs = new ResourceStringInfo();
                rs.StringIsCustom = chkCustomString.Checked;
                rs.UICultureCode = uic.UICultureCode;
                rs.TranslationText = txtText.Text.Trim();
                //rs.StringKey = ri.StringKey.Trim();
                rs.StringId = ri.StringId;
                // update translation
                //SqlResourceManager.SetResourceStringInfo(rs);
                if (lblKeyEng.Visible)
                {
                    rs.StringKey = lblKeyEng.Text.Trim();
                }
                else
                {
                    rs.StringKey = txtKey.Text.Trim();
                }

                // update key
                SqlResourceManager.SetResourceStringInfo(rs);
                lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
                lblInfo.Visible = true;
                lblError.Visible = false;
                pageTitleTabs[1, 0] = rs.StringKey;
            }
            catch
            {
                lblError.Text = ResHelper.GetString("Administration-UICulture_String_New.StringAlreardyExists").Replace("%%key%%", txtKey.Text.Trim());
                lblError.Visible = true;
                lblInfo.Visible = false;
            }
        }
    }
}
