using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SiteProvider;
using CMS.FormEngine;

public partial class CMSSiteManager_Development_WebParts_WebPart_Edit_New : SiteManagerPage
{
    string[,] pageTitleTabs = new string[2, 3];

    protected void Page_Load(object sender, EventArgs e)
    {
        // initialize
        lblWebPartFileName.Text = ResHelper.GetString("Development-WebPart_Edit.WebPartFileName");       
        lbWebPartDisplaytName.Text = ResHelper.GetString("Development-WebPart_Edit.WebPartDisplaytName");
        lbWebPartName.Text = ResHelper.GetString("Development-WebPart_Edit.WebPartName");
        btnOK.Text = ResHelper.GetString("Development-WebPart_Edit.OK");
        rfvWebPartDisplayName.ErrorMessage = ResHelper.GetString("Development-WebPart_Edit.ErrorDisplayName");
        rfvWebPartFileName.ErrorMessage = ResHelper.GetString("Development-WebPart_Edit.ErrorFileName");
        rfvWebPartName.ErrorMessage = ResHelper.GetString("Development-WebPart_Edit.ErrorWebPartName");

        pageTitleTabs[0, 0] = ResHelper.GetString("Development-WebPart_Edit.WebParts");
        pageTitleTabs[0, 1] = "~/CMSSiteManager/Development/WebParts/WebPart_Frameset.aspx";
        pageTitleTabs[0, 2] = "devmain";
        pageTitleTabs[1, 0] = ResHelper.GetString("Development-WebPart_Edit.New");
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        this.PageTitle.Breadcrumbs = pageTitleTabs;
        this.PageTitle.TitleText = ResHelper.GetString("Development-WebPart_Edit.TitleNew");
        this.PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/WebParts/newwebpart.gif";
    }

    /// <summary>
    /// Updates existing or creates new web part
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnOK_Click(object sender, EventArgs e)
    {
        WebPartInfo wi = new WebPartInfo();

        wi.WebPartDisplayName = txtWebPartDisplayName.Text;
        wi.WebPartFileName = txtWebPartFileName.Text;
        wi.WebPartName = txtWebPartName.Text;
        wi.WebPartCategoryID = ValidationHelper.GetInteger(Request.QueryString["parentid"], 0);
        wi.WebPartProperties = CreateDefaultFormDefinition();
        try
        {
            WebPartInfoProvider.SetWebPartInfo(wi);
            // refresh web part tree
            ltlScript.Text = "<script language=\"javascript\" type=\"text/javascript\">";
            ltlScript.Text += "parent.frames['webparttree'].location.replace('WebPart_Tree.aspx?webpartid=" + wi.WebPartID + "');";
            ltlScript.Text += "location.replace('WebPart_Edit_Frameset.aspx?webpartid=" + wi.WebPartID + "')";
            ltlScript.Text += "</script>";

            pageTitleTabs[1, 0] = wi.WebPartDisplayName;
            this.PageTitle.Breadcrumbs = pageTitleTabs;
            lblInfo.Visible = true;
            lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
        }
        catch(Exception ex)
        {
            lblError.Visible = true;
            lblError.Text = ex.Message.Replace("%%name%%",wi.WebPartName);
        }
    }


    /// <summary>
    /// Creates three default form fields for new webpart.
    /// </summary>
    /// <returns>Form definition.</returns>
    protected string CreateDefaultFormDefinition()
    {
        FormInfo fi = new FormInfo();
        FormFieldInfo ffi = new FormFieldInfo();

        // Create empty form definition.
        fi.LoadXmlDefinition("<form></form>");

        // Create 'WebPartControlID' field.
        ffi.Name = "WebPartControlID";
        ffi.Caption = "Web part control ID";
        ffi.DataType = FormFieldDataTypeEnum.Text;
        ffi.Size = 50;
        ffi.FieldType = FormFieldControlTypeEnum.TextBoxControl;
        ffi.RegularExpression = "\\w+";
        ffi.ValidationErrorMessage = "Control ID must match identificator format.";
        // Add 'WebPartControlID' field to form definition.
        fi.AddFormField(ffi);

        ffi = new FormFieldInfo();
        // Create 'Visible' field.
        ffi.Name = "Visible";
        ffi.Caption = "Visible";
        ffi.DataType = FormFieldDataTypeEnum.Boolean;
        ffi.DefaultValue = "true";
        ffi.FieldType = FormFieldControlTypeEnum.CheckBoxControl;
        // Add 'Visible' field to form definition.
        fi.AddFormField(ffi);

        ffi = new FormFieldInfo();
        // Create 'HideOnSubPages' field.
        ffi.Name = "HideOnSubPages";
        ffi.Caption = "Hide on subpages";
        ffi.DataType = FormFieldDataTypeEnum.Boolean;
        ffi.FieldType = FormFieldControlTypeEnum.CheckBoxControl;
        // Add 'HideOnSubPages' field to form definition.
        fi.AddFormField(ffi);

        ffi = new FormFieldInfo();
        // Create 'ShowForDocumentTypes' field.
        ffi.Name = "ShowForDocumentTypes";
        ffi.Caption = "Show for document types";
        ffi.DataType = FormFieldDataTypeEnum.Text;
        ffi.Size = 200;
        ffi.AllowEmpty = true;
        ffi.FieldType = FormFieldControlTypeEnum.CustomUserControl;
        ffi.Settings["controlname"] = "selectclassnames";
        // Add 'ShowForDocumentTypes' field to form definition.
        fi.AddFormField(ffi);

        ffi = new FormFieldInfo();
        // Create 'DisplayToRoles' field.
        ffi.Name = "DisplayToRoles";
        ffi.Caption = "Display to roles";
        ffi.DataType = FormFieldDataTypeEnum.Text;
        ffi.Size = 200;
        ffi.AllowEmpty = true;
        ffi.FieldType = FormFieldControlTypeEnum.CustomUserControl;
        ffi.Settings["controlname"] = "rolecheckboxselector";
        // Add 'DisplayToRoles' field to form definition.
        fi.AddFormField(ffi);

        // Create 'HTML Envelope' category.
        FormCategoryInfo fci = new FormCategoryInfo();
        fci.CategoryName = "HTML Envelope";
        // Add 'HTML Envelope' category to form definition.
        fi.AddFormCategory(fci);

        ffi = new FormFieldInfo();
        // Create 'Container' field.
        ffi.Name = "Container";
        ffi.Caption = "Web part container";
        ffi.DataType = FormFieldDataTypeEnum.Text;
        ffi.Size = 200;
        ffi.AllowEmpty = true;
        ffi.FieldType = FormFieldControlTypeEnum.CustomUserControl;
        ffi.Settings["controlname"] = "selectcontainer";
        // Add 'Container' field to form definition.
        fi.AddFormField(ffi);

        ffi = new FormFieldInfo();
        // Create 'ContainerTitle' field.
        ffi.Name = "ContainerTitle";
        ffi.Caption = "Web part container title";
        ffi.DataType = FormFieldDataTypeEnum.Text;
        ffi.Size = 200;
        ffi.AllowEmpty = true;
        ffi.FieldType = FormFieldControlTypeEnum.TextBoxControl;
        // Add 'ContainerTitle' field to form definition.
        fi.AddFormField(ffi);

        ffi = new FormFieldInfo();
        // Create 'ContentBefore' field.
        ffi.Name = "ContentBefore";
        ffi.Caption = "Content before";
        ffi.DataType = FormFieldDataTypeEnum.LongText;
        ffi.AllowEmpty = true;
        ffi.FieldType = FormFieldControlTypeEnum.CustomUserControl;
        ffi.Settings["controlname"] = "largetextarea";
        // Add 'ContentBefore' field to form definition.
        fi.AddFormField(ffi);

        ffi = new FormFieldInfo();
        // Create 'ContentAfter' field.
        ffi.Name = "ContentAfter";
        ffi.Caption = "Content after";
        ffi.DataType = FormFieldDataTypeEnum.LongText;
        ffi.AllowEmpty = true;
        ffi.FieldType = FormFieldControlTypeEnum.CustomUserControl;
        ffi.Settings["controlname"] = "largetextarea";
        // Add 'ContentAfter' field to form definition.
        fi.AddFormField(ffi); 

        return fi.GetXmlDefinition();
    }
}
