using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.WorkflowEngine;
using CMS.CMSHelper;
using CMS.GlobalHelper;
using CMS.SiteProvider;

public partial class SiteManager_Development_Workflows_Workflow_Scopes : SiteManagerPage
{
    protected int workflowId = 0;
    protected int siteId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // control initialization
        lnkNewScope.Text = ResHelper.GetString("Development-Workflow_Scopes.NewScope");

        UniGridWorkflowScopes.GridView.GridLines = GridLines.Horizontal;
        UniGridWorkflowScopes.OnAction += new OnActionEventHandler(UniGridRoles_OnAction);

        lblSite.Text = ResHelper.GetString("Development-Workflow_Scopes.Site");
        imgNewScope.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/Workflows/addscope.gif";


        if (!IsPostBack)
        {
            DataSet sitesSet = SiteInfoProvider.GetAllSites();
            DataTable sitesTable = sitesSet.Tables[0];
            foreach (DataRow siteRow in sitesTable.Rows)
            {
                ListItem siteListItem = new ListItem(siteRow["SiteDisplayName"].ToString(), siteRow["SiteID"].ToString());
                drpSites.Items.Add(siteListItem);
            }
            if ((Request.QueryString["siteid"] != null) && (Request.QueryString["siteid"].ToString() != ""))
            {
                drpSites.SelectedValue = Request.QueryString["siteid"].ToString();
            }
            else  if ( CMSContext.CurrentSite != null )
            {
                drpSites.SelectedValue = CMSContext.CurrentSite.SiteID.ToString();
            }
        }


        if ((Request.QueryString["workflowid"] != null) && (Request.QueryString["workflowid"].ToString() != ""))
        {
            workflowId = Convert.ToInt32(Request.QueryString["workflowid"]);
        }
        
        lnkNewScope.NavigateUrl = "Workflow_Scope_Edit.aspx?workflowid=" + workflowId;
        if (drpSites.SelectedIndex < 0)
        {
            if (drpSites.Items.Count > 0)
            {
                drpSites.SelectedIndex = 0;
                siteId = Convert.ToInt32(drpSites.SelectedValue);
            }
            else
            {
                lnkNewScope.Enabled = false;
            }
        }
        else
        {
            siteId = Convert.ToInt32(drpSites.SelectedValue);
        }
        lnkNewScope.NavigateUrl += "&siteid=" + siteId;        

        
        UniGridWorkflowScopes.WhereCondition = "ScopeWorkflowID = " + workflowId + " AND ScopeSiteID = " + siteId;
        if (!IsPostBack)
        {
            UniGridWorkflowScopes.OrderBy = "ScopeStartingPath";
        }
    }

    /// <summary>
    /// Handles the UniGrid's OnAction event.
    /// </summary>
    /// <param name="actionName">Name of item (button) that threw event.</param>
    /// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
    protected void UniGridRoles_OnAction(string actionName, object actionArgument)
    {
        int workflowScopeId = Convert.ToInt32(actionArgument);
        if (actionName == "edit")
        {
            Response.Redirect("Workflow_Scope_Edit.aspx?scopeid=" + workflowScopeId.ToString());
        }

        else if (actionName == "delete")
        {
            if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.administration", "Delete"))
            {
                RedirectToAccessDenied("cms.administration", "Delete");
            }
            WorkflowInfoProvider.DeleteWorkflowScopeInfo(workflowScopeId);
        }
    }
    
    protected void drpSites_SelectedIndexChanged(object sender, EventArgs e)
    {
        UniGridWorkflowScopes.GridView.DataBind();
    }
}