using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;

using CMS.SettingsProvider;
using CMS.SiteProvider;
using CMS.GlobalHelper;

public partial class CMSDesk_Settings_keys : SiteManagerPage
{
    protected int siteId = 0;
    protected string siteName = "";
    protected int categoryId = 0;
    protected DataTable keyTable = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        //IsRoundedByDollarChar("$ahoj$");
        if ((Request.QueryString["siteid"]) != null)
        {
            siteId = Int32.Parse(Request.QueryString["siteid"]);
        }
        if (siteId > 0)
        {
            SiteInfo si = SiteInfoProvider.GetSiteInfo(siteId);
            siteName = si.SiteName;
        }

        PageTitle1.TitleText = ResHelper.GetString("Header.Settings");
        PageTitle1.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Settings/settings.gif";

        if ((Request.QueryString["categoryid"]) != null)
        {
            categoryId = Int32.Parse(Request.QueryString["categoryid"]);
        }
        string inheritFromGlobalMsg = ResHelper.GetString("Settings-Keys.CheckBoxInheritGlobalMsg");
        string noCategorySelectedMsg = ResHelper.GetString("Settings-Keys.NoCategorySelectedMsg");
        string displayName = "";
        string keyDescription = "";
        
        if (categoryId != 0)
        {
            Label errorLabel = null;
            Label mLabel = new Label();
            mLabel.ID = "lblInfo";
            mLabel.Visible = false;
            mLabel.EnableViewState = false;
            PlaceHolderContent.Controls.Add(mLabel);

            PlaceHolderContent.Controls.Add(new LiteralControl("<br><table border=\"0\" cellpadding=\"0\" cellspacing=\"10\">"));

           
           //Load settings keys into DataSet
            DataSet keysSet = SettingsKeyProvider.GetSettingsKeys(siteId, categoryId);
            keyTable = keysSet.Tables[0];
            int i = 0;
            foreach (DataRow keyRow in keyTable.Rows)
            {
                i++;
                PlaceHolder placeHolderRow = new PlaceHolder();
                placeHolderRow.ID = "PlaceHolderRow_" + i.ToString();

                
                placeHolderRow.Controls.Add(new LiteralControl("<tr>"));
                
               

                placeHolderRow.Controls.Add(new LiteralControl("<td style=\"padding: 0px 0px 0px 0px\">"));
                Label labelKeyName = new Label();
                labelKeyName.ID = "LabelKeyDisplayName_" + i.ToString();
                displayName = GetResourceName(keyRow["KeyDisplayName"].ToString());
                labelKeyName.Text = displayName == "" ? keyRow["KeyDisplayName"].ToString() : ResHelper.GetString(displayName);
                labelKeyName.Attributes.Add("style", "cursor: help;");
                labelKeyName.ToolTip = keyDescription == "" ? keyRow["KeyDescription"].ToString() : ResHelper.GetString(keyDescription);
                placeHolderRow.Controls.Add(labelKeyName);
                placeHolderRow.Controls.Add(new LiteralControl("</td>"));
                placeHolderRow.Controls.Add(new LiteralControl("<td>"));
                Image helpImg = new Image();
                helpImg.ID = "imgHelp_" + i.ToString();
                helpImg.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Settings/help.gif";
                keyDescription = GetResourceName(keyRow["KeyDescription"].ToString());
                helpImg.ToolTip = keyDescription == "" ? keyRow["KeyDescription"].ToString() : ResHelper.GetString(keyDescription);
                placeHolderRow.Controls.Add(helpImg);
                placeHolderRow.Controls.Add(new LiteralControl("</td>"));
                

                placeHolderRow.Controls.Add(new LiteralControl("<td style=\"padding: 0px 20px 0px 0px\">"));

                CheckBox chbox2 = new CheckBox();
                if (siteId > 0)
                {
                    chbox2.ID = "CheckBoxIsGlobal_" + i.ToString();
                    chbox2.CheckedChanged += new EventHandler(chbox2_CheckedChanged);
                    chbox2.AutoPostBack = true;
                }
                
                if (keyRow["KeyType"].ToString() == "boolean")// add checkbox
                {
                    CheckBox chbox = new CheckBox();
                    if (keyRow["KeyValue"] == DBNull.Value)
                    {
                        if (siteId > 0) chbox2.Checked = true;
                        chbox.Checked = SettingsKeyProvider.GetBoolValue(keyRow["keyName"].ToString().ToLower());
                        chbox.Enabled = false;
                    }
                    else
                    {
                        string keyName = "";
                        if (siteId > 0)
                        {
                            chbox2.Checked = false;
                            keyName = SiteInfoProvider.GetSiteInfo(siteId).SiteName + "." + keyRow["keyName"].ToString();
                        }
                        else
                        {
                            keyName = keyRow["keyName"].ToString();
                        }
                        keyName = keyName.ToLower();

                        chbox.Checked = SettingsKeyProvider.GetBoolValue(keyName);
                            //if (keyRow["KeyValue"].ToString().ToLower() == "true") chbox.Checked = true;
                        //else chbox.Checked = false;
                        chbox.Enabled = true;
                    }
                    chbox.ID = "CheckBoxKeyValue_" + i.ToString();
                    placeHolderRow.Controls.Add(chbox);
                }
                else //add textbox
                {
                    TextBox tbox = new TextBox();
                    if (keyRow["KeyValue"] == DBNull.Value)
                    {
                        if (siteId > 0) chbox2.Checked = true;
                        tbox.Text = SettingsKeyProvider.GetStringValue(keyRow["keyName"].ToString());
                        tbox.Enabled = false;
                    }
                    else
                    {
                        if (siteId > 0) chbox2.Checked = false;
                        tbox.Text = keyRow["KeyValue"].ToString();
                        tbox.Enabled = true;
                    }
                    tbox.ID = "TextBoxKeyValue_" + i.ToString();
                    placeHolderRow.Controls.Add(tbox);
                }
                placeHolderRow.Controls.Add(new LiteralControl("<br />"));

                if (siteId > 0)
                {
                    placeHolderRow.Controls.Add(chbox2);
                    placeHolderRow.Controls.Add(new LiteralControl(inheritFromGlobalMsg));
                }
                else chbox2.Dispose();
                placeHolderRow.Controls.Add(new LiteralControl("</td>"));


                placeHolderRow.Controls.Add(new LiteralControl("<td>"));
                Button btn = new Button();
                btn.Text = ResHelper.GetString("General.Save");
                btn.ID = "ButtonSave_" + i.ToString();
                btn.CommandName = "save";
                btn.CommandArgument = keyRow["KeyName"].ToString();
                btn.Click += new EventHandler(btn_Click);
                btn.SkinID = "ContentButton";
                placeHolderRow.Controls.Add(btn);
                placeHolderRow.Controls.Add(new LiteralControl("</td>"));
                placeHolderRow.Controls.Add(new LiteralControl("<td>"));
                labelKeyName = new Label();
                labelKeyName.ID = "LabelKeyName_" + i.ToString();
                labelKeyName.Text = keyRow["KeyName"].ToString();
                labelKeyName.Visible = false;
                placeHolderRow.Controls.Add(labelKeyName);
                // Add error label if KeyType is integer.
                if (keyRow["KeyType"].ToString() == "int")
                {
                    errorLabel = new Label();
                    errorLabel.ID = "lblError_" + i.ToString();
                    errorLabel.EnableViewState = false;
                    errorLabel.SkinID = "ErrorLabel";
                    placeHolderRow.Controls.Add(errorLabel);
                }
                placeHolderRow.Controls.Add(new LiteralControl("</td>"));
                PlaceHolderContent.Controls.Add(placeHolderRow);
            }
            PlaceHolderContent.Controls.Add(new LiteralControl("</table>"));
        }
        else
        {
            PlaceHolderContent.Controls.Add(new LiteralControl(noCategorySelectedMsg));
        }
    }


    /// <summary>
    /// Handles 'inherit from global settings' checkboxes.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    void chbox2_CheckedChanged(object sender, EventArgs e)
    {
        CheckBox chboxSender = (CheckBox)sender;//inherit from global settings?
        Control ctrl = chboxSender.Parent.Controls[8];//check box or text box with key value
        Label lbl;
        if (ValidationHelper.GetInteger(keyTable.Rows[0]["siteId"],0) == 0) //global site
        {
            lbl = (Label)chboxSender.Parent.Controls[15];//label with key name
        }
        else //other site
        {
            lbl = (Label)chboxSender.Parent.Controls[17];//label with key name
        }
        string keyName = lbl.Text;

        if (ctrl is CheckBox)
        {
            CheckBox chbox = (CheckBox)ctrl;
            chbox.Enabled = !chbox.Enabled;
            chbox.Checked = SettingsKeyProvider.GetBoolValue(keyName);
        }
        else if (ctrl is TextBox)
        {
            TextBox tb = (TextBox)ctrl;
            tb.Enabled = !tb.Enabled;
            tb.Text = SettingsKeyProvider.GetStringValue(keyName);
        }
    }


    /// <summary>
    /// Handles Save buttons clicks.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    void btn_Click(object sender, EventArgs e)
    {
        Button btn = (Button)sender;
        Label lbl;
        Label errorLabel = null;

        if (ValidationHelper.GetInteger(keyTable.Rows[0]["siteId"], 0) == 0) //global site
        {
            lbl = (Label)btn.Parent.Controls[15];//label with key name
        }
        else //other site
        {
            lbl = (Label)btn.Parent.Controls[17];//label with key name
        }
        string keyName = lbl.Text;

        object keyValue = DBNull.Value;
        
        Control ctrl = btn.Parent.Controls[8];//check box or text box with key value
        if (btn.Parent.Controls[8] is CheckBox)
        {
            CheckBox rb2 = new CheckBox();
            if (ValidationHelper.GetInteger(keyTable.Rows[0]["siteId"], 0) == 0)
            {
                rb2.Checked = false;
            }
            else
            {
                rb2 = (CheckBox)btn.Parent.Controls[10];//inherit from global settings?
            }
            if (!rb2.Checked)
            {
                if (ctrl is CheckBox)
                {
                    CheckBox rb = (CheckBox)ctrl;
                    keyValue = rb.Checked;
                }
                else if (ctrl is TextBox)
                {
                    TextBox tb = (TextBox)ctrl;
                    SettingsKeyInfo ski = SettingsKeyProvider.GetSettingsKeyInfo(keyName);
                    // Validate if key type is integer
                    if ((ski.KeyType == "int") && (!ValidationHelper.IsInteger(tb.Text)))
                    {
                        // Get identification number of control.
                        string id = tb.ID.Substring(tb.ID.IndexOf("_") + 1);
                        errorLabel = (Label)btn.Parent.FindControl("lblError_" + id);
                        errorLabel.Text = ResHelper.GetString("Settings.ValidationIntError");
                        return;
                    }
                    // Validate if key type is double
                    else if ((ski.KeyType == "double") && (!ValidationHelper.IsDouble(tb.Text)))
                    {
                        // Get identification number of control.
                        string id = tb.ID.Substring(tb.ID.IndexOf("_") + 1);
                        errorLabel = (Label)btn.Parent.FindControl("lblError_" + id);
                        errorLabel.Text = ResHelper.GetString("Settings.ValidationDoubleError");
                        return;
                    }
                    keyValue = tb.Text;
                }
            }
        }
        else
        {
            if (ctrl is CheckBox)
            {
                CheckBox rb = (CheckBox)ctrl;
                keyValue = rb.Checked;
            }
            else if (ctrl is TextBox)
            {
                TextBox tb = (TextBox)ctrl;
                SettingsKeyInfo ski = SettingsKeyProvider.GetSettingsKeyInfo(keyName);
                // Validate if key type is integer
                if ((ski.KeyType == "int") && (!ValidationHelper.IsInteger(tb.Text)))
                {
                    // Get identification number of control.
                    string id = tb.ID.Substring(tb.ID.IndexOf("_") + 1);
                    errorLabel = (Label)btn.Parent.FindControl("lblError_" + id);
                    errorLabel.Text = ResHelper.GetString("Settings.ValidationIntError");
                    return;
                }
                // Validate if key type is double
                else if ((ski.KeyType == "double") && (!ValidationHelper.IsDouble(tb.Text)))
                {
                    // Get identification number of control.
                    string id = tb.ID.Substring(tb.ID.IndexOf("_") + 1);
                    errorLabel = (Label)btn.Parent.FindControl("lblError_" + id);
                    errorLabel.Text = ResHelper.GetString("Settings.ValidationDoubleError");
                    return;
                }
                keyValue = tb.Text;
            }
        }

        if (siteId != 0) keyName = siteName + "." + keyName;
        SettingsKeyProvider.SetValue(keyName, keyValue);
    
    
         Label mLabel = (Label)PlaceHolderContent.FindControl("lblInfo");
         mLabel.Text = ResHelper.GetString("general.changessaved");
         mLabel.Visible = true;
    }
    

    /// <summary>
    /// Get resource name.
    /// </summary>
    /// <param name="key">Key.</param>
    /// <returns></returns>
    public static string GetResourceName(string key)
    {
        Regex Exp = new Regex("^(\\$)(.*)(\\$)$");

        if ((key == null)||(!Exp.Match(key.ToString()).Success)) 
        {
            return "";
        }
        else
        {
            return Exp.Replace(key.ToString(), "$2");
        }
    }
}
