using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.SiteProvider;
using CMS.CMSHelper;
using CMS.DataEngine;

public partial class CMSWebParts_Designers_RoleCheckboxSelection : DesignerPage
{    
    protected string txtClientId = "";
    protected string lblClientId = "";
    protected string roleNames = "";
    protected DataSet dsRoles = null;
    protected SiteInfo si = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        // Get info from URL               
        txtClientId = ValidationHelper.GetString(Request.QueryString["txtElem"], "");
        lblClientId = ValidationHelper.GetString(Request.QueryString["lblElem"], "");
        roleNames = ValidationHelper.GetString(Request.QueryString["names"], "");

        // Control initialization
        this.titleElem.TitleText = ResHelper.GetString("RoleNameSelection.Title");
        this.titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSWebParts/Designers/RoleSelection.gif";
        this.btnOK.Text = ResHelper.GetString("General.OK");
        this.btnCancel.Text = ResHelper.GetString("General.Cancel");
        btnCancel.OnClientClick = "Cancel();";
                
        // Get current site
        si = CMSContext.CurrentSite;

        if (si != null)
        {
            // Grid initialization
            gridRoles.GridLines = GridLines.Horizontal;

            if (!this.IsPostBack)
            {
                gridRoles.Columns[0].HeaderText = ResHelper.GetString("RoleNameSelection.Select");
                gridRoles.Columns[1].HeaderText = ResHelper.GetString("RoleNameSelection.DisplayName");
                gridRoles.Columns[2].HeaderText = ResHelper.GetString("RoleNameSelection.CodeName");

                // Get all site roles
                dsRoles = RoleInfoProvider.GetAllRoles(si.SiteID);

                // Fill grid with roles
                if (!DataHelper.DataSourceIsEmpty(dsRoles))
                {
                    dsRoles.Tables[0].DefaultView.Sort = "RoleDisplayName";
                    gridRoles.DataSource = dsRoles.Tables[0].DefaultView;
                    gridRoles.DataBind();
                }
            }
        }
    }


    protected void btnOK_Click(object sender, EventArgs e)
    {
        string selectedRoles = "";

        // Find checked roles
        foreach (GridViewRow row in gridRoles.Rows)
        {
            CheckBox chBox = (CheckBox)row.FindControl("chkSelect");
            if (chBox != null)
            {
                if (chBox.Checked)
                {
                    selectedRoles += row.Cells[2].Text.Trim() + ";";
                }                                
            }
        }

        selectedRoles = selectedRoles.TrimEnd(';');

        // Set roles to the textbox
        if ((txtClientId != "") && (lblClientId != ""))
        {
            ltlScript.Text = ScriptHelper.GetScript("SetRolesToTextBox('" + selectedRoles + "', '" + txtClientId + "', '" + lblClientId + "');"); 
        }
        
    }

       
    protected void gridRoles_DataBound(object sender, EventArgs e)
    {        
        string name = "";
        roleNames = ';' + roleNames.Trim(';') + ';';

        // Mark selected roles
        foreach (GridViewRow row in gridRoles.Rows)
        {
            CheckBox chBox = (CheckBox)row.FindControl("chkSelect");                                    
            if (chBox != null)
            {
                name = ';' + row.Cells[2].Text.Trim() + ';';
                chBox.Checked = (roleNames.Contains(name));
            }
        }
    }
}
