using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.Forums;

public partial class CMSWebParts_Forum_ForumFlat : CMSAbstractWebPart
{
    #region Public properties


    /// <summary>
    /// Enable display user picture.
    /// </summary>
    public bool EnablePicture
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("EnableImages"), this.ForumFlatView1.EnablePicture); }
        set
        {
            this.SetValue("EnableImages", value);
            this.ForumFlatView1.EnablePicture = ValidationHelper.GetBoolean(value, this.ForumFlatView1.EnablePicture);
        }
    }

    /// <summary>
    /// Max. picture width
    /// </summary>
    public int MaxPictureWidth
    {
        get { return ValidationHelper.GetInteger(this.GetValue("MaxImageWidth"), this.ForumFlatView1.MaxPictureWidth); }
        set
        {
            this.SetValue("MaxImageWidth", value);
            this.ForumFlatView1.MaxPictureWidth = ValidationHelper.GetInteger(value, this.ForumFlatView1.MaxPictureWidth);
        }
    }

    /// <summary>
    /// Max picture height
    /// </summary>
    public int MaxPictureHeight
    {
        get { return ValidationHelper.GetInteger(this.GetValue("MaxImageHeight"), this.ForumFlatView1.MaxPictureHeight); }
        set
        {
            this.SetValue("MaxImageHeight", value);
            this.ForumFlatView1.MaxPictureHeight = ValidationHelper.GetInteger(value, this.ForumFlatView1.MaxPictureHeight);
        }
    }

    /// <summary>
    /// Enable signature
    /// </summary>
    public bool EnableSignature
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("EnableSignature"), this.ForumFlatView1.EnableSignature); }
        set
        {
            this.SetValue("EnableSignature", value);
            this.ForumFlatView1.EnableSignature = ValidationHelper.GetBoolean(value, this.ForumFlatView1.EnableSignature);
        }
    }


    /// <summary>
    /// Forum name
    /// </summary>
    public string ForumName
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("ForumName"), "");
        }
        set
        {
            this.SetValue("ForumName", value);
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.ForumFlatView1.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.ForumFlatView1.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("WhereCondition"), this.ForumFlatView1.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.ForumFlatView1.WhereCondition = value;
        }
    }


    /// <summary>
    /// Select only approved
    /// </summary>
    public bool SelectOnlyApproved
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyApproved"), this.ForumFlatView1.SelectOnlyApproved);
        }
        set
        {
            this.SetValue("SelectOnlyApproved", value);
            this.ForumFlatView1.SelectOnlyApproved = value;
        }
    }


    /// <summary>
    /// Post path
    /// </summary>
    public string PostPath
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("PostPath"), this.ForumFlatView1.PostPath);
        }
        set
        {
            this.SetValue("PostPath", value);
            this.ForumFlatView1.PostPath = value;
        }
    }


    /// <summary>
    /// Enable subscription
    /// </summary>
    public bool EnableSubscription
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("EnableSubscription"), this.ForumFlatView1.EnableSubscription);
        }
        set
        {
            this.SetValue("EnableSubscription", value);
            this.ForumFlatView1.EnableSubscription = value;
        }
    }


    /// <summary>
    /// Enable paging
    /// </summary>
    public bool EnablePaging
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("EnablePaging"), this.ForumFlatView1.EnablePaging);
        }
        set
        {
            this.SetValue("EnablePaging", value);
            this.ForumFlatView1.EnablePaging = value;
        }
    }


    /// <summary>
    /// Page size
    /// </summary>
    public int PageSize
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("PageSize"), this.ForumFlatView1.PageSize);
        }
        set
        {
            this.SetValue("PageSize", value);
            this.ForumFlatView1.PageSize = value;
        }
    }


    /// <summary>
    /// Check permissions
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.ForumFlatView1.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
            this.ForumFlatView1.CheckPermissions = value;
        }
    }


    /// <summary>
    /// If true, only authenticated users can read the forum
    /// </summary>
    public bool AnonymousRead
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("AnonymousRead"), this.ForumFlatView1.NoAuthenticatedRead);
        }
        set
        {
            this.SetValue("AnonymousRead", value);
            this.ForumFlatView1.NoAuthenticatedRead = value;
        }
    }

    /// <summary>
    /// Querystring for thread
    /// </summary>
    public string ThreadQueryString
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("ThreadQueryString"), this.ForumFlatView1.mForumProperties.QueryStringThread);
        }
        set
        {
            this.SetValue("ThreadQueryString", value);
            this.ForumFlatView1.mForumProperties.QueryStringThread = value;
        }
    }

    
    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.ForumFlatView1.StopProcessing = true; // Do nothing
        }
        else
        {
            if (CMSContext.CurrentSite != null)
            {
                ForumInfo fi = ForumInfoProvider.GetForumInfo(this.ForumName, CMSContext.CurrentSite.SiteID);

                if (fi != null)
                {
                    this.ForumFlatView1.ForumID = fi.ForumID;
                }
                else
                {
                    this.ForumFlatView1.AdHocForum = true;
                }
            }


            this.ForumFlatView1.mForumProperties.QueryStringThread = this.ThreadQueryString;
            this.ForumFlatView1.MaxRelativeLevel = this.MaxRelativeLevel;
            this.ForumFlatView1.WhereCondition = this.WhereCondition;
            this.ForumFlatView1.SelectOnlyApproved = this.SelectOnlyApproved;
            this.ForumFlatView1.PostPath = this.PostPath;

            this.ForumFlatView1.EnableSubscription = this.EnableSubscription;

            this.ForumFlatView1.EnablePaging = this.EnablePaging;
            this.ForumFlatView1.PageSize = this.PageSize;

            this.ForumFlatView1.CheckPermissions = this.CheckPermissions;

            this.ForumFlatView1.NoAuthenticatedRead = this.AnonymousRead;

            this.ForumFlatView1.EnablePicture = this.EnablePicture;
            this.ForumFlatView1.EnableSignature = this.EnableSignature;
            this.ForumFlatView1.MaxPictureWidth = this.MaxPictureWidth;
            this.ForumFlatView1.MaxPictureHeight = this.MaxPictureHeight;
        }
    }
}
