using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.Forums;

public partial class CMSWebParts_Forum_ForumGroup : CMSAbstractWebPart
{
    #region "Public properties"

    /// <summary>
    /// Enable display user picture.
    /// </summary>
    public bool EnablePicture
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("EnableImages"), this.Forum1.EnablePicture); }
        set
        {
            this.SetValue("EnableImages", value);
            this.Forum1.EnablePicture = ValidationHelper.GetBoolean(value, this.Forum1.EnablePicture);
        }
    }

    /// <summary>
    /// Max. picture width
    /// </summary>
    public int MaxPictureWidth
    {
        get { return ValidationHelper.GetInteger(this.GetValue("MaxImageWidth"), this.Forum1.MaxPictureWidth); }
        set
        {
            this.SetValue("MaxImageWidth", value);
            this.Forum1.MaxPictureWidth = ValidationHelper.GetInteger(value, this.Forum1.MaxPictureWidth);
        }
    }

    /// <summary>
    /// Max picture height
    /// </summary>
    public int MaxPictureHeight
    {
        get { return ValidationHelper.GetInteger(this.GetValue("MaxImageHeight"), this.Forum1.MaxPictureHeight); }
        set
        {
            this.SetValue("MaxImageHeight", value);
            this.Forum1.MaxPictureHeight = ValidationHelper.GetInteger(value, this.Forum1.MaxPictureHeight);
        }
    }

    /// <summary>
    /// Enable signature
    /// </summary>
    public bool EnableSignature
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("EnableSignature"), this.Forum1.EnableSignature); }
        set
        {
            this.SetValue("EnableSignature", value);
            this.Forum1.EnableSignature = ValidationHelper.GetBoolean(value, this.Forum1.EnableSignature);
        }
    }

    /// <summary>
    /// Group name
    /// </summary>
    public string GroupName
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("GroupName"), this.Forum1.GroupName);
        }
        set
        {
            this.SetValue("GroupName", value);
            this.Forum1.GroupName = value;
        }
    }


    /// <summary>
    /// True if the tree should be expanded
    /// </summary>
    public bool ExpandTree
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ExpandTree"), false);
        }
        set
        {
            this.SetValue("ExpandTree", value);
            this.Forum1.ExpandTree = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.Forum1.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.Forum1.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("WhereCondition"), this.Forum1.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.Forum1.WhereCondition = value;
        }
    }


    /// <summary>
    /// True if should be selected only approved posts
    /// </summary>
    public bool SelectOnlyApproved
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyApproved"), this.Forum1.SelectOnlyApproved);
        }
        set
        {
            this.SetValue("SelectOnlyApproved", value);
            this.Forum1.SelectOnlyApproved = value;
        }
    }


    /// <summary>
    /// Starting path simillar to alias path (to be able to display only part of the thread)
    /// </summary>
    public string PostPath
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("PostPath"), this.Forum1.PostPath);
        }
        set
        {
            this.SetValue("PostPath", value);
            this.Forum1.PostPath = value;
        }
    }


    /// <summary>
    /// Show mode
    /// </summary>
    public ShowModeEnum ShowMode
    {
        get
        {
            return ForumModes.GetShowMode(ValidationHelper.GetString(this.GetValue("ShowMode"), this.Forum1.ShowMode.ToString()));
        }
        set
        {
            this.SetValue("ShowMode", value);
            this.Forum1.ShowMode = value;
        }
    }


    /// <summary>
    /// True if the paging should be enabled
    /// </summary>
    public bool EnablePaging
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("EnablePaging"), this.Forum1.EnablePaging);
        }
        set
        {
            this.SetValue("EnablePaging", value);
            this.Forum1.EnablePaging = value;
        }
    }


    /// <summary>
    /// Size of the forum page
    /// </summary>
    public int PageSize
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("PageSize"), this.Forum1.PageSize);
        }
        set
        {
            this.SetValue("PageSize", value);
            this.Forum1.PageSize = value;
        }
    }


    /// <summary>
    /// If true, the alternating style is used
    /// </summary>
    public bool UseAlternatingStyle
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("UseAlternatingStyle"), this.Forum1.UseAlternatingStyle);
        }
        set
        {
            this.SetValue("UseAlternatingStyle", value);
            this.Forum1.UseAlternatingStyle = value;
        }
    }


    /// <summary>
    /// Querystring ForumID
    /// </summary>
    public string QueryStringForumID
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("QueryStringForumID"), this.Forum1.QueryStringForumID);
        }
        set
        {
            this.SetValue("QueryStringForumID", value);
            this.Forum1.QueryStringForumID = value;
        }
    }

    /// <summary>
    /// Querystring for thread
    /// </summary>
    public string ThreadQueryString
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("ThreadQueryString"), this.Forum1.mForumProperties.QueryStringThread);
        }
        set
        {
            this.SetValue("ThreadQueryString", value);
            this.Forum1.mForumProperties.QueryStringThread = value;
        }
    }


    /// <summary>
    /// If true, only open threads are displayed
    /// </summary>
    public bool DisplayOnlyOpen
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("DisplayOnlyOpen"), this.Forum1.DisplayOnlyOpen);
        }
        set
        {
            this.SetValue("DisplayOnlyOpen", value);
            this.Forum1.DisplayOnlyOpen = value;
        }
    }


    /// <summary>
    /// True if the permissions should be checked
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.Forum1.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
            this.Forum1.CheckPermissions = value;
        }
    }


    /// <summary>
    /// True if the subscription should be enabled
    /// </summary>
    public bool EnableSubscription
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("EnableSubscription"), this.Forum1.EnableSubscription);
        }
        set
        {
            this.SetValue("EnableSubscription", value);
            this.Forum1.EnableSubscription = value;
        }
    }


    /// <summary>
    /// If true, only authenticated users should read the forum
    /// </summary>
    public bool AnonymousRead
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("AnonymousRead"), this.Forum1.NoAuthenticatedRead);
        }
        set
        {
            this.SetValue("AnonymousRead", value);
            this.Forum1.NoAuthenticatedRead = value;
        }
    }


    /// <summary>
    /// Stop processing
    /// </summary>
    public bool StopProccesing
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("StopProccesing"), this.Forum1.StopProcessing);
        }
        set
        {
            this.SetValue("StopProccesing", value);
            this.Forum1.StopProcessing = value;
        }
    }

    /// <summary>
    /// True if the flat view sholud be used
    /// </summary>
    public bool UseFlatView
    {
        get
        {
            return ValidationHelper.GetBoolean(ValidationHelper.GetInteger(this.GetValue("ForumViewMode"), 1), this.Forum1.UseFlatView);
        }
        set
        {
            this.SetValue("ForumViewMode", value);
            this.Forum1.UseFlatView = value;
        }
    }

    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }

    /// <summary>
    /// OnLoad
    /// </summary>
    /// <param name="e"></param>
    protected override void OnLoad(EventArgs e)
    {

        this.Forum1.StopProcessing = this.StopProccesing;

        base.OnLoad(e);
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.Forum1.StopProcessing = true;  // Do nothing
        }
        else
        {
            // Hide other groups on the page if some forum is specified
            // Portal engine page
            if (this.PartInstance != null)
            {
                for (int j = 0; j < this.PartInstance.ParentZone.ParentPageTemplateInfo.WebPartZones.Count; j++)
                {
                    CMS.PortalEngine.WebPartZoneInstance wpzi = ((CMS.PortalEngine.WebPartZoneInstance)this.PartInstance.ParentZone.ParentPageTemplateInfo.WebPartZones[j]);

                    for (int i = 0; i < wpzi.WebParts.Count; i++)
                    {
                        CMS.PortalEngine.WebPartInstance wpi = ((CMS.PortalEngine.WebPartInstance)wpzi.WebParts[i]);
                        if (wpi.WebPartType.ToLower() == "forumgroup")
                        {
                            if (wpi.ControlID != ValidationHelper.GetString(this.GetValue("WebPartControlID"), ""))
                            {
                                if (Request.QueryString[DataHelper.GetNotEmpty(this.QueryStringForumID, this.Forum1.mForumProperties.QueryStringForumID)] != null)
                                {
                                    int forumId = ValidationHelper.GetInteger(Request.QueryString[DataHelper.GetNotEmpty(this.QueryStringForumID, this.Forum1.mForumProperties.QueryStringForumID)], 0);
                                    if (forumId > 0)
                                    {

                                        ForumGroupInfo fgi = ForumGroupInfoProvider.GetForumGroupInfo(ValidationHelper.GetString(wpi.GetValue("GroupName"), ""), CMSContext.CurrentSite.SiteName);
                                        if (fgi != null)
                                        {
                                            DataSet ds = ForumInfoProvider.GetForumsByGroupID(fgi.GroupID);
                                            if (!DataHelper.DataSourceIsEmpty(ds))
                                            {
                                                bool isInGroup = false;
                                                foreach (DataRow dr in ds.Tables[0].Rows)
                                                {
                                                    if (forumId == ValidationHelper.GetInteger(dr["ForumId"], -1))
                                                    {
                                                        isInGroup = true;
                                                    }
                                                }

                                                if (!isInGroup)
                                                {
                                                    wpi.SetValue("StopProccesing", true);
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            else // ASPX Pages
            {
                for (int i = 0; i < this.Page.Controls.Count; i++)
                {
                    if ((this.Page.Controls[i] != null) && (this.Page.Controls[i] is CMSWebParts_Forum_ForumGroup))
                    {
                        CMSWebParts_Forum_ForumGroup mWebPart = (CMSWebParts_Forum_ForumGroup)this.Page.Controls[i];
                        if (mWebPart.ClientID != this.ClientID)
                        {
                            if (Request.QueryString[DataHelper.GetNotEmpty(this.QueryStringForumID, this.Forum1.mForumProperties.QueryStringForumID)] != null)
                            {
                                int forumId = ValidationHelper.GetInteger(Request.QueryString[DataHelper.GetNotEmpty(this.QueryStringForumID, this.Forum1.mForumProperties.QueryStringForumID)], 0);
                                if (forumId > 0)
                                {

                                    ForumGroupInfo fgi = ForumGroupInfoProvider.GetForumGroupInfo(ValidationHelper.GetString(mWebPart.GetValue("GroupName"), ""), CMSContext.CurrentSite.SiteName);
                                    if (fgi != null)
                                    {
                                        DataSet ds = ForumInfoProvider.GetForumsByGroupID(fgi.GroupID);
                                        if (!DataHelper.DataSourceIsEmpty(ds))
                                        {
                                            bool isInGroup = false;
                                            foreach (DataRow dr in ds.Tables[0].Rows)
                                            {
                                                if (forumId == ValidationHelper.GetInteger(dr["ForumId"], -1))
                                                {
                                                    isInGroup = true;
                                                }
                                            }

                                            if (!isInGroup)
                                            {
                                                mWebPart.SetValue("StopProccesing", true);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }

            this.Forum1.StopProcessing = this.StopProccesing;

            this.Forum1.mForumProperties.QueryStringThread = this.ThreadQueryString;
            this.Forum1.ExpandTree = this.ExpandTree;
            this.Forum1.GroupName = this.GroupName;

            this.Forum1.UseFlatView = this.UseFlatView;

            this.Forum1.MaxRelativeLevel = this.MaxRelativeLevel;
            this.Forum1.WhereCondition = this.WhereCondition;
            this.Forum1.SelectOnlyApproved = this.SelectOnlyApproved;
            this.Forum1.PostPath = this.PostPath;
            this.Forum1.ShowMode = this.ShowMode;

            this.Forum1.EnablePaging = this.EnablePaging;
            this.Forum1.PageSize = this.PageSize;

            this.Forum1.UseAlternatingStyle = this.UseAlternatingStyle;
            this.Forum1.QueryStringForumID = this.QueryStringForumID;
            this.Forum1.DisplayOnlyOpen = this.DisplayOnlyOpen;
            this.Forum1.CheckPermissions = this.CheckPermissions;
            this.Forum1.EnableSubscription = this.EnableSubscription;
            this.Forum1.NoAuthenticatedRead = this.AnonymousRead;

            this.Forum1.EnablePicture = this.EnablePicture;
            this.Forum1.EnableSignature = this.EnableSignature;
            this.Forum1.MaxPictureWidth = this.MaxPictureWidth;
            this.Forum1.MaxPictureHeight = this.MaxPictureHeight;

        }
    }
}
