using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;

public partial class CMSWebParts_Navigation_Breadcrumbs : CMSAbstractWebPart
{
    #region "Document properties"

    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CacheMinutes"), this.bcElem.CacheMinutes);
        }
        set
        {
            this.SetValue("CacheMinutes", value);
            this.bcElem.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Check permissions
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.bcElem.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
        }
    }


    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.bcElem.CombineWithDefaultCulture);
        }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.bcElem.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.bcElem.CultureCode), this.bcElem.CultureCode);
        }
        set
        {
            this.SetValue("CultureCode", value);
            this.bcElem.CultureCode = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), this.bcElem.Path), this.bcElem.Path);
        }
        set
        {
            this.SetValue("Path", value);
            this.bcElem.Path = value;
        }
    }


    /// <summary>
    /// Select only published nodes
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.bcElem.SelectOnlyPublished);
        }
        set
        {
            this.SetValue("SelctOnlyPublished", value);
            this.bcElem.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.bcElem.SiteName), this.bcElem.SiteName);
        }
        set
        {
            this.SetValue("SiteName", value);
            this.bcElem.SiteName = value;
        }
    }

    #endregion


    #region "Public properties"

    /// <summary>
    /// Breadcrumb separator
    /// </summary>
    public string BreadcrumbSeparator
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("BreadCrumbSeparator"), this.bcElem.BreadCrumbSeparator), this.bcElem.BreadCrumbSeparator);
        }
        set
        {
            this.SetValue("BreadCrumbSeparator", value);
            this.bcElem.BreadCrumbSeparator = value;
        }
    }


    /// <summary>
    /// Default path
    /// </summary>
    public string DefaultPath
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("DefaultPath"), this.bcElem.DefaultPath), this.bcElem.DefaultPath);
        }
        set
        {
            this.SetValue("DefaultPath", value);
            this.bcElem.DefaultPath = value;
        }
    }


    /// <summary>
    /// Select nodes starting path
    /// </summary>
    public string SelectNodesStartPath
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SelectNodesStartPath"), this.bcElem.StartingPath), this.bcElem.StartingPath);
        }
        set
        {
            this.SetValue("SelectNodesStartPath", value);
            this.bcElem.StartingPath = value;
        }
    }


    /// <summary>
    /// Show current item in path
    /// </summary>
    public bool ShowCurrentItem
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowCurrentItem"), this.bcElem.ShowCurrentItem);
        }
        set
        {
            this.SetValue("ShowCurrentItem", value);
            this.bcElem.ShowCurrentItem = value;
        }
    }


    /// <summary>
    /// Show current item as link
    /// </summary>
    public bool ShowCurrentItemAsLink
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowCurrentItemAsLink"), this.bcElem.ShowCurrentItemAsLink);
        }
        set
        {
            this.SetValue("ShowCurrentItemAsLink", value);
            this.bcElem.ShowCurrentItemAsLink = value;
        }
    }


    /// <summary>
    /// URL target
    /// </summary>
    public string UrlTarget
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("UrlTarget"), this.bcElem.UrlTarget), this.bcElem.UrlTarget);
        }
        set
        {
            this.SetValue("UrlTarget", value);
            this.bcElem.UrlTarget = value;
        }
    }

    /// <summary>
    /// Breadcrumb separator
    /// </summary>
    public string BreadcrumbSeparatorRTL
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("BreadCrumbSeparatorRTL"), this.bcElem.BreadCrumbSeparatorRTL), this.bcElem.BreadCrumbSeparatorRTL);
        }
        set
        {
            this.SetValue("BreadCrumbSeparatorRTL", value);
            this.bcElem.BreadCrumbSeparatorRTL = value;
        }
    }

    /// <summary>
    /// Class names
    /// </summary>
    public string ClassNames
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Classnames"), this.bcElem.ClassNames), this.bcElem.ClassNames);
        }
        set
        {
            this.SetValue("ClassNames", value);
            this.bcElem.ClassNames = value;
        }
    }

    /// <summary>
    /// Indicates if apply document menu item properties.
    /// </summary>
    public bool ApplyMenuDesign
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ApplyMenuDesign"), this.bcElem.ApplyMenuDesign);
        }
        set
        {
            this.SetValue("ApplyMenuDesign", value);
        }
    }


    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.bcElem.StopProcessing = true;
        }

        // Document properties
        this.bcElem.CacheItemName = this.CacheItemName;
        this.bcElem.CacheMinutes = this.CacheMinutes;
        this.bcElem.CheckPermissions = this.CheckPermissions;
        this.bcElem.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
        this.bcElem.CultureCode = this.CultureCode;
        this.bcElem.Path = this.Path;
        this.bcElem.SelectOnlyPublished = this.SelectOnlyPublished;
        this.bcElem.SiteName = this.SiteName;

        this.bcElem.BreadCrumbSeparator = this.BreadcrumbSeparator;
        this.bcElem.DefaultPath = this.DefaultPath;
        this.bcElem.StartingPath = this.SelectNodesStartPath;
        this.bcElem.ShowCurrentItem = this.ShowCurrentItem;
        this.bcElem.ShowCurrentItemAsLink = this.ShowCurrentItemAsLink;
        this.bcElem.UrlTarget = this.UrlTarget;

        this.bcElem.BreadCrumbSeparatorRTL = this.BreadcrumbSeparatorRTL;
        this.bcElem.ClassNames = this.ClassNames;
        this.bcElem.ApplyMenuDesign = this.ApplyMenuDesign;

    }
}
