using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.skmMenuControl;

public partial class CMSWebParts_cmsmenu : CMSAbstractWebPart
{
    #region "Document properties"

    public bool EnableRTLBehaviour
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("EnableRTLBehaviour"), this.CMSMenu1.EnableRTLBehaviour); }
        set
        {
            this.SetValue("EnableRTLBehaviour", value);
            this.CMSMenu1.EnableRTLBehaviour = ValidationHelper.GetBoolean(value, false);
        }

    }


    /// <summary>
    /// Indicates if apply document menu item properties.
    /// </summary>
    public bool ApplyMenuDesign
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ApplyMenuDesign"), this.CMSMenu1.ApplyMenuDesign);
        }
        set
        {
            this.SetValue("ApplyMenuDesign", value);
        }
    }

    /// <summary>
    /// Indicates if higlighted images is not specified, use item image if exist.
    /// </summary>
    public bool UseItemImagesForHiglightedItem
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("UseItemImagesForHiglightedItem"), this.CMSMenu1.UseItemImagesForHiglightedItem);
        }
        set
        {
            this.SetValue("UseItemImagesForHiglightedItem", value);
        }
    }

    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CacheMinutes"), this.CMSMenu1.CacheMinutes);
        }
        set
        {
            this.SetValue("CacheMinutes", value);
            this.CMSMenu1.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Check permissions
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.CMSMenu1.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
        }
    }


    /// <summary>
    /// Class names
    /// </summary>
    public string ClassNames
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Classnames"), this.CMSMenu1.ClassNames), this.CMSMenu1.ClassNames);
        }
        set
        {
            this.SetValue("ClassNames", value);
            this.CMSMenu1.ClassNames = value;
        }
    }


    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.CMSMenu1.CombineWithDefaultCulture);
        }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.CMSMenu1.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.CMSMenu1.CultureCode), this.CMSMenu1.CultureCode);
        }
        set
        {
            this.SetValue("CultureCode", value);
            this.CMSMenu1.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.CMSMenu1.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.CMSMenu1.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.CMSMenu1.OrderBy), this.CMSMenu1.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.CMSMenu1.OrderBy = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), this.CMSMenu1.Path), this.CMSMenu1.Path);
        }
        set
        {
            this.SetValue("Path", value);
            this.CMSMenu1.Path = value;
        }
    }


    /// <summary>
    /// Select only published nodes
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.CMSMenu1.SelectOnlyPublished);
        }
        set
        {
            this.SetValue("SelctOnlyPublished", value);
            this.CMSMenu1.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.CMSMenu1.SiteName), this.CMSMenu1.SiteName);
        }
        set
        {
            this.SetValue("SiteName", value);
            this.CMSMenu1.SiteName = value;
        }
    }

    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.CMSMenu1.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.CMSMenu1.WhereCondition = value;
        }
    }

    #endregion


    #region "Public properties"

    /// <summary>
    /// Render Image ALT
    /// </summary>
    public bool RenderImageAlt
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("RenderImageAlt"), this.CMSMenu1.RenderImageAlt);
        }
        set
        {
            this.SetValue("RenderImageAlt", value);
            this.CMSMenu1.RenderImageAlt = value;
        }
    }

    /// <summary>
    /// Mouse cursor
    /// </summary>
    public MouseCursor Cursor
    {
        get
        {
            return (MouseCursor)ValidationHelper.GetInteger(this.GetValue("Cursor"), (int)this.CMSMenu1.Cursor);
        }
        set
        {
            this.SetValue("Cursor", value.ToString());
            this.CMSMenu1.Cursor = value;
        }
    }


    /// <summary>
    /// Css prefix
    /// </summary>
    public string CSSPrefix
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CSSPrefix"), this.CMSMenu1.CSSPrefix), this.CMSMenu1.CSSPrefix);
        }
        set
        {
            this.SetValue("CSSPrefix", value);
            this.CMSMenu1.CSSPrefix = value;
        }
    }


    /// <summary>
    /// External script path
    /// </summary>
    public string ExternalScriptPath
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("ExternalScriptPath"), this.CMSMenu1.ExternalScriptPath);
        }
        set
        {
            this.SetValue("ExternalScriptPath", value);
            this.CMSMenu1.ExternalScriptPath = value;
        }
    }


    /// <summary>
    /// Highlight all items in path
    /// </summary>
    public bool HighlightAllItemsInPath
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("HighlightAllItemsInPath"), this.CMSMenu1.HighlightAllItemsInPath);
        }
        set
        {
            this.SetValue("HighlightAllItemsInPath", value);
            this.CMSMenu1.HighlightAllItemsInPath = value;
        }
    }


    /// <summary>
    /// Highlighted node path
    /// </summary>
    public string HighlightedNodePath
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("HighlightedNodePath"), this.CMSMenu1.HighlightedNodePath), this.CMSMenu1.HighlightedNodePath);
        }
        set
        {
            this.SetValue("HighlightedNodePath", value);
            this.CMSMenu1.HighlightedNodePath = value;
        }
    }


    /// <summary>
    /// Menu layout
    /// </summary>
    public MenuLayout Layout
    {
        get
        {
            return CMS.skmMenuControl.Menu.GetLayout(DataHelper.GetNotEmpty(this.GetValue("Layout"), this.CMSMenu1.Layout.ToString()));
        }
        set
        {
            this.SetValue("Layout", value);
            this.CMSMenu1.Layout = value;
        }
    }


    /// <summary>
    /// Render item name
    /// </summary>
    public bool RenderItemName
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("RenderItemName"), this.CMSMenu1.RenderItemName);
        }
        set
        {
            this.SetValue("RenderItemName", value);
            this.CMSMenu1.RenderItemName = value;
        }
    }


    /// <summary>
    /// Submenu indicator
    /// </summary>
    public string SubMenuIndicator
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SubmenuIndicator"), this.CMSMenu1.SubmenuIndicator), this.CMSMenu1.SubmenuIndicator);
        }
        set
        {
            this.SetValue("SubmenuIndicator", value);
            this.CMSMenu1.SubmenuIndicator = value;
        }

    }


    /// <summary>
    /// Use alternating styles
    /// </summary>
    public bool UseAlternatingStyles
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("UseAlternatingStyles"), this.CMSMenu1.UseAlternatingStyles);
        }
        set
        {
            this.SetValue("UseAlternatingStyles", value);
            this.CMSMenu1.UseAlternatingStyles = value;
        }
    }


    /// <summary>
    /// Padding
    /// </summary>
    public int Padding
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("Padding"), this.CMSMenu1.Padding);
        }
        set
        {
            this.SetValue("Padding", value);
            this.CMSMenu1.Padding = value;
        }
    }


    /// <summary>
    /// Spacing
    /// </summary>
    public int Spacing
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("Spacing"), this.CMSMenu1.Spacing);
        }
        set
        {
            this.SetValue("Spacing", value);
            this.CMSMenu1.Spacing = value;
        }
    }


    /// <summary>
    /// Separator CSS class
    /// </summary>
    public string SeparatorCSS
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("SeparatorCSS"), this.CMSMenu1.SeparatorCssClass);
        }
        set
        {
            this.SetValue("", value);
            this.CMSMenu1.SeparatorCssClass = value;
        }
    }


    /// <summary>
    /// Separator height
    /// </summary>
    public int SeparatorHeight
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("SeparatorHeight"), this.CMSMenu1.SeparatorHeight);
        }
        set
        {
            this.SetValue("SeparatorHeight", value);
            this.CMSMenu1.SeparatorHeight = value;
        }
    }


    /// <summary>
    /// Separator text
    /// </summary>
    public string SeparatorText
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("SeparatorText"), this.CMSMenu1.SeparatorText);
        }
        set
        {
            this.SetValue("SeparatorText", value);
            this.CMSMenu1.SeparatorText = value;
        }
    }


    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.CMSMenu1.StopProcessing = true;
        }
        else
        {
            // Set properties from Webpart form        
            this.CMSMenu1.ApplyMenuDesign = this.ApplyMenuDesign;
            this.CMSMenu1.UseItemImagesForHiglightedItem = this.UseItemImagesForHiglightedItem;
            this.CMSMenu1.CacheItemName = this.CacheItemName;
            this.CMSMenu1.CacheMinutes = this.CacheMinutes;
            this.CMSMenu1.CheckPermissions = this.CheckPermissions;
            this.CMSMenu1.ClassNames = this.ClassNames;
            this.CMSMenu1.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
            this.CMSMenu1.CSSPrefix = this.CSSPrefix;
            this.CMSMenu1.CultureCode = this.CultureCode;
            // Cursor is integer to MouseCursorEnum
            this.CMSMenu1.Cursor = this.Cursor;
            this.CMSMenu1.ExternalScriptPath = this.ExternalScriptPath;
            this.CMSMenu1.HighlightAllItemsInPath = this.HighlightAllItemsInPath;
            this.CMSMenu1.HighlightedNodePath = this.HighlightedNodePath;
            // Layout is integer to MenuLayoutEnum
            this.CMSMenu1.Layout = this.Layout;
            this.CMSMenu1.MaxRelativeLevel = this.MaxRelativeLevel;
            this.CMSMenu1.OrderBy = this.OrderBy;
            this.CMSMenu1.RenderItemName = this.RenderItemName;
            this.CMSMenu1.Path = this.Path;
            this.CMSMenu1.SelectOnlyPublished = this.SelectOnlyPublished;
            this.CMSMenu1.SiteName = this.SiteName;
            this.CMSMenu1.SubmenuIndicator = this.SubMenuIndicator;
            this.CMSMenu1.UseAlternatingStyles = this.UseAlternatingStyles;
            this.CMSMenu1.WhereCondition = this.WhereCondition;
            this.CMSMenu1.Padding = this.Padding;
            this.CMSMenu1.Spacing = this.Spacing;
            this.CMSMenu1.SeparatorCssClass = this.SeparatorCSS;
            this.CMSMenu1.SeparatorHeight = this.SeparatorHeight;
            this.CMSMenu1.SeparatorText = this.SeparatorText;
            this.CMSMenu1.EnableRTLBehaviour = this.EnableRTLBehaviour;
            this.CMSMenu1.RenderImageAlt = this.RenderImageAlt;
        }
    }
}
