using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.Controls;

public partial class CMSWebParts_Navigation_cmstabcontrol : CMSAbstractWebPart
{
    #region Public properties
    
    /// <summary>
    /// Render Image ALT
    /// </summary>
    public bool RenderImageAlt
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("RenderImageAlt"), this.CMSTabControl1.RenderImageAlt);
        }
        set
        {
            this.SetValue("RenderImageAlt", value);
            this.CMSTabControl1.RenderImageAlt = value;
        }
    }

    /// <summary>
    /// Indicates if apply document menu item properties.
    /// </summary>
    public bool ApplyMenuDesign
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ApplyMenuDesign"), this.CMSTabControl1.ApplyMenuDesign);
        }
        set
        {
            this.SetValue("ApplyMenuDesign", value);
        }
    }

    /// <summary>
    /// Indicates if higlighted images is not specified, use item image if exist.
    /// </summary>
    public bool UseItemImagesForHiglightedItem
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("UseItemImagesForHiglightedItem"), this.CMSTabControl1.UseItemImagesForHiglightedItem);
        }
        set
        {
            this.SetValue("UseItemImagesForHiglightedItem", value);
        }
    }

    /// <summary>
    /// True if the permissions should be checked
    /// </summary>
    public bool CheckPermissions
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.CMSTabControl1.CheckPermissions); }
        set
        {
            this.SetValue("CheckPermissions", value);
            this.CMSTabControl1.CheckPermissions = value;
        }
    }


    /// <summary>
    /// Class names which should be displayed
    /// </summary>
    public string ClassNames
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Classnames"), this.CMSTabControl1.ClassNames), this.CMSTabControl1.ClassNames); }
        set
        {
            this.SetValue("Classnames", value);
            this.CMSTabControl1.ClassNames = value;
        }
    }


    /// <summary>
    /// True if the displayed documents should be combined with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.CMSTabControl1.CombineWithDefaultCulture); }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.CMSTabControl1.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Culture code of the documents which should be displayed
    /// </summary>
    public string CultureCode
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.CMSTabControl1.CultureCode), this.CMSTabControl1.CultureCode); }
        set
        {
            this.SetValue("CultureCode", value);
            this.CMSTabControl1.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level of the documents which should be displayed
    /// </summary>
    public int MaxRelativeLevel
    {
        get { return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.CMSTabControl1.MaxRelativeLevel); }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.CMSTabControl1.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Highlighted node path
    /// </summary>
    public string HighlightedNodePath
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("HighlightedNodePath"), this.CMSTabControl1.HighlightedNodePath), this.CMSTabControl1.HighlightedNodePath); }
        set
        {
            this.SetValue("HighlightedNodePath", value);
            this.CMSTabControl1.HighlightedNodePath = value;
        }
    }


    /// <summary>
    /// Order by expression
    /// </summary>
    public string OrderBy
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.CMSTabControl1.OrderBy), this.CMSTabControl1.OrderBy); }
        set
        {
            this.SetValue("OrderBy", value);
            this.CMSTabControl1.OrderBy = value;
        }
    }


    /// <summary>
    /// Starting path
    /// </summary>
    public string Path
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), this.CMSTabControl1.Path), this.CMSTabControl1.Path); }
        set
        {
            this.SetValue("Path", value);
            this.CMSTabControl1.Path = value;
        }
    }


    /// <summary>
    /// True if only published documents should be displayed
    /// </summary>
    public bool SelectOnlyPublished
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.CMSTabControl1.SelectOnlyPublished); }
        set
        {
            this.SetValue("SelectOnlyPublished", value);
            this.CMSTabControl1.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.CMSTabControl1.SiteName), this.CMSTabControl1.SiteName); }
        set
        {
            this.SetValue("SiteName", value);
            this.CMSTabControl1.SiteName = value;
        }
    }


    /// <summary>
    /// True if the alternating styles should be used
    /// </summary>
    public bool UseAlternatingStyles
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("UseAlternatingStyles"), this.CMSTabControl1.UseAlternatingStyles); }
        set
        {
            this.SetValue("UseAlternatingStyles", value);
            this.CMSTabControl1.UseAlternatingStyles = value;
        }
    }


    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("WhereCondition"), this.CMSTabControl1.WhereCondition), this.CMSTabControl1.WhereCondition); }
        set
        {
            this.SetValue("WhereCondition", value);
            this.CMSTabControl1.WhereCondition = value;
        }
    }


    /// <summary>
    /// If true, the client script is used after selection
    /// </summary>
    public bool UseClientScript
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("UseClientScript"), this.CMSTabControl1.UseClientScript); }
        set
        {
            this.SetValue("UseClientScript", value);
            this.CMSTabControl1.UseClientScript = value;
        }
    }


    /// <summary>
    /// Layout of the tab control
    /// </summary>
    public TabControlLayoutEnum TabControlLayout
    {
        get { return this.CMSTabControl1.GetTabControlLayout(ValidationHelper.GetString(this.GetValue("TabControlLayout"), this.CMSTabControl1.TabControlLayout.ToString())); }
        set
        {
            this.SetValue("TabControlLayout", value);
            this.CMSTabControl1.TabControlLayout = value;
        }
    }


    /// <summary>
    /// Target url
    /// </summary>
    public string UrlTarget
    {
        get { return DataHelper.GetNotEmpty(this.GetValue("UrlTarget"), this.CMSTabControl1.UrlTarget); }
        set
        {
            this.SetValue("UrlTarget", value);
            this.CMSTabControl1.UrlTarget = value;
        }
    }


    #endregion

    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.CMSTabControl1.StopProcessing = true;
        }
        else
        {
            // Set properties from Webpart form        
            this.CMSTabControl1.ApplyMenuDesign = this.ApplyMenuDesign;
            this.CMSTabControl1.UseItemImagesForHiglightedItem = this.UseItemImagesForHiglightedItem;
            this.CMSTabControl1.CacheItemName = this.CacheItemName;
            this.CMSTabControl1.CacheMinutes = this.CacheMinutes;
            this.CMSTabControl1.CheckPermissions = this.CheckPermissions;
            this.CMSTabControl1.ClassNames = this.ClassNames;
            this.CMSTabControl1.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
            this.CMSTabControl1.CultureCode = this.CultureCode;
            this.CMSTabControl1.MaxRelativeLevel = this.MaxRelativeLevel;
            this.CMSTabControl1.HighlightedNodePath = this.HighlightedNodePath;
            this.CMSTabControl1.OrderBy = this.OrderBy;
            this.CMSTabControl1.Path = this.Path;
            this.CMSTabControl1.SelectOnlyPublished = this.SelectOnlyPublished;
            this.CMSTabControl1.SiteName = this.SiteName;
            this.CMSTabControl1.UseAlternatingStyles = this.UseAlternatingStyles;
            this.CMSTabControl1.WhereCondition = this.WhereCondition;

            this.CMSTabControl1.UseClientScript = this.UseClientScript;
            this.CMSTabControl1.TabControlLayout = this.TabControlLayout;
            this.CMSTabControl1.UrlTarget = this.UrlTarget;
            this.CMSTabControl1.RenderImageAlt = this.RenderImageAlt;
        }
    }

}
