using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;

public partial class CMSWebParts_cmstreemenu : CMSAbstractWebPart
{
    #region "Document properties"



    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CacheMinutes"), this.menuElem.CacheMinutes);
        }
        set
        {
            this.SetValue("CacheMinutes", value);
            this.menuElem.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Check permissions
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.menuElem.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
        }
    }


    /// <summary>
    /// Class names
    /// </summary>
    public string ClassNames
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Classnames"), this.menuElem.ClassNames), this.menuElem.ClassNames);
        }
        set
        {
            this.SetValue("ClassNames", value);
            this.menuElem.ClassNames = value;
        }
    }


    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.menuElem.CombineWithDefaultCulture);
        }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.menuElem.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.menuElem.CultureCode), this.menuElem.CultureCode);
        }
        set
        {
            this.SetValue("CultureCode", value);
            this.menuElem.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.menuElem.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.menuElem.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.menuElem.OrderBy), this.menuElem.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.menuElem.OrderBy = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), this.menuElem.Path), this.menuElem.Path);
        }
        set
        {
            this.SetValue("Path", value);
            this.menuElem.Path = value;
        }
    }


    /// <summary>
    /// Select only published nodes
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.menuElem.SelectOnlyPublished);
        }
        set
        {
            this.SetValue("SelctOnlyPublished", value);
            this.menuElem.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.menuElem.SiteName), this.menuElem.SiteName);
        }
        set
        {
            this.SetValue("SiteName", value);
            this.menuElem.SiteName = value;
        }
    }

    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.menuElem.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.menuElem.WhereCondition = value;
        }
    }

    #endregion


    #region "Public properties"


    /// <summary>
    /// Render Image ALT
    /// </summary>
    public bool RenderImageAlt
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("RenderImageAlt"), this.menuElem.RenderImageAlt);
        }
        set
        {
            this.SetValue("RenderImageAlt", value);
            this.menuElem.RenderImageAlt = value;
        }
    }

    /// <summary>
    /// Indicates if apply document menu item properties.
    /// </summary>
    public bool ApplyMenuDesign
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ApplyMenuDesign"), this.menuElem.ApplyMenuDesign);
        }
        set
        {
            this.SetValue("ApplyMenuDesign", value);
        }
    }

    /// <summary>
    /// Indicates if higlighted images is not specified, use item image if exist.
    /// </summary>
    public bool UseItemImagesForHiglightedItem
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("UseItemImagesForHiglightedItem"), this.menuElem.UseItemImagesForHiglightedItem);
        }
        set
        {
            this.SetValue("UseItemImagesForHiglightedItem", value);
        }
    }

    /// <summary>
    /// Css prefix
    /// </summary>
    public string CSSPrefix
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CSSPrefix"), this.menuElem.CSSPrefix), this.menuElem.CSSPrefix);
        }
        set
        {
            this.SetValue("CSSPrefix", value);
            this.menuElem.CSSPrefix = value;
        }
    }


    /// <summary>
    /// Highlight all items in path
    /// </summary>
    public bool HighlightAllItemsInPath
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("HighlightAllItemsInPath"), this.menuElem.HighlightAllItemsInPath);
        }
        set
        {
            this.SetValue("HighlightAllItemsInPath", value);
            this.menuElem.HighlightAllItemsInPath = value;
        }
    }


    /// <summary>
    /// Highlighted node path
    /// </summary>
    public string HighlightedNodePath
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("HighlightedNodePath"), this.menuElem.HighlightedNodePath), this.menuElem.HighlightedNodePath);
        }
        set
        {
            this.SetValue("HighlightedNodePath", value);
            this.menuElem.HighlightedNodePath = value;
        }
    }


    /// <summary>
    /// Use alternating styles
    /// </summary>
    public bool UseAlternatingStyles
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("UseAlternatingStyles"), this.menuElem.UseAlternatingStyles);
        }
        set
        {
            this.SetValue("UseAlternatingStyles", value);
            this.menuElem.UseAlternatingStyles = value;
        }
    }


    /// <summary>
    /// Display highlighted item as link
    /// </summary>
    public bool DisplayHighlightedItemAsLink
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("DisplayHighlightedItemAsLink"), this.menuElem.DisplayHighlightedItemAsLink);
        }
        set
        {
            this.SetValue("DisplayHighlightedItemAsLink", value);
            this.menuElem.DisplayHighlightedItemAsLink = value;
        }
    }


    /// <summary>
    /// On mouse out script
    /// </summary>
    public string OnMouseOutScript
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OnMouseOutScript"), this.menuElem.OnMouseOutScript), this.menuElem.OnMouseOutScript);
        }
        set
        {
            this.SetValue("OnMouseOutScript", value);
            this.menuElem.OnMouseOutScript = value;
        }
    }


    /// <summary>
    /// On mouse Over script
    /// </summary>
    public string OnMouseOverScript
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OnMouseOverScript"), this.menuElem.OnMouseOverScript), this.menuElem.OnMouseOverScript);
        }
        set
        {
            this.SetValue("OnMouseOverScript", value);
            this.menuElem.OnMouseOverScript = value;
        }
    }


    /// <summary>
    /// Submenu indicator
    /// </summary>
    public string SubMenuIndicator
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SubmenuIndicator"), this.menuElem.SubmenuIndicator), this.menuElem.SubmenuIndicator);
        }
        set
        {
            this.SetValue("SubmenuIndicator", value);
            this.menuElem.SubmenuIndicator = value;
        }
    }


    /// <summary>
    /// URL target
    /// </summary>
    public string UrlTarget
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("UrlTarget"), this.menuElem.UrlTarget), this.menuElem.UrlTarget);
        }
        set
        {
            this.SetValue("UrlTarget", value);
            this.menuElem.UrlTarget = value;
        }
    }


    /// <summary>
    /// CellPadding
    /// </summary>
    public int CellPadding
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CellPadding"), this.menuElem.CellPadding);
        }
        set
        {
            this.SetValue("CellPadding", value);
            this.menuElem.CellPadding = value;
        }
    }


    /// <summary>
    /// CellSpacing
    /// </summary>
    public int CellSpacing
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CellSpacing"), this.menuElem.CellSpacing);
        }
        set
        {
            this.SetValue("CellSpacing", value);
            this.menuElem.CellSpacing = value;
        }
    }


    /// <summary>
    /// Collapse selected node on click
    /// </summary>
    public bool CollapseSelectedNodeOnClick
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CollapseSelectedNodeOnClick"), this.menuElem.CollapseSelectedNodeOnClick);
        }
        set
        {
            this.SetValue("CollapseSelectedNodeOnClick", value);
            this.menuElem.CollapseSelectedNodeOnClick = value;
        }
    }


    /// <summary>
    /// Collapse selected node on click
    /// </summary>
    public bool GenerateIndentationInsideLink
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("GenerateIndentationInsideLink"), this.menuElem.GenerateIndentationInsideLink);
        }
        set
        {
            this.SetValue("GenerateIndentationInsideLink", value);
            this.menuElem.GenerateIndentationInsideLink = value;
        }
    }



    /// <summary>
    /// Collapse selected node on click
    /// </summary>
    public bool GenerateOnlyOuterLink
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("GenerateOnlyOuterLink"), this.menuElem.GenerateOnlyOuterLink);
        }
        set
        {
            this.SetValue("GenerateOnlyOuterLink", value);
            this.menuElem.GenerateOnlyOuterLink = value;
        }
    }


    /// <summary>
    /// Menu indentation
    /// </summary>
    public int Indentation
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("Indentation"), this.menuElem.Indentation);
        }
        set
        {
            this.SetValue("Indentation", value);
            this.menuElem.Indentation = value;
        }
    }


    /// <summary>
    /// Menu item image URL
    /// </summary>
    public string MenuItemImageUrl
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("MenuItemImageUrl"), this.menuElem.MenuItemImageUrl), this.menuElem.MenuItemImageUrl);
        }
        set
        {
            this.SetValue("MenuItemImageUrl", value);
            this.menuElem.MenuItemImageUrl = value;
        }
    }


    /// <summary>
    /// Menu item OpenImage URL
    /// </summary>
    public string MenuItemOpenImageUrl
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("MenuItemOpenImageUrl"), this.menuElem.MenuItemOpenImageUrl), this.menuElem.MenuItemOpenImageUrl);
        }
        set
        {
            this.SetValue("MenuItemOpenImageUrl", value);
            this.menuElem.MenuItemOpenImageUrl = value;
        }
    }

    #endregion



    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.menuElem.StopProcessing = true;
        }
        else
        {
            // Document properties
            this.menuElem.ApplyMenuDesign = this.ApplyMenuDesign;
            this.menuElem.UseItemImagesForHiglightedItem = this.UseItemImagesForHiglightedItem;
            this.menuElem.CacheItemName = this.CacheItemName;
            this.menuElem.CacheMinutes = this.CacheMinutes;
            this.menuElem.WhereCondition = this.WhereCondition;
            this.menuElem.OrderBy = this.OrderBy;
            this.menuElem.Path = this.Path;
            this.menuElem.SelectOnlyPublished = this.SelectOnlyPublished;
            this.menuElem.SiteName = this.SiteName;
            this.menuElem.CheckPermissions = this.CheckPermissions;
            this.menuElem.ClassNames = this.ClassNames;
            this.menuElem.CultureCode = this.CultureCode;
            this.menuElem.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
            this.menuElem.MaxRelativeLevel = this.MaxRelativeLevel;

            // Public properties
            this.menuElem.CSSPrefix = this.CSSPrefix;
            this.menuElem.DisplayHighlightedItemAsLink = this.DisplayHighlightedItemAsLink;
            this.menuElem.HighlightAllItemsInPath = this.HighlightAllItemsInPath;
            this.menuElem.HighlightedNodePath = this.HighlightedNodePath;
            this.menuElem.OnMouseOutScript = this.OnMouseOutScript;
            this.menuElem.OnMouseOverScript = this.OnMouseOverScript;
            this.menuElem.SubmenuIndicator = this.SubMenuIndicator;
            this.menuElem.UrlTarget = this.UrlTarget;
            this.menuElem.UseAlternatingStyles = this.UseAlternatingStyles;

            this.menuElem.CellPadding = this.CellPadding;
            this.menuElem.CellSpacing = this.CellSpacing;

            this.menuElem.CollapseSelectedNodeOnClick = this.CollapseSelectedNodeOnClick;
            this.menuElem.GenerateIndentationInsideLink = this.GenerateIndentationInsideLink;
            this.menuElem.GenerateOnlyOuterLink = this.GenerateOnlyOuterLink;
            this.menuElem.Indentation = this.Indentation;
            this.menuElem.MenuItemImageUrl = this.MenuItemImageUrl;
            this.menuElem.MenuItemOpenImageUrl = this.MenuItemOpenImageUrl;
            this.menuElem.RenderImageAlt = this.RenderImageAlt;
        }
    }

}
