using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.ISearchEngine;
using CMS.Controls;

public partial class CMSWebParts_Search_cmssearchresults : CMSAbstractWebPart
{
    #region Public properties


    /// <summary>
    /// True if the permisions should be checked
    /// </summary>
    public bool CheckPermissions
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.CMSSearchResults1.CheckPermissions); }
        set
        {
            this.SetValue("CheckPermissions", value);
            this.CMSSearchResults1.CheckPermissions = value;
        }
    }


    /// <summary>
    /// Class names which should be displayed
    /// </summary>
    public string ClassNames
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Classnames"), this.CMSSearchResults1.ClassNames), this.CMSSearchResults1.ClassNames); }
        set
        {
            this.SetValue("Classnames", value);
            this.CMSSearchResults1.ClassNames = value;
        }
    }


    /// <summary>
    /// ID of the search dialog
    /// </summary>
    public string CMSSearchDialogID
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CMSSearchDialogID"), this.CMSSearchResults1.CMSSearchDialogID), this.CMSSearchResults1.CMSSearchDialogID); }
        set
        {
            this.SetValue("CMSSearchDialogID", value);
            this.CMSSearchResults1.CMSSearchDialogID = value;
        }
    }


    /// <summary>
    /// If true, documents are combined with default culture version
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.CMSSearchResults1.CombineWithDefaultCulture); }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.CMSSearchResults1.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Culture code of the documents
    /// </summary>
    public string CultureCode
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.CMSSearchResults1.CultureCode), this.CMSSearchResults1.CultureCode); }
        set
        {
            this.SetValue("CultureCode", value);
            this.CMSSearchResults1.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level of the documents to be shown
    /// </summary>
    public int MaxRelativeLevel
    {
        get { return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.CMSSearchResults1.MaxRelativeLevel); }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.CMSSearchResults1.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Path of the documents
    /// </summary>
    public string Path
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), this.CMSSearchResults1.Path), this.CMSSearchResults1.Path); }
        set
        {
            this.SetValue("Path", value);
            this.CMSSearchResults1.Path = value;
        }
    }


    /// <summary>
    /// Search mode
    /// </summary>
    public SearchModeEnum SearchMode
    {
        get { return CMSSearchResults1.GetSearchMode(DataHelper.GetNotEmpty(this.GetValue("SearchMode"), this.CMSSearchResults1.SearchMode.ToString())); }
        set
        {
            this.SetValue("SearchMode", value);
            this.CMSSearchResults1.SearchMode = value;
        }
    }


    /// <summary>
    /// If true, only published documents are selected
    /// </summary>
    public bool SelectOnlyPublished
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.CMSSearchResults1.SelectOnlyPublished); }
        set
        {
            this.SetValue("SelectOnlyPublished", value);
            this.CMSSearchResults1.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.CMSSearchResults1.SiteName), this.CMSSearchResults1.SiteName); }
        set
        {
            this.SetValue("SiteName", value);
            this.CMSSearchResults1.SiteName = value;
        }
    }

    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("WhereCondition"), this.CMSSearchResults1.WhereCondition), this.CMSSearchResults1.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.CMSSearchResults1.WhereCondition = value;
        }
    }

    /// <summary>
    /// Order by
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.CMSSearchResults1.OrderBy), this.CMSSearchResults1.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.CMSSearchResults1.OrderBy = value;
        }
    }

    ///// <summary>
    ///// SkinID of the 
    ///// </summary>
    //public string SkinID
    //{
    //    get { return ValidationHelper.GetString(this.GetValue("SkinID"), ""); }
    //    set
    //    {
    //        this.SetValue("SkinID", value);
    //        this.CMSSearchResults1.SkinID = value;
    //    }
    //}


    /// <summary>
    /// Text to be displayed if no results has been found
    /// </summary>
    public string NoResultText
    {
        get { return DataHelper.GetNotEmpty(this.GetValue("NoResultText"), ResHelper.LocalizeString("{$CMSSearchResults.NoDocumentFound$}")); }
        set
        {
            this.SetValue("NoResultText", value);
            this.CMSSearchResults1.NoResultsLabel.Text = value;
        }
    }


    /// <summary>
    /// Name of the transforamtion which is used for displaying the results
    /// </summary>
    public string TransformationName
    {
        get { return DataHelper.GetNotEmpty(this.GetValue("TransformationName"), this.CMSSearchResults1.TransformationName); }
        set
        {
            this.SetValue("TransformationName", value);
            this.CMSSearchResults1.TransformationName = value;
        }
    }


    /// <summary>
    /// Name of the query string
    /// </summary>
    public string QueryStringName
    {
        get { return DataHelper.GetNotEmpty(this.GetValue("QueryStringName"), this.CMSSearchResults1.QueryStringKey); }
        set
        {
            this.SetValue("QueryStringName", value);
            this.CMSSearchResults1.QueryStringKey = value;
        }
    }


    /// <summary>
    /// Number of the search results on each sigle page
    /// </summary>
    public int PageSize
    {
        get { return ValidationHelper.GetInteger(this.GetValue("PageSize"), this.CMSSearchResults1.PagerControl.PageSize); }
        set
        {
            this.SetValue("PageSize", value);
            this.CMSSearchResults1.PagerControl.PageSize = value;
        }
    }


    /// <summary>
    /// Position of the pager
    /// </summary>
    public PagingPlaceTypeEnum PagerPosition
    {
        get { return this.CMSSearchResults1.PagerControl.GetPagerPosition(DataHelper.GetNotEmpty(this.GetValue("PagerPosition"), this.CMSSearchResults1.PagerControl.PagerPosition.ToString())); }
        set
        {
            this.SetValue("PagerPosition", value);
            this.CMSSearchResults1.PagerControl.PagerPosition = value;
        }
    }


    /// <summary>
    /// Paging mode
    /// </summary>
    public PagingModeTypeEnum PagingMode
    {
        get { return this.CMSSearchResults1.PagerControl.GetPagingMode(DataHelper.GetNotEmpty(this.GetValue("PagingMode"), this.CMSSearchResults1.PagerControl.PagingMode.ToString())); }
        set
        {
            this.SetValue("PagingMode", value);
            this.CMSSearchResults1.PagerControl.PagingMode = value;
        }
    }


    /// <summary>
    /// If true, first and last page is shown if paging is allowed
    /// </summary>
    public bool ShowFirstLast
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("ShowFirstLast"), this.CMSSearchResults1.PagerControl.ShowFirstLast); }
        set
        {
            this.SetValue("ShowFirstLast", value);
            this.CMSSearchResults1.PagerControl.ShowFirstLast = value;
        }
    }



    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }
    
    
    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == CMS.CMSHelper.ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.CMSSearchResults1.StopProcessing = true;
        }
        else
        {
            // Setup the control
            this.CMSSearchResults1.CacheItemName = this.CacheItemName ;
            this.CMSSearchResults1.CacheMinutes = this.CacheMinutes;
            this.CMSSearchResults1.CheckPermissions = this.CheckPermissions;
            this.CMSSearchResults1.ClassNames = this.ClassNames;
            this.CMSSearchResults1.CMSSearchDialogID = this.CMSSearchDialogID;
            this.CMSSearchResults1.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
            this.CMSSearchResults1.CultureCode = this.CultureCode;
            this.CMSSearchResults1.MaxRelativeLevel = this.MaxRelativeLevel;
            this.CMSSearchResults1.Path = this.Path;

            this.CMSSearchResults1.SearchMode = this.SearchMode;

            this.CMSSearchResults1.SelectOnlyPublished = this.SelectOnlyPublished;
            this.CMSSearchResults1.SiteName = this.SiteName;
            // this.CMSSearchResults1.StartingPath = DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("StartingPath"), this.CMSSearchResults1.StartingPath), this.CMSSearchResults1.StartingPath);
            // Set SkinID property
            //this.CMSSearchResults1.SkinID = this.SkinID;
            // Set 'no results' text
            this.CMSSearchResults1.NoResultsLabel.Text = this.NoResultText;

            this.CMSSearchResults1.TransformationName = this.TransformationName;

            // This Query string key isn property of DataPager ! This property set DataPager QueryStrinKey with search query parameters
            this.CMSSearchResults1.QueryStringKey = this.QueryStringName;

            this.CMSSearchResults1.PagerControl.PageSize = this.PageSize;

            this.CMSSearchResults1.PagerControl.PagerPosition = this.PagerPosition;

            this.CMSSearchResults1.PagerControl.PagingMode = this.PagingMode;

            this.CMSSearchResults1.PagerControl.ShowFirstLast = this.ShowFirstLast;

            this.CMSSearchResults1.WhereCondition = this.WhereCondition;
            this.CMSSearchResults1.OrderBy = this.OrderBy;
        }
    }

}
