using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;


using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.SettingsProvider;
using CMS.DataEngine;
using CMS.CMSHelper;

public partial class CMSWebParts_Viewers_cmsdatagrid : CMSAbstractWebPart
{
    protected string[] mColumnList;
    protected string[] mGlobalNameID = null;

    #region "Document properties"

    ///// <summary>
    ///// Cache item name
    ///// </summary>
    //public string CacheItemName
    //{
    //    get
    //    {
    //        return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CacheItemName"), this.CMSDataGrid1.CacheItemName), this.CMSDataGrid1.CacheItemName);
    //    }
    //    set
    //    {
    //        this.SetValue("CacheItemName", value);
    //        this.CMSDataGrid1.CacheItemName = value;
    //    }
    //}


    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CacheMinutes"), this.CMSDataGrid1.CacheMinutes);
        }
        set
        {
            this.SetValue("CacheMinutes", value);
            this.CMSDataGrid1.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Check permissions
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.CMSDataGrid1.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
        }
    }


    /// <summary>
    /// Class names
    /// </summary>
    public string ClassNames
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Classnames"), this.CMSDataGrid1.ClassNames), this.CMSDataGrid1.ClassNames);
        }
        set
        {
            this.SetValue("ClassNames", value);
            this.CMSDataGrid1.ClassNames = value;
        }
    }


    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.CMSDataGrid1.CombineWithDefaultCulture);
        }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.CMSDataGrid1.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.CMSDataGrid1.CultureCode), this.CMSDataGrid1.CultureCode);
        }
        set
        {
            this.SetValue("CultureCode", value);
            this.CMSDataGrid1.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.CMSDataGrid1.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.CMSDataGrid1.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.CMSDataGrid1.OrderBy), this.CMSDataGrid1.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.CMSDataGrid1.OrderBy = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), null), null);
        }
        set
        {
            this.SetValue("Path", value);
            this.CMSDataGrid1.Path = value;
        }
    }


    /// <summary>
    /// Select only published nodes
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.CMSDataGrid1.SelectOnlyPublished);
        }
        set
        {
            this.SetValue("SelctOnlyPublished", value);
            this.CMSDataGrid1.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.CMSDataGrid1.SiteName), this.CMSDataGrid1.SiteName);
        }
        set
        {
            this.SetValue("SiteName", value);
            this.CMSDataGrid1.SiteName = value;
        }
    }

    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.CMSDataGrid1.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.CMSDataGrid1.WhereCondition = value;
        }
    }


    /// <summary>
    /// Select top N items
    /// </summary>
    public int SelectTopN
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("SelectTopN"), this.CMSDataGrid1.SelectTopN);
        }
        set
        {
            this.SetValue("SelectTopN", value);
            this.CMSDataGrid1.SelectTopN = value;
        }
    }

    #endregion


    #region "Relationships properties"

    /// <summary>
    /// Related node is on the left side
    /// </summary>
    public bool RelatedNodeIsOnTheLeftSide
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("RelatedNodeIsOnTheLeftSide"), this.CMSDataGrid1.RelatedNodeIsOnTheLeftSide);
        }
        set
        {
            this.SetValue("RelatedNodeIsOnTheLeftSide", value);
            this.CMSDataGrid1.RelatedNodeIsOnTheLeftSide = value;
        }
    }


    /// <summary>
    /// Relationship name
    /// </summary>
    public string RelationshipName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("RelationshipName"), this.CMSDataGrid1.RelationshipName), this.CMSDataGrid1.RelationshipName);
        }
        set
        {
            this.SetValue("RelationshipName", value);
            this.CMSDataGrid1.RelationshipName = value;
        }
    }


    /// <summary>
    /// Relationship with node GUID
    /// </summary>
    public Guid RelationshipWithNodeGUID
    {
        get
        {
            return ValidationHelper.GetGuid(this.GetValue("RelationshipWithNodeGuid"), this.CMSDataGrid1.RelationshipWithNodeGuid);
        }
        set
        {
            this.SetValue("RelationshipWithNodeGuid", value);
            this.CMSDataGrid1.RelationshipWithNodeGuid = value;
        }
    }

    #endregion


    #region "Transformation properties"

    /// <summary>
    /// Transformation name
    /// </summary>
    public string SelectedItemTransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SelectedItemTransformationName"), this.CMSDataGrid1.SelectedItemTransformationName), this.CMSDataGrid1.SelectedItemTransformationName);
        }
        set
        {
            this.SetValue("SelectedItemTransformationName", value);
            this.CMSDataGrid1.SelectedItemTransformationName = value;
        }
    }
    #endregion


    #region Public properties

    ///// <summary>
    ///// Skin ID
    ///// </summary>
    //public string SkinID
    //{
    //    get { return ValidationHelper.GetString(this.GetValue("SkinID"), ""); }
    //    set
    //    {
    //        this.SetValue("SkinID", value);
    //        this.CMSDataGrid1.SkinID = value;
    //    }
    //}


    /// <summary>
    /// Hide control for zero rows
    /// </summary>
    public bool HideControlForZeroRows
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("HideControlForZeroRows"), this.CMSDataGrid1.HideControlForZeroRows); }
        set
        {
            this.SetValue("HideControlForZeroRows", value);
            this.CMSDataGrid1.HideControlForZeroRows = value;
        }
    }


    /// <summary>
    /// Text for zero rows
    /// </summary>
    public string ZeroRowsText
    {
        get { return ValidationHelper.GetString(this.GetValue("ZeroRowsText"), this.CMSDataGrid1.ZeroRowsText); }
        set
        {
            this.SetValue("ZeroRowsText", value);
            this.CMSDataGrid1.ZeroRowsText = value;
        }
    }


    /// <summary>
    /// True if the sorting is ascending
    /// </summary>
    public bool SortAscending
    {
        get { return (ValidationHelper.GetBoolean(this.GetValue("SortAscending"), this.CMSDataGrid1.SortAscending)); }
        set
        {
            this.SetValue("SortAscending", value);
            this.CMSDataGrid1.SortAscending = value;
        }
    }


    /// <summary>
    /// True if the sorting is allowed
    /// </summary>
    public bool AllowSorting
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("AllowSorting"), this.CMSDataGrid1.AllowSorting); }
        set
        {
            this.SetValue("AllowSorting", value);
            this.CMSDataGrid1.AllowSorting = value;
        }
    }


    /// <summary>
    /// True if the sorting process is in the code
    /// </summary>
    public bool ProcessSorting
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("ProcessSorting"), this.CMSDataGrid1.ProcessSorting); }
        set
        {
            this.SetValue("ProcessSorting", value);
            this.CMSDataGrid1.ProcessSorting = value;
        }
    }


    /// <summary>
    /// Sort field
    /// </summary>
    public string SortField
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SortField"), this.CMSDataGrid1.SortField), this.CMSDataGrid1.SortField); }
        set
        {
            this.SetValue("SortField", value);
            this.CMSDataGrid1.SortField = value;
        }
    }


    /// <summary>
    /// True if the paging should be allowed
    /// </summary>
    public bool AllowPaging
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("AllowPaging"), this.CMSDataGrid1.AllowPaging); }
        set
        {
            this.SetValue("AllowPaging", value);
            this.CMSDataGrid1.AllowPaging = value;
        }
    }


    /// <summary>
    /// Allow custom paging
    /// </summary>
    public bool AllowCustomPaging
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("AllowCustomPaging"), this.CMSDataGrid1.AllowCustomPaging); }
        set
        {
            this.SetValue("AllowCustomPaging", value);
            this.CMSDataGrid1.AllowCustomPaging = value;
        }
    }


    /// <summary>
    /// Size of the page if the paging is allowed
    /// </summary>
    public int PageSize
    {
        get { return ValidationHelper.GetInteger(this.GetValue("PageSize"), this.CMSDataGrid1.PageSize); }
        set
        {
            this.SetValue("PageSize", value);
            this.CMSDataGrid1.PageSize = value;
        }
    }


    /// <summary>
    /// If true, the databind is automatic
    /// </summary>
    public bool DataBindByDefault
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("DataBindByDefault"), this.CMSDataGrid1.DataBindByDefault); }
        set
        {
            this.SetValue("DataBindByDefault", value);
            this.CMSDataGrid1.DataBindByDefault = value;
        }
    }


    /// <summary>
    /// Pager mode
    /// </summary>
    public PagerMode PagingMode
    {
        get { return this.CMSDataGrid1.GetPagerMode(ValidationHelper.GetString(this.GetValue("Mode"), "")); }
        set
        {
            this.SetValue("Mode", value);
        }
    }


    /// <summary>
    /// True if the header should be shown
    /// </summary>
    public bool ShowHeader
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("ShowHeader"), this.CMSDataGrid1.ShowHeader); }
        set
        {
            this.SetValue("ShowHeader", value);
            this.CMSDataGrid1.ShowHeader = value;
        }
    }


    /// <summary>
    /// True if the footer should be shown
    /// </summary>
    public bool ShowFooter
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("ShowFooter"), this.CMSDataGrid1.ShowFooter); }
        set
        {
            this.SetValue("ShowFooter", value);
            this.CMSDataGrid1.ShowFooter = value;
        }
    }


    /// <summary>
    /// Tool tip
    /// </summary>
    public string ToolTip
    {
        get { return DataHelper.GetNotEmpty(this.GetValue("ToolTip"), this.CMSDataGrid1.ToolTip); }
        set
        {
            this.SetValue("ToolTip", value);
            this.CMSDataGrid1.ToolTip = value;
        }
    }


    /// <summary>
    /// True if the new button should be shown
    /// </summary>
    public bool ShowNewButton
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("ShowNewButton"), this.CMSEditModeButtonAdd1.Visible); }
        set
        {
            this.SetValue("ShowNewButton", value);
            this.CMSEditModeButtonAdd1.Visible = value;
        }
    }


    /// <summary>
    /// New button text
    /// </summary>
    public string NewButtonText
    {
        get { return DataHelper.GetNotEmpty(this.GetValue("NewButtonText"), this.CMSEditModeButtonAdd1.Text); }
        set
        {
            this.SetValue("NewButtonText", value);
            this.CMSEditModeButtonAdd1.Text = value;
        }
    }


    /// <summary>
    /// Columns selector
    /// </summary>
    public string ColumnsSelector
    {
        get { return DataHelper.GetNotEmpty(this.GetValue("ColumnSelector"), ""); }
        set
        {
            this.SetValue("ColumnSelector", value);
        }
    }




    #endregion

    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.CMSDataGrid1.StopProcessing = true;
        }
        else
        {
            this.CMSDataGrid1.EnableViewState = true;
            // Set properties from Webpart form   
            this.CMSDataGrid1.CacheItemName = this.CacheItemName;
            this.CMSDataGrid1.CacheMinutes = this.CacheMinutes;
            this.CMSDataGrid1.CheckPermissions = this.CheckPermissions;

            this.CMSDataGrid1.ClassNames = this.ClassNames;
            this.CMSDataGrid1.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
            this.CMSDataGrid1.CultureCode = this.CultureCode;

            this.CMSDataGrid1.MaxRelativeLevel = this.MaxRelativeLevel;
            this.CMSDataGrid1.OrderBy = this.OrderBy;

            this.CMSDataGrid1.RelatedNodeIsOnTheLeftSide = this.RelatedNodeIsOnTheLeftSide;

            this.CMSDataGrid1.RelationshipName = this.RelationshipName;
            this.CMSDataGrid1.RelationshipWithNodeGuid = this.RelationshipWithNodeGUID;
            this.CMSDataGrid1.SelectedItemTransformationName = this.SelectedItemTransformationName;


            this.CMSDataGrid1.Path = this.Path;

            this.CMSDataGrid1.SelectTopN = this.SelectTopN;
            this.CMSDataGrid1.SelectOnlyPublished = this.SelectOnlyPublished;
            this.CMSDataGrid1.SiteName = this.SiteName;
            this.CMSDataGrid1.WhereCondition = this.WhereCondition;

            this.CMSDataGrid1.SkinID = this.SkinID;

            this.CMSDataGrid1.HideControlForZeroRows = this.HideControlForZeroRows;
            this.CMSDataGrid1.ZeroRowsText = this.ZeroRowsText;

            this.CMSDataGrid1.SortAscending = this.SortAscending;
            this.CMSDataGrid1.AllowSorting = this.AllowSorting;
            this.CMSDataGrid1.ProcessSorting = this.ProcessSorting;
            this.CMSDataGrid1.SortField = this.SortField;

            this.CMSDataGrid1.AllowPaging = this.AllowPaging;
            this.CMSDataGrid1.AllowCustomPaging = this.AllowCustomPaging;
            this.CMSDataGrid1.PageSize = this.PageSize;
            this.CMSDataGrid1.DataBindByDefault = this.DataBindByDefault;

            this.CMSDataGrid1.SelectTopN = this.SelectTopN;
            this.CMSDataGrid1.PagerStyle.Mode = this.PagingMode;

            this.CMSDataGrid1.ShowHeader = this.ShowHeader;
            this.CMSDataGrid1.ShowFooter = this.ShowFooter;
            this.CMSDataGrid1.ToolTip = this.ToolTip;

            // CMSEditModeButtonAdd
            this.CMSEditModeButtonAdd1.Visible = this.ShowNewButton;
            this.CMSEditModeButtonAdd1.Text = this.NewButtonText;

            string[] mClassNames = this.CMSDataGrid1.ClassNames.Split(';');
            this.CMSEditModeButtonAdd1.ClassName = DataHelper.GetNotEmpty(mClassNames[0], "");

            string mPath = "";
            if (this.CMSDataGrid1.Path.EndsWith("/%"))
            {
                mPath = this.CMSDataGrid1.Path.Remove(this.CMSDataGrid1.Path.Length - 2);
            }
            if (this.CMSDataGrid1.Path.EndsWith("/"))
            {
                mPath = this.CMSDataGrid1.Path.Remove(this.CMSDataGrid1.Path.Length - 1);
            }

            this.CMSEditModeButtonAdd1.Path = DataHelper.GetNotEmpty(mPath, "");

            LoadFromDataClass(this.CMSDataGrid1.ClassNames);

            InitColumns(this.ColumnsSelector);
        }
    }

    public override void ReloadData()
    {
        base.ReloadData();
        this.SetupControl();
        this.CMSDataGrid1.ReloadData(true);
    }


    /// <summary>
    /// Get information from XML and add it to columns
    /// </summary>
    /// <param name="mXML">Input XML string</param>
    /// <returns>Return false if params is null or empty or when Xml haven't any node</returns>
    protected bool InitColumns(string mXML)
    {
        if (this.CMSDataGrid1.Columns.Count > 0)
        {
            return false;
        }

        if ((mXML == null) || (mXML == ""))
        {
            return false;
        }

        if ((this.mColumnList == null) || (mColumnList.Length == 0))
        {
            return false;
        }

        XmlDocument mXMLDocument = new XmlDocument();
        mXMLDocument.LoadXml(mXML);

        XmlNodeList NodeList = mXMLDocument.DocumentElement.GetElementsByTagName("column");
        if (NodeList.Count == 0)
        {
            return false;
        }

        CMSDataGrid1.AutoGenerateColumns = false;
        CMSDataGrid1.ItemDataBound += new DataGridItemEventHandler(CMSDataGrid1_ItemDataBound);

        foreach (XmlNode node in NodeList)
        {
            string mName = XmlHelper.GetXmlAttributeValue(node.Attributes["name"], "");
            string mHeader = XmlHelper.GetXmlAttributeValue(node.Attributes["header"], "");
            string mType = XmlHelper.GetXmlAttributeValue(node.Attributes["type"], "");

            if (DataHelper.GetNotEmpty(mName, "") != "")
            {
                if (IsInTable(mName))
                {
                    DataGridColumn column = null;
                    if ((mType != null) && (mType == "link"))
                    {
                        if (mGlobalNameID == null)
                        {
                            mGlobalNameID = new string[0];
                        }

                        string[] mHelpGlobal = new string[mGlobalNameID.Length + 1];

                        mHelpGlobal[mGlobalNameID.Length] = mName;

                        for (int i = 0; i < mGlobalNameID.Length; i++)
                        {
                            mHelpGlobal[i] = mGlobalNameID[i];
                        }

                        mGlobalNameID = mHelpGlobal;

                        TemplateColumn col = new TemplateColumn();
                        col.ItemTemplate = new DynamicItem(mName);
                        column = col;
                    }
                    else
                    {
                        BoundColumn col = new BoundColumn();
                        column = col;

                        col.DataField = mName;
                    }

                    // Load header
                    if (DataHelper.GetNotEmpty(mHeader, "") != "")
                    {
                        column.HeaderText = ResHelper.LocalizeString(mHeader);
                    }
                    else
                    {
                        column.HeaderText = mName;
                    }

                    if (this.CMSDataGrid1.AllowSorting)
                    {
                        column.SortExpression = mName;
                    }

                    this.CMSDataGrid1.Columns.Add(column);

                }
            }
        }

        return true;
    }


    /// <summary>
    ///  Check if column is valid for classnames
    /// </summary>
    /// <param name="mColumn">Name of column</param>
    /// <returns>Return true if column is on table</returns>
    protected bool IsInTable(string mColumn)
    {
        if ((DataHelper.GetNotEmpty(mColumn, "") == "") || (mColumnList == null))
        {
            return false;
        }

        for (int i = mColumnList.GetLowerBound(0); i <= mColumnList.GetUpperBound(0); i++)
        {
            if (mColumnList[i] == mColumn) return true;
        }

        return false;
    }


    /// <summary>
    /// Load Columns names from Tree
    /// </summary>
    protected void LoadFromDataClass(string classNames)
    {
        ArrayList columnList = new ArrayList();
        ArrayList classesList = new ArrayList();
        if ((classNames != null) && (classNames != ""))
        {
            classesList = new ArrayList(classNames.Split(';'));
        }

        // If more than 1 DataClasses are in classesList, get columns only from CMS.Tree and CMS.Document.
        if (classesList.Count > 1)
        {
            classesList = new ArrayList();
        }
        classesList.Add("CMS.Tree");
        classesList.Add("CMS.Document");

        // Fill columnList with column names from all classes.
        foreach (string className in classesList)
        {
            DataClass dc = new DataClass(className);
            DataClassInfo dci = DataClassInfoProvider.GetDataClass(className);
            // Get columns only from couplet classes.
            if (dci.ClassIsCoupledClass)
            {
                foreach (DataColumn col in dc.DataRow.Table.Columns)
                {
                    columnList.Add(col.ColumnName);
                }
            }
        }
        // Set string array.
        this.mColumnList = (String[])columnList.ToArray(typeof(string));
    }


    /// <summary>
    /// Item data bound handler
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    void CMSDataGrid1_ItemDataBound(object sender, DataGridItemEventArgs e)
    {
        if (mGlobalNameID != null)
        {
            for (int i = mGlobalNameID.GetLowerBound(0); i <= mGlobalNameID.GetUpperBound(0); i++)
            {
                if (mGlobalNameID[i] != null && mGlobalNameID[i] != "")
                {
                    Control ctrl = e.Item.FindControl(mGlobalNameID[i]);
                    if (ctrl != null)
                    {
                        ((HyperLink)ctrl).Text = ((DataRowView)e.Item.DataItem)[mGlobalNameID[i]].ToString();
                        ((HyperLink)ctrl).NavigateUrl = CMSContext.GetUrl(((DataRowView)e.Item.DataItem)["NodeAliasPath"].ToString(), ((DataRowView)e.Item.DataItem)["DocumentUrlPath"].ToString());
                    }
                }
            }
        }
    }

}

