using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.Controls;
using CMS.CMSHelper;


public partial class CMSWebParts_cmsdatalist : CMSAbstractWebPart
{
    #region "Document properties"

    ///// <summary>
    ///// Cache item name
    ///// </summary>
    //public string CacheItemName
    //{
    //    get
    //    {
    //        return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CacheItemName"), this.lstElem.CacheItemName), this.lstElem.CacheItemName);
    //    }
    //    set
    //    {
    //        this.SetValue("CacheItemName", value);
    //        this.lstElem.CacheItemName = value;
    //    }
    //}


    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CacheMinutes"), this.lstElem.CacheMinutes);
        }
        set
        {
            this.SetValue("CacheMinutes", value);
            this.lstElem.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Check permissions
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.lstElem.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
        }
    }


    /// <summary>
    /// Class names
    /// </summary>
    public string ClassNames
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Classnames"), this.lstElem.ClassNames), this.lstElem.ClassNames);
        }
        set
        {
            this.SetValue("ClassNames", value);
            this.lstElem.ClassNames = value;
        }
    }


    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.lstElem.CombineWithDefaultCulture);
        }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.lstElem.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.lstElem.CultureCode), this.lstElem.CultureCode);
        }
        set
        {
            this.SetValue("CultureCode", value);
            this.lstElem.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.lstElem.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.lstElem.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.lstElem.OrderBy), this.lstElem.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.lstElem.OrderBy = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), null), null);
        }
        set
        {
            this.SetValue("Path", value);
            this.lstElem.Path = value;
        }
    }


    /// <summary>
    /// Select only published nodes
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.lstElem.SelectOnlyPublished);
        }
        set
        {
            this.SetValue("SelctOnlyPublished", value);
            this.lstElem.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.lstElem.SiteName), this.lstElem.SiteName);
        }
        set
        {
            this.SetValue("SiteName", value);
            this.lstElem.SiteName = value;
        }
    }

    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.lstElem.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.lstElem.WhereCondition = value;
        }
    }


    /// <summary>
    /// Select top N items
    /// </summary>
    public int SelectTopN
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("SelectTopN"), this.lstElem.SelectTopN);
        }
        set
        {
            this.SetValue("SelectTopN", value);
            this.lstElem.SelectTopN = value;
        }
    }

    #endregion


    #region "Pager properties"

    /// <summary>
    /// Pager control
    /// </summary>
    public DataPager PagerControl
    {
        get
        {
            return (DataPager)this.lstElem.PagerControl;
        }
    }


    /// <summary>
    /// Enable paging
    /// </summary>
    public bool EnablePaging
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("EnablePaging"), this.lstElem.EnablePaging);
        }
        set
        {
            this.SetValue("EnablePaging", value);
            this.lstElem.EnablePaging = value;
        }
    }


    /// <summary>
    /// Pager position
    /// </summary>
    public PagingPlaceTypeEnum PagerPosition
    {
        get
        {
            return this.PagerControl.GetPagerPosition(DataHelper.GetNotEmpty(this.GetValue("PagerPosition"), this.PagerControl.PagerPosition.ToString()));
        }
        set
        {
            this.SetValue("PagerPosition", value.ToString());
            this.PagerControl.PagerPosition = value;
        }
    }


    /// <summary>
    /// Page size
    /// </summary>
    public int PageSize
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("PageSize"), this.PagerControl.PageSize);
        }
        set
        {
            this.SetValue("PageSize", value);
            this.PagerControl.PageSize = value;
        }
    }


    /// <summary>
    /// Pager query string key
    /// </summary>
    public string QueryStringKey
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("QueryStringKey"), this.PagerControl.QueryStringKey), this.PagerControl.QueryStringKey);
        }
        set
        {
            this.SetValue("QueryStringKey", value);
            this.PagerControl.QueryStringKey = value;
        }
    }


    /// <summary>
    /// Paging mode
    /// </summary>
    public PagingModeTypeEnum PagingMode
    {
        get
        {
            return this.PagerControl.GetPagingMode(DataHelper.GetNotEmpty(this.GetValue("PagingMode"), this.PagerControl.PagingMode.ToString()));
        }
        set
        {
            this.SetValue("PagingMode", value.ToString());
            this.PagerControl.PagingMode = value;
        }
    }


    /// <summary>
    /// Show first / last links
    /// </summary>
    public bool ShowFirstLast
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowFirstLast"), this.PagerControl.ShowFirstLast);
        }
        set
        {
            this.SetValue("ShowFirstLast", value);
            this.PagerControl.ShowFirstLast = value;
        }
    }

    #endregion


    #region "Relationships properties"

    /// <summary>
    /// Related node is on the left side
    /// </summary>
    public bool RelatedNodeIsOnTheLeftSide
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("RelatedNodeIsOnTheLeftSide"), this.lstElem.RelatedNodeIsOnTheLeftSide);
        }
        set
        {
            this.SetValue("RelatedNodeIsOnTheLeftSide", value);
            this.lstElem.RelatedNodeIsOnTheLeftSide = value;
        }
    }


    /// <summary>
    /// Relationship name
    /// </summary>
    public string RelationshipName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("RelationshipName"), this.lstElem.RelationshipName), this.lstElem.RelationshipName);
        }
        set
        {
            this.SetValue("RelationshipName", value);
            this.lstElem.RelationshipName = value;
        }
    }


    /// <summary>
    /// Relationship with node GUID
    /// </summary>
    public Guid RelationshipWithNodeGUID
    {
        get
        {
            return ValidationHelper.GetGuid(this.GetValue("RelationshipWithNodeGuid"), this.lstElem.RelationshipWithNodeGuid);
        }
        set
        {
            this.SetValue("RelationshipWithNodeGuid", value);
            this.lstElem.RelationshipWithNodeGuid = value;
        }
    }

    #endregion


    #region "Transformation properties"

    /// <summary>
    /// Transformation name
    /// </summary>
    public string TransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("TransformationName"), this.lstElem.TransformationName), this.lstElem.TransformationName);
        }
        set
        {
            this.SetValue("TransformationName", value);
            this.lstElem.TransformationName = value;
        }
    }


    /// <summary>
    /// Transformation name
    /// </summary>
    public string SelectedItemTransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SelectedItemTransformationName"), this.lstElem.SelectedItemTransformationName), this.lstElem.SelectedItemTransformationName);
        }
        set
        {
            this.SetValue("SelectedItemTransformationName", value);
            this.lstElem.SelectedItemTransformationName = value;
        }
    }


    /// <summary>
    /// Transformation name
    /// </summary>
    public string AlternatingTransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("AlternatingTransformationName"), this.lstElem.AlternatingTransformationName), this.lstElem.AlternatingTransformationName);
        }
        set
        {
            this.SetValue("AlternatingTransformationName", value);
            this.lstElem.AlternatingTransformationName = value;
        }
    }

    #endregion


    #region "Public properties"

    /// <summary>
    /// Nested repeater ID
    /// </summary>
    public string NestedRepeaterID
    {
        get { return ValidationHelper.GetString(this.GetValue("NestedRepeaterID"), lstElem.NestedRepeaterID); }
        set
        {
            this.SetValue("NestedRepeaterID", value);
            this.lstElem.NestedRepeaterID = value;
        }
    }

    /// <summary>
    /// Nested datalist ID
    /// </summary>
    public string NestedDataListID
    {
        get { return ValidationHelper.GetString(this.GetValue("NestedDataListID"), lstElem.NestedDataListID); }
        set
        {
            this.SetValue("NestedDataListID", value);
            this.lstElem.NestedDataListID = value;
        }
    }

    /// <summary>
    /// Hide control for zero rows
    /// </summary>
    public bool HideControlForZeroRows
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("HideControlForZeroRows"), this.lstElem.HideControlForZeroRows);
        }
        set
        {
            this.SetValue("HideControlForZeroRows", value);
            this.lstElem.HideControlForZeroRows = value;
        }
    }


    /// <summary>
    /// Zero rows text
    /// </summary>
    public string ZeroRowsText
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("ZeroRowsText"), this.lstElem.ZeroRowsText), this.lstElem.ZeroRowsText);
        }
        set
        {
            this.SetValue("ZeroRowsText", value);
            this.lstElem.ZeroRowsText = value;
        }
    }


    /// <summary>
    /// Repeat columns
    /// </summary>
    public int RepeatColumns
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("RepeatColumns"), this.lstElem.RepeatColumns);
        }
        set
        {
            this.SetValue("RepeatColumns", value);
            this.lstElem.RepeatColumns = value;
        }
    }


    /// <summary>
    /// Repeat layout
    /// </summary>
    public RepeatLayout RepeatLayout
    {
        get
        {
            return CMSDataList.GetRepeatLayout(DataHelper.GetNotEmpty(this.GetValue("RepeatLayout"), this.lstElem.RepeatLayout.ToString()));
        }
        set
        {
            this.SetValue("RepeatLayout", value.ToString());
            this.lstElem.RepeatLayout = value;
        }
    }


    /// <summary>
    /// Repeat Direction
    /// </summary>
    public RepeatDirection RepeatDirection
    {
        get
        {
            return CMSDataList.GetRepeatDirection(DataHelper.GetNotEmpty(this.GetValue("RepeatDirection"), this.lstElem.RepeatDirection.ToString()));
        }
        set
        {
            this.SetValue("RepeatDirection", value.ToString());
            this.lstElem.RepeatDirection = value;
        }
    }


    #endregion


    #region "Editing mode buttons properties"

    /// <summary>
    /// Show new button
    /// </summary>
    public bool ShowNewButton
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowNewButton"), this.btnAdd.Visible);
        }
        set
        {
            this.SetValue("ShowNewButton", value);
            this.btnAdd.Visible = value;
        }
    }


    /// <summary>
    /// New button text
    /// </summary>
    public string NewButtonText
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("NewButtonText"), this.btnAdd.Text);
        }
        set
        {
            this.SetValue("NewButtonText", value);
            this.btnAdd.Text = value;
        }
    }


    /// <summary>
    /// Show edit / delete buttons
    /// </summary>
    public bool ShowEditDeleteButtons
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowEditDeleteButtons"), this.lstElem.ShowEditDeleteButtons);
        }
        set
        {
            this.SetValue("ShowEditDeleteButtons", value);
            this.lstElem.ShowEditDeleteButtons = value;
        }
    }

    #endregion


    #region "Data binding properties"

    /// <summary>
    /// Databind by default
    /// </summary>
    public bool DataBindByDefault
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("DataBindByDefault"), this.lstElem.DataBindByDefault);
        }
        set
        {
            this.SetValue("DataBindByDefault", value);
            this.lstElem.DataBindByDefault = value;
        }
    }


    /// <summary>
    /// BuildFormat by default
    /// </summary>
    public bool BuildFormatByDefault
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("BuildFormatByDefault"), this.lstElem.BuildFormatByDefault);
        }
        set
        {
            this.SetValue("BuildFormatByDefault", value);
            this.lstElem.BuildFormatByDefault = value;
        }
    }

    #endregion

    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }

    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        // In design mode is pocessing of control stoped
        if ((this.PageManager.ViewMode == CMS.CMSHelper.ViewModeEnum.Design) || this.HideOnCurrentPage || (!this.IsVisible))
        {
            this.lstElem.StopProcessing = true;
        }
        else
        {
            // Document properties
            this.lstElem.CacheItemName = this.CacheItemName;
            this.lstElem.CacheMinutes = this.CacheMinutes;
            this.lstElem.CheckPermissions = this.CheckPermissions;
            this.lstElem.ClassNames = this.ClassNames;
            this.lstElem.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
            this.lstElem.CultureCode = this.CultureCode;
            this.lstElem.Path = this.Path;
            this.lstElem.MaxRelativeLevel = this.MaxRelativeLevel;
            this.lstElem.OrderBy = this.OrderBy;
            this.lstElem.SelectTopN = this.SelectTopN;
            this.lstElem.SelectOnlyPublished = this.SelectOnlyPublished;
            this.lstElem.SiteName = this.SiteName;
            this.lstElem.WhereCondition = this.WhereCondition;

            // Relationships
            this.lstElem.RelatedNodeIsOnTheLeftSide = this.RelatedNodeIsOnTheLeftSide;
            this.lstElem.RelationshipName = this.RelationshipName;
            this.lstElem.RelationshipWithNodeGuid = this.RelationshipWithNodeGUID;

            // Transformations
            this.lstElem.SelectedItemTransformationName = this.SelectedItemTransformationName;
            this.lstElem.AlternatingTransformationName = this.AlternatingTransformationName;
            this.lstElem.TransformationName = this.TransformationName;

            // Pager
            this.PagerControl.PagerPosition = this.PagerPosition;
            this.lstElem.EnablePaging = this.EnablePaging;
            this.PagerControl.PageSize = this.PageSize;
            this.PagerControl.QueryStringKey = this.QueryStringKey;
            this.PagerControl.PagingMode = this.PagingMode;
            this.PagerControl.ShowFirstLast = this.ShowFirstLast;

            // Public
            this.lstElem.RepeatColumns = this.RepeatColumns;
            this.lstElem.RepeatLayout = this.RepeatLayout;
            this.lstElem.RepeatDirection = this.RepeatDirection;
            this.lstElem.HideControlForZeroRows = this.HideControlForZeroRows;
            this.lstElem.ZeroRowsText = this.ZeroRowsText;


            this.lstElem.NestedRepeaterID = this.NestedRepeaterID;
            this.lstElem.NestedDataListID = this.NestedDataListID;

            // Binding
            this.lstElem.DataBindByDefault = this.DataBindByDefault;
            this.lstElem.BuildFormatByDefault = this.BuildFormatByDefault;

            // Editing buttons
            this.lstElem.ShowEditDeleteButtons = this.ShowEditDeleteButtons;

            // CMSEditModeButtonAdd
            this.btnAdd.Visible = this.ShowNewButton;
            this.btnAdd.Text = this.NewButtonText;

            string[] mClassNames = this.lstElem.ClassNames.Split(';');
            this.btnAdd.ClassName = DataHelper.GetNotEmpty(mClassNames[0], "");

            string mPath = "";
            if (this.lstElem.Path.EndsWith("/%"))
            {
                mPath = this.lstElem.Path.Remove(this.lstElem.Path.Length - 2);
            }
            if (this.lstElem.Path.EndsWith("/"))
            {
                mPath = this.lstElem.Path.Remove(this.lstElem.Path.Length - 1);
            }

            this.btnAdd.Path = DataHelper.GetNotEmpty(mPath, "");
        }
    }
    
    
    public override void ReloadData()
    {
        base.ReloadData();
        this.SetupControl();
        this.lstElem.ReloadData(true);
    }

}
