using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.SiteProvider;
using CMS.DataEngine;

public partial class CMSWebParts_Viewers_relateddocuments : CMSAbstractWebPart
{
    #region Public properties
    
    /// <summary>
    /// Current document is on the left side
    /// </summary>
    public bool CurrentDocumentIsOnTheLeftSide
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CurrentDocumentIsOnTheLeftSide"), true);
        }
        set
        {
            this.SetValue("CurrentDocumentIsOnTheLeftSide", value);
        }
    }


    /// <summary>
    /// Relationship name
    /// </summary>
    public string RelationshipName
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("RelationshipName"), "");
        }
        set
        {
            this.SetValue("RelationshipName", value);
        }
    }


    /// <summary>
    /// Transformation name
    /// </summary>
    public string TransformationName
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("TransformationName"), "");
        }
        set
        {
            this.SetValue("TransformationName", value);
        }
    }


    /// <summary>
    /// Hide control for zero rows
    /// </summary>
    public bool HideControlForZeroRows
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("HideControlForZeroRows"), this.CMSRepeater1.HideControlForZeroRows);
        }
        set
        {
            this.SetValue("HideControlForZeroRows", value);
            this.CMSRepeater1.HideControlForZeroRows = value;
        }
    }


    /// <summary>
    /// Zero rows text
    /// </summary>
    public string ZeroRowsText
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("ZeroRowsText"), this.CMSRepeater1.ZeroRowsText);
        }
        set
        {
            this.SetValue("ZeroRowsText", value);
            this.CMSRepeater1.ZeroRowsText = value;
        }
    }



    #endregion

    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
 	    base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.CMSRepeater1.StopProcessing = true;
        }
        else
        {
            // Setup the control
            TreeProvider tp = new TreeProvider();
            DataSet ds = tp.SelectNodes(TreeProvider.ALL_SITES, "/%", CMSContext.CurrentDocument.DocumentCulture, true, "", "", "", -1, false, CMSContext.CurrentDocument.NodeGUID, this.RelationshipName, this.CurrentDocumentIsOnTheLeftSide);

            if (!DataHelper.IsEmpty(ds))
            {
                CMSRepeater1.DataSource = ds;
            }

            this.CMSRepeater1.Path = "/%";
            this.CMSRepeater1.MaxRelativeLevel = -1;
            this.CMSRepeater1.ClassNames = "CMS.Root";
            if (this.TransformationName != string.Empty)
            {
                this.CMSRepeater1.TransformationName = this.TransformationName;
            }
            this.CMSRepeater1.HideControlForZeroRows = this.HideControlForZeroRows;
            this.CMSRepeater1.ZeroRowsText = this.ZeroRowsText;
            this.CMSRepeater1.EnablePaging = false;
        }
    }
}
