/* ### TABLES ###  */

ALTER TABLE [CMS_Attachment] ALTER COLUMN [AttachmentMimeType] [nvarchar] (100) NOT NULL
GO

ALTER TABLE [CMS_Class] ADD [ClassIsMenuItemType] [bit] NULL
GO

ALTER TABLE [CMS_Form] ADD [FormEmailSubject] [nvarchar] (250) NULL
GO

ALTER TABLE [CMS_PageTemplate] ADD [PageTemplateHeader] [ntext] NULL
GO

ALTER TABLE [CMS_Tree] ADD [NodeChildNodesCount] [int] NULL, [RequiresSSL] [bit] NULL  
GO

sp_rename 'CMS_Tree.[NodeBodyCssClass]', 'NodeBodyElementAttributes', 'COLUMN' 
GO

ALTER TABLE [CMS_User] ADD     
[UserCreated] [datetime] NULL,
[LastLogon] [datetime] NULL,
[UserNickName] [nvarchar] (200) NULL,
[UserPicture] [nvarchar] (500) NULL,
[UserSignature] [ntext] NULL
GO

ALTER TABLE [CMS_WorkflowScope] ALTER COLUMN [ScopeClassID] [int] NULL
GO

ALTER TABLE [Forums_Forum] ADD [ForumAllowChangeName] [bit] NULL,
 [ForumHTMLEditor] [bit] NULL 
GO
 
ALTER TABLE [Forums_ForumPost] ADD [PostUserSignature] [ntext] NULL
GO

/*### Constaints & FK ###*/
ALTER TABLE [CMS_ACLItem] DROP
CONSTRAINT [FK__CMS_ACLIt__ACLID__108B795B],
CONSTRAINT [FK__CMS_ACLIt__LastM__1367E606],
CONSTRAINT [FK__CMS_ACLIt__RoleI__117F9D94],
CONSTRAINT [FK__CMS_ACLIt__UserI__1273C1CD]
GO

ALTER TABLE [CMS_ACLItem] ADD
CONSTRAINT [FK__CMS_ACLIt__ACLID__108B795B]
    FOREIGN KEY ([ACLID]) REFERENCES [CMS_ACL] ([ACLID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_ACLIt__LastM__1367E606]
    FOREIGN KEY ([LastModifiedByUserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_ACLIt__RoleI__117F9D94]
    FOREIGN KEY ([RoleID]) REFERENCES [CMS_Role] ([RoleID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_ACLIt__UserI__1273C1CD]
    FOREIGN KEY ([UserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_AllowedChildClasses] DROP
CONSTRAINT [FK__CMS_Allow__Child__1CF15040],
CONSTRAINT [FK__CMS_Allow__Paren__1BFD2C07]
GO

ALTER TABLE [CMS_AllowedChildClasses] ADD
CONSTRAINT [FK__CMS_Allow__Child__1CF15040]
    FOREIGN KEY ([ChildClassID]) REFERENCES [CMS_Class] ([ClassID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Allow__Paren__1BFD2C07]
    FOREIGN KEY ([ParentClassID]) REFERENCES [CMS_Class] ([ClassID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_Attachment] DROP CONSTRAINT [FK__CMS_Attac__Attac__09A971A2]
GO

ALTER TABLE [CMS_Attachment] ADD
CONSTRAINT [FK__CMS_Attac__Attac__09A971A2]
    FOREIGN KEY ([AttachmentDocumentID]) REFERENCES [CMS_Document] ([DocumentID]) NOT FOR REPLICATION
GO

DROP INDEX [CMS_Class].[IX_CMS_Class_1]
GO

CREATE UNIQUE NONCLUSTERED INDEX [IX_CMS_Class_1]                                                 
    ON [CMS_Class] ([ClassName]) ON [PRIMARY]  
GO

ALTER TABLE [CMS_ClassSite] DROP
	CONSTRAINT [FK__CMS_Class__Class__182C9B23],
	CONSTRAINT [FK__CMS_Class__SiteI__1920BF5C]
GO

ALTER TABLE [CMS_ClassSite] ADD
CONSTRAINT [FK__CMS_Class__Class__182C9B23]
    FOREIGN KEY ([ClassID]) REFERENCES [CMS_Class] ([ClassID]) NOT FOR REPLICATION,                                                                                                                                                                       
CONSTRAINT [FK__CMS_Class__SiteI__1920BF5C]
    FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_CssStylesheetSite] DROP
CONSTRAINT [FK__CMS_CssSt__SiteI__03317E3D],
CONSTRAINT [FK__CMS_CssSt__Style__023D5A04]
GO

ALTER TABLE [CMS_CssStylesheetSite] ADD
CONSTRAINT [FK__CMS_CssSt__SiteI__03317E3D]
FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_CssSt__Style__023D5A04]
FOREIGN KEY ([StylesheetID]) REFERENCES [CMS_CssStylesheet] ([StylesheetID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_Document] DROP
CONSTRAINT [FK__CMS_Docum__Docum__38996AB5],
CONSTRAINT [FK__CMS_Docum__Docum__398D8EEE],
CONSTRAINT [FK__CMS_Docum__Docum__3A81B327],
CONSTRAINT [FK__CMS_Docum__Docum__3B75D760],
CONSTRAINT [FK__CMS_Docum__Docum__3C69FB99],
CONSTRAINT [FK__CMS_Docum__Docum__3D5E1FD2],
CONSTRAINT [FK__CMS_Docum__Docum__3E52440B]
GO

ALTER TABLE [CMS_Document] ADD
CONSTRAINT [FK__CMS_Docum__Docum__398D8EEE]
FOREIGN KEY ([DocumentPageTemplateID]) REFERENCES [CMS_PageTemplate] ([PageTemplateID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Docum__Docum__3A81B327]
FOREIGN KEY ([DocumentNodeID]) REFERENCES [CMS_Tree] ([NodeID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Docum__Docum__3B75D760]
FOREIGN KEY ([DocumentCreatedByUserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Docum__Docum__3C69FB99]
FOREIGN KEY ([DocumentCheckedOutByUserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Docum__Docum__3D5E1FD2]
FOREIGN KEY ([DocumentModifiedByUserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Docum__Docum__3E52440B]
FOREIGN KEY ([DocumentWorkflowStepID]) REFERENCES [CMS_WorkflowStep] ([StepID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_EmailTemplate] DROP
CONSTRAINT [FK__CMS_Email__Email__412EB0B6]

ALTER TABLE [CMS_EmailTemplate] ADD
CONSTRAINT [FK__CMS_Email__Email__412EB0B6]
FOREIGN KEY ([EmailTemplateSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_EventLog] DROP
CONSTRAINT [FK__CMS_Event__NodeI__44FF419A],
CONSTRAINT [FK__CMS_Event__SiteI__440B1D61],
CONSTRAINT [FK__CMS_Event__UserI__45F365D3]
GO

ALTER TABLE [CMS_EventLog] ADD
CONSTRAINT [FK__CMS_Event__NodeI__44FF419A]
FOREIGN KEY ([NodeID]) REFERENCES [CMS_Tree] ([NodeID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Event__SiteI__440B1D61]
FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Event__UserI__45F365D3]
FOREIGN KEY ([UserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_Form] DROP
CONSTRAINT [FK__CMS_Form__FormCl__282DF8C2]
GO

ALTER TABLE [CMS_Form] ADD
CONSTRAINT [FK__CMS_Form__FormCl__282DF8C2]
FOREIGN KEY ([FormClassID]) REFERENCES [CMS_Class] ([ClassID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_InlineControlSite] DROP
CONSTRAINT [FK__CMS_Inlin__Contr__2EDAF651],
CONSTRAINT [FK__CMS_Inlin__SiteI__2FCF1A8A]
GO

ALTER TABLE [CMS_InlineControlSite] ADD
CONSTRAINT [FK__CMS_Inlin__Contr__2EDAF651]
FOREIGN KEY ([ControlID]) REFERENCES [CMS_InlineControl] ([ControlID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Inlin__SiteI__2FCF1A8A]
FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_InlineControlSite] DROP
CONSTRAINT [FK__CMS_Inlin__Contr__2EDAF651],
CONSTRAINT [FK__CMS_Inlin__SiteI__2FCF1A8A]
GO

ALTER TABLE [CMS_InlineControlSite] ADD
CONSTRAINT [FK__CMS_Inlin__Contr__2EDAF651]
FOREIGN KEY ([ControlID]) REFERENCES [CMS_InlineControl] ([ControlID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Inlin__SiteI__2FCF1A8A]
FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_Layout] DROP
CONSTRAINT [FK_CMS_Layout_CMS_User]
GO

ALTER TABLE [CMS_Layout] ADD
CONSTRAINT [FK_CMS_Layout_CMS_User]
FOREIGN KEY ([LayoutCheckedOutByUserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_PageTemplate] DROP
CONSTRAINT [FK__CMS_PageT__PageT__30F848ED],
CONSTRAINT [FK__CMS_PageT__PageT__31EC6D26],
CONSTRAINT [FK_CMS_PageTemplate_CMS_User]
GO

ALTER TABLE [CMS_PageTemplate] ADD
CONSTRAINT [FK__CMS_PageT__PageT__30F848ED]
FOREIGN KEY ([PageTemplateLayoutID]) REFERENCES [CMS_Layout] ([LayoutID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_PageT__PageT__31EC6D26]
FOREIGN KEY ([PageTemplateCategoryID]) REFERENCES [CMS_PageTemplateCategory] ([CategoryID]) NOT FOR REPLICATION,
CONSTRAINT [FK_CMS_PageTemplate_CMS_User]
FOREIGN KEY ([PageTemplateLayoutCheckedOutByUserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_PageTemplateCategory] DROP
CONSTRAINT [FK__CMS_PageT__Categ__2E1BDC42]
GO

ALTER TABLE [CMS_PageTemplateCategory] ADD
CONSTRAINT [FK__CMS_PageT__Categ__2E1BDC42]
FOREIGN KEY ([CategoryParentID]) REFERENCES [CMS_PageTemplateCategory] ([CategoryID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_PageTemplateSite] DROP
CONSTRAINT [FK__CMS_PageT__PageT__34C8D9D1],
CONSTRAINT [FK__CMS_PageT__SiteI__35BCFE0A]
GO

ALTER TABLE [CMS_PageTemplateSite] ADD
CONSTRAINT [FK__CMS_PageT__PageT__34C8D9D1]
FOREIGN KEY ([PageTemplateID]) REFERENCES [CMS_PageTemplate] ([PageTemplateID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_PageT__SiteI__35BCFE0A]
FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_Permission] DROP
CONSTRAINT [FK__CMS_Permi__Class__4BAC3F29],
CONSTRAINT [FK__CMS_Permi__Resou__4CA06362]
GO

ALTER TABLE [CMS_Permission] ADD
CONSTRAINT [FK__CMS_Permi__Class__4BAC3F29]
FOREIGN KEY ([ClassID]) REFERENCES [CMS_Class] ([ClassID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Permi__Resou__4CA06362]
FOREIGN KEY ([ResourceID]) REFERENCES [CMS_Resource] ([ResourceID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_Query] DROP
CONSTRAINT [FK__CMS_Query__Class__4F7CD00D]
GO

ALTER TABLE [CMS_Query] ADD
CONSTRAINT [FK__CMS_Query__Class__4F7CD00D]
FOREIGN KEY ([ClassID]) REFERENCES [CMS_Class] ([ClassID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_Relationship] DROP
CONSTRAINT [FK__CMS_Relat__LeftN__151B244E],
CONSTRAINT [FK__CMS_Relat__Relat__14270015],
CONSTRAINT [FK__CMS_Relat__Right__160F4887]
GO

ALTER TABLE [CMS_Relationship] ADD
CONSTRAINT [FK__CMS_Relat__LeftN__151B244E]
FOREIGN KEY ([LeftNodeID]) REFERENCES [CMS_Tree] ([NodeID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Relat__Relat__14270015]
FOREIGN KEY ([RelationshipNameID]) REFERENCES [CMS_RelationshipName] ([RelationshipNameID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Relat__Right__160F4887]
FOREIGN KEY ([RightNodeID]) REFERENCES [CMS_Tree] ([NodeID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_RelationshipNameSite] DROP
CONSTRAINT [FK__CMS_Relat__Relat__10566F31],
CONSTRAINT [FK__CMS_Relat__SiteI__114A936A]
GO

ALTER TABLE [CMS_RelationshipNameSite] ADD
CONSTRAINT [FK__CMS_Relat__Relat__10566F31]
FOREIGN KEY ([RelationshipNameID]) REFERENCES [CMS_RelationshipName] ([RelationshipNameID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Relat__SiteI__114A936A]
FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_ResourceSite] DROP
CONSTRAINT [FK__CMS_Resou__Resou__52593CB8],
CONSTRAINT [FK__CMS_Resou__SiteI__534D60F1]
GO

ALTER TABLE [CMS_ResourceSite] ADD
CONSTRAINT [FK__CMS_Resou__Resou__52593CB8]
FOREIGN KEY ([ResourceID]) REFERENCES [CMS_Resource] ([ResourceID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Resou__SiteI__534D60F1]
FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_ResourceTranslation] DROP
CONSTRAINT [FK__CMS_Resou__Trans__1CBC4616],
CONSTRAINT [FK__CMS_Resou__Trans__1DB06A4F]
GO

ALTER TABLE [CMS_ResourceTranslation] ADD
CONSTRAINT [FK__CMS_Resou__Trans__1CBC4616]
FOREIGN KEY ([TranslationStringID]) REFERENCES [CMS_ResourceString] ([StringID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Resou__Trans__1DB06A4F]
FOREIGN KEY ([TranslationUICultureID]) REFERENCES [CMS_UICulture] ([UICultureID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_Role] DROP
CONSTRAINT [FK__CMS_Role__SiteID__08EA5793]
GO

ALTER TABLE [CMS_Role] ADD
CONSTRAINT [FK__CMS_Role__SiteID__08EA5793]
FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_RolePermission] DROP
CONSTRAINT [FK__CMS_RoleP__Permi__5629CD9C],
CONSTRAINT [FK__CMS_RoleP__RoleI__571DF1D5]
GO

ALTER TABLE [CMS_RolePermission] ADD
CONSTRAINT [FK__CMS_RoleP__Permi__5629CD9C]
FOREIGN KEY ([PermissionID]) REFERENCES [CMS_Permission] ([PermissionID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_RoleP__RoleI__571DF1D5]
FOREIGN KEY ([RoleID]) REFERENCES [CMS_Role] ([RoleID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_ScheduledTask] DROP
CONSTRAINT [FK__CMS_Sched__TaskS__32AB8735]
GO

ALTER TABLE [CMS_ScheduledTask] ADD
CONSTRAINT [FK__CMS_Sched__TaskS__32AB8735]
FOREIGN KEY ([TaskSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_SettingsKey] DROP
CONSTRAINT [FK__CMS_Setti__KeyCa__5CD6CB2B],
CONSTRAINT [FK__CMS_Setti__SiteI__5DCAEF64]
GO

ALTER TABLE [CMS_SettingsKey] ADD
CONSTRAINT [FK__CMS_Setti__KeyCa__5CD6CB2B]
FOREIGN KEY ([KeyCategoryID]) REFERENCES [CMS_SettingsCategory] ([CategoryID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Setti__SiteI__5DCAEF64]
FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_Site] DROP
CONSTRAINT [FK__CMS_Site__SiteDe__7F60ED59]
GO

ALTER TABLE [CMS_Site] ADD
CONSTRAINT [FK__CMS_Site__SiteDe__7F60ED59]
FOREIGN KEY ([SiteDefaultStylesheetID]) REFERENCES [CMS_CssStylesheet] ([StylesheetID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_SiteCulture] DROP
CONSTRAINT [FK__CMS_SiteC__Cultu__60A75C0F],
CONSTRAINT [FK__CMS_SiteC__SiteI__619B8048]
GO

ALTER TABLE [CMS_SiteCulture] ADD
CONSTRAINT [FK__CMS_SiteC__Cultu__60A75C0F]
FOREIGN KEY ([CultureID]) REFERENCES [CMS_Culture] ([CultureID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_SiteC__SiteI__619B8048]
FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_SiteDomainAlias] DROP
CONSTRAINT [FK__CMS_SiteD__SiteI__6477ECF3]
GO

ALTER TABLE [CMS_SiteDomainAlias] ADD
CONSTRAINT [FK__CMS_SiteD__SiteI__6477ECF3]
FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_State] DROP
CONSTRAINT [FK_CMS_State_CMS_Country]
GO

ALTER TABLE [CMS_State] ADD
CONSTRAINT [FK_CMS_State_CMS_Country]
FOREIGN KEY ([CountryID]) REFERENCES [CMS_Country] ([CountryID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_Transformation] DROP
CONSTRAINT [FK__CMS_Trans__Trans__6754599E],
CONSTRAINT [FK_CMS_Transformation_CMS_User]
GO

ALTER TABLE [CMS_Transformation] ADD
CONSTRAINT [FK__CMS_Trans__Trans__6754599E]
FOREIGN KEY ([TransformationClassID]) REFERENCES [CMS_Class] ([ClassID]) NOT FOR REPLICATION,
CONSTRAINT [FK_CMS_Transformation_CMS_User]
FOREIGN KEY ([TransformationCheckedOutByUserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_Tree] DROP
CONSTRAINT [FK__CMS_Tree__NodeAC__21B6055D],
CONSTRAINT [FK__CMS_Tree__NodeCl__22AA2996],
CONSTRAINT [FK__CMS_Tree__NodeSi__239E4DCF]
GO

ALTER TABLE [CMS_Tree] ADD
CONSTRAINT [FK__CMS_Tree__NodeAC__21B6055D]
FOREIGN KEY ([NodeACLID]) REFERENCES [CMS_ACL] ([ACLID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Tree__NodeCl__22AA2996]
FOREIGN KEY ([NodeClassID]) REFERENCES [CMS_Class] ([ClassID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Tree__NodeSi__239E4DCF]
FOREIGN KEY ([NodeSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_UserRole] DROP
CONSTRAINT [FK__CMS_UserR__RoleI__6A30C649],
CONSTRAINT [FK__CMS_UserR__UserI__6B24EA82]
GO

ALTER TABLE [CMS_UserRole] ADD
CONSTRAINT [FK__CMS_UserR__RoleI__6A30C649]
FOREIGN KEY ([RoleID]) REFERENCES [CMS_Role] ([RoleID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_UserR__UserI__6B24EA82]
FOREIGN KEY ([UserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_UserSite] DROP
CONSTRAINT [FK__CMS_UserS__SiteI__6E01572D],
CONSTRAINT [FK__CMS_UserS__UserI__6EF57B66]
GO

ALTER TABLE [CMS_UserSite] ADD
CONSTRAINT [FK__CMS_UserS__SiteI__6E01572D]
FOREIGN KEY ([SiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_UserS__UserI__6EF57B66]
FOREIGN KEY ([UserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_VersionAttachment] DROP
CONSTRAINT [FK__CMS_Versi__Attac__208CD6FA],
CONSTRAINT [FK__CMS_Versi__Versi__2180FB33]
GO

ALTER TABLE [CMS_VersionAttachment] ADD
CONSTRAINT [FK__CMS_Versi__Attac__208CD6FA]
FOREIGN KEY ([AttachmentHistoryID]) REFERENCES [CMS_AttachmentHistory] ([AttachmentHistoryID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Versi__Versi__2180FB33]
FOREIGN KEY ([VersionHistoryID]) REFERENCES [CMS_VersionHistory] ([VersionHistoryID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_VersionHistory] DROP
CONSTRAINT [FK__CMS_Versi__Modif__72C60C4A],
CONSTRAINT [FK_CMS_VersionHistory_CMS_Site]
GO

ALTER TABLE [CMS_VersionHistory] ADD
CONSTRAINT [FK__CMS_Versi__Modif__72C60C4A]
FOREIGN KEY ([ModifiedByUserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION,
CONSTRAINT [FK_CMS_VersionHistory_CMS_Site]
FOREIGN KEY ([NodeSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_WebFarmServerTask] DROP
CONSTRAINT [FK__CMS_WebFa__Serve__395884C4]
GO

ALTER TABLE [CMS_WebFarmServerTask] ADD
CONSTRAINT [FK__CMS_WebFa__Serve__395884C4]
FOREIGN KEY ([ServerID]) REFERENCES [CMS_WebFarmServer] ([ServerID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_WebPart] DROP
CONSTRAINT [FK__CMS_WebPa__WebPa__778AC167]
GO

ALTER TABLE [CMS_WebPart] ADD
CONSTRAINT [FK__CMS_WebPa__WebPa__778AC167]
FOREIGN KEY ([WebPartCategoryID]) REFERENCES [CMS_WebPartCategory] ([CategoryID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_WorkflowHistory] DROP
CONSTRAINT [FK__CMS_Workf__Appro__00200768],
CONSTRAINT [FK__CMS_Workf__StepI__02084FDA],
CONSTRAINT [FK__CMS_Workf__Versi__01142BA1]
GO

ALTER TABLE [CMS_WorkflowHistory] ADD
CONSTRAINT [FK__CMS_Workf__Appro__00200768]
FOREIGN KEY ([ApprovedByUserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Workf__StepI__02084FDA]
FOREIGN KEY ([StepID]) REFERENCES [CMS_WorkflowStep] ([StepID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Workf__Versi__01142BA1]
FOREIGN KEY ([VersionHistoryID]) REFERENCES [CMS_VersionHistory] ([VersionHistoryID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_WorkflowScope] DROP
CONSTRAINT [FK__CMS_Workf__Scope__04E4BC85],
CONSTRAINT [FK__CMS_Workf__Scope__05D8E0BE],
CONSTRAINT [FK__CMS_Workf__Scope__06CD04F7]
GO

ALTER TABLE [CMS_WorkflowScope] ADD
CONSTRAINT [FK__CMS_Workf__Scope__04E4BC85]
FOREIGN KEY ([ScopeClassID]) REFERENCES [CMS_Class] ([ClassID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Workf__Scope__05D8E0BE]
FOREIGN KEY ([ScopeSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Workf__Scope__06CD04F7]
FOREIGN KEY ([ScopeWorkflowID]) REFERENCES [CMS_Workflow] ([WorkflowID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_WorkflowStep] DROP
CONSTRAINT [FK__CMS_Workf__StepW__286302EC]
GO

ALTER TABLE [CMS_WorkflowStep] ADD
CONSTRAINT [FK__CMS_Workf__StepW__286302EC]
FOREIGN KEY ([StepWorkflowID]) REFERENCES [CMS_Workflow] ([WorkflowID]) NOT FOR REPLICATION
GO

ALTER TABLE [CMS_WorkflowStepRoles] DROP
CONSTRAINT [FK__CMS_Workf__RoleI__7C4F7684],
CONSTRAINT [FK__CMS_Workf__StepI__7D439ABD]
GO

ALTER TABLE [CMS_WorkflowStepRoles] ADD
CONSTRAINT [FK__CMS_Workf__RoleI__7C4F7684]
FOREIGN KEY ([RoleID]) REFERENCES [CMS_Role] ([RoleID]) NOT FOR REPLICATION,
CONSTRAINT [FK__CMS_Workf__StepI__7D439ABD]
FOREIGN KEY ([StepID]) REFERENCES [CMS_WorkflowStep] ([StepID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_Address] DROP
CONSTRAINT [FK_COM_Address_CMS_Country],
CONSTRAINT [FK_COM_Address_CMS_State],
CONSTRAINT [FK_COM_Address_COM_Customer]
GO

ALTER TABLE [COM_Address] ADD
CONSTRAINT [FK_COM_Address_CMS_Country]
FOREIGN KEY ([AddressCountryID]) REFERENCES [CMS_Country] ([CountryID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Address_CMS_State]
FOREIGN KEY ([AddressStateID]) REFERENCES [CMS_State] ([StateID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Address_COM_Customer]
FOREIGN KEY ([AddressCustomerID]) REFERENCES [COM_Customer] ([CustomerID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_CurrencyExchangeRate] DROP
CONSTRAINT [FK_COM_CurrencyExchangeRate_COM_Currency1],
CONSTRAINT [FK_COM_CurrencyExchangeRate_COM_ExchangeTable]
GO

ALTER TABLE [COM_CurrencyExchangeRate] ADD
CONSTRAINT [FK_COM_CurrencyExchangeRate_COM_Currency1]
FOREIGN KEY ([ExchangeRateToCurrencyID]) REFERENCES [COM_Currency] ([CurrencyID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_CurrencyExchangeRate_COM_ExchangeTable]
FOREIGN KEY ([ExchangeTableID]) REFERENCES [COM_ExchangeTable] ([ExchangeTableID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_Customer] DROP
CONSTRAINT [FK_COM_Customer_CMS_Country],
CONSTRAINT [FK_COM_Customer_CMS_State],
CONSTRAINT [FK_COM_Customer_CMS_User],
CONSTRAINT [FK_COM_Customer_COM_Currency],
CONSTRAINT [FK_COM_Customer_COM_PaymentOption],
CONSTRAINT [FK_COM_Customer_COM_ShippingOption]
GO

ALTER TABLE [COM_Customer] ADD
CONSTRAINT [FK_COM_Customer_CMS_Country]
FOREIGN KEY ([CustomerCountryID]) REFERENCES [CMS_Country] ([CountryID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Customer_CMS_State]
FOREIGN KEY ([CustomerStateID]) REFERENCES [CMS_State] ([StateID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Customer_CMS_User]
FOREIGN KEY ([CustomerUserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Customer_COM_Currency]
FOREIGN KEY ([CustomerPreferredCurrencyID]) REFERENCES [COM_Currency] ([CurrencyID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Customer_COM_PaymentOption]
FOREIGN KEY ([CustomerPrefferedPaymentOptionID]) REFERENCES [COM_PaymentOption] ([PaymentOptionID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Customer_COM_ShippingOption]
FOREIGN KEY ([CustomerPreferredShippingOptionID]) REFERENCES [COM_ShippingOption] ([ShippingOptionID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_Order] DROP
CONSTRAINT [FK_COM_Order_CMS_Site],
CONSTRAINT [FK_COM_Order_COM_Currency],
CONSTRAINT [FK_COM_Order_COM_Customer],
CONSTRAINT [FK_COM_Order_COM_CustomerAdress],
CONSTRAINT [FK_COM_Order_COM_CustomerAdress1],
CONSTRAINT [FK_COM_Order_COM_DiscountCoupon],
CONSTRAINT [FK_COM_Order_COM_PaymentOption],
CONSTRAINT [FK_COM_Order_COM_ShippingOption],
CONSTRAINT [FK_COM_Order_COM_Status]
GO

ALTER TABLE [COM_Order] ADD
CONSTRAINT [FK_COM_Order_CMS_Site]
FOREIGN KEY ([OrderSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Order_COM_Currency]
FOREIGN KEY ([OrderCurrencyID]) REFERENCES [COM_Currency] ([CurrencyID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Order_COM_Customer]
FOREIGN KEY ([OrderCustomerID]) REFERENCES [COM_Customer] ([CustomerID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Order_COM_CustomerAdress]
FOREIGN KEY ([OrderBillingAddressID]) REFERENCES [COM_Address] ([AddressID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Order_COM_CustomerAdress1]
FOREIGN KEY ([OrderShippingAddressID]) REFERENCES [COM_Address] ([AddressID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Order_COM_DiscountCoupon]
FOREIGN KEY ([OrderDiscountCouponID]) REFERENCES [COM_DiscountCoupon] ([DiscountCouponID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Order_COM_PaymentOption]
FOREIGN KEY ([OrderPaymentOptionID]) REFERENCES [COM_PaymentOption] ([PaymentOptionID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Order_COM_ShippingOption]
FOREIGN KEY ([OrderShippingOptionID]) REFERENCES [COM_ShippingOption] ([ShippingOptionID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_Order_COM_Status]
FOREIGN KEY ([OrderStatusID]) REFERENCES [COM_OrderStatus] ([StatusID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_OrderItem] DROP
CONSTRAINT [FK_COM_OrderItem_COM_Order],
CONSTRAINT [FK_COM_OrderItem_COM_SKU]
GO

ALTER TABLE [COM_OrderItem] ADD
CONSTRAINT [FK_COM_OrderItem_COM_Order]
FOREIGN KEY ([OrderItemOrderID]) REFERENCES [COM_Order] ([OrderID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_OrderItem_COM_SKU]
FOREIGN KEY ([OrderItemSKUID]) REFERENCES [COM_SKU] ([SKUID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_OrderStatusUser] DROP
CONSTRAINT [FK_COM_OrderStatusUser_CMS_User],
CONSTRAINT [FK_COM_OrderStatusUser_COM_Order],
CONSTRAINT [FK_COM_OrderStatusUser_COM_Status],
CONSTRAINT [FK_COM_OrderStatusUser_COM_Status1]
GO

ALTER TABLE [COM_OrderStatusUser] ADD
CONSTRAINT [FK_COM_OrderStatusUser_CMS_User]
FOREIGN KEY ([ChangedByUserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_OrderStatusUser_COM_Order]
FOREIGN KEY ([OrderID]) REFERENCES [COM_Order] ([OrderID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_OrderStatusUser_COM_Status]
FOREIGN KEY ([FromStatusID]) REFERENCES [COM_OrderStatus] ([StatusID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_OrderStatusUser_COM_Status1]
FOREIGN KEY ([ToStatusID]) REFERENCES [COM_OrderStatus] ([StatusID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_PaymentOption] DROP
CONSTRAINT [FK_COM_PaymentOption_CMS_Site]
GO

ALTER TABLE [COM_PaymentOption] ADD
CONSTRAINT [FK_COM_PaymentOption_CMS_Site]
FOREIGN KEY ([PaymentOptionSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_ShippingOption] DROP
CONSTRAINT [FK_COM_ShippingOption_CMS_Site]
GO

ALTER TABLE [COM_ShippingOption] ADD
CONSTRAINT [FK_COM_ShippingOption_CMS_Site]
FOREIGN KEY ([ShippingOptionSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_ShoppingCart] DROP
CONSTRAINT [FK_COM_ShoppingCart_CMS_Site],
CONSTRAINT [FK_COM_ShoppingCart_CMS_User],
CONSTRAINT [FK_COM_ShoppingCart_COM_Currency],
CONSTRAINT [FK_COM_ShoppingCart_COM_DiscountCoupon],
CONSTRAINT [FK_COM_ShoppingCart_COM_PaymentOption],
CONSTRAINT [FK_COM_ShoppingCart_COM_ShippingOption]
GO

ALTER TABLE [COM_ShoppingCart] ADD
CONSTRAINT [FK_COM_ShoppingCart_CMS_Site]
FOREIGN KEY ([ShoppingCartSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_ShoppingCart_CMS_User]
FOREIGN KEY ([ShoppingCartUserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_ShoppingCart_COM_Currency]
FOREIGN KEY ([ShoppingCartCurrencyID]) REFERENCES [COM_Currency] ([CurrencyID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_ShoppingCart_COM_DiscountCoupon]
FOREIGN KEY ([ShoppingCartDiscountCouponID]) REFERENCES [COM_DiscountCoupon] ([DiscountCouponID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_ShoppingCart_COM_PaymentOption]
FOREIGN KEY ([ShoppingCartPaymentOptionID]) REFERENCES [COM_PaymentOption] ([PaymentOptionID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_ShoppingCart_COM_ShippingOption]
FOREIGN KEY ([ShoppingCartShippingOptionID]) REFERENCES [COM_ShippingOption] ([ShippingOptionID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_ShoppingCartSKU] DROP
CONSTRAINT [FK_COM_ShoppingCartSKU_COM_ShoppingCart],
CONSTRAINT [FK_COM_ShoppingCartSKU_COM_SKU]
GO

ALTER TABLE [COM_ShoppingCartSKU] ADD
CONSTRAINT [FK_COM_ShoppingCartSKU_COM_ShoppingCart]
FOREIGN KEY ([ShoppingCartID]) REFERENCES [COM_ShoppingCart] ([ShoppingCartID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_ShoppingCartSKU_COM_SKU]
FOREIGN KEY ([SKUID]) REFERENCES [COM_SKU] ([SKUID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_SKU] DROP
CONSTRAINT [FK_COM_SKU_COM_Department],
CONSTRAINT [FK_COM_SKU_COM_InternalStatus],
CONSTRAINT [FK_COM_SKU_COM_Manifacturer],
CONSTRAINT [FK_COM_SKU_COM_PublicStatus]
GO

ALTER TABLE [COM_SKU] ADD
CONSTRAINT [FK_COM_SKU_COM_Department]
FOREIGN KEY ([SKUDepartmentID]) REFERENCES [COM_Department] ([DepartmentID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_SKU_COM_InternalStatus]
FOREIGN KEY ([SKUInternalStatusID]) REFERENCES [COM_InternalStatus] ([InternalStatusID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_SKU_COM_Manifacturer]
FOREIGN KEY ([SKUManufacturerID]) REFERENCES [COM_Manufacturer] ([ManufacturerID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_SKU_COM_PublicStatus]
FOREIGN KEY ([SKUPublicStatusID]) REFERENCES [COM_PublicStatus] ([PublicStatusID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_SKUDiscountCoupon] DROP
CONSTRAINT [FK_COM_SKUDiscountCoupon_COM_DiscountCoupon],
CONSTRAINT [FK_COM_SKUDiscountCoupon_COM_SKU]
GO

ALTER TABLE [COM_SKUDiscountCoupon] ADD
CONSTRAINT [FK_COM_SKUDiscountCoupon_COM_DiscountCoupon]
FOREIGN KEY ([DiscountCouponID]) REFERENCES [COM_DiscountCoupon] ([DiscountCouponID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_SKUDiscountCoupon_COM_SKU]
FOREIGN KEY ([SKUID]) REFERENCES [COM_SKU] ([SKUID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_SKUTaxClasses] DROP
CONSTRAINT [FK_COM_SKUTaxClasses_COM_SKU],
CONSTRAINT [FK_COM_SKUTaxClasses_COM_TaxClass]
GO

ALTER TABLE [COM_SKUTaxClasses] ADD
CONSTRAINT [FK_COM_SKUTaxClasses_COM_SKU]
FOREIGN KEY ([SKUID]) REFERENCES [COM_SKU] ([SKUID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_SKUTaxClasses_COM_TaxClass]
FOREIGN KEY ([TaxClassID]) REFERENCES [COM_TaxClass] ([TaxClassID]) NOT FOR REPLICATION
GO

ALTER TABLE [COM_UserDepartment] DROP
CONSTRAINT [FK_COM_UserDepartment_CMS_User],
CONSTRAINT [FK_COM_UserDepartment_COM_Department]
GO

ALTER TABLE [COM_UserDepartment] ADD
CONSTRAINT [FK_COM_UserDepartment_CMS_User]
FOREIGN KEY ([UserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION,
CONSTRAINT [FK_COM_UserDepartment_COM_Department]
FOREIGN KEY ([DepartmentID]) REFERENCES [COM_Department] ([DepartmentID]) NOT FOR REPLICATION
GO

ALTER TABLE [Forums_ForumGroup] DROP
CONSTRAINT [FK_Forums_ForumGroup_CMS_Site]
GO

ALTER TABLE [Forums_ForumGroup] ADD
CONSTRAINT [FK_Forums_ForumGroup_CMS_Site]
FOREIGN KEY ([GroupSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [Forums_ForumModerators] DROP
CONSTRAINT [FK_Forums_ForumModerators_CMS_User],
CONSTRAINT [FK_Forums_ForumModerators_Forums_Forum]
GO

ALTER TABLE [Forums_ForumModerators] ADD
CONSTRAINT [FK_Forums_ForumModerators_CMS_User]
FOREIGN KEY ([UserID]) REFERENCES [CMS_User] ([UserID]) NOT FOR REPLICATION,
CONSTRAINT [FK_Forums_ForumModerators_Forums_Forum]
FOREIGN KEY ([ForumID]) REFERENCES [Forums_Forum] ([ForumID]) NOT FOR REPLICATION
GO

ALTER TABLE [Forums_ForumPost] DROP
CONSTRAINT [FK_Forums_ForumPost_Forums_Forum],
CONSTRAINT [FK_Forums_ForumPost_Forums_ForumPost]
GO

ALTER TABLE [Forums_ForumPost] ADD
CONSTRAINT [FK_Forums_ForumPost_Forums_Forum]
FOREIGN KEY ([PostForumID]) REFERENCES [Forums_Forum] ([ForumID]) NOT FOR REPLICATION,
CONSTRAINT [FK_Forums_ForumPost_Forums_ForumPost]
FOREIGN KEY ([PostParentID]) REFERENCES [Forums_ForumPost] ([PostId]) NOT FOR REPLICATION
GO

ALTER TABLE [Forums_ForumRoles] DROP
CONSTRAINT [FK_Forums_ForumRoles_CMS_Role],
CONSTRAINT [FK_Forums_ForumRoles_Forums_Forum]
GO

ALTER TABLE [Forums_ForumRoles] ADD
CONSTRAINT [FK_Forums_ForumRoles_CMS_Role]
FOREIGN KEY ([RoleID]) REFERENCES [CMS_Role] ([RoleID]) NOT FOR REPLICATION,
CONSTRAINT [FK_Forums_ForumRoles_Forums_Forum]
FOREIGN KEY ([ForumID]) REFERENCES [Forums_Forum] ([ForumID]) NOT FOR REPLICATION
GO

ALTER TABLE [Forums_ForumSubscription] DROP
CONSTRAINT [FK_Forums_ForumSubscription_Forums_Forum]
GO

ALTER TABLE [Forums_ForumSubscription] ADD
CONSTRAINT [FK_Forums_ForumSubscription_Forums_Forum]
FOREIGN KEY ([SubscriptionForumID]) REFERENCES [Forums_Forum] ([ForumID]) NOT FOR REPLICATION
GO

ALTER TABLE [Newsletter_EmailTemplate] DROP
CONSTRAINT [FK__Newslette__Templ__40058253]
GO

ALTER TABLE [Newsletter_EmailTemplate] ADD
CONSTRAINT [FK__Newslette__Templ__40058253]
FOREIGN KEY ([TemplateSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [Newsletter_Newsletter] DROP
CONSTRAINT [FK__Newslette__Newsl__42E1EEFE],
CONSTRAINT [FK__Newslette__Newsl__43D61337],
CONSTRAINT [FK__Newslette__Newsl__44CA3770],
CONSTRAINT [FK__Newslette__Newsl__45BE5BA9]
GO

ALTER TABLE [Newsletter_Newsletter] ADD
CONSTRAINT [FK__Newslette__Newsl__42E1EEFE]
FOREIGN KEY ([NewsletterSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION,
CONSTRAINT [FK__Newslette__Newsl__43D61337]
FOREIGN KEY ([NewsletterSubscriptionTemplateID]) REFERENCES [Newsletter_EmailTemplate] ([TemplateID]) NOT FOR REPLICATION,
CONSTRAINT [FK__Newslette__Newsl__44CA3770]
FOREIGN KEY ([NewsletterUnsubscriptionTemplateID]) REFERENCES [Newsletter_EmailTemplate] ([TemplateID]) NOT FOR REPLICATION,
CONSTRAINT [FK__Newslette__Newsl__45BE5BA9]
FOREIGN KEY ([NewsletterTemplateID]) REFERENCES [Newsletter_EmailTemplate] ([TemplateID]) NOT FOR REPLICATION
GO

ALTER TABLE [Newsletter_NewsletterIssue] DROP
CONSTRAINT [FK__Newslette__Issue__489AC854],
CONSTRAINT [FK__Newslette__Issue__498EEC8D]
GO

ALTER TABLE [Newsletter_NewsletterIssue] ADD
CONSTRAINT [FK__Newslette__Issue__489AC854]
FOREIGN KEY ([IssueTemplateID]) REFERENCES [Newsletter_EmailTemplate] ([TemplateID]) NOT FOR REPLICATION,
CONSTRAINT [FK__Newslette__Issue__498EEC8D]
FOREIGN KEY ([IssueNewsletterID]) REFERENCES [Newsletter_Newsletter] ([NewsletterID]) NOT FOR REPLICATION
GO

ALTER TABLE [Newsletter_Subscriber] DROP
CONSTRAINT [FK__Newslette__Subsc__4C6B5938]
GO

ALTER TABLE [Newsletter_Subscriber] ADD
CONSTRAINT [FK__Newslette__Subsc__4C6B5938]
FOREIGN KEY ([SubscriberSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

ALTER TABLE [Newsletter_SubscriberNewsletter] DROP
CONSTRAINT [FK__Newslette__Newsl__4F47C5E3],
CONSTRAINT [FK__Newslette__Subsc__503BEA1C]
GO

ALTER TABLE [Newsletter_SubscriberNewsletter] ADD
CONSTRAINT [FK__Newslette__Newsl__4F47C5E3]
FOREIGN KEY ([NewsletterID]) REFERENCES [Newsletter_Newsletter] ([NewsletterID]) NOT FOR REPLICATION,
CONSTRAINT [FK__Newslette__Subsc__503BEA1C]
FOREIGN KEY ([SubscriberID]) REFERENCES [Newsletter_Subscriber] ([SubscriberID]) NOT FOR REPLICATION
GO

ALTER TABLE [Staging_Synchronization] DROP
CONSTRAINT [FK_Staging_Synchronization_Staging_Server],
CONSTRAINT [FK_Staging_Synchronization_Staging_Task]
GO

ALTER TABLE [Staging_Synchronization] ADD
CONSTRAINT [FK_Staging_Synchronization_Staging_Server]
FOREIGN KEY ([SynchronizationServerID]) REFERENCES [Staging_Server] ([ServerID]) NOT FOR REPLICATION,
CONSTRAINT [FK_Staging_Synchronization_Staging_Task]
FOREIGN KEY ([SynchronizationTaskID]) REFERENCES [Staging_Task] ([TaskID]) NOT FOR REPLICATION
GO

ALTER TABLE [Staging_SyncLog] DROP
CONSTRAINT [FK_Staging_SyncLog_Staging_Server],
CONSTRAINT [FK_Staging_SyncLog_Staging_Task]
GO

ALTER TABLE [Staging_SyncLog] ADD
CONSTRAINT [FK_Staging_SyncLog_Staging_Server]
FOREIGN KEY ([SyncLogServerID]) REFERENCES [Staging_Server] ([ServerID]) NOT FOR REPLICATION,
CONSTRAINT [FK_Staging_SyncLog_Staging_Task]
FOREIGN KEY ([SyncLogTaskID]) REFERENCES [Staging_Task] ([TaskID]) NOT FOR REPLICATION
GO

ALTER TABLE [Staging_Task] DROP
CONSTRAINT [FK_Staging_Task_CMS_Site]
GO

ALTER TABLE [Staging_Task] ADD
CONSTRAINT [FK_Staging_Task_CMS_Site]
FOREIGN KEY ([TaskSiteID]) REFERENCES [CMS_Site] ([SiteID]) NOT FOR REPLICATION
GO

/* ### Stored procedures ### */

set ANSI_NULLS ON
GO

set QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [Proc_CMS_Class_Insert]
	@ClassID int = NULL,
	@ClassDisplayName nvarchar(100),
    @ClassName nvarchar(100),
    @ClassUsesVersioning bit,
    @ClassIsDocumentType bit,
    @ClassIsCoupledClass bit,
    @ClassXmlSchema ntext,
    @ClassFormDefinition ntext,
    @ClassNewPageUrl nvarchar(100),
    @ClassEditingPageUrl nvarchar(100),
    @ClassListPageUrl nvarchar(100),
    @ClassNodeNameSource nvarchar(100),
    @ClassTableName nvarchar(100),
	@ClassViewPageUrl nvarchar(450),
	@ClassPreviewPageUrl nvarchar(450),
	@ClassFormLayout ntext,
	@ClassShowAsSystemTable bit,
	@ClassUsePublishFromTo bit,
	@ClassShowTemplateSelection bit,
	@ClassSKUMappings nvarchar(500),
	@ClassIsMenuItemType bit
AS
INSERT INTO [CMS_Class] (
	[ClassDisplayName],
	[ClassName],
	[ClassUsesVersioning],
	[ClassIsDocumentType],
	[ClassIsCoupledClass],
	[ClassXmlSchema],
	[ClassFormDefinition],
	[ClassNewPageUrl],
	[ClassEditingPageUrl],
	[ClassListPageUrl],
	[ClassNodeNameSource],	
	[ClassTableName],
	[ClassViewPageUrl],
	[ClassPreviewPageUrl],
	[ClassFormLayout],
	[ClassShowAsSystemTable],
	[ClassUsePublishFromTo],
	[ClassShowTemplateSelection],
    [ClassSKUMappings],
	[ClassIsMenuItemType]
)
VALUES (
	@ClassDisplayName, 
	@ClassName, 
	@ClassUsesVersioning, 
	@ClassIsDocumentType, 
	@ClassIsCoupledClass, 
	@ClassXmlSchema, 
	@ClassFormDefinition, 
	@ClassNewPageUrl, 
	@ClassEditingPageUrl, 
	@ClassListPageUrl, 
	@ClassNodeNameSource, 
	@ClassTableName,
	@ClassViewPageUrl,
	@ClassPreviewPageUrl,
	@ClassFormLayout,
	@ClassShowAsSystemTable,
	@ClassUsePublishFromTo,
	@ClassShowTemplateSelection,
	@ClassSKUMappings,
	@ClassIsMenuItemType
)
SELECT @@identity
GO 



ALTER PROCEDURE [Proc_CMS_Class_Update]
	@ClassID int,
    @ClassDisplayName nvarchar(100),
    @ClassName nvarchar(100),
    @ClassUsesVersioning bit,
    @ClassIsDocumentType bit,
    @ClassIsCoupledClass bit,
    @ClassXmlSchema ntext,
    @ClassFormDefinition ntext,
    @ClassNewPageUrl nvarchar(100),
    @ClassEditingPageUrl nvarchar(100),
    @ClassListPageUrl nvarchar(100),
    @ClassNodeNameSource nvarchar(100),
    @ClassTableName nvarchar(100),
	@ClassViewPageUrl nvarchar(450),
	@ClassPreviewPageUrl nvarchar(450),
	@ClassFormLayout ntext,
	@ClassShowAsSystemTable bit,
	@ClassUsePublishFromTo bit,
	@ClassShowTemplateSelection bit,
	@ClassSKUMappings nvarchar(450),
	@ClassIsMenuItemType bit
AS
UPDATE [CMS_Class] 
SET 
	ClassDisplayName = @ClassDisplayName,
	ClassName = @ClassName,
	ClassUsesVersioning = ClassUsesVersioning,
	ClassIsDocumentType = @ClassIsDocumentType,
	ClassIsCoupledClass = @ClassIsCoupledClass,
	ClassXmlSchema = @ClassXmlSchema,
	ClassFormDefinition = @ClassFormDefinition,
	ClassNewPageUrl = @ClassNewPageUrl,
	ClassEditingPageUrl = @ClassEditingPageUrl,
	ClassListPageUrl = @ClassListPageUrl,
	ClassNodeNameSource = @ClassNodeNameSource,
	ClassTableName = @ClassTableName,
	ClassViewPageUrl = @ClassViewPageUrl,
	ClassPreviewPageUrl = @ClassPreviewPageUrl,
	ClassFormLayout = @ClassFormLayout,
	ClassShowAsSystemTable = @ClassShowAsSystemTable,
	ClassUsePublishFromTo = @ClassUsePublishFromTo,
	ClassShowTemplateSelection = @ClassShowTemplateSelection,
	ClassSKUMappings = @ClassSKUMappings,
	ClassIsMenuItemType = @ClassIsMenuItemType
WHERE
	ClassID = @ClassID
GO

ALTER PROCEDURE [Proc_CMS_Site_RemoveDependences] 
	@SiteID int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	-- removes VersionHistory dependences from VersionAttachment
	DELETE FROM [CMS_VersionAttachment] WHERE VersionHistoryID IN (
		SELECT VersionHistoryID FROM [CMS_VersionHistory] WHERE NodeSiteID = @SiteID
	);
	-- removes VersionHistory dependences from WorkflowHistory
	DELETE FROM [CMS_WorkflowHistory] WHERE VersionHistoryID IN (
		SELECT VersionHistoryID FROM [CMS_VersionHistory] WHERE NodeSiteID = @SiteID
	);
	-- deletes site's VersionHistory
	DELETE FROM [CMS_VersionHistory] WHERE NodeSiteID = @SiteID;

	-- deletes site's SettingKeys
	DELETE FROM [CMS_SettingsKey] WHERE SiteID=@SiteID;
	-- deletes site's EmailTemplates
	DELETE FROM [CMS_EmailTemplate] WHERE EmailTemplateSiteID=@SiteID;
	-- deletes site's DomainAliases
	DELETE FROM [CMS_SiteDomainAlias] WHERE SiteID=@SiteID;
	-- deletes site's cultures
	DELETE FROM [CMS_SiteCulture] WHERE SiteID=@SiteID;
	-- deletes site's PageTemplates
	DELETE FROM [CMS_PageTemplateSite] WHERE SiteID=@SiteID;
	-- deletes site's Users
	DELETE FROM [CMS_UserSite] WHERE SiteID=@SiteID;

	-- removes Role's dependences when site's Roles are deleted
	DELETE FROM [Forums_ForumRoles ] WHERE RoleID IN (
		SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
	);
	DELETE FROM [CMS_UserRole] WHERE RoleID IN (
		SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
	);
	DELETE FROM [CMS_RolePermission] WHERE RoleID IN (
		SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
	);
	DELETE FROM [CMS_WorkflowStepRoles] WHERE RoleID IN (
		SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
	);
	-- deletes site's Roles
	DELETE FROM [CMS_Role] WHERE SiteID=@SiteID;
	-- deletes site's Resources
	DELETE FROM [CMS_ResourceSite] WHERE SiteID=@SiteID;
	-- deletes site's Classes
	DELETE FROM [CMS_ClassSite] WHERE SiteID=@SiteID;
	-- deletes Events of the site
	DELETE FROM [CMS_EventLog] WHERE SiteID=@SiteID;
	-- deletes site's RelationshipNames
	DELETE FROM [CMS_RelationshipNameSite] WHERE SiteID=@SiteID;
	-- deletes site's WorkflowScopes
	DELETE FROM [CMS_WorkflowScope] WHERE ScopeSiteID=@SiteID;
	-- deletes site's CSSStylesheets
	DELETE FROM CMS_CssStylesheetSite WHERE SiteID=@SiteID;
	-- deletes site's InlineControls
	DELETE FROM [CMS_InlineControlSite] WHERE SiteID=@SiteID;
	-- deletes site's ScheduledTasks
	DELETE FROM [CMS_ScheduledTask] WHERE TaskSiteID=@SiteID;
	
	-- removes Newsletter_Subscriber's dependences when site's Newsletter_Subscribers are deleted
	DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (
		SELECT SubscriberID FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID
	);
	DELETE FROM [Newsletter_SubscriberNewsletter] WHERE SubscriberID IN (
		SELECT SubscriberID FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID
	);
	-- deletes site's Newsletter_Subscribers
	DELETE FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID;
	-- removes Newsletter_Newsletter's dependences when site's Newsletter_Newsletters are deleted
	DELETE FROM [Newsletter_Emails] WHERE EmailNewsletterIssueID IN (
		SELECT IssueID FROM [Newsletter_NewsletterIssue] WHERE IssueNewsletterID IN (
			SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
		)
	);
	DELETE FROM [Newsletter_NewsletterIssue] WHERE IssueNewsletterID IN (
		SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
	);
	DELETE FROM [Newsletter_SubscriberNewsletter] WHERE NewsletterID IN (
		SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
	);
	-- deletes site's Newsletter_Newsletters
	DELETE FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID;
	-- removes Newsletter_EmailTemplate's dependences when site's Newsletter_EmailTemplates are deleted
	DELETE FROM [Newsletter_Emails] WHERE EmailNewsletterIssueID IN (
		SELECT IssueID FROM [Newsletter_NewsletterIssue] WHERE IssueTemplateID IN (
			SELECT TemplateID FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID
		)
	);
	DELETE FROM [Newsletter_NewsletterIssue] WHERE IssueTemplateID IN (
			SELECT TemplateID FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID
	);
	-- deletes site's Newsletter_EmailTemplates
	DELETE FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID;
	-- removes CMS_Class's dependences when BizForms are deleted
	DELETE FROM [CMS_Query] WHERE ClassID IN (
		SELECT FormClassID FROM [CMS_Form] WHERE FormSiteID=@SiteID
	);
	-- insert ClassIDs of BizForms into the temporaty table
	SELECT FormClassID INTO [TempTable] FROM [CMS_Form] WHERE FormSiteID=@SiteID;
	-- deletes site's BizForms from CMS_Form
	DELETE FROM [CMS_Form] WHERE FormSiteID=@SiteID;
	-- deletes BizForm's records in CMS_Class
	DELETE FROM [CMS_Class] WHERE ClassID IN (
		SELECT FormClassID FROM [TempTable]
	);

	-- Forum dependencies
	UPDATE [Forums_ForumPost]  SET PostParentID=NULL WHERE PostForumId IN (
		SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
		SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID
		));

	DELETE FROM [Forums_ForumPost] WHERE PostForumId IN (
		SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
		SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
	);

	DELETE FROM [Forums_ForumRoles ] WHERE ForumId IN (
		SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
		SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
	);

	DELETE FROM [Forums_ForumModerators] WHERE ForumID IN (
		SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID  IN (
		SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
	);

	DELETE FROM [Forums_ForumSubscription] WHERE SubscriptionForumId IN (
		SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID  IN (
		SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
	);
	
	DELETE FROM [Forums_Forum] WHERE ForumGroupId  IN (
		SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID);	

	DELETE FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID;

	-- delete Staging dependences
	DELETE FROM [Staging_Synchronization] WHERE SynchronizationTaskID IN (
		SELECT TaskID FROM [Staging_Task] WHERE TaskSiteID = @SiteID
	);

	DELETE FROM [Staging_SyncLog] WHERE SyncLogTaskID IN (
		SELECT TaskID FROM [Staging_Task] WHERE TaskSiteID = @SiteID
	);
	-- delete StagingTasks
	DELETE FROM [Staging_Task] WHERE TaskSiteID = @SiteID;

	-- ECOMMERCE
	-- delete COM_ShoppingCart dependences
	DELETE FROM [COM_ShoppingCartSKU] WHERE ShoppingCartID IN (
		SELECT ShoppingCartID FROM [COM_ShoppingCart] WHERE ShoppingCartSiteID = @SiteID
	);
	-- delete COM_ShoppingCart
	DELETE FROM [COM_ShoppingCart] WHERE ShoppingCartSiteID = @SiteID;

	-- delete COM_Order dependences
	DELETE FROM [COM_OrderStatusUser] WHERE OrderID IN (
		SELECT OrderID FROM [COM_Order] WHERE OrderSiteID = @SiteID
	);
	DELETE FROM [COM_OrderItem] WHERE OrderItemOrderID IN (
		SELECT OrderID FROM [COM_Order] WHERE OrderSiteID = @SiteID
	);
	-- delete COM_Order
	DELETE FROM [COM_Order] WHERE OrderSiteID = @SiteID;

	-- delete COM_ShippingOption dependences
	DELETE FROM [COM_ShoppingCart] WHERE ShoppingCartShippingOptionID IN (
		SELECT ShippingOptionID FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID
	);
	UPDATE [COM_Customer] SET CustomerPreferredShippingOptionID=NULL WHERE CustomerPreferredShippingOptionID IN (
		SELECT ShippingOptionID FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID
	);
	-- delete COM_ShippingOption
	DELETE FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID;

	-- delete COM_PaymentOption dependences
	DELETE FROM [COM_ShoppingCart] WHERE ShoppingCartPaymentOptionID IN (
		SELECT PaymentOptionID FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID
	);
	UPDATE [COM_Customer] SET CustomerPrefferedPaymentOptionID=NULL WHERE CustomerPrefferedPaymentOptionID IN (
		SELECT PaymentOptionID FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID
	);
	-- delete COM_PaymentOption
	DELETE FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID;

	-- drops temporary table
	DROP TABLE [TempTable];
END
GO

CREATE PROCEDURE [Proc_CMS_Tree_SelectParentWithSSLNode]
	@SiteID int,
	@NodeAliasPath nvarchar(450)
AS
BEGIN
SELECT TOP 1 * FROM CMS_Tree WHERE
	(NodeSiteID=@SiteID AND (NodeAliasPath='/' OR @NodeAliasPath LIKE NodeAliasPath+'/%') AND RequiresSSL IS NOT NULL) ORDER BY NodeAliasPath DESC
END
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


/*### Data ### */

UPDATE [CMS_Class] SET [ClassXmlSchema] ='<?xml version="1.0" encoding="utf-8"?>
<xs:schema id="NewDataSet" xmlns="" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
  <xs:element name="NewDataSet" msdata:IsDataSet="true" msdata:UseCurrentLocale="true">
    <xs:complexType>
      <xs:choice minOccurs="0" maxOccurs="unbounded">
        <xs:element name="CMS_Site">
          <xs:complexType>
            <xs:sequence>
              <xs:element name="SiteID" msdata:ReadOnly="true" msdata:AutoIncrement="true" type="xs:int" />
              <xs:element name="SiteName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="SiteDisplayName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="200" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="SiteDescription" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="SiteStatus">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="20" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="SiteDomainName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="400" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="SiteDefaultStylesheetID" type="xs:int" minOccurs="0" />
              <xs:element name="SiteDefaultVisitorCulture" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="50" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="SiteDefaultEditorStylesheet" type="xs:int" minOccurs="0" />
              <xs:element name="SiteStoreAllowAnonymousCustomers" type="xs:boolean" minOccurs="0" />
              <xs:element name="SiteStoreShippingFreeLimit" type="xs:double" minOccurs="0" />
              <xs:element name="SiteInvoiceTemplate" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="SiteDefaultCountryID" type="xs:int" minOccurs="0" />
              <xs:element name="SiteShowTaxRegistrationID" type="xs:boolean" minOccurs="0" />
              <xs:element name="SiteShowOrganizationID" type="xs:boolean" minOccurs="0" />
              <xs:element name="SiteSendStoreEmailsFrom" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="SiteSendOrderNotificationTo" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
            </xs:sequence>
          </xs:complexType>
        </xs:element>
      </xs:choice>
    </xs:complexType>
    <xs:unique name="Constraint1" msdata:PrimaryKey="true">
      <xs:selector xpath=".//CMS_Site" />
      <xs:field xpath="SiteID" />
    </xs:unique>
  </xs:element>
</xs:schema>' WHERE ClassName = 'cms.site'
GO

UPDATE [CMS_Class] SET [ClassXmlSchema] = '<?xml version="1.0" encoding="utf-8"?>
<xs:schema id="NewDataSet" xmlns="" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
  <xs:element name="NewDataSet" msdata:IsDataSet="true" msdata:UseCurrentLocale="true">
    <xs:complexType>
      <xs:choice minOccurs="0" maxOccurs="unbounded">
        <xs:element name="CMS_User">
          <xs:complexType>
            <xs:sequence>
              <xs:element name="UserID" msdata:ReadOnly="true" msdata:AutoIncrement="true" type="xs:int" />
              <xs:element name="UserName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="FirstName" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="MiddleName" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="LastName" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="FullName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="200" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="Email" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="UserPassword">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PreferredCultureCode" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="10" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PreferredUICultureCode" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="10" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="UserEnabled" type="xs:boolean" />
              <xs:element name="UserIsEditor" type="xs:boolean" />
              <xs:element name="UserIsGlobalAdministrator" type="xs:boolean" />
              <xs:element name="UserIsExternal" type="xs:boolean" minOccurs="0" />
              <xs:element name="UserPasswordFormat" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="10" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="UserCreated" type="xs:dateTime" minOccurs="0" />
              <xs:element name="LastLogon" type="xs:dateTime" minOccurs="0" />
              <xs:element name="UserNickName" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="200" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="UserPicture" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="500" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="UserSignature" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
            </xs:sequence>
          </xs:complexType>
        </xs:element>
      </xs:choice>
    </xs:complexType>
    <xs:unique name="Constraint1" msdata:PrimaryKey="true">
      <xs:selector xpath=".//CMS_User" />
      <xs:field xpath="UserID" />
    </xs:unique>
  </xs:element>
</xs:schema>', [ClassFormDefinition] = '<form><field column="UserID" fieldcaption="" visible="false" defaultvalue="" columntype="integer" fieldtype="label" allowempty="false" isPK="true" system="true" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UserName" fieldcaption="" visible="false" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="true" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="FirstName" fieldcaption="" visible="false" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="true" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MiddleName" fieldcaption="" visible="false" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="true" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="LastName" fieldcaption="" visible="false" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="true" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="FullName" fieldcaption="" visible="false" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="true" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Email" fieldcaption="" visible="false" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="true" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="UserPassword" fieldcaption="" visible="false" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="true" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PreferredCultureCode" fieldcaption="" visible="false" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="true" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PreferredUICultureCode" fieldcaption="" visible="false" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="true" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UserEnabled" fieldcaption="" visible="false" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="true" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UserIsEditor" fieldcaption="" visible="false" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="true" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UserIsGlobalAdministrator" fieldcaption="" visible="false" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="true" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UserIsExternal" fieldcaption="" visible="false" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="true" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UserPasswordFormat" fieldcaption="" visible="false" defaultvalue="" columntype="text" fieldtype="label" allowempty="true" isPK="false" system="true" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UserNickName" fieldcaption="User nick name" visible="false" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="true" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UserPicture" fieldcaption="UserPicture" visible="false" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="true" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UserSignature" fieldcaption="User signature" visible="false" defaultvalue="" columntype="longtext" fieldtype="textarea" allowempty="true" isPK="false" system="true" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><size></size><cols></cols><rows></rows></settings></field><field column="UserCreated" fieldcaption="" visible="false" defaultvalue="" columntype="datetime" fieldtype="label" allowempty="true" isPK="false" system="true"
 columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="LastLogon" fieldcaption="" visible="false" defaultvalue="" columntype="datetime" fieldtype="label" allowempty="true" isPK="false" system="true" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /></form>' WHERE ClassName = 'cms.user'
 GO

 UPDATE [CMS_Class] SET  [ClassXmlSchema] = '<?xml version="1.0" encoding="utf-8"?>
<xs:schema id="NewDataSet" xmlns="" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
  <xs:element name="NewDataSet" msdata:IsDataSet="true" msdata:UseCurrentLocale="true">
    <xs:complexType>
      <xs:choice minOccurs="0" maxOccurs="unbounded">
        <xs:element name="CMS_Tree">
          <xs:complexType>
            <xs:sequence>
              <xs:element name="NodeID" msdata:ReadOnly="true" msdata:AutoIncrement="true" type="xs:int" />
              <xs:element name="NodeAliasPath">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="450" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NodeName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NodeAlias">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="50" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NodeClassID" type="xs:int" />
              <xs:element name="NodeParentID" type="xs:int" />
              <xs:element name="NodeLevel" type="xs:int" />
              <xs:element name="NodeACLID" type="xs:int" minOccurs="0" />
              <xs:element name="NodeSiteID" type="xs:int" />
              <xs:element name="NodeGUID" msdata:DataType="System.Guid, mscorlib, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" type="xs:string" minOccurs="0" />
              <xs:element name="NodeOrder" type="xs:int" minOccurs="0" />
              <xs:element name="IsSecuredNode" type="xs:boolean" minOccurs="0" />
              <xs:element name="NodeCacheMinutes" type="xs:int" minOccurs="0" />
              <xs:element name="NodeSKUID" type="xs:int" minOccurs="0" />
              <xs:element name="NodeDocType" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NodeHeadTags" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NodeBodyElementAttributes" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NodeInheritPageLevels" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="200" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NodeChildNodesCount" type="xs:int" minOccurs="0" />
              <xs:element name="RequiresSSL" type="xs:boolean" minOccurs="0" />
            </xs:sequence>
          </xs:complexType>
        </xs:element>
      </xs:choice>
    </xs:complexType>
    <xs:unique name="Constraint1" msdata:PrimaryKey="true">
      <xs:selector xpath=".//CMS_Tree" />
      <xs:field xpath="NodeID" />
    </xs:unique>
  </xs:element>
</xs:schema>' Where ClassName = 'cms.tree'
GO

UPDATE [CMS_Class] SET [ClassXmlSchema] = '<?xml version="1.0" encoding="utf-8"?>
<xs:schema id="NewDataSet" xmlns="" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
  <xs:element name="NewDataSet" msdata:IsDataSet="true" msdata:UseCurrentLocale="true">
    <xs:complexType>
      <xs:choice minOccurs="0" maxOccurs="unbounded">
        <xs:element name="CMS_PageTemplate">
          <xs:complexType>
            <xs:sequence>
              <xs:element name="PageTemplateID" msdata:ReadOnly="true" msdata:AutoIncrement="true" type="xs:int" />
              <xs:element name="PageTemplateDisplayName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="200" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PageTemplateCodeName" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PageTemplateDescription" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PageTemplateFile">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="400" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PageTemplateIsPortal" type="xs:boolean" minOccurs="0" />
              <xs:element name="PageTemplateCategoryID" type="xs:int" minOccurs="0" />
              <xs:element name="PageTemplateLayoutID" type="xs:int" minOccurs="0" />
              <xs:element name="PageTemplateWebParts" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PageTemplateIsReusable" type="xs:boolean" minOccurs="0" />
              <xs:element name="PageTemplateShowAsMasterTemplate" type="xs:boolean" minOccurs="0" />
              <xs:element name="PageTemplateInheritPageLevels" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="200" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PageTemplateLayout" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PageTemplateLayoutCheckedOutFileName" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="450" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PageTemplateLayoutCheckedOutByUserID" type="xs:int" minOccurs="0" />
              <xs:element name="PageTemplateLayoutCheckedOutMachineName" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="50" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PageTemplateVersionGUID" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="50" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PageTemplateHeader" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
            </xs:sequence>
          </xs:complexType>
        </xs:element>
      </xs:choice>
    </xs:complexType>
    <xs:unique name="Constraint1" msdata:PrimaryKey="true">
      <xs:selector xpath=".//CMS_PageTemplate" />
      <xs:field xpath="PageTemplateID" />
    </xs:unique>
  </xs:element>
</xs:schema>' WHERE ClassName = 'cms.PageTemplate'
GO

UPDATE [CMS_Class] SET [ClassXmlSchema] = '<?xml version="1.0" encoding="utf-8"?>
<xs:schema id="NewDataSet" xmlns="" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
  <xs:element name="NewDataSet" msdata:IsDataSet="true" msdata:UseCurrentLocale="true">
    <xs:complexType>
      <xs:choice minOccurs="0" maxOccurs="unbounded">
        <xs:element name="cms_form">
          <xs:complexType>
            <xs:sequence>
              <xs:element name="FormID" msdata:ReadOnly="true" msdata:AutoIncrement="true" type="xs:int" />
              <xs:element name="FormDisplayName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="FormName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="FormSendToEmail" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="400" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="FormSendFromEmail" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="400" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="FormEmailSubject" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="250" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="FormClassID" type="xs:int" />
              <xs:element name="FormItems" type="xs:int" />
              <xs:element name="FormReportFields" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="FormRedirectToUrl" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="400" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="FormDisplayText" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="FormClearAfterSave" type="xs:boolean" />
              <xs:element name="FormSubmitButtonText" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="400" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="FormSiteID" type="xs:int" />
            </xs:sequence>
          </xs:complexType>
        </xs:element>
      </xs:choice>
    </xs:complexType>
    <xs:unique name="Constraint1" msdata:PrimaryKey="true">
      <xs:selector xpath=".//cms_form" />
      <xs:field xpath="FormID" />
    </xs:unique>
  </xs:element>
</xs:schema>' WHERE ClassName='cms.form'
GO

UPDATE [CMS_Class] SET  [ClassFormDefinition] = '<form><field column="SubscriberID" fieldcaption="" visible="false" defaultvalue="" columntype="integer" fieldtype="label" allowempty="false" isPK="true" system="true" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SubscriberEmail" fieldcaption="{$SubscribeForm.Email$}" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="true" columnsize="400" fielddescription="" regularexpression="^[a-zA-Z0-9]([_\.\-]?[a-zA-Z0-9]+)*@[a-zA-Z0-9]([\.\-]?[a-zA-Z0-9]+)*\.[a-zA-Z]{2,6}$" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="{$NewsletterSubscription.ErrorInvalidEmail$}" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="SubscriberFirstName" fieldcaption="{$SubscribeForm.FirstName$}" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="true" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="SubscriberLastName" fieldcaption="{$SubscribeForm.LastName$}" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="true" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="SubscriberSiteID" fieldcaption="" visible="false" defaultvalue="" columntype="integer" fieldtype="label" allowempty="false" isPK="false" system="true" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SubscriberGUID" fieldcaption="SubscriberGUID" visible="false" defaultvalue="" columntype="file" fieldtype="label" allowempty="false" isPK="false" system="true" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /></form>', [ClassShowAsSystemTable] = 1 WHERE ClassName = 'newsletter.subscriber'
GO

UPDATE [CMS_Class] SET [ClassXmlSchema] ='<?xml version="1.0" encoding="utf-8"?>
<xs:schema id="NewDataSet" xmlns="" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
  <xs:element name="NewDataSet" msdata:IsDataSet="true" msdata:UseCurrentLocale="true">
    <xs:complexType>
      <xs:choice minOccurs="0" maxOccurs="unbounded">
        <xs:element name="Newsletter_SubscriberNewsletter">
          <xs:complexType>
            <xs:sequence>
              <xs:element name="SubscriberID" type="xs:int" />
              <xs:element name="NewsletterID" type="xs:int" />
              <xs:element name="SubscribedWhen" type="xs:dateTime" />
            </xs:sequence>
          </xs:complexType>
        </xs:element>
      </xs:choice>
    </xs:complexType>
    <xs:unique name="Constraint1" msdata:PrimaryKey="true">
      <xs:selector xpath=".//Newsletter_SubscriberNewsletter" />
      <xs:field xpath="SubscriberID" />
      <xs:field xpath="NewsletterID" />
    </xs:unique>
  </xs:element>
</xs:schema>' WHERE ClassName = 'newsletter.subscribernewsletter'
GO

Update [CMS_Class] SET [ClassXmlSchema] = '<?xml version="1.0" encoding="utf-8"?>
<xs:schema id="NewDataSet" xmlns="" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
  <xs:element name="NewDataSet" msdata:IsDataSet="true" msdata:UseCurrentLocale="true">
    <xs:complexType>
      <xs:choice minOccurs="0" maxOccurs="unbounded">
        <xs:element name="Newsletter_Newsletter">
          <xs:complexType>
            <xs:sequence>
              <xs:element name="NewsletterID" msdata:ReadOnly="true" msdata:AutoIncrement="true" type="xs:int" />
              <xs:element name="NewsletterDisplayName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="250" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NewsletterName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="250" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NewsletterType">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="5" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NewsletterSubscriptionTemplateID" type="xs:int" />
              <xs:element name="NewsletterUnsubscriptionTemplateID" type="xs:int" />
              <xs:element name="NewsletterSenderName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="200" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NewsletterSenderEmail">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="200" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NewsletterDynamicSubject" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="500" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NewsletterDynamicURL" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="500" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="NewsletterDynamicScheduledTaskID" type="xs:int" minOccurs="0" />
              <xs:element name="NewsletterTemplateID" type="xs:int" minOccurs="0" />
              <xs:element name="NewsletterSiteID" type="xs:int" />
              <xs:element name="NewsletterGUID" msdata:DataType="System.Guid, mscorlib, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" type="xs:string" />
              <xs:element name="NewsletterUnsubscribeUrl" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1000" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
            </xs:sequence>
          </xs:complexType>
        </xs:element>
      </xs:choice>
    </xs:complexType>
    <xs:unique name="Constraint1" msdata:PrimaryKey="true">
      <xs:selector xpath=".//Newsletter_Newsletter" />
      <xs:field xpath="NewsletterID" />
    </xs:unique>
  </xs:element>
</xs:schema>' WHERE ClassName='newsletter.newsletter'
GO

UPDATE [CMS_Class] SET [ClassXmlSchema] = '<?xml version="1.0" encoding="utf-8"?>
<xs:schema id="NewDataSet" xmlns="" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
  <xs:element name="NewDataSet" msdata:IsDataSet="true" msdata:UseCurrentLocale="true">
    <xs:complexType>
      <xs:choice minOccurs="0" maxOccurs="unbounded">
        <xs:element name="Forums_Forum">
          <xs:complexType>
            <xs:sequence>
              <xs:element name="ForumID" msdata:ReadOnly="true" msdata:AutoIncrement="true" type="xs:int" />
              <xs:element name="ForumGroupID" type="xs:int" />
              <xs:element name="ForumName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="200" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="ForumDisplayName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="200" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="ForumDescription" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="ForumOrder" type="xs:int" minOccurs="0" />
              <xs:element name="ForumDocumentID" type="xs:int" minOccurs="0" />
              <xs:element name="ForumOpen" type="xs:boolean" />
              <xs:element name="ForumModerated" type="xs:boolean" />
              <xs:element name="ForumDisplayEmails" type="xs:boolean" />
              <xs:element name="ForumRequireEmail" type="xs:boolean" />
              <xs:element name="ForumAccess" type="xs:int" />
              <xs:element name="ForumThreads" type="xs:int" />
              <xs:element name="ForumPosts" type="xs:int" />
              <xs:element name="ForumLastPostTime" type="xs:dateTime" minOccurs="0" />
              <xs:element name="ForumLastPostUserName" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="ForumBaseUrl" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="200" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="ForumAllowChangeName" type="xs:boolean" minOccurs="0" />
              <xs:element name="ForumHTMLEditor" type="xs:boolean" minOccurs="0" />
            </xs:sequence>
          </xs:complexType>
        </xs:element>
      </xs:choice>
    </xs:complexType>
    <xs:unique name="Constraint1" msdata:PrimaryKey="true">
      <xs:selector xpath=".//Forums_Forum" />
      <xs:field xpath="ForumID" />
    </xs:unique>
  </xs:element>
</xs:schema>' WHERE ClassName= 'Forums.Forum'
GO

UPDATE [CMS_Class] SET [ClassXmlSchema] = '<?xml version="1.0" encoding="utf-8"?>
<xs:schema id="NewDataSet" xmlns="" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
  <xs:element name="NewDataSet" msdata:IsDataSet="true" msdata:UseCurrentLocale="true">
    <xs:complexType>
      <xs:choice minOccurs="0" maxOccurs="unbounded">
        <xs:element name="Forums_ForumPost">
          <xs:complexType>
            <xs:sequence>
              <xs:element name="PostId" msdata:ReadOnly="true" msdata:AutoIncrement="true" type="xs:int" />
              <xs:element name="PostForumID" type="xs:int" />
              <xs:element name="PostParentID" type="xs:int" minOccurs="0" />
              <xs:element name="PostIDPath">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="450" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PostLevel" type="xs:int" />
              <xs:element name="PostSubject">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="450" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PostUserID" type="xs:int" minOccurs="0" />
              <xs:element name="PostUserName">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PostUserMail" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PostText" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PostTime" type="xs:dateTime" />
              <xs:element name="PostApprovedByUserID" type="xs:int" minOccurs="0" />
              <xs:element name="PostThreadPosts" type="xs:int" minOccurs="0" />
              <xs:element name="PostThreadLastPostUserName" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="100" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
              <xs:element name="PostThreadLastPostTime" type="xs:dateTime" minOccurs="0" />
              <xs:element name="PostUserSignature" minOccurs="0">
                <xs:simpleType>
                  <xs:restriction base="xs:string">
                    <xs:maxLength value="1073741823" />
                  </xs:restriction>
                </xs:simpleType>
              </xs:element>
            </xs:sequence>
          </xs:complexType>
        </xs:element>
      </xs:choice>
    </xs:complexType>
    <xs:unique name="Constraint1" msdata:PrimaryKey="true">
      <xs:selector xpath=".//Forums_ForumPost" />
      <xs:field xpath="PostId" />
    </xs:unique>
  </xs:element>
</xs:schema>' WHERE ClassName = 'Forums.ForumPost'
GO

INSERT [CMS_FormUserControl] ( [UserControlDisplayName], [UserControlCodeName], [UserControlFileName], [UserControlForText], [UserControlForLongText], [UserControlForInteger], [UserControlForDecimal], [UserControlForDateTime], [UserControlForBoolean], [UserControlForFile], [UserControlShowInBizForms], [UserControlDefaultDataType], [UserControlDefaultDataTypeSize], [UserControlShowInDocumentTypes], [UserControlShowInSystemTables], [UserControlShowInWebParts]) VALUES ( 'Role checkbox selector', 'RoleCheckboxSelector', 'RoleCheckboxSelector.ascx', 1, 0, 0, 0, 0, 0, 0, 0, 'Text', NULL, 0, 0, 1)
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.user')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'INSERT INTO CMS_User ( [UserName], [FirstName], [MiddleName], [LastName], [FullName], [Email], [UserPassword], [PreferredCultureCode], [PreferredUICultureCode], [UserEnabled], [UserIsEditor], [UserIsGlobalAdministrator], [UserIsExternal], [UserPasswordFormat], [UserCreated], [LastLogon], [UserNickName], [UserPicture], [UserSignature] ) VALUES (  @UserName, @FirstName, @MiddleName, @LastName, @FullName, @Email, @UserPassword, @PreferredCultureCode, @PreferredUICultureCode, @UserEnabled, @UserIsEditor, @UserIsGlobalAdministrator, @UserIsExternal, @UserPasswordFormat, @UserCreated, @LastLogon, @UserNickName, @UserPicture, @UserSignature); SELECT @@identity AS [UserID]' WHERE [QueryName]= 'insert' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'UPDATE CMS_User SET  [UserName] = @UserName, [FirstName] = @FirstName, [MiddleName] = @MiddleName, [LastName] = @LastName, [FullName] = @FullName, [Email] = @Email, [UserPassword] = @UserPassword, [PreferredCultureCode] = @PreferredCultureCode, [PreferredUICultureCode] = @PreferredUICultureCode, [UserEnabled] = @UserEnabled, [UserIsEditor] = @UserIsEditor, [UserIsGlobalAdministrator] = @UserIsGlobalAdministrator, [UserIsExternal] = @UserIsExternal, [UserPasswordFormat] = @UserPasswordFormat, [UserCreated] = @UserCreated, [LastLogon] = @LastLogon, [UserNickName] = @UserNickName, [UserPicture] = @UserPicture, [UserSignature] = @UserSignature WHERE [UserID] = @UserID' WHERE [QueryName]= 'update' AND [ClassID]=@classid
end
GO


DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.tree')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'INSERT INTO CMS_Tree ( [NodeAliasPath], [NodeName], [NodeAlias], [NodeClassID], [NodeParentID], [NodeLevel], [NodeACLID], [NodeSiteID], [NodeGUID], [NodeOrder], [IsSecuredNode], [NodeCacheMinutes], [NodeSKUID], [NodeDocType], [NodeHeadTags], [NodeBodyElementAttributes], [NodeInheritPageLevels], [NodeChildNodesCount], [RequiresSSL] ) VALUES (  @NodeAliasPath, @NodeName, @NodeAlias, @NodeClassID, @NodeParentID, @NodeLevel, @NodeACLID, @NodeSiteID, @NodeGUID, @NodeOrder, @IsSecuredNode, @NodeCacheMinutes, @NodeSKUID, @NodeDocType, @NodeHeadTags, @NodeBodyElementAttributes, @NodeInheritPageLevels, @NodeChildNodesCount, @RequiresSSL); SELECT @@identity AS [NodeID]' WHERE [QueryName]= 'insert' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'UPDATE CMS_Tree SET  [NodeAliasPath] = @NodeAliasPath, [NodeName] = @NodeName, [NodeAlias] = @NodeAlias, [NodeClassID] = @NodeClassID, [NodeParentID] = @NodeParentID, [NodeLevel] = @NodeLevel, [NodeACLID] = @NodeACLID, [NodeSiteID] = @NodeSiteID, [NodeGUID] = @NodeGUID, [NodeOrder] = @NodeOrder, [IsSecuredNode] = @IsSecuredNode, [NodeCacheMinutes] = @NodeCacheMinutes, [NodeSKUID] = @NodeSKUID, [NodeDocType] = @NodeDocType, [NodeHeadTags] = @NodeHeadTags, [NodeBodyElementAttributes] = @NodeBodyElementAttributes, [NodeInheritPageLevels] = @NodeInheritPageLevels, [NodeChildNodesCount] = @NodeChildNodesCount, [RequiresSSL] = @RequiresSSL WHERE [NodeID] = @NodeID' WHERE [QueryName]= 'update' AND [ClassID]=@classid
end
GO


DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.pagetemplate')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'INSERT INTO CMS_PageTemplate ( [PageTemplateDisplayName], [PageTemplateCodeName], [PageTemplateDescription], [PageTemplateFile], [PageTemplateIsPortal], [PageTemplateCategoryID], [PageTemplateLayoutID], [PageTemplateWebParts], [PageTemplateIsReusable], [PageTemplateShowAsMasterTemplate], [PageTemplateInheritPageLevels], [PageTemplateLayout], [PageTemplateLayoutCheckedOutFileName], [PageTemplateLayoutCheckedOutByUserID], [PageTemplateLayoutCheckedOutMachineName], [PageTemplateVersionGUID], [PageTemplateHeader] ) VALUES (  @PageTemplateDisplayName, @PageTemplateCodeName, @PageTemplateDescription, @PageTemplateFile, @PageTemplateIsPortal, @PageTemplateCategoryID, @PageTemplateLayoutID, @PageTemplateWebParts, @PageTemplateIsReusable, @PageTemplateShowAsMasterTemplate, @PageTemplateInheritPageLevels, @PageTemplateLayout, @PageTemplateLayoutCheckedOutFileName, @PageTemplateLayoutCheckedOutByUserID, @PageTemplateLayoutCheckedOutMachineName, @PageTemplateVersionGUID, @PageTemplateHeader); SELECT @@identity AS [PageTemplateID]' WHERE [QueryName]= 'insert' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'UPDATE CMS_PageTemplate SET  [PageTemplateDisplayName] = @PageTemplateDisplayName, [PageTemplateCodeName] = @PageTemplateCodeName, [PageTemplateDescription] = @PageTemplateDescription, [PageTemplateFile] = @PageTemplateFile, [PageTemplateIsPortal] = @PageTemplateIsPortal, [PageTemplateCategoryID] = @PageTemplateCategoryID, [PageTemplateLayoutID] = @PageTemplateLayoutID, [PageTemplateWebParts] = @PageTemplateWebParts, [PageTemplateIsReusable] = @PageTemplateIsReusable, [PageTemplateShowAsMasterTemplate] = @PageTemplateShowAsMasterTemplate, [PageTemplateInheritPageLevels] = @PageTemplateInheritPageLevels, [PageTemplateLayout] = @PageTemplateLayout, [PageTemplateLayoutCheckedOutFileName] = @PageTemplateLayoutCheckedOutFileName, [PageTemplateLayoutCheckedOutByUserID] = @PageTemplateLayoutCheckedOutByUserID, [PageTemplateLayoutCheckedOutMachineName] = @PageTemplateLayoutCheckedOutMachineName, [PageTemplateVersionGUID] = @PageTemplateVersionGUID, [PageTemplateHeader] = @PageTemplateHeader WHERE [PageTemplateID] = @PageTemplateID' WHERE [QueryName]= 'update' AND [ClassID]=@classid
end
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.workflowscope')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'SELECT TOP 1 * FROM CMS_WorkflowScope WHERE ScopeSiteID = @ScopeSiteID AND (ScopeClassID = @ScopeClassID OR ScopeClassID IS NULL) AND (ScopeStartingPath = ''/'' OR @NodeAliasPath LIKE ScopeStartingPath + ''/%'' OR @NodeAliasPath LIKE ScopeStartingPath) ORDER BY ScopeStartingPath DESC' WHERE [QueryName]= 'getnodescope' AND [ClassID]=@classid
end
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.workflow')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'SELECT CMS_WorkflowScope.*, CMS_Site.SiteDisplayName, CMS_Class.ClassDisplayName FROM CMS_WorkflowScope INNER JOIN CMS_Site ON CMS_Site.SiteID = CMS_WorkflowScope.ScopeSiteID LEFT OUTER JOIN CMS_Class ON CMS_Class.ClassID = CMS_WorkflowScope.ScopeClassID WHERE ##WHERE## ORDER BY ##ORDERBY##' WHERE [QueryName]= 'selectallscopes' AND [ClassID]=@classid
end
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.form')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'SELECT * FROM cms_form WHERE [FormID] = @ID' WHERE [QueryName]= 'select' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'DELETE FROM cms_form WHERE [FormID] = @ID' WHERE [QueryName]= 'delete' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'INSERT INTO cms_form ( [FormDisplayName], [FormName], [FormSendToEmail], [FormSendFromEmail], [FormEmailSubject], [FormClassID], [FormItems], [FormReportFields], [FormRedirectToUrl], [FormDisplayText], [FormClearAfterSave], [FormSubmitButtonText], [FormSiteID] ) VALUES (  @FormDisplayName, @FormName, @FormSendToEmail, @FormSendFromEmail, @FormEmailSubject, @FormClassID, @FormItems, @FormReportFields, @FormRedirectToUrl, @FormDisplayText, @FormClearAfterSave, @FormSubmitButtonText, @FormSiteID); SELECT @@identity AS [FormID]' WHERE [QueryName]= 'insert' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'UPDATE cms_form SET  [FormDisplayName] = @FormDisplayName, [FormName] = @FormName, [FormSendToEmail] = @FormSendToEmail, [FormSendFromEmail] = @FormSendFromEmail, [FormEmailSubject] = @FormEmailSubject, [FormClassID] = @FormClassID, [FormItems] = @FormItems, [FormReportFields] = @FormReportFields, [FormRedirectToUrl] = @FormRedirectToUrl, [FormDisplayText] = @FormDisplayText, [FormClearAfterSave] = @FormClearAfterSave, [FormSubmitButtonText] = @FormSubmitButtonText, [FormSiteID] = @FormSiteID WHERE [FormID] = @FormID' WHERE [QueryName]= 'update' AND [ClassID]=@classid
end
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='newsletter.emailtemplate')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'SELECT * FROM Newsletter_EmailTemplate WHERE [TemplateID] = @ID' WHERE [QueryName]= 'select' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'DELETE FROM Newsletter_EmailTemplate WHERE [TemplateID] = @ID' WHERE [QueryName]= 'delete' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'INSERT INTO Newsletter_EmailTemplate ( [TemplateDisplayName], [TemplateName], [TemplateBody], [TemplateSiteID], [TemplateHeader], [TemplateFooter], [TemplateType] ) VALUES (  @TemplateDisplayName, @TemplateName, @TemplateBody, @TemplateSiteID, @TemplateHeader, @TemplateFooter, @TemplateType); SELECT @@identity AS [TemplateID]' WHERE [QueryName]= 'insert' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'UPDATE Newsletter_EmailTemplate SET  [TemplateDisplayName] = @TemplateDisplayName, [TemplateName] = @TemplateName, [TemplateBody] = @TemplateBody, [TemplateSiteID] = @TemplateSiteID, [TemplateHeader] = @TemplateHeader, [TemplateFooter] = @TemplateFooter, [TemplateType] = @TemplateType WHERE [TemplateID] = @TemplateID' WHERE [QueryName]= 'update' AND [ClassID]=@classid
end
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='newsletter.subscriber')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'SELECT * FROM Newsletter_Subscriber WHERE [SubscriberID] = @ID' WHERE [QueryName]= 'select' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'DELETE FROM Newsletter_Subscriber WHERE [SubscriberID] = @ID' WHERE [QueryName]= 'delete' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'INSERT INTO Newsletter_Subscriber ( [SubscriberEmail], [SubscriberFirstName], [SubscriberLastName], [SubscriberSiteID], [SubscriberGUID] ) VALUES (  @SubscriberEmail, @SubscriberFirstName, @SubscriberLastName, @SubscriberSiteID, @SubscriberGUID); SELECT @@identity AS [SubscriberID]' WHERE [QueryName]= 'insert' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'UPDATE Newsletter_Subscriber SET  [SubscriberEmail] = @SubscriberEmail, [SubscriberFirstName] = @SubscriberFirstName, [SubscriberLastName] = @SubscriberLastName, [SubscriberSiteID] = @SubscriberSiteID, [SubscriberGUID] = @SubscriberGUID WHERE [SubscriberID] = @SubscriberID' WHERE [QueryName]= 'update' AND [ClassID]=@classid
end
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='newsletter.newsletter')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'SELECT * FROM Newsletter_Newsletter WHERE [NewsletterID] = @ID' WHERE [QueryName]= 'select' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'DELETE FROM Newsletter_Newsletter WHERE [NewsletterID] = @ID' WHERE [QueryName]= 'delete' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'INSERT INTO Newsletter_Newsletter ( [NewsletterDisplayName], [NewsletterName], [NewsletterType], [NewsletterSubscriptionTemplateID], [NewsletterUnsubscriptionTemplateID], [NewsletterSenderName], [NewsletterSenderEmail], [NewsletterDynamicSubject], [NewsletterDynamicURL], [NewsletterDynamicScheduledTaskID], [NewsletterTemplateID], [NewsletterSiteID], [NewsletterGUID], [NewsletterUnsubscribeUrl] ) VALUES (  @NewsletterDisplayName, @NewsletterName, @NewsletterType, @NewsletterSubscriptionTemplateID, @NewsletterUnsubscriptionTemplateID, @NewsletterSenderName, @NewsletterSenderEmail, @NewsletterDynamicSubject, @NewsletterDynamicURL, @NewsletterDynamicScheduledTaskID, @NewsletterTemplateID, @NewsletterSiteID, @NewsletterGUID, @NewsletterUnsubscribeUrl); SELECT @@identity AS [NewsletterID]' WHERE [QueryName]= 'insert' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'UPDATE Newsletter_Newsletter SET  [NewsletterDisplayName] = @NewsletterDisplayName, [NewsletterName] = @NewsletterName, [NewsletterType] = @NewsletterType, [NewsletterSubscriptionTemplateID] = @NewsletterSubscriptionTemplateID, [NewsletterUnsubscriptionTemplateID] = @NewsletterUnsubscriptionTemplateID, [NewsletterSenderName] = @NewsletterSenderName, [NewsletterSenderEmail] = @NewsletterSenderEmail, [NewsletterDynamicSubject] = @NewsletterDynamicSubject, [NewsletterDynamicURL] = @NewsletterDynamicURL, [NewsletterDynamicScheduledTaskID] = @NewsletterDynamicScheduledTaskID, [NewsletterTemplateID] = @NewsletterTemplateID, [NewsletterSiteID] = @NewsletterSiteID, [NewsletterGUID] = @NewsletterGUID, [NewsletterUnsubscribeUrl] = @NewsletterUnsubscribeUrl WHERE [NewsletterID] = @NewsletterID' WHERE [QueryName]= 'update' AND [ClassID]=@classid
end
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='newsletter.emails')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'SELECT * FROM Newsletter_Emails WHERE [EmailID] = @ID' WHERE [QueryName]= 'select' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'DELETE FROM Newsletter_Emails WHERE [EmailID] = @ID' WHERE [QueryName]= 'delete' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'INSERT INTO Newsletter_Emails ( [EmailNewsletterIssueID], [EmailSubscriberID], [EmailText], [EmailSubject], [ErrorMessage], [EmailLastSendAttempt] ) VALUES (  @EmailNewsletterIssueID, @EmailSubscriberID, @EmailText, @EmailSubject, @ErrorMessage, @EmailLastSendAttempt); SELECT @@identity AS [EmailID]' WHERE [QueryName]= 'insert' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'UPDATE Newsletter_Emails SET  [EmailNewsletterIssueID] = @EmailNewsletterIssueID, [EmailSubscriberID] = @EmailSubscriberID, [EmailText] = @EmailText, [EmailSubject] = @EmailSubject, [ErrorMessage] = @ErrorMessage, [EmailLastSendAttempt] = @EmailLastSendAttempt WHERE [EmailID] = @EmailID' WHERE [QueryName]= 'update' AND [ClassID]=@classid
end
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.layout')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'SELECT * FROM CMS_Layout WHERE [LayoutID] = @LayoutID' WHERE [QueryName]= 'select' AND [ClassID]=@classid
end
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='Forums.Forum')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'INSERT INTO Forums_Forum ( [ForumGroupID], [ForumName], [ForumDisplayName], [ForumDescription], [ForumOrder], [ForumDocumentID], [ForumOpen], [ForumModerated], [ForumDisplayEmails], [ForumRequireEmail], [ForumAccess], [ForumThreads], [ForumPosts], [ForumLastPostTime], [ForumLastPostUserName], [ForumBaseUrl], [ForumAllowChangeName], [ForumHTMLEditor] ) VALUES (  @ForumGroupID, @ForumName, @ForumDisplayName, @ForumDescription, @ForumOrder, @ForumDocumentID, @ForumOpen, @ForumModerated, @ForumDisplayEmails, @ForumRequireEmail, @ForumAccess, @ForumThreads, @ForumPosts, @ForumLastPostTime, @ForumLastPostUserName, @ForumBaseUrl, @ForumAllowChangeName, @ForumHTMLEditor); SELECT @@identity AS [ForumID]' WHERE [QueryName]= 'insert' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'UPDATE Forums_Forum SET  [ForumGroupID] = @ForumGroupID, [ForumName] = @ForumName, [ForumDisplayName] = @ForumDisplayName, [ForumDescription] = @ForumDescription, [ForumOrder] = @ForumOrder, [ForumDocumentID] = @ForumDocumentID, [ForumOpen] = @ForumOpen, [ForumModerated] = @ForumModerated, [ForumDisplayEmails] = @ForumDisplayEmails, [ForumRequireEmail] = @ForumRequireEmail, [ForumAccess] = @ForumAccess, [ForumThreads] = @ForumThreads, [ForumPosts] = @ForumPosts, [ForumLastPostTime] = @ForumLastPostTime, [ForumLastPostUserName] = @ForumLastPostUserName, [ForumBaseUrl] = @ForumBaseUrl, [ForumAllowChangeName] = @ForumAllowChangeName, [ForumHTMLEditor] = @ForumHTMLEditor WHERE [ForumID] = @ForumID' WHERE [QueryName]= 'update' AND [ClassID]=@classid
end
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='Forums.ForumPost')
if @classid<>0
begin
UPDATE [CMS_Query] SET [QueryText]= 'INSERT INTO Forums_ForumPost ( [PostForumID], [PostParentID], [PostIDPath], [PostLevel], [PostSubject], [PostUserID], [PostUserName], [PostUserMail], [PostText], [PostTime], [PostApprovedByUserID], [PostThreadPosts], [PostThreadLastPostUserName], [PostThreadLastPostTime], [PostUserSignature] ) VALUES (  @PostForumID, @PostParentID, @PostIDPath, @PostLevel, @PostSubject, @PostUserID, @PostUserName, @PostUserMail, @PostText, @PostTime, @PostApprovedByUserID, @PostThreadPosts, @PostThreadLastPostUserName, @PostThreadLastPostTime, @PostUserSignature); SELECT @@identity AS [PostId]' WHERE [QueryName]= 'insert' AND [ClassID]=@classid
UPDATE [CMS_Query] SET [QueryText]= 'UPDATE Forums_ForumPost SET  [PostForumID] = @PostForumID, [PostParentID] = @PostParentID, [PostIDPath] = @PostIDPath, [PostLevel] = @PostLevel, [PostSubject] = @PostSubject, [PostUserID] = @PostUserID, [PostUserName] = @PostUserName, [PostUserMail] = @PostUserMail, [PostText] = @PostText, [PostTime] = @PostTime, [PostApprovedByUserID] = @PostApprovedByUserID, [PostThreadPosts] = @PostThreadPosts, [PostThreadLastPostUserName] = @PostThreadLastPostUserName, [PostThreadLastPostTime] = @PostThreadLastPostTime, [PostUserSignature] = @PostUserSignature WHERE [PostId] = @PostId' WHERE [QueryName]= 'update' AND [ClassID]=@classid
end
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='cms.tree')
if @classid<>0
begin
INSERT [CMS_Query] ( [QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ( 'updatechildnodescount', 0, 'UPDATE CMS_Tree SET NodeChildNodesCount = (SELECT COUNT(*) FROM CMS_Tree WHERE NodeParentID = @NodeID AND NodeID <> @NodeID) WHERE NodeID = @NodeID', 1, @classid, 0)
INSERT [CMS_Query] ( [QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ( 'GetParentProperty', 0, 'SELECT TOP 1 * FROM CMS_Document WHERE ((DocumentNodeID IN (SELECT NodeID FROM CMS_TREE WHERE NodeSiteID = @SiteID ))AND(DocumentNamePath=''/'' OR @DocumentNamePath LIKE DocumentNamePath+''/%'')AND(##WHERE##) ) ORDER BY DocumentNamePath DESC', 0, @classId, 0)
INSERT [CMS_Query] ( [QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ( 'selectParentSSLNode', 1, 'Proc_CMS_Tree_SelectParentWithSSLNode', 0, @classid, 1)
end
GO

DECLARE @classid int
set @classid = (SELECT ClassID FROM CMS_Class WHERE ClassName='newsletter.subscribernewsletter')
if @classid<>0
begin
INSERT [CMS_Query] ( [QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ( 'select', 0, 'SELECT * FROM Newsletter_SubscriberNewsletter WHERE [SubscriberID] = @ID', 0, @classid, 0)
INSERT [CMS_Query] ( [QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ( 'delete', 0, 'DELETE FROM Newsletter_SubscriberNewsletter WHERE [SubscriberID] = @ID', 0, @classid, 0)
INSERT [CMS_Query] ( [QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ( 'insert', 0, 'INSERT INTO Newsletter_SubscriberNewsletter ( [NewsletterID], [SubscribedWhen] ) VALUES (  @NewsletterID, @SubscribedWhen); SELECT @@identity AS [SubscriberID]', 0, @classid, 0)
INSERT [CMS_Query] ( [QueryName], [QueryTypeID], [QueryText], [QueryRequiresTransaction], [ClassID], [QueryIsLocked]) VALUES ( 'update', 0, 'UPDATE Newsletter_SubscriberNewsletter SET  [NewsletterID] = @NewsletterID, [SubscribedWhen] = @SubscribedWhen WHERE [SubscriberID] = @SubscriberID', 0, @classid, 0)
end
GO


/*Settings key*/
DECLARE @categoryid int
set @categoryid = (SELECT CategoryID FROM CMS_SettingsCategory WHERE CategoryDisplayName='URLs')
if @categoryid<>0
begin
INSERT [CMS_SettingsKey] ( [KeyName], [KeyDisplayName], [KeyDescription], [KeyValue], [KeyType], [KeyCategoryID], [SiteID]) VALUES ( 'CMSUsePermanentURLs', 'Use permanent URLs', 'Use permanent URL format (getdoc/...) for links?', '1', 'boolean', @categoryid, NULL)
end
GO

DECLARE @categoryid int
set @categoryid = (SELECT CategoryID FROM CMS_SettingsCategory WHERE CategoryDisplayName='Web Site')
if @categoryid<>0
begin
INSERT [CMS_SettingsKey] ( [KeyName], [KeyDisplayName], [KeyDescription], [KeyValue], [KeyType], [KeyCategoryID], [SiteID]) VALUES ( 'CMSCombineImagesWithDefaultCulture', 'Combine Files With Default Culture', 'Indicates if default culture version of the file should be used when the document is not translated.', '1', 'boolean', @categoryid, NULL)
INSERT [CMS_SettingsKey] ( [KeyName], [KeyDisplayName], [KeyDescription], [KeyValue], [KeyType], [KeyCategoryID], [SiteID]) VALUES ( 'CMSPageTitleFormat', 'Page Title Format', 'Specifies page title format. Example: {%prefix%} - {%pagetitle_orelse_name%}', '{%prefix%} - {%pagetitle_orelse_name%}', 'string', @categoryid, NULL)
end
GO

DECLARE @categoryid int
set @categoryid = (SELECT CategoryID FROM CMS_SettingsCategory WHERE CategoryDisplayName='E-mails')
if @categoryid<>0
begin
INSERT [CMS_SettingsKey] ( [KeyName], [KeyDisplayName], [KeyDescription], [KeyValue], [KeyType], [KeyCategoryID], [SiteID]) VALUES ( 'CMSUseSSL', 'Use SSL', 'Indicates if e-mails should be sent over SSL.', '0', 'boolean', @categoryid, NULL)
end
GO

DECLARE @categoryid int
set @categoryid = (SELECT CategoryID FROM CMS_SettingsCategory WHERE CategoryDisplayName='Content Management')
if @categoryid<>0
begin
INSERT [CMS_SettingsKey] ( [KeyName], [KeyDisplayName], [KeyDescription], [KeyValue], [KeyType], [KeyCategoryID], [SiteID]) VALUES ( 'CMSConfirmChanges', 'Notify when leaving the page', 'Notifies the user that she hasn''t saved the changes when the user tries to leave the page in the editing mode.', '0', 'boolean', @categoryid, NULL)
end
GO

/*Web parts*/
DECLARE @categoryid int
set @categoryid = (SELECT CategoryID FROM CMS_WebPartCategory WHERE CategoryDisplayName='General')
if @categoryid<>0
begin
INSERT [CMS_WebPart] ( [WebPartName], [WebPartDisplayName], [WebPartDescription], [WebPartFileName], [WebPartProperties], [WebPartCategoryID]) VALUES ( 'HeadHTML', 'Head HTML code', 'Allows adding the custom HTML code to the HEAD tag of the page', 'general/headhtml.ascx', '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="HTMLCode" fieldcaption="HTML code" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>', @categoryid)
end
GO

DECLARE @categoryid int
set @categoryid = (SELECT CategoryID FROM CMS_WebPartCategory WHERE CategoryDisplayName='Text')
if @categoryid<>0
begin
INSERT [CMS_WebPart] ( [WebPartName], [WebPartDisplayName], [WebPartDescription], [WebPartFileName], [WebPartProperties], [WebPartCategoryID]) VALUES ('EditableImage', 'Editable image', 'The Editable text web part displays an editable region that contains single image.', 'Text/EditableImage.ascx', '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="ImageWidth" fieldcaption="Image width" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ImageHeight" fieldcaption="Image height" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ImageTitle" fieldcaption="Image title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="AlternateText" fieldcaption="Alternate text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="DisplaySelectorTextBox" fieldcaption="Display image page path" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>', @categoryid)
end
GO

DECLARE @categoryid int
set @categoryid = (SELECT CategoryID FROM CMS_WebPartCategory WHERE CategoryDisplayName='Text')
if @categoryid<>0
begin
INSERT [CMS_WebPart] ( [WebPartName], [WebPartDisplayName], [WebPartDescription], [WebPartFileName], [WebPartProperties], [WebPartCategoryID]) VALUES ( 'PagedText', 'Paged text', 'Displays the document field as a paged text', 'Text/PagedText.ascx', '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="Path to the document" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="ColumnName" fieldcaption="Text field name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="Document field that should be used as a source of the text." regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><category name="Content filter" /><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" defaultvalue="" columntype="text" fieldtype="radiobuttons" allowempty="true" isPK="false" system="false" columnsize="5" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true"><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="20" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true"><settings><controlname>selectculture</controlname></settings></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="SiteName" fieldcaption="Site name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><category name="Paging" /><field column="PagingMode" fieldcaption="Paging mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="20" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true"><settings><options><item value="querystring" text="Query string" /><item value="postback" text="Postback" /></options></settings></field><field column="PagerPosition" fieldcaption="Pager position" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true"><settings><options><item value="bottom" text="Bottom" /><item value="top" text="Top" /></options></settings></field><field column="QueryStringKey" fieldcaption="Query string key" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="ShowFirstLast" fieldcaption="Show first and last buttons" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="PageSize" fieldcaption="Page size (characters)" visible="true" defaultvalue="1000" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="PagerFormat" fieldcaption="Pager format" visible="true" defaultvalue="Page {0} of {2}" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="You can use the following expressions: {0} for current page, {2} for total number of pages." regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true"><settings><controlname>largetextarea</controlname></settings></field></form>', @categoryid)
end
GO

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectpath</controlname></settings></field><field column="HighlightedNodePath" fieldcaption="Highlighted document path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsinglepath</controlname></settings></field><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="4" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="-1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="Design" /><field column="CSSPrefix" fieldcaption="CSS prefix" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="Cursor" fieldcaption="Cursor" visible="true" columntype="text" fieldtype="dropdownlist" allowempty="true" columnsize="1" fielddescription="" defaultvalue="1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="0" text="Standard" /><item value="1" text="Hand" /></options></settings></field><field column="HighlightAllItemsInPath" fieldcaption="Highlight all items in path" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="ExternalScriptPath" fieldcaption="External script path" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="Layout" fieldcaption="Layout" visible="true" columntype="text" fieldtype="dropdownlist" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="vertical" text="Vertical" /><item value="horizontal" text="Horizontal" /></options></settings></field><field column="Padding" fieldcaption="Padding" visible="true" defaultvalue="2" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="RenderItemName" fieldcaption="Render item name" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="0"><settings /></field><field column="RenderImageAlt" fieldcaption="Render image alt" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Spacing" fieldcaption="Spacing" visible="true" defaultvalue="2" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SubmenuIndicator" fieldcaption="Submenu indicator image" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="UseAlternatingStyles" fieldcaption="Use alternating styles" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="0"><settings /></field><field column="UseItemImagesForHiglightedItem" fieldcaption="Use item images for higlighted item" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ApplyMenuDesign" fieldcaption="ApplyMenuDesign" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="EnableRTLBehaviour" fieldcaption="Enable RTL behaviour" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Menu item separator" /><field column="SeparatorCSS" fieldcaption="Separator CSS class" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SeparatorHeight" fieldcaption="Separator height" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SeparatorText" fieldcaption="Separator text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='cmsmenu'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectpath</controlname></settings></field><field column="HighlightedNodePath" fieldcaption="Highlighted document path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsinglepath</controlname></settings></field><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="4" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="20" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="-1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="Design" /><field column="CellPadding" fieldcaption="Cell padding" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="0"><settings /></field><field column="CellSpacing" fieldcaption="Cell spacing" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="0" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CollapseSelectedNodeOnClick" fieldcaption="Collapse selected item on click" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="CSSPrefix" fieldcaption="CSS prefix" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="DisplayHighlightedItemAsLink" fieldcaption="Display highlighted item as link" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="GenerateIndentationInsideLink" fieldcaption="Generate indentation inside link" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="0"><settings /></field><field column="GenerateOnlyOuterLink" fieldcaption="Generate only outer link" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="0"><settings /></field><field column="HighlightAllItemsInPath" fieldcaption="Highlight all items in path" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="Indentation" fieldcaption="Indentation" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="3" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="MenuItemImageUrl" fieldcaption="Item image url" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="MenuItemOpenImageUrl" fieldcaption="Open item image url" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OnMouseOutScript" fieldcaption="OnMouseOut script" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OnMouseOverScript" fieldcaption="OnMouseOver script" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SubmenuIndicator" fieldcaption="Sub-menu indicator image" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="UrlTarget" fieldcaption="Target frame" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="UseAlternatingStyles" fieldcaption="Use alternating styles" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="0"><settings /></field><field column="UseItemImagesForHiglightedItem" fieldcaption="Use item images for higlighted item" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ApplyMenuDesign" fieldcaption="Apply menu design" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="RenderImageAlt" fieldcaption="Render image alt" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='cmstreemenu'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Text" fieldcaption="Text" visible="true" columntype="longtext" fieldtype="usercontrol" allowempty="true" defaultvalue="" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='statictext'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Design" /><field column="RegionTitle" fieldcaption="Editable region title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="RegionType" fieldcaption="Editable region type" visible="true" defaultvalue="HtmlEditor" columntype="text" fieldtype="dropdownlist" allowempty="false" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="TextBox" text="Text box" /><item value="TextArea" text="Text area" /><item value="HtmlEditor" text="HTML Editor" /></options></settings></field><field column="DialogWidth" fieldcaption="Editable region width" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="DialogHeight" fieldcaption="Editable region height" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><category name="Behavior" /><field column="HtmlAreaToolbar" fieldcaption="HTML editor toolbar set" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HtmlAreaToolbarLocation" fieldcaption="HTML editor toolbar location" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="Out:FCKToolbar" text="Shared toolbar" /><item value="In" text="In-line toolbar" /></options></settings></field><field column="MinLength" fieldcaption="Minimum length" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="MaxLength" fieldcaption="Maximum length" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="WordWrap" fieldcaption="Word wrap (text area only)" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><category name="Security" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='editabletext'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectpath</controlname></settings></field><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="5" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true"><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="20" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="-1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SelectTopN" fieldcaption="Select top N documents" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="Transformations" /><field column="TransformationName" fieldcaption="Transformation" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selecttransformation</controlname></settings></field><field column="AlternatingTransformationName" fieldcaption="Alternating transformation" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selecttransformation</controlname></settings></field><field column="SelectedItemTransformationName" fieldcaption="Selected item transformation" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selecttransformation</controlname></settings></field><field column="ItemSeparator" fieldcaption="Item separator" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="NestedRepeaterID" fieldcaption="Nested repeater ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="NestedDataListID" fieldcaption="Nested datalist ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Paging" /><field column="EnablePaging" fieldcaption="Enable paging" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="PagingMode" fieldcaption="Paging mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="querystring" text="Query string" /><item value="postback" text="Postback" /></options></settings></field><field column="PagerPosition" fieldcaption="Pager position" visible="true" columntype="text" fieldtype="dropdownlist" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="bottom" text="Bottom" /><item value="top" text="Top" /></options></settings></field><field column="PageSize" fieldcaption="Page size" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="10" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="QueryStringKey" fieldcaption="Query string key" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowFirstLast" fieldcaption="Show first and last buttons" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Relationships" /><field column="RelationshipWithNodeGuid" fieldcaption="Main document" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>relationshipconfiguration</controlname></settings></field><field column="RelatedNodeIsOnTheLeftSide" fieldcaption="Main document is on the left side" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="RelationshipName" fieldcaption="Relationship  name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectrelationshipname</controlname></settings></field><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="1"><settings /></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Editing buttons" /><field column="ShowNewButton" fieldcaption="Show New button" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="NewButtonText" fieldcaption="New button text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowEditDeleteButtons" fieldcaption="Show Edit and Delete buttons" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='repeater'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectpath</controlname></settings></field><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="4" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="20" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="-1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SelectTopN" fieldcaption="Select top N documents" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="Transformations" /><field column="TransformationName" fieldcaption="Transformation" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="AlternatingTransformationName" fieldcaption="Alternating transformation" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="SelectedItemTransformationName" fieldcaption="Selected item transformation" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="NestedRepeaterID" fieldcaption="Nested repeater ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="NestedDataListID" fieldcaption="Nested datalist ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Layout" /><field column="RepeatColumns" fieldcaption="Repeat columns" visible="true" defaultvalue="3" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="RepeatDirection" fieldcaption="Repeat direction" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="horizontal" text="Horizontal" /><item value="vertical" text="Vertical" /></options></settings></field><field column="RepeatLayout" fieldcaption="Repeat layout" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="table" text="Table" /><item value="flow" text="Flow" /></options></settings></field><category name="Paging" /><field column="EnablePaging" fieldcaption="Enable paging" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="0"><settings /></field><field column="PagingMode" fieldcaption="Paging mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="querystring" text="Query string" /><item value="postback" text="Postback" /></options></settings></field><field column="PagerPosition" fieldcaption="Pager position" visible="true" columntype="text" fieldtype="dropdownlist" allowempty="false" columnsize="50" fielddescription="" defaultvalue="0" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="bottom" text="Bottom" /><item value="top" text="Top" /></options></settings></field><field column="PageSize" fieldcaption="Page size" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="10"><settings /></field><field column="QueryStringKey" fieldcaption="Query string key" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowFirstLast" fieldcaption="Show first and last buttons" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Relationships" /><field column="RelationshipWithNodeGuid" fieldcaption="Main document" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>relationshipconfiguration</controlname></settings></field><field column="RelatedNodeIsOnTheLeftSide" fieldcaption="Main document is on the left side" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="RelationshipName" fieldcaption="Relationship name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="100" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectrelationshipname</controlname></settings></field><category name="System settings" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Editing buttons" /><field column="ShowNewButton" fieldcaption="Show New button" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="NewButtonText" fieldcaption="New button text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowEditDeleteButtons" fieldcaption="Show edit and delete buttons" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='cmsdatalist'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="User control" /><field column="UserControlPath" fieldcaption="User control virtual path" visible="true" columntype="text" fieldtype="textbox" allowempty="true" defaultvalue="" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='usercontrol'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectpath</controlname></settings></field><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="4" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="20" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="-1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsite</controlname></settings></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SelectTopN" fieldcaption="Select top N documents" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="Transformations" /><field column="TransformationName" fieldcaption="Transformation name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="SelectedItemTransformationName" fieldcaption="Selected item transformation name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="Relationships" /><field column="RelationshipWithNodeGuid" fieldcaption="Main document" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>relationshipconfiguration</controlname></settings></field><field column="RelatedNodeIsOnTheLeftSide" fieldcaption="Main document is on the left side" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="RelationshipName" fieldcaption="Relationship  name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectrelationshipname</controlname></settings></field><category name="System settings" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="1"><settings /></field><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='cmsxsltlist'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Behavior" /><field column="PageTemplate" fieldcaption="Default page template" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectpagetemplate</controlname></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='pageplaceholder'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="QueryName" fieldcaption="Query name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="250" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectquery</controlname></settings></field><category name="Content filter" /><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="SelectTopN" fieldcaption="Select top N documents" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="Transformations" /><field column="TransformationName" fieldcaption="Transformation name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="AlternatingTransformationName" fieldcaption="Alternating transformation" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="ItemSeparator" fieldcaption="Item separator" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><category name="Paging" /><field column="EnablePaging" fieldcaption="Enable paging" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="PagingMode" fieldcaption="Paging mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="querystring" text="Query string" /><item value="postback" text="Postback" /></options></settings></field><field column="PagerPosition" fieldcaption="Pager position" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="bottom" text="Bottom" /><item value="top" text="Top" /></options></settings></field><field column="PageSize" fieldcaption="Page size" visible="true" defaultvalue="10" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="QueryStringKey" fieldcaption="Query string key" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowFirstLast" fieldcaption="Show first and last buttons" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="50" fielddescription="" defaultvalue="No data found" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="Editing buttons" /><field column="ShowEditDeleteButtons" fieldcaption="Show edit and delete buttons" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='queryrepeater'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="QueryName" fieldcaption="Query name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectquery</controlname></settings></field><category name="Content filter" /><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="SelectTopN" fieldcaption="Select top N documents" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="Transformations" /><field column="TransformationName" fieldcaption="Transformation" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="AlternatingTransformationName" fieldcaption="Alternating transformation" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="Layout" /><field column="RepeatColumns" fieldcaption="Repeat columns" visible="true" defaultvalue="3" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="RepeatDirection" fieldcaption="Repeat direction" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="horizontal" text="Horizontal" /><item value="vertical" text="Vertical" /></options></settings></field><field column="RepeatLayout" fieldcaption="Repeat layout" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="table" text="Table" /><item value="flow" text="Flow" /></options></settings></field><category name="Paging" /><field column="EnablePaging" fieldcaption="Enable paging" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="PageSize" fieldcaption="Page size" visible="true" defaultvalue="10" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="PagerPosition" fieldcaption="Pager position" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="bottom" text="Bottom" /><item value="top" text="Top" /></options></settings></field><field column="PagingMode" fieldcaption="Paging mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="querystring" text="Query string" /><item value="postback" text="Postback" /></options></settings></field><field column="ShowFirstLast" fieldcaption="Show first and last buttons" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="QueryStringKey" fieldcaption="Query string key" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="false" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="50" fielddescription="" defaultvalue="No data found" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="Editing buttons" /><field column="ShowEditDeleteButtons" fieldcaption="Show edit and delete buttons" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='querydatalist'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectpath</controlname></settings></field><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="4" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="20" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="-1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SelectTopN" fieldcaption="Select top N documents" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="Design" /><field column="ColumnSelector" fieldcaption="Displayed columns" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcolumns</controlname></settings></field><field column="ShowHeader" fieldcaption="Show header" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ToolTip" fieldcaption="Tool tip" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SkinID" fieldcaption="Skin ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Transformations" /><field column="SelectedItemTransformationName" fieldcaption="Selected item transformation" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="Paging" /><field column="AllowPaging" fieldcaption="Enable paging" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PageSize" fieldcaption="Page size" visible="true" defaultvalue="10" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="Mode" fieldcaption="Pager style" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="nextprev" text="Previous-Next buttons" /><item value="numericpages" text="Page numbers" /></options></settings></field><category name="Sorting" /><field column="AllowSorting" fieldcaption="Enable sorting" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SortAscending" fieldcaption="Sort ascending" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SortField" fieldcaption="Default sort field" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Relationships" /><field column="RelationshipWithNodeGuid" fieldcaption="Main document" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="10" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>relationshipconfiguration</controlname></settings></field><field column="RelationshipName" fieldcaption="Relationship  name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectrelationshipname</controlname></settings></field><field column="RelatedNodeIsOnTheLeftSide" fieldcaption="Main document is on the left side" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="System settings" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="1"><settings /></field><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="New button" /><field column="ShowNewButton" fieldcaption="Show New button" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="NewButtonText" fieldcaption="New button text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='cmsdatagrid'
GO

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<a>
DisplayLayout
<field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Layout" /><field column="DisplayLayout" fieldcaption="Display layout" visible="true" defaultvalue="horizontal" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="horizontal" text="Horizontal" /><item value="vertical" text="Vertical" /></options></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></a>' WHERE WebPartName = 'languageselection'
GO

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Selected path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsinglepath</controlname></settings></field><field column="DefaultPath" fieldcaption="Default path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsinglepath</controlname></settings></field><field column="SelectNodesStartPath" fieldcaption="Starting path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="/" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsinglepath</controlname></settings></field><field column="ClassNames" fieldcaption="Class names" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><category name="Content filter" /><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="4" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectculture</controlname></settings></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectsite</controlname></settings></field><category name="Design" /><field column="BreadCrumbSeparator" fieldcaption="Breadcrumb separator" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="&amp;gt;" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="BreadCrumbSeparatorRTL" fieldcaption="Breadcrumb separator RTL" visible="true" defaultvalue="&amp;lt;" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowCurrentItem" fieldcaption="Show current item" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="ShowCurrentItemAsLink" fieldcaption="Show current item as a link" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="UrlTarget" fieldcaption="Target frame" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="ApplyMenuDesign" fieldcaption="Apply menu design" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='breadcrumbs'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectpath</controlname></settings></field><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="4" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="20" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="-1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="Design" /><field column="UrlTarget" fieldcaption="Target frame" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='cmssitemap'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<a><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="450" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectpath</controlname></settings></field><field column="HighlightedNodePath" fieldcaption="Highlighted document path" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsinglepath</controlname></settings></field><field column="UseClientScript" fieldcaption="Use client script" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UrlTarget" fieldcaption="Url target" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" defaultvalue="" columntype="text" fieldtype="radiobuttons" allowempty="true" isPK="false" system="false" columnsize="4" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="20" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" defaultvalue="1" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="SiteName" fieldcaption="Site name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><category name="Design" /><field column="UseAlternatingStyles" fieldcaption="Use alternating styles" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="TabControlLayout" fieldcaption="Tab control layout" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="horizontal" text="Horizontal" /><item value="vertical" text="Vertical" /></options></settings></field><field column="UseItemImagesForHiglightedItem" fieldcaption="Use item images for higlighted item" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ApplyMenuDesign" fieldcaption="Apply menu design" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="RenderImageAlt" fieldcaption="Render image alt" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>largetextarea</controlname></settings></field></a>' WHERE WebPartName='cmstabcontrol'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectpath</controlname></settings></field><field column="HighlightedNodePath" fieldcaption="Highlighted document path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsinglepath</controlname></settings></field><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="4" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="20" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="-1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="Design" /><field column="CSSPrefix" fieldcaption="CSS prefix" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="DisplayHighlightedItemAsLink" fieldcaption="Display highlighted item as link" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="DisplayOnlySelectedPath" fieldcaption="Display only selected path" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="FirstItemCssClass" fieldcaption="First item CSS class" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="HighlightAllItemsInPath" fieldcaption="Highlight all items in path" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="HoverCSSClassName" fieldcaption="LI hover CSS class name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="LastItemCssClass" fieldcaption="Last item CSS class" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OnMouseOutScript" fieldcaption="OnMouseOut script" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="OnMouseOverScript" fieldcaption="OnMouseOver script" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="RenderCssClasses" fieldcaption="Render CSS classes" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="RenderItemID" fieldcaption="Render item ID" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="RenderLinkTitle" fieldcaption="Render link title:" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="If true, renders the accessibility title attribute." regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="RenderImageAlt" fieldcaption="Render image alt" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ItemIdPrefix" fieldcaption="Item ID prefix" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SubmenuIndicator" fieldcaption="Sub-menu indicator image" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="UrlTarget" fieldcaption="Target frame" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="UseAlternatingStyles" fieldcaption="Use alternating styles" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="0"><settings /></field><field column="UseItemImagesForHiglightedItem" fieldcaption="Use item images for higlighted items" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ApplyMenuDesign" fieldcaption="Apply menu design" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='cmslistmenu'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Search dialog settings" /><field column="SearchButtonText" fieldcaption="Search button text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchForLabel" fieldcaption="Search label text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchModeLabel" fieldcaption="Search mode label text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchScopeLabel" fieldcaption="Search scope label text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchMode" fieldcaption="Search mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="anyword" text="Any word" /><item value="allwords" text="All words" /><item value="exactphrase" text="Exact phrase" /></options></settings></field><field column="SearchScope" fieldcaption="Search scope" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="searchallcontent" text="Search all content" /><item value="searchcurrentsection" text="Search current section" /></options></settings></field><field column="ShowSearchMode" fieldcaption="Show search mode" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowSearchScope" fieldcaption="Show search scope" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="SkinID" fieldcaption="Skin ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='cmssearchdialog'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Searched content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsinglepath</controlname></settings></field><category name="Search results settings" /><field column="SearchMode" fieldcaption="Search mode" visible="true" columntype="text" fieldtype="dropdownlist" allowempty="false" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="anyword" text="Any word" /><item value="allwords" text="All words" /><item value="exactphrase" text="Exact phrase" /></options></settings></field><field column="CMSSearchDialogID" fieldcaption="Search dialog ID" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="NoResultText" fieldcaption="No results text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Searched content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="4" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="20" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="-1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="Where condition" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="OrderBy" fieldcaption="Order by" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Transformations" /><field column="TransformationName" fieldcaption="Search results transformation" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="Paging" /><field column="PageSize" fieldcaption="Page size" visible="true" defaultvalue="10" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="PagerPosition" fieldcaption="Pager position" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="bottom" text="Bottom" /><item value="top" text="Top" /></options></settings></field><field column="ShowFirstLast" fieldcaption="Show first and last buttons" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="QueryStringKey" fieldcaption="Query string key" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="PagingMode" fieldcaption="Paging mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="querystring" text="Querystring" /><item value="postback" text="Postback" /></options></settings></field><category name="System settings" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="false" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='cmssearchresults'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="450" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectpath</controlname></settings></field><field column="DayField" fieldcaption="Day field" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" columntype="text" fieldtype="radiobuttons" allowempty="true" columnsize="4" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="20" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="-1" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="true" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""></field><field column="SiteName" fieldcaption="Site name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="500" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="Design" /><field column="SkinID" fieldcaption="Skin ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Transformations" /><field column="TransformationName" fieldcaption="Transformation" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="NoEventTransformationName" fieldcaption="No event transformation" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="Relationships" /><field column="RelationshipName" fieldcaption="Relationship name" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectrelationshipname</controlname></settings></field><field column="RelationshipWithNodeGuid" fieldcaption="Main document" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" columnsize="50" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>relationshipconfiguration</controlname></settings></field><field column="RelatedNodeIsOnTheLeftSide" fieldcaption="Main document is on the left side" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="false" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="System settings" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" columntype="boolean" fieldtype="checkbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="1"><settings /></field><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" columnsize="200" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" columnsize="" fielddescription="" defaultvalue="" isPK="false" system="false" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='cmscalendar'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="QueryName" fieldcaption="Query name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="200" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectquery</controlname></settings></field><category name="Content filter" /><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="500" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SelectTopN" fieldcaption="Select top N documents" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="500" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Design" /><field column="ColumnSelector" fieldcaption="Displayed columns" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcolumns</controlname></settings></field><field column="ShowHeader" fieldcaption="Show header" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" fielddescription="" /><field column="ShowFooter" fieldcaption="Show footer" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ToolTip" fieldcaption="Tool tip" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="200" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="SkinID" fieldcaption="Skin ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Paging" /><field column="AllowPaging" fieldcaption="Enable paging" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PageSize" fieldcaption="Page size" visible="true" defaultvalue="10" columntype="integer" fieldtype="textbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="Mode" fieldcaption="Pager style" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="nextprev" text="Previous-Next buttons" /><item value="numericpages" text="Page numbers" /></options></settings></field><category name="Sorting" /><field column="AllowSorting" fieldcaption="Enable sorting" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SortField" fieldcaption="Default sort field" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="100" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SortAscending" fieldcaption="Sort ascending" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="200" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" fielddescription="" isPK="false" system="false" columnsize="50" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='querydatagrid'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="450" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectpath</controlname></settings></field><category name="Content filter" /><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" defaultvalue="" columntype="text" fieldtype="radiobuttons" allowempty="true" isPK="false" system="false" columnsize="4" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" defaultvalue="-1" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SiteName" fieldcaption="Site name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Transformations" /><field column="DetailTransformation" fieldcaption="Detail transformation" visible="true" defaultvalue="cms.file.imagegallery-detail-600" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="ThumbnailTransformation" fieldcaption="Thumbnail transformation" visible="true" defaultvalue="cms.file.imagegallery-thumbnails-300" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="Layout" /><field column="Columns" fieldcaption="Columns" visible="true" defaultvalue="3" columntype="integer" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="RowsPerPage" fieldcaption="Rows per page" visible="true" defaultvalue="3" columntype="integer" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Paging" /><field column="ShowFirstLast" fieldcaption="Show first and last buttons" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="QueryStringKey" fieldcaption="Query string key" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PagingMode" fieldcaption="Paging mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="querystring" text="Query string" /><item value="postback" text="Postback" /></options></settings></field><field column="ShowButtonsOnTop" fieldcaption="Show buttons on top" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Relationships" /><field column="RelationshipWithNodeGuid" fieldcaption="Main document" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>relationshipconfiguration</controlname></settings></field><field column="RelationshipName" fieldcaption="Relationship name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectrelationshipname</controlname></settings></field><field column="RelatedNodeIsOnTheLeftSide" fieldcaption="Related node is on the left side" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true" /><category name="System settings" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='ImageGallery'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Searched content" /><field column="Path" fieldcaption="Path" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="450" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsinglepath</controlname></settings></field><category name="Searched content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="CombineWithDefaultCulture" fieldcaption="Combine with default culture" visible="true" defaultvalue="" columntype="text" fieldtype="radiobuttons" allowempty="true" isPK="false" system="false" columnsize="4" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="true" text="Yes" /><item value="false" text="No" /><item value="" text="Use site settings" /></options></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="20" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" defaultvalue="-1" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SelectOnlyPublished" fieldcaption="Select only published" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="SiteName" fieldcaption="Site name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsite</controlname></settings></field><field column="WhereCondition" fieldcaption="Where condition" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="OrderBy" fieldcaption="Order by" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Transformations" /><field column="TransformationName" fieldcaption="Search results transformation" visible="true" defaultvalue="CMS.Root.searchresults" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="Search dialog settings" /><field column="SearchButtonText" fieldcaption="Search button text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchForLabel" fieldcaption="Search label text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchModeLabel" fieldcaption="Search mode label text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchScopeLabel" fieldcaption="Search scope label text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchMode" fieldcaption="Search mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="anyword" text="Any word" /><item value="allwords" text="All words" /><item value="exactphrase" text="Exact phrase" /></options></settings></field><field column="SearchScope" fieldcaption="Search scope" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="searchallcontent" text="Search all content" /><item value="searchcurrentsection" text="Search current section" /></options></settings></field><field column="ShowSearchMode" fieldcaption="Show search mode" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowSearchScope" fieldcaption="Show search scope" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SkinID" fieldcaption="Skin ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="NoResults" fieldcaption="No results text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Paging" /><field column="PagerPosition" fieldcaption="Pager position" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><options><item value="bottom" text="Bottom" /><item value="top" text="Top" /></options></settings></field><field column="PageSize" fieldcaption="Page size" visible="true" defaultvalue="10" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="PagingMode" fieldcaption="Paging mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="querystring" text="Querystring" /><item value="postback" text="Postback" /></options></settings></field><field column="QueryStringKey" fieldcaption="Query string key" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowFirstLast" fieldcaption="Show first and last buttons" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='cmscompletesearchdialog'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Search box settings" /><field column="SearchButtonText" fieldcaption="Search button text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchButtonCssClass" fieldcaption="Search button CSS class" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchLabelText" fieldcaption="Search label text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchLabelCssClass" fieldcaption="Search label CSS class" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchTextboxCssClass" fieldcaption="Search textbox CSS class" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SearchResultsPageUrl" fieldcaption="Search results page URL" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowSearchLabel" fieldcaption="Show search label" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SkinID" fieldcaption="Skin ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Button settings" /><field column="ShowImageButton" fieldcaption="Show image button" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ImageUrl" fieldcaption="Button image url" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='cmssearchbox'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Text" fieldcaption="Text" visible="true" defaultvalue="" columntype="longtext" fieldtype="htmlarea" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions=""><settings><size></size><height>250</height><width>500</width></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>'  WHERE WebPartName='statichtml'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Display settings" /><field column="ShowOnlyWhenAuthenticated" fieldcaption="Show only when authenticated" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="LabelText" fieldcaption="Label text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="LabelCSS" fieldcaption="Label CSS class" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UserCSS" fieldcaption="User text CSS class" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='currentuser'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Sign out button settings" /><field column="SignOutText" fieldcaption="Button text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="RedirectToURL" fieldcaption="Redirect to URL" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowOnlyWhenAuthenticated" fieldcaption="Show only when authenticated" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SkinID" fieldcaption="Skin ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='SignOutButton'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Logon form settings" /><field column="DefaultTargetURL" fieldcaption="Default target URL" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SkinID" fieldcaption="Skin ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="FailureText" fieldcaption="Logon failure text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="AllowPasswordRetrieval" fieldcaption="Allow forgotten password retrieval" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SendEmailFrom" fieldcaption="Send email from" visible="true" defaultvalue="admin@domain.com" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='logonform'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Registration form settings" /><field column="FirstNameText" fieldcaption="First name text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="LastNameText" fieldcaption="Last name text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="EmailText" fieldcaption="E-mail text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PasswordText" fieldcaption="Password text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ConfirmPasswordText" fieldcaption="Confirmation password text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ButtonText" fieldcaption="Button text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="AssignToRoles" fieldcaption="Assign user to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>roleselector</controlname></settings></field><field column="RedirectToURL" fieldcaption="Redirect to URL" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SkinID" fieldcaption="Skin ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Extended settings" /><field column="EnableUserAfterRegistration" fieldcaption="Enable user after registration" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="NotifyAdministrator" fieldcaption="Notify administrator about new registrations" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="FromAddress" fieldcaption="From e-mail address" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ToAddress" fieldcaption="To e-mail address:" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="DisplayMessage" fieldcaption="Display message after registration" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>'  WHERE WebPartName='registrationform'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Misc" /><field column="EnableAddButton" fieldcaption="Show Add attachment button" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Transformations" /><field column="TransformationName" fieldcaption="Transformation" visible="true" defaultvalue="cms.file.attachmentlist" columntype="text" fieldtype="usercontrol" allowempty="false" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='attachments'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Relationships" /><field column="RelationshipName" fieldcaption="Relationship name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectrelationshipname</controlname></settings></field><field column="CurrentDocumentIsOnTheLeftSide" fieldcaption="Current document is on the left side" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" spellcheck="true"></field><category name="Transformations" /><field column="TransformationName" fieldcaption="Transformation name" visible="true" defaultvalue="CMS.Root.relateddocuments" columntype="text" fieldtype="usercontrol" allowempty="false" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='relateddocuments'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Dialog settings" /><field column="NewsletterName" fieldcaption="Newsletter code name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="400" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="DisplayFirstName" fieldcaption="Display first name" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="FirstNameText" fieldcaption="First name label text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="DisplayLastName" fieldcaption="Display last name" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="LastNameText" fieldcaption="Last name label text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="EmailText" fieldcaption="E-mail label text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ButtonText" fieldcaption="Submit button text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SkinID" fieldcaption="Skin ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='NewsletterSubscription'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Dialog" /><field column="UnsubscribedText" fieldcaption="Confirmation text" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='NewsletterUnsubscription'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="BizForm settings" /><field column="BizFormName" fieldcaption="Form name" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="false" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><query>SELECT FormName, FormDisplayName FROM CMS_Form ORDER BY FormDisplayName</query></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='BizForm'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="450" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectpath</controlname></settings></field><category name="Content filter" /><field column="ClassNames" fieldcaption="Document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="20" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectculture</controlname></settings></field><field column="SiteName" fieldcaption="Site name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsite</controlname></settings></field><category name="Transformations" /><field column="TransformationName" fieldcaption="Transformation" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="Paging" /><field column="PagerPosition" fieldcaption="Pager position" visible="true" defaultvalue="0" columntype="text" fieldtype="dropdownlist" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="bottom" text="Bottom" /><item value="top" text="Top" /></options></settings></field><field column="BackText" fieldcaption="Previous button text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="NextText" fieldcaption="Next button text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SelectedPageClass" fieldcaption="Selected page class name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UnselectedPageClass" fieldcaption="Unselected page class name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SelectedNextClass" fieldcaption="Selected next class name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UnselectedNextClass" fieldcaption="Unselected next class name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SelectedPrevClass" fieldcaption="Selected previous class name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UnselectedPrevClass" fieldcaption="Unselected previous class name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PageNumberSeparator" fieldcaption="Page separator" visible="true" defaultvalue="-" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='DocumentPager'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="JavaScript" /><field column="InlineScript" fieldcaption="In-line script" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="LinkedFile" fieldcaption="Linked file" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="500" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='javascript'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Forum" /><field column="ForumViewMode" fieldcaption="Forum view mode" visible="true" defaultvalue="" columntype="integer" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="1" text="Thread list (default)" /><item value="0" text="Tree" /></options></settings></field><field column="GroupName" fieldcaption="Group name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>forumgroupselector</controlname></settings></field><field column="QueryStringForumID" fieldcaption="Forum ID URL parameter name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ThreadQueryString" fieldcaption="Thread ID URL parameter name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="DisplayOnlyOpen" fieldcaption="Display only open" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="UseAlternatingStyle" fieldcaption="Use alternating styles" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="AnonymousRead" fieldcaption="Anonymous users can read" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="EnableSubscription" fieldcaption="Enable subscription" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Extended properties" /><field column="EnableImages" fieldcaption="Enable images" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxImageWidth" fieldcaption="Max. image width" visible="true" defaultvalue="50" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxImageHeight" fieldcaption="Max. image height" visible="true" defaultvalue="60" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="EnableSignature" fieldcaption="Enable signature" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Tree forum properties" /><field column="ShowMode" fieldcaption="Display mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="treemode" text="Tree mode" /><item value="detailmode" text="Detail mode" /><item value="dynamicdetailmode" text="Dynamic detail mode" /></options></settings></field><field column="ExpandTree" fieldcaption="Expanded tree" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Threaded forum properties" /><field column="EnablePaging" fieldcaption="Enable paging" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PageSize" fieldcaption="Page size" visible="true" defaultvalue="10" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Forum content" /><field column="PostPath" fieldcaption="Post path" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" defaultvalue="-1" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SelectOnlyApproved" fieldcaption="Display only approved" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="WhereCondition" fieldcaption="Where condition" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='ForumGroup'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Layout" /><field column="TransformationName" fieldcaption="Transformation" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Web service settings" /><field column="WebServiceURL" fieldcaption="Web service URL (.asmx file)" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="1000" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="WebServiceParameters" fieldcaption="Web service parameters" visible="true" defaultvalue="" columntype="longtext" fieldtype="textarea" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><size></size><cols></cols><rows></rows></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='RepeaterForWebservice'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Design" /><field column="ShowHeader" fieldcaption="Show header" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowFooter" fieldcaption="Show footer" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ToolTip" fieldcaption="Tool tip" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SkinID" fieldcaption="Skin ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Paging" /><field column="AllowPaging" fieldcaption="Enable paging" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PageSize" fieldcaption="Page size" visible="true" defaultvalue="10" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Mode" fieldcaption="Pager style" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="nextprev" text="Previous-Next buttons" /><item value="numericpages" text="Page numbers" /></options></settings></field><category name="Sorting" /><field column="AllowSorting" fieldcaption="Enable sorting" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SortField" fieldcaption="Default sort field" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SortAscending" fieldcaption="Sort ascending" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Web service settings" /><field column="WebServiceURL" fieldcaption="Web service URL (.asmx file)" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="1000" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="WebServiceParameters" fieldcaption="Web service parameters" visible="true" defaultvalue="" columntype="longtext" fieldtype="textarea" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><size /><cols /><rows /></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='GridForWebservice'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Forum" /><field column="ForumName" fieldcaption="Forum name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>forumselector</controlname></settings></field><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="AnonymousRead" fieldcaption="Anonymous users can read" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="EnableSubscription" fieldcaption="Enable subscription" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ThreadQueryString" fieldcaption="Thread ID URL parameter name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Threaded forum properties" /><field column="EnablePaging" fieldcaption="Enable paging" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PageSize" fieldcaption="Page size" visible="true" defaultvalue="10" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="1" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Extended properties" /><field column="EnableImages" fieldcaption="Enable images" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxImageWidth" fieldcaption="Max. image width" visible="true" defaultvalue="50" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxImageHeight" fieldcaption="Max. image height" visible="true" defaultvalue="60" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="EnableSignature" fieldcaption="Enable signature" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Forum content" /><field column="PostPath" fieldcaption="Post path" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" defaultvalue="-1" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SelectOnlyApproved" fieldcaption="Display only approved" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="WhereCondition" fieldcaption="Where condition" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='ForumFlat'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Forum" /><field column="ForumName" fieldcaption="Forum name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>forumselector</controlname></settings></field><field column="CheckPermissions" fieldcaption="Check permissions" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="AnonymousRead" fieldcaption="Anonymous users can read" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="EnableSubscription" fieldcaption="Enable subscription" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Tree forum properties" /><field column="ShowMode" fieldcaption="Display mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="treemode" text="Tree mode" /><item value="detailmode" text="Detail mode" /><item value="dynamicdetailmode" text="Dynamic detail mode" /></options></settings></field><field column="ExpandTree" fieldcaption="Expanded tree" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Extended properties" /><field column="EnableImages" fieldcaption="Enable images" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxImageWidth" fieldcaption="Max. image width" visible="true" defaultvalue="50" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxImageHeight" fieldcaption="Max. image height" visible="true" defaultvalue="60" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="EnableSignature" fieldcaption="Enable signature" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Forum content" /><field column="PostPath" fieldcaption="Post path" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" defaultvalue="-1" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="SelectOnlyApproved" fieldcaption="Display only approved" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="WhereCondition" fieldcaption="Where condition" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='ForumTree'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Layout" /><field column="RepeatColumns" fieldcaption="Repeat columns" visible="true" defaultvalue="3" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="RepeatDirection" fieldcaption="Repeat direction" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="horizontal" text="Horizontal" /><item value="vertical" text="Vertical" /></options></settings></field><field column="RepeatLayout" fieldcaption="Repeat layout" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="table" text="Table" /><item value="flow" text="Flow" /></options></settings></field><field column="TransformationName" fieldcaption="Transformation" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Web service settings" /><field column="WebServiceURL" fieldcaption="Web service URL (.asmx file)" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="1000" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="WebServiceParameters" fieldcaption="Web service parameter" visible="true" defaultvalue="" columntype="longtext" fieldtype="textarea" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><size></size><cols></cols><rows></rows></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='datalistforwebservice'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Extended properties" /><field column="MaxPictureWidth" fieldcaption="Max. picture width" visible="true" defaultvalue="50" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxPictureHeight" fieldcaption="Max. picture height" visible="true" defaultvalue="60" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='MyProfileWebPart'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on sub-pages" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Settings" /><field column="RedirectUrl" fieldcaption="Redirect to URL" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="150" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='ForumSearch'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Settings" /><field column="Groups" fieldcaption="Groups" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>groupsselector</controlname></settings></field><field column="AnonymousRead" fieldcaption="Anonymous users can read" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="NoResults" fieldcaption="No results text" visible="true" defaultvalue="No posts found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ForumQueryString" fieldcaption="Forum ID URL parameter name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ThreadQueryString" fieldcaption="Thread ID URL parameter name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="EnableSubscription" fieldcaption="Enable subscription" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Extended properties" /><field column="EnablePicture" fieldcaption="Enable picture" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxImageWidth" fieldcaption="Max. image width" visible="true" defaultvalue="50" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MaxImageHeight" fieldcaption="Max. image height" visible="true" defaultvalue="60" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="EnableSignature" fieldcaption="Enable signature" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>'  WHERE WebPartName='ForumSearchResults'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="General" /><field column="PasswordRetrieval" fieldcaption="Allow forgotten password retrieval" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="RedirectAfterPurchase" fieldcaption="Default URL after purchase" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectpath</controlname></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='ShoppingCart'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Shopping cart preview properties" /><field column="ShoppingCartLinkUrl" fieldcaption="Shopping cart link URL" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"></field><field column="ShoppingCartLinkText" fieldcaption="Shopping cart link text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="TotalPriceTitleText" fieldcaption="Total price text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MyAccountLinkUrl" fieldcaption="My Account link URL" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="MyAccountLinkText" fieldcaption="My Account link text" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='ShoppingCartMiniPreview'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="Path" fieldcaption="Path" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectpath</controlname></settings></field><field column="SiteName" fieldcaption="Site name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectsite</controlname></settings></field><field column="CultureCode" fieldcaption="Culture code" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectculture</controlname></settings></field><field column="MaxRelativeLevel" fieldcaption="Maximum nesting level" visible="true" defaultvalue="-1" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ClassNames" fieldcaption="Document type" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="TransformationName" fieldcaption="Transformation name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="500" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Cache" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" defaultvalue="" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>'  WHERE WebPartName='RandomDocument'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Ecommerce" /><field column="AllowEmptyPassword" fieldcaption="Allow empty password:" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="CssClass" fieldcaption="Tabs css class" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>' WHERE WebPartName='MyAccount'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="Content" /><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="OrderBy" fieldcaption="ORDER BY" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Layout" /><field column="RepeatColumns" fieldcaption="Repeat columns" visible="true" defaultvalue="3" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="RepeatDirection" fieldcaption="Repeat direction" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="horizontal" text="Horizontal" /><item value="vertical" text="Vertical" /></options></settings></field><field column="RepeatLayout" fieldcaption="Repeat layout" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="table" text="Table" /><item value="flow" text="Flow" /></options></settings></field><category name="Paging" /><field column="EnablePaging" fieldcaption="Enable paging" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PageSize" fieldcaption="Page size" visible="true" defaultvalue="10" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="PagerPosition" fieldcaption="Pager position" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="bottom" text="Bottom" /><item value="top" text="Top" /></options></settings></field><field column="PagingMode" fieldcaption="Paging mode" visible="true" defaultvalue="" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="10" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><options><item value="querystring" text="Query string" /><item value="postback" text="Postback" /></options></settings></field><field column="ShowFirstLast" fieldcaption="Show first and last last buttons" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="QueryStringKey" fieldcaption="Query string key" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="Transformations" /><field column="TransformationName" fieldcaption="Transformation name" visible="true" defaultvalue="CMS.Root.GeneralProductPreview" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="AlternatingTransformationName" fieldcaption="Alternating transformation name" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="100" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><field column="SelectedItemTransformationName" fieldcaption="Selected item transformation name" visible="true" defaultvalue="CMS.Root.GeneralProductDetail" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selecttransformation</controlname></settings></field><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide control for zero rows" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field></form>'  WHERE WebPartName='ProducDataList'

UPDATE [CMS_WebPart] SET [WebPartProperties] = '<form><field column="WebPartControlID" fieldcaption="Web part control ID" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="50" fielddescription="" regularexpression="\w+" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="Control ID must match identificator format." captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="Visible" fieldcaption="Visible" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="HideOnSubPages" fieldcaption="Hide on subpages" visible="true" defaultvalue="" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ShowForDocumentTypes" fieldcaption="Show for document types" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectclassnames</controlname></settings></field><field column="DisplayToRoles" fieldcaption="Display to roles" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>rolecheckboxselector</controlname></settings></field><category name="HTML Envelope" /><field column="Container" fieldcaption="Web part container" visible="true" defaultvalue="" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>selectcontainer</controlname></settings></field><field column="ContainerTitle" fieldcaption="Web part container title" visible="true" defaultvalue="" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /><field column="ContentBefore" fieldcaption="Content before" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="ContentAfter" fieldcaption="Content after" visible="true" defaultvalue="" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false"><settings><controlname>largetextarea</controlname></settings></field><field column="MaximalPasswordLength" fieldcaption="Maximal password length" visible="true" defaultvalue="0" columntype="integer" fieldtype="textbox" allowempty="false" isPK="false" system="false" columnsize="" fielddescription="" regularexpression="" minstringlength="" maxstringlength="" minnumericvalue="0" maxnumericvalue="" mindatetimevalue="" maxdatetimevalue="" validationerrormessage="" captionstyle="" inputcontrolstyle="" fileextensions="" publicfield="false" /></form>'  WHERE WebPartName='ChangePassword'

GO

/*### Views update ### */
DROP VIEW View_CMS_Tree_Joined 
GO

CREATE VIEW View_CMS_Tree_Joined
AS
SELECT     CASE WHEN ((DocumentCheckedOutVersionHistoryID IS NULL AND DocumentPublishedVersionHistoryID IS NULL) OR
                      (DocumentCheckedOutVersionHistoryID IS NOT NULL AND DocumentPublishedVersionHistoryID IS NOT NULL)) AND (DocumentPublishFrom IS NULL OR (DocumentPublishFrom IS NOT NULL AND DocumentPublishFrom <= getdate())) AND (DocumentPublishTo IS NULL OR
                      (DocumentPublishTo IS NOT NULL AND DocumentPublishTo >= getdate())) AND ((StepName <> 'archived') OR
                      (StepName IS NULL)) THEN 1 ELSE 0 END AS Published, CMS_Site.SiteName, CMS_Class.ClassName, CMS_Class.ClassDisplayName,
                      CMS_Tree.NodeID, CMS_Tree.NodeAliasPath, CMS_Tree.NodeName, CMS_Tree.NodeAlias, CMS_Tree.NodeClassID,
                      CMS_Tree.NodeParentID, CMS_Tree.NodeLevel, CMS_Tree.NodeACLID, CMS_Tree.NodeSiteID, CMS_Tree.NodeGUID,
                      CMS_Tree.NodeOrder, CMS_Document.DocumentID, CMS_Document.DocumentName, CMS_Document.DocumentNamePath,
                      CMS_Document.DocumentModifiedWhen, CMS_Document.DocumentModifiedByUserID, CMS_Document.DocumentForeignKeyValue,
                      CMS_Document.DocumentCreatedByUserID, CMS_Document.DocumentCreatedWhen, CMS_Document.DocumentCheckedOutByUserID,
                      CMS_Document.DocumentCheckedOutWhen, CMS_Document.DocumentCheckedOutVersionHistoryID,   
                      CMS_Document.DocumentPublishedVersionHistoryID, CMS_Document.DocumentWorkflowStepID, CMS_Document.DocumentPublishFrom,
                      CMS_Document.DocumentPublishTo, CMS_Document.DocumentUrlPath, CMS_Document.DocumentCulture,
                      CMS_Document.DocumentNodeID, CMS_Document.DocumentPageTitle, CMS_Document.DocumentPageKeyWords,
                      CMS_Document.DocumentPageDescription, CMS_Document.DocumentShowInSiteMap,
                      CMS_Document.DocumentMenuItemHideInNavigation, CMS_Document.DocumentMenuCaption, CMS_Document.DocumentMenuStyle,
                      CMS_Document.DocumentMenuItemImage, CMS_Document.DocumentMenuItemLeftImage,             
                      CMS_Document.DocumentMenuItemRightImage, CMS_Document.DocumentPageTemplateID, CMS_Document.DocumentMenuJavascript,
                      CMS_Document.DocumentMenuRedirectUrl, CMS_Document.DocumentUseNamePathForUrlPath, CMS_Document.DocumentStylesheetID,
                      CMS_Document.DocumentContent, CMS_Tree.IsSecuredNode, CMS_Document.DocumentMenuClass,   
                      CMS_Document.DocumentMenuStyleOver, CMS_Document.DocumentMenuClassOver, CMS_Document.DocumentMenuItemImageOver,
                      CMS_Document.DocumentMenuItemLeftImageOver, CMS_Document.DocumentMenuItemRightImageOver,
                      CMS_Document.DocumentMenuStyleHighlighted, CMS_Document.DocumentMenuClassHighlighted,   
                      CMS_Document.DocumentMenuItemImageHighlighted, CMS_Document.DocumentMenuItemLeftImageHighlighted,
                      CMS_Document.DocumentMenuItemRightImageHighlighted, CMS_Tree.NodeCacheMinutes, CMS_Tree.NodeSKUID,                 
                      CMS_Tree.NodeDocType, CMS_Tree.NodeHeadTags, COM_SKU.SKUID, COM_SKU.SKUNumber, COM_SKU.SKUName,                   
                      COM_SKU.SKUDescription, COM_SKU.SKUPrice, COM_SKU.SKUEnabled, COM_SKU.SKUDepartmentID, COM_SKU.SKUManufacturerID,
                      COM_SKU.SKUInternalStatusID, COM_SKU.SKUPublicStatusID, COM_SKU.SKUSupplierID, COM_SKU.SKUAvailableInDays, COM_SKU.SKUGUID,
                      CMS_Tree.NodeInheritPageLevels, CMS_Document.DocumentMenuItemInactive, CMS_Tree.NodeChildNodesCount,
                      CMS_Tree.NodeBodyElementAttributes, CMS_Tree.RequiresSSL
				FROM CMS_Tree INNER JOIN
                      CMS_Document ON CMS_Tree.NodeID = CMS_Document.DocumentNodeID INNER JOIN
                      CMS_Site ON CMS_Tree.NodeSiteID = CMS_Site.SiteID INNER JOIN
                      CMS_Class ON CMS_Tree.NodeClassID = CMS_Class.ClassID LEFT OUTER JOIN
                      CMS_WorkflowStep ON CMS_Document.DocumentWorkflowStepID = CMS_WorkflowStep.StepID LEFT OUTER JOIN
                      View_COM_SKU AS COM_SKU ON CMS_Tree.NodeSKUID = COM_SKU.SKUID
GO
					  
DROP VIEW View_CMS_Tree_Joined_Versions
GO					  
	
CREATE VIEW View_CMS_Tree_Joined_Versions
AS
SELECT CASE WHEN ((DocumentCheckedOutVersionHistoryID IS NULL AND DocumentPublishedVersionHistoryID IS NULL) OR
                      (DocumentCheckedOutVersionHistoryID IS NOT NULL AND DocumentPublishedVersionHistoryID IS NOT NULL)) AND (DocumentPublishFrom IS NULL OR
                      (DocumentPublishFrom IS NOT NULL AND DocumentPublishFrom <= getdate())) AND (DocumentPublishTo IS NULL OR
                      (DocumentPublishTo IS NOT NULL AND DocumentPublishTo >= getdate())) AND ((StepName <> 'archived') OR
                      (StepName IS NULL)) THEN 1 ELSE 0 END AS Published, CMS_Site.SiteName, CMS_Class.ClassName, CMS_Class.ClassDisplayName,
                      CMS_Tree.NodeID, CMS_Tree.NodeAliasPath, CMS_Tree.NodeName, CMS_Tree.NodeAlias, CMS_Tree.NodeClassID,
                      CMS_Tree.NodeParentID, CMS_Tree.NodeLevel, CMS_Tree.NodeACLID, CMS_Tree.NodeSiteID, CMS_Tree.NodeGUID,
                      CMS_Tree.NodeOrder, CMS_Document.DocumentID, CMS_Document.DocumentName, CMS_Document.DocumentNamePath,
                      CMS_Document.DocumentModifiedWhen, CMS_Document.DocumentModifiedByUserID, CMS_Document.DocumentForeignKeyValue,
                      CMS_Document.DocumentCreatedByUserID, CMS_Document.DocumentCreatedWhen, CMS_Document.DocumentCheckedOutByUserID,
                      CMS_Document.DocumentCheckedOutWhen, CMS_Document.DocumentCheckedOutVersionHistoryID,
                      CMS_Document.DocumentPublishedVersionHistoryID, CMS_Document.DocumentWorkflowStepID, CMS_Document.DocumentPublishFrom,
                      CMS_Document.DocumentPublishTo, CMS_Document.DocumentUrlPath, CMS_Document.DocumentCulture,
                      CMS_Document.DocumentNodeID, CMS_Document.DocumentPageTitle, CMS_Document.DocumentPageKeyWords,
                      CMS_Document.DocumentPageDescription, CMS_Document.DocumentShowInSiteMap,
                      CMS_Document.DocumentMenuItemHideInNavigation, CMS_Document.DocumentMenuCaption, CMS_Document.DocumentMenuStyle,
                      CMS_Document.DocumentMenuItemImage, CMS_Document.DocumentMenuItemLeftImage,
                      CMS_Document.DocumentMenuItemRightImage, CMS_Document.DocumentPageTemplateID, CMS_Document.DocumentMenuJavascript,
                      CMS_Document.DocumentMenuRedirectUrl, CMS_Document.DocumentUseNamePathForUrlPath, CMS_Document.DocumentStylesheetID,
                      CMS_Document.DocumentContent, CMS_VersionHistory.NodeXML, CMS_Tree.IsSecuredNode, CMS_Document.DocumentMenuClass,
                      CMS_Document.DocumentMenuStyleOver, CMS_Document.DocumentMenuClassOver, CMS_Document.DocumentMenuItemImageOver,
                      CMS_Document.DocumentMenuItemLeftImageOver, CMS_Document.DocumentMenuItemRightImageOver,
                      CMS_Document.DocumentMenuStyleHighlighted, CMS_Document.DocumentMenuClassHighlighted,
                      CMS_Document.DocumentMenuItemImageHighlighted, CMS_Document.DocumentMenuItemLeftImageHighlighted,
                      CMS_Document.DocumentMenuItemRightImageHighlighted, CMS_Tree.NodeCacheMinutes, CMS_Tree.NodeSKUID,
                      CMS_Tree.NodeDocType, CMS_Tree.NodeHeadTags, COM_SKU.SKUID, COM_SKU.SKUNumber, COM_SKU.SKUName,
                      COM_SKU.SKUDescription, COM_SKU.SKUPrice, COM_SKU.SKUEnabled, COM_SKU.SKUDepartmentID, COM_SKU.SKUManufacturerID,
                      COM_SKU.SKUInternalStatusID, COM_SKU.SKUPublicStatusID, COM_SKU.SKUSupplierID, COM_SKU.SKUAvailableInDays, COM_SKU.SKUGUID,
                      CMS_Tree.NodeInheritPageLevels, CMS_Document.DocumentMenuItemInactive, CMS_Tree.NodeChildNodesCount,
                      CMS_Tree.NodeBodyElementAttributes, CMS_Tree.RequiresSSL
			FROM CMS_Tree INNER JOIN
                      CMS_Document ON CMS_Tree.NodeID = CMS_Document.DocumentNodeID INNER JOIN
                      CMS_Site ON CMS_Tree.NodeSiteID = CMS_Site.SiteID INNER JOIN
                      CMS_Class ON CMS_Tree.NodeClassID = CMS_Class.ClassID LEFT OUTER JOIN
                      CMS_VersionHistory ON
                      CMS_Document.DocumentCheckedOutVersionHistoryID = CMS_VersionHistory.VersionHistoryID LEFT OUTER JOIN
                      CMS_WorkflowStep ON CMS_Document.DocumentWorkflowStepID = CMS_WorkflowStep.StepID LEFT OUTER JOIN
                      View_COM_SKU AS COM_SKU ON CMS_Tree.NodeSKUID = COM_SKU.SKUID
GO

DROP VIEW View_PageInfo	
GO

CREATE VIEW View_PageInfo
AS
SELECT     CMS_Tree.NodeID, CMS_Tree.NodeAliasPath, CMS_Tree.NodeName, CMS_Tree.NodeAlias, CMS_Tree.NodeClassID,
                      CMS_Tree.NodeParentID, CMS_Tree.NodeLevel, CMS_Tree.NodeACLID, CMS_Tree.NodeSiteID, CMS_Tree.NodeGUID,
                      CMS_Tree.NodeOrder, CMS_Document.DocumentID, CMS_Document.DocumentName, CMS_Document.DocumentNamePath,
                      CMS_Document.DocumentPublishFrom, CMS_Document.DocumentPublishTo, CMS_Document.DocumentUrlPath,
                      CMS_Document.DocumentCulture, CMS_Document.DocumentPageTitle, CMS_Document.DocumentPageKeyWords,
                      CMS_Document.DocumentPageDescription, CMS_Document.DocumentMenuCaption, CMS_Document.DocumentPageTemplateID,
                      CMS_PageTemplate.PageTemplateID, CMS_PageTemplate.PageTemplateDisplayName, CMS_PageTemplate.PageTemplateDescription,
                      CMS_PageTemplate.PageTemplateFile, CMS_PageTemplate.PageTemplateIsPortal, CMS_PageTemplate.PageTemplateCategoryID,
                      CMS_PageTemplate.PageTemplateLayoutID, CMS_PageTemplate.PageTemplateWebParts,
                      CMS_PageTemplate.PageTemplateIsReusable, CMS_Class.ClassName, CMS_Document.DocumentContent,
                      CMS_PageTemplate.PageTemplateCodeName, CMS_Document.DocumentStylesheetID, CMS_Tree.IsSecuredNode,
                      CMS_Document.DocumentMenuRedirectUrl, CMS_PageTemplate.PageTemplateInheritPageLevels,
                      CMS_PageTemplate.PageTemplateShowAsMasterTemplate, CMS_Document.DocumentMenuJavascript, CMS_Tree.NodeCacheMinutes,
                      CMS_Tree.NodeSKUID, CMS_Tree.NodeSKUID AS Expr1, CMS_Tree.NodeDocType, CMS_Tree.NodeHeadTags,
                      CMS_Tree.NodeInheritPageLevels, CMS_PageTemplate.PageTemplateLayout,
                      CMS_PageTemplate.PageTemplateLayoutCheckedOutFileName, CMS_PageTemplate.PageTemplateLayoutCheckedOutByUserID,
                      CMS_PageTemplate.PageTemplateLayoutCheckedOutMachineName, CMS_Document.DocumentMenuItemInactive,
                      CMS_Document.DocumentMenuClass, CMS_Document.DocumentMenuStyle, CMS_Document.DocumentMenuItemHideInNavigation,
                      CMS_Tree.NodeChildNodesCount, CMS_Tree.NodeBodyElementAttributes, CMS_Tree.RequiresSSL
FROM         CMS_Tree INNER JOIN
                      CMS_Document ON CMS_Document.DocumentNodeID = CMS_Tree.NodeID INNER JOIN
                      CMS_Class ON CMS_Tree.NodeClassID = CMS_Class.ClassID LEFT OUTER JOIN
                      CMS_PageTemplate ON CMS_Document.DocumentPageTemplateID = CMS_PageTemplate.PageTemplateID
GO
					  
DROP VIEW View_PageInfo_Blank
GO

CREATE VIEW View_PageInfo_Blank
AS
SELECT     CMS_Tree.NodeID, CMS_Tree.NodeAliasPath, CMS_Tree.NodeName, CMS_Tree.NodeAlias, CMS_Tree.NodeClassID,
                      CMS_Tree.NodeParentID, CMS_Tree.NodeLevel, CMS_Tree.NodeACLID, CMS_Tree.NodeSiteID, CMS_Tree.NodeGUID,
                      CMS_Tree.NodeOrder, CMS_Document.DocumentID, CMS_Document.DocumentName, CMS_Document.DocumentNamePath,
                      CMS_Document.DocumentPublishFrom, CMS_Document.DocumentPublishTo, CMS_Document.DocumentUrlPath,
                      CMS_Document.DocumentCulture, CMS_Document.DocumentPageTitle, CMS_Document.DocumentPageKeyWords,
                      CMS_Document.DocumentPageDescription, CMS_Document.DocumentMenuCaption, CMS_Document.DocumentPageTemplateID,
                      CMS_PageTemplate.PageTemplateID, CMS_PageTemplate.PageTemplateDisplayName, CMS_PageTemplate.PageTemplateDescription,
                      CMS_PageTemplate.PageTemplateFile, CMS_PageTemplate.PageTemplateIsPortal, CMS_PageTemplate.PageTemplateCategoryID,
                      CMS_PageTemplate.PageTemplateLayoutID, CMS_PageTemplate.PageTemplateWebParts,
                      CMS_PageTemplate.PageTemplateIsReusable, CMS_Class.ClassName, CMS_Document.DocumentContent,
                      CMS_PageTemplate.PageTemplateCodeName, CMS_Document.DocumentStylesheetID, CMS_Tree.IsSecuredNode,
                      CMS_Document.DocumentMenuRedirectUrl, CMS_PageTemplate.PageTemplateInheritPageLevels,
                      CMS_PageTemplate.PageTemplateShowAsMasterTemplate, CMS_Document.DocumentMenuJavascript, CMS_Tree.NodeCacheMinutes,
                      CMS_Tree.NodeSKUID, CMS_Tree.NodeSKUID AS Expr1, CMS_Tree.NodeDocType, CMS_Tree.NodeHeadTags,
                      CMS_Tree.NodeInheritPageLevels, CMS_PageTemplate.PageTemplateLayout,
                      CMS_PageTemplate.PageTemplateLayoutCheckedOutFileName, CMS_PageTemplate.PageTemplateLayoutCheckedOutByUserID,                                                                                                                             
                      CMS_PageTemplate.PageTemplateLayoutCheckedOutMachineName, CMS_Document.DocumentMenuItemInactive,
                      CMS_Document.DocumentMenuClass, CMS_Document.DocumentMenuStyle, CMS_Document.DocumentMenuItemHideInNavigation,
                      CMS_Tree.NodeChildNodesCount, CMS_Tree.NodeBodyElementAttributes, CMS_Tree.RequiresSSL
FROM         CMS_Tree INNER JOIN
                      CMS_Class ON CMS_Tree.NodeClassID = CMS_Class.ClassID LEFT OUTER JOIN
                      CMS_Document ON 1 = 0 LEFT OUTER JOIN
                      CMS_PageTemplate ON 1 = 0
GO

/* ### Special ### */

/*Node count*/

UPDATE CMS_Tree SET NodeChildNodesCount = (SELECT COUNT(NodeID) FROM View_CMS_Tree_Joined WHERE NodeParentID = CMS_Tree.NodeID)
GO

/*Settings*/
-- CREATE NEW SETTINGS TO EXISTING SITES

	DECLARE @categoryid int
	DECLARE @setts int;
	
	DECLARE @statusCursor CURSOR;
    SET @statusCursor = CURSOR FOR SELECT SiteID FROM [CMS_Site];
	
	
	DECLARE @cSiteId int;
	/* Loop through all sites and add them settings */
	OPEN @statusCursor
	FETCH NEXT FROM @statusCursor INTO @cSiteId;
	WHILE @@FETCH_STATUS = 0
	BEGIN
		
		
	
set @categoryid = (SELECT CategoryID FROM CMS_SettingsCategory WHERE CategoryDisplayName='URLs')
if @categoryid<>0
begin
INSERT [CMS_SettingsKey] ( [KeyName], [KeyDisplayName], [KeyDescription], [KeyValue], [KeyType], [KeyCategoryID], [SiteID]) VALUES ( 'CMSUsePermanentURLs', 'Use permanent URLs', 'Use permanent URL format (getdoc/...) for links?', NULL, 'boolean', @categoryid, @cSiteId)
end



set @categoryid = (SELECT CategoryID FROM CMS_SettingsCategory WHERE CategoryDisplayName='Web Site')
if @categoryid<>0
begin
INSERT [CMS_SettingsKey] ( [KeyName], [KeyDisplayName], [KeyDescription], [KeyValue], [KeyType], [KeyCategoryID], [SiteID]) VALUES ( 'CMSCombineImagesWithDefaultCulture', 'Combine Files With Default Culture', 'Indicates if default culture version of the file should be used when the document is not translated.', NULL, 'boolean', @categoryid, @cSiteId)
INSERT [CMS_SettingsKey] ( [KeyName], [KeyDisplayName], [KeyDescription], [KeyValue], [KeyType], [KeyCategoryID], [SiteID]) VALUES ( 'CMSPageTitleFormat', 'Page Title Format', 'Specifies page title format. Example: {%prefix%} - {%pagetitle_orelse_name%}', NULL, 'string', @categoryid, @cSiteId)
end



set @categoryid = (SELECT CategoryID FROM CMS_SettingsCategory WHERE CategoryDisplayName='E-mails')
if @categoryid<>0
begin
INSERT [CMS_SettingsKey] ( [KeyName], [KeyDisplayName], [KeyDescription], [KeyValue], [KeyType], [KeyCategoryID], [SiteID]) VALUES ( 'CMSUseSSL', 'Use SSL', 'Indicates if e-mails should be sent over SSL.', NULL, 'boolean', @categoryid, @cSiteId)
end



set @categoryid = (SELECT CategoryID FROM CMS_SettingsCategory WHERE CategoryDisplayName='Content Management')
if @categoryid<>0
begin
INSERT [CMS_SettingsKey] ([KeyName], [KeyDisplayName], [KeyDescription], [KeyValue], [KeyType], [KeyCategoryID], [SiteID]) VALUES ( 'CMSConfirmChanges', 'Notify when leaving the page', 'Notifies the user that she hasn''t saved the changes when the user tries to leave the page in the editing mode.', NULL, 'boolean', @categoryid, @cSiteId)
end


		
    FETCH NEXT FROM @statusCursor INTO @cSiteId;
	END
	CLOSE @statusCursor;
	DEALLOCATE @statusCursor;
	
GO	